#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 5
#define STATE_COUNT 1384
#define SYMBOL_COUNT 115
#define ALIAS_COUNT 1
#define TOKEN_COUNT 74
#define EXTERNAL_TOKEN_COUNT 9
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym__simple_heredoc = 1,
  sym__heredoc_beginning = 2,
  sym__heredoc_middle = 3,
  sym__heredoc_end = 4,
  sym_file_descriptor = 5,
  sym__empty_value = 6,
  sym__concat = 7,
  sym_variable_name = 8,
  anon_sym_for = 9,
  anon_sym_in = 10,
  anon_sym_while = 11,
  anon_sym_do = 12,
  anon_sym_done = 13,
  anon_sym_if = 14,
  anon_sym_then = 15,
  anon_sym_fi = 16,
  anon_sym_elif = 17,
  anon_sym_else = 18,
  anon_sym_case = 19,
  anon_sym_esac = 20,
  anon_sym_PIPE = 21,
  anon_sym_RPAREN = 22,
  anon_sym_SEMI_SEMI = 23,
  anon_sym_function = 24,
  anon_sym_LPAREN = 25,
  anon_sym_LBRACE = 26,
  anon_sym_RBRACE = 27,
  anon_sym_PIPE_AMP = 28,
  anon_sym_AMP_AMP = 29,
  anon_sym_PIPE_PIPE = 30,
  anon_sym_LBRACK = 31,
  anon_sym_RBRACK = 32,
  anon_sym_LBRACK_LBRACK = 33,
  anon_sym_RBRACK_RBRACK = 34,
  anon_sym_EQ = 35,
  anon_sym_PLUS_EQ = 36,
  anon_sym_LT = 37,
  anon_sym_GT = 38,
  anon_sym_GT_GT = 39,
  anon_sym_AMP_GT = 40,
  anon_sym_AMP_GT_GT = 41,
  anon_sym_LT_AMP = 42,
  anon_sym_GT_AMP = 43,
  anon_sym_LT_LT = 44,
  anon_sym_LT_LT_DASH = 45,
  anon_sym_DQUOTE = 46,
  aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH = 47,
  sym_raw_string = 48,
  anon_sym_DOLLAR = 49,
  anon_sym_DOLLAR_LBRACE = 50,
  anon_sym_POUND = 51,
  anon_sym_AT = 52,
  anon_sym_COLON = 53,
  anon_sym_COLON_QMARK = 54,
  anon_sym_COLON_DASH = 55,
  anon_sym_PERCENT = 56,
  anon_sym_SLASH = 57,
  anon_sym_DOLLAR_LPAREN = 58,
  anon_sym_BQUOTE = 59,
  anon_sym_LT_LPAREN = 60,
  anon_sym_GT_LPAREN = 61,
  sym_word = 62,
  sym_comment = 63,
  sym_simple_variable_name = 64,
  anon_sym_STAR = 65,
  anon_sym_QMARK = 66,
  anon_sym_DASH = 67,
  anon_sym_BANG = 68,
  anon_sym_0 = 69,
  anon_sym__ = 70,
  anon_sym_SEMI = 71,
  anon_sym_LF = 72,
  anon_sym_AMP = 73,
  sym_program = 74,
  sym__terminated_statement = 75,
  sym_for_statement = 76,
  sym_while_statement = 77,
  sym_do_group = 78,
  sym_if_statement = 79,
  sym_elif_clause = 80,
  sym_else_clause = 81,
  sym_case_statement = 82,
  sym_case_item = 83,
  sym_function_definition = 84,
  sym_compound_statement = 85,
  sym_subshell = 86,
  sym_pipeline = 87,
  sym_list = 88,
  sym_bracket_command = 89,
  sym_command = 90,
  sym_command_name = 91,
  sym_environment_variable_assignment = 92,
  sym_subscript = 93,
  sym_file_redirect = 94,
  sym_heredoc_redirect = 95,
  sym_heredoc = 96,
  sym_concatenation = 97,
  sym_string = 98,
  sym_array = 99,
  sym_simple_expansion = 100,
  sym_expansion = 101,
  sym_command_substitution = 102,
  sym_process_substitution = 103,
  sym_special_variable_name = 104,
  aux_sym_program_repeat1 = 105,
  aux_sym_for_statement_repeat1 = 106,
  aux_sym_if_statement_repeat1 = 107,
  aux_sym_case_statement_repeat1 = 108,
  aux_sym_case_item_repeat1 = 109,
  aux_sym_command_repeat1 = 110,
  aux_sym_command_repeat2 = 111,
  aux_sym_heredoc_repeat1 = 112,
  aux_sym_concatenation_repeat1 = 113,
  aux_sym_string_repeat1 = 114,
  alias_sym_variable_name = 115,
};

static const char *ts_symbol_names[] = {
  [sym__simple_heredoc] = "_simple_heredoc",
  [sym__heredoc_beginning] = "_heredoc_beginning",
  [sym__heredoc_middle] = "_heredoc_middle",
  [sym__heredoc_end] = "_heredoc_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = "/[^\"`$]+/",
  [sym_raw_string] = "raw_string",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_POUND] = "#",
  [anon_sym_AT] = "@",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_word] = "word",
  [sym_comment] = "comment",
  [sym_simple_variable_name] = "simple_variable_name",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_bracket_command] = "bracket_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_environment_variable_assignment] = "environment_variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc] = "heredoc",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [sym_special_variable_name] = "special_variable_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_repeat1] = "heredoc_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [alias_sym_variable_name] = "variable_name",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__simple_heredoc] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_variable_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_bracket_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_environment_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[3][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [1] = alias_sym_variable_name,
  },
  [2] = {
    [2] = alias_sym_variable_name,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(24);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(41);
      if (lookahead == '\\')
        SKIP(43);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(6);
      if (lookahead == '{')
        ADVANCE(7);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 13:
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead != 0)
        ADVANCE(13);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 18:
      if (lookahead == '=')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_simple_variable_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(25);
      if (lookahead == '?')
        ADVANCE(26);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '(')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(32);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(36);
      if (lookahead == '(')
        ADVANCE(37);
      if (lookahead == '>')
        ADVANCE(38);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 43:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(50);
      if (lookahead == '|')
        ADVANCE(51);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 53:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(61);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'w')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(53);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(54);
      END_STATE();
    case 55:
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '(')
        ADVANCE(31);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(58);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 59:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 61:
      if (lookahead == '\n')
        SKIP(53);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'a')
        ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 's')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'o')
        ADVANCE(67);
      if (lookahead == 'u')
        ADVANCE(69);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'r')
        ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'n')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'c')
        ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 't')
        ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'i')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'o')
        ADVANCE(74);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'n')
        ADVANCE(75);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'h')
        ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'i')
        ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'l')
        ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 83:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead == ':')
        ADVANCE(24);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '\\')
        SKIP(86);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'd')
        ADVANCE(88);
      if (lookahead == 'e')
        ADVANCE(90);
      if (lookahead == 'f')
        ADVANCE(96);
      if (lookahead == 'i')
        ADVANCE(98);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(83);
      END_STATE();
    case 84:
      if (lookahead == '&')
        ADVANCE(10);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 86:
      if (lookahead == '\n')
        SKIP(83);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 88:
      if (lookahead == 'o')
        ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 90:
      if (lookahead == 'l')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 'i')
        ADVANCE(92);
      if (lookahead == 's')
        ADVANCE(94);
      END_STATE();
    case 92:
      if (lookahead == 'f')
        ADVANCE(93);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 94:
      if (lookahead == 'e')
        ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 96:
      if (lookahead == 'i')
        ADVANCE(97);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 98:
      if (lookahead == 'n')
        ADVANCE(99);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 100:
      if (lookahead == 'h')
        ADVANCE(101);
      END_STATE();
    case 101:
      if (lookahead == 'e')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 'n')
        ADVANCE(103);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 104:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(105);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 105:
      if (lookahead == '\n')
        SKIP(104);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 106:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(107);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(109);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(110);
      if (lookahead != 0)
        ADVANCE(108);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(108);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(107);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '\n')
        ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(108);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH);
      if (lookahead == '#')
        ADVANCE(107);
      if (lookahead == '\\')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(110);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(108);
      END_STATE();
    case 111:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(113);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 113:
      if (lookahead == '\n')
        SKIP(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(50);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == '|')
        ADVANCE(115);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 116:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(117);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(24);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '?')
        ADVANCE(39);
      if (lookahead == '@')
        ADVANCE(40);
      if (lookahead == '[')
        ADVANCE(85);
      if (lookahead == '\\')
        SKIP(118);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(116);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 118:
      if (lookahead == '\n')
        SKIP(116);
      END_STATE();
    case 119:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(120);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(119);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        SKIP(119);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 121:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(122);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(123);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'w')
        ADVANCE(78);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(121);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != '{')
        ADVANCE(60);
      END_STATE();
    case 122:
      if (lookahead == ';')
        ADVANCE(28);
      END_STATE();
    case 123:
      if (lookahead == '\n')
        SKIP(121);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 124:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(125);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(126);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(10);
      END_STATE();
    case 126:
      if (lookahead == '\n')
        SKIP(124);
      END_STATE();
    case 127:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(128);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(127);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 128:
      if (lookahead == '\n')
        SKIP(127);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 129:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(130);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(129);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 130:
      if (lookahead == '\n')
        SKIP(129);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 131:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(132);
      if (lookahead == '>')
        ADVANCE(133);
      if (lookahead == '\\')
        ADVANCE(134);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(131);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 132:
      if (lookahead == '(')
        ADVANCE(31);
      END_STATE();
    case 133:
      if (lookahead == '(')
        ADVANCE(37);
      END_STATE();
    case 134:
      if (lookahead == '\n')
        SKIP(131);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 135:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(136);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(137);
      if (lookahead == 'i')
        ADVANCE(98);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 137:
      if (lookahead == '\n')
        SKIP(135);
      END_STATE();
    case 138:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(139);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(138);
      if (lookahead != 0 &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 139:
      if (lookahead == '\n')
        SKIP(138);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 140:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(141);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        SKIP(140);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 142:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(132);
      if (lookahead == '>')
        ADVANCE(133);
      if (lookahead == '\\')
        ADVANCE(143);
      if (lookahead == ']')
        ADVANCE(144);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 143:
      if (lookahead == '\n')
        SKIP(142);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 145:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(132);
      if (lookahead == '>')
        ADVANCE(133);
      if (lookahead == '\\')
        ADVANCE(146);
      if (lookahead == ']')
        ADVANCE(147);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(145);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        SKIP(145);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == ']')
        ADVANCE(148);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 149:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(151);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(149);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 150:
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 151:
      if (lookahead == '\n')
        SKIP(149);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 152:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(153);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(152);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        SKIP(152);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 154:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(155);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(154);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 155:
      if (lookahead == '\n')
        SKIP(154);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 156:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(156);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 157:
      if (lookahead == '\n')
        SKIP(156);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 158:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(159);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '{')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 159:
      if (lookahead == '\n')
        SKIP(158);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 160:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '\\')
        ADVANCE(161);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(114);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(160);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(60);
      END_STATE();
    case 161:
      if (lookahead == '\n')
        SKIP(160);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 162:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(163);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'w')
        ADVANCE(78);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(162);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{')
        ADVANCE(60);
      END_STATE();
    case 163:
      if (lookahead == '\n')
        SKIP(162);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 164:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(167);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(36);
      if (lookahead == '>')
        ADVANCE(38);
      END_STATE();
    case 167:
      if (lookahead == '\n')
        SKIP(164);
      END_STATE();
    case 168:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '\\')
        SKIP(169);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(168);
      END_STATE();
    case 169:
      if (lookahead == '\n')
        SKIP(168);
      END_STATE();
    case 170:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '<')
        ADVANCE(32);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        SKIP(170);
      END_STATE();
    case 173:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(174);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      END_STATE();
    case 174:
      if (lookahead == '\n')
        SKIP(173);
      END_STATE();
    case 175:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '\\')
        SKIP(176);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(175);
      END_STATE();
    case 176:
      if (lookahead == '\n')
        SKIP(175);
      END_STATE();
    case 177:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(132);
      if (lookahead == '>')
        ADVANCE(133);
      if (lookahead == '\\')
        ADVANCE(178);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(177);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        SKIP(177);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 179:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(180);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'd')
        ADVANCE(181);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'w')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(179);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        SKIP(179);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'o')
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'n')
        ADVANCE(183);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(184);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 185:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(186);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(187);
      if (lookahead == 'f')
        ADVANCE(193);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'w')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(185);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 186:
      if (lookahead == '\n')
        SKIP(185);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'l')
        ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'i')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(190);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(192);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'i')
        ADVANCE(194);
      if (lookahead == 'o')
        ADVANCE(67);
      if (lookahead == 'u')
        ADVANCE(69);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 195:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(196);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(195);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        SKIP(195);
      END_STATE();
    case 197:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'w')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 198:
      if (lookahead == '\n')
        SKIP(197);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 199:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(132);
      if (lookahead == '>')
        ADVANCE(133);
      if (lookahead == '\\')
        ADVANCE(200);
      if (lookahead == ']')
        ADVANCE(144);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{')
        ADVANCE(60);
      END_STATE();
    case 200:
      if (lookahead == '\n')
        SKIP(199);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 201:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(202);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        SKIP(201);
      END_STATE();
    case 203:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(204);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      END_STATE();
    case 204:
      if (lookahead == '\n')
        SKIP(203);
      END_STATE();
    case 205:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(206);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      END_STATE();
    case 206:
      if (lookahead == '\n')
        SKIP(205);
      END_STATE();
    case 207:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(208);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      END_STATE();
    case 208:
      if (lookahead == '\n')
        SKIP(207);
      END_STATE();
    case 209:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == '<')
        ADVANCE(171);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 211:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(212);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(7);
      END_STATE();
    case 213:
      if (lookahead == '\n')
        SKIP(211);
      END_STATE();
    case 214:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(215);
      if (lookahead == ']')
        ADVANCE(87);
      if (lookahead == '|')
        ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(214);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(136);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(132);
      if (lookahead == '>')
        ADVANCE(133);
      if (lookahead == '\\')
        ADVANCE(218);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(217);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 218:
      if (lookahead == '\n')
        SKIP(217);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 219:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(193);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'w')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        SKIP(219);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 221:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(132);
      if (lookahead == '>')
        ADVANCE(133);
      if (lookahead == '\\')
        ADVANCE(222);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'e')
        ADVANCE(223);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(221);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 's')
        ADVANCE(224);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'a')
        ADVANCE(225);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != 'a' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead == 'c')
        ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 227:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '\\')
        SKIP(228);
      if (lookahead == '}')
        ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(227);
      END_STATE();
    case 228:
      if (lookahead == '\n')
        SKIP(227);
      END_STATE();
    case 229:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(150);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(166);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 230:
      if (lookahead == '\n')
        SKIP(229);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        ADVANCE(112);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(125);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(232);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 232:
      if (lookahead == '\n')
        SKIP(231);
      END_STATE();
    case 233:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(234);
      if (lookahead == '|')
        ADVANCE(216);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      END_STATE();
    case 234:
      if (lookahead == '\n')
        SKIP(233);
      END_STATE();
    case 235:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(236);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      END_STATE();
    case 236:
      if (lookahead == '\n')
        SKIP(235);
      END_STATE();
    case 237:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(238);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      END_STATE();
    case 238:
      if (lookahead == '\n')
        SKIP(237);
      END_STATE();
    case 239:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(55);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(122);
      if (lookahead == '<')
        ADVANCE(56);
      if (lookahead == '>')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(57);
      if (lookahead == '\\')
        ADVANCE(240);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == 'c')
        ADVANCE(62);
      if (lookahead == 'f')
        ADVANCE(66);
      if (lookahead == 'i')
        ADVANCE(76);
      if (lookahead == 'w')
        ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != '{' &&
          lookahead != '}')
        ADVANCE(60);
      END_STATE();
    case 240:
      if (lookahead == '\n')
        SKIP(239);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(60);
      END_STATE();
    case 241:
      if (lookahead == '#')
        ADVANCE(54);
      if (lookahead == '&')
        ADVANCE(84);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(242);
      if (lookahead == '`')
        ADVANCE(47);
      if (lookahead == '|')
        ADVANCE(49);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 242:
      if (lookahead == '\n')
        SKIP(241);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 53, .external_lex_state = 2},
  [2] = {.lex_state = 53},
  [3] = {.lex_state = 83},
  [4] = {.lex_state = 104},
  [5] = {.lex_state = 53, .external_lex_state = 2},
  [6] = {.lex_state = 53, .external_lex_state = 2},
  [7] = {.lex_state = 104},
  [8] = {.lex_state = 104},
  [9] = {.lex_state = 53, .external_lex_state = 2},
  [10] = {.lex_state = 104},
  [11] = {.lex_state = 104},
  [12] = {.lex_state = 104},
  [13] = {.lex_state = 106},
  [14] = {.lex_state = 111, .external_lex_state = 3},
  [15] = {.lex_state = 116},
  [16] = {.lex_state = 116},
  [17] = {.lex_state = 53, .external_lex_state = 2},
  [18] = {.lex_state = 53, .external_lex_state = 2},
  [19] = {.lex_state = 53, .external_lex_state = 2},
  [20] = {.lex_state = 119, .external_lex_state = 3},
  [21] = {.lex_state = 53},
  [22] = {.lex_state = 121, .external_lex_state = 2},
  [23] = {.lex_state = 124, .external_lex_state = 4},
  [24] = {.lex_state = 111, .external_lex_state = 5},
  [25] = {.lex_state = 127, .external_lex_state = 6},
  [26] = {.lex_state = 83},
  [27] = {.lex_state = 104, .external_lex_state = 2},
  [28] = {.lex_state = 129, .external_lex_state = 5},
  [29] = {.lex_state = 53, .external_lex_state = 2},
  [30] = {.lex_state = 104, .external_lex_state = 2},
  [31] = {.lex_state = 104},
  [32] = {.lex_state = 104},
  [33] = {.lex_state = 131, .external_lex_state = 7},
  [34] = {.lex_state = 83},
  [35] = {.lex_state = 83},
  [36] = {.lex_state = 124, .external_lex_state = 4},
  [37] = {.lex_state = 127, .external_lex_state = 6},
  [38] = {.lex_state = 83},
  [39] = {.lex_state = 106},
  [40] = {.lex_state = 135, .external_lex_state = 8},
  [41] = {.lex_state = 116},
  [42] = {.lex_state = 116},
  [43] = {.lex_state = 53, .external_lex_state = 2},
  [44] = {.lex_state = 53, .external_lex_state = 2},
  [45] = {.lex_state = 53, .external_lex_state = 2},
  [46] = {.lex_state = 135, .external_lex_state = 4},
  [47] = {.lex_state = 83},
  [48] = {.lex_state = 83},
  [49] = {.lex_state = 104},
  [50] = {.lex_state = 129, .external_lex_state = 3},
  [51] = {.lex_state = 138, .external_lex_state = 3},
  [52] = {.lex_state = 124, .external_lex_state = 4},
  [53] = {.lex_state = 129, .external_lex_state = 5},
  [54] = {.lex_state = 140, .external_lex_state = 6},
  [55] = {.lex_state = 83},
  [56] = {.lex_state = 53, .external_lex_state = 2},
  [57] = {.lex_state = 104, .external_lex_state = 2},
  [58] = {.lex_state = 106},
  [59] = {.lex_state = 142, .external_lex_state = 9},
  [60] = {.lex_state = 116},
  [61] = {.lex_state = 116},
  [62] = {.lex_state = 53, .external_lex_state = 2},
  [63] = {.lex_state = 53, .external_lex_state = 2},
  [64] = {.lex_state = 53, .external_lex_state = 2},
  [65] = {.lex_state = 142},
  [66] = {.lex_state = 142},
  [67] = {.lex_state = 106},
  [68] = {.lex_state = 145, .external_lex_state = 9},
  [69] = {.lex_state = 116},
  [70] = {.lex_state = 116},
  [71] = {.lex_state = 53, .external_lex_state = 2},
  [72] = {.lex_state = 53, .external_lex_state = 2},
  [73] = {.lex_state = 53, .external_lex_state = 2},
  [74] = {.lex_state = 145},
  [75] = {.lex_state = 145},
  [76] = {.lex_state = 106},
  [77] = {.lex_state = 104, .external_lex_state = 10},
  [78] = {.lex_state = 116},
  [79] = {.lex_state = 116},
  [80] = {.lex_state = 53, .external_lex_state = 2},
  [81] = {.lex_state = 53, .external_lex_state = 2},
  [82] = {.lex_state = 53, .external_lex_state = 2},
  [83] = {.lex_state = 104, .external_lex_state = 2},
  [84] = {.lex_state = 129, .external_lex_state = 3},
  [85] = {.lex_state = 106},
  [86] = {.lex_state = 116},
  [87] = {.lex_state = 116},
  [88] = {.lex_state = 53, .external_lex_state = 2},
  [89] = {.lex_state = 53, .external_lex_state = 2},
  [90] = {.lex_state = 106},
  [91] = {.lex_state = 104},
  [92] = {.lex_state = 111, .external_lex_state = 3},
  [93] = {.lex_state = 129, .external_lex_state = 3},
  [94] = {.lex_state = 129, .external_lex_state = 3},
  [95] = {.lex_state = 129, .external_lex_state = 3},
  [96] = {.lex_state = 83},
  [97] = {.lex_state = 116},
  [98] = {.lex_state = 83},
  [99] = {.lex_state = 83},
  [100] = {.lex_state = 83},
  [101] = {.lex_state = 104},
  [102] = {.lex_state = 53, .external_lex_state = 2},
  [103] = {.lex_state = 53, .external_lex_state = 2},
  [104] = {.lex_state = 104},
  [105] = {.lex_state = 104},
  [106] = {.lex_state = 53, .external_lex_state = 2},
  [107] = {.lex_state = 104},
  [108] = {.lex_state = 104},
  [109] = {.lex_state = 106},
  [110] = {.lex_state = 149, .external_lex_state = 11},
  [111] = {.lex_state = 116},
  [112] = {.lex_state = 116},
  [113] = {.lex_state = 53, .external_lex_state = 2},
  [114] = {.lex_state = 53, .external_lex_state = 2},
  [115] = {.lex_state = 53, .external_lex_state = 2},
  [116] = {.lex_state = 152, .external_lex_state = 11},
  [117] = {.lex_state = 83},
  [118] = {.lex_state = 149, .external_lex_state = 12},
  [119] = {.lex_state = 154, .external_lex_state = 2},
  [120] = {.lex_state = 83},
  [121] = {.lex_state = 149, .external_lex_state = 12},
  [122] = {.lex_state = 104, .external_lex_state = 2},
  [123] = {.lex_state = 83},
  [124] = {.lex_state = 104},
  [125] = {.lex_state = 156, .external_lex_state = 11},
  [126] = {.lex_state = 158, .external_lex_state = 11},
  [127] = {.lex_state = 83},
  [128] = {.lex_state = 156, .external_lex_state = 12},
  [129] = {.lex_state = 160, .external_lex_state = 2},
  [130] = {.lex_state = 83},
  [131] = {.lex_state = 104, .external_lex_state = 2},
  [132] = {.lex_state = 83},
  [133] = {.lex_state = 154, .external_lex_state = 2},
  [134] = {.lex_state = 83},
  [135] = {.lex_state = 162, .external_lex_state = 2},
  [136] = {.lex_state = 164, .external_lex_state = 5},
  [137] = {.lex_state = 53, .external_lex_state = 2},
  [138] = {.lex_state = 121, .external_lex_state = 2},
  [139] = {.lex_state = 53, .external_lex_state = 2},
  [140] = {.lex_state = 53},
  [141] = {.lex_state = 104},
  [142] = {.lex_state = 168, .external_lex_state = 13},
  [143] = {.lex_state = 111, .external_lex_state = 3},
  [144] = {.lex_state = 170, .external_lex_state = 5},
  [145] = {.lex_state = 129, .external_lex_state = 5},
  [146] = {.lex_state = 111, .external_lex_state = 5},
  [147] = {.lex_state = 173, .external_lex_state = 5},
  [148] = {.lex_state = 53, .external_lex_state = 2},
  [149] = {.lex_state = 83},
  [150] = {.lex_state = 111, .external_lex_state = 5},
  [151] = {.lex_state = 83},
  [152] = {.lex_state = 104, .external_lex_state = 2},
  [153] = {.lex_state = 104, .external_lex_state = 10},
  [154] = {.lex_state = 104, .external_lex_state = 2},
  [155] = {.lex_state = 106},
  [156] = {.lex_state = 175, .external_lex_state = 9},
  [157] = {.lex_state = 116},
  [158] = {.lex_state = 116},
  [159] = {.lex_state = 53, .external_lex_state = 2},
  [160] = {.lex_state = 53, .external_lex_state = 2},
  [161] = {.lex_state = 53, .external_lex_state = 2},
  [162] = {.lex_state = 83},
  [163] = {.lex_state = 140, .external_lex_state = 6},
  [164] = {.lex_state = 177},
  [165] = {.lex_state = 106},
  [166] = {.lex_state = 127, .external_lex_state = 14},
  [167] = {.lex_state = 116},
  [168] = {.lex_state = 116},
  [169] = {.lex_state = 53, .external_lex_state = 2},
  [170] = {.lex_state = 53, .external_lex_state = 2},
  [171] = {.lex_state = 53, .external_lex_state = 2},
  [172] = {.lex_state = 104},
  [173] = {.lex_state = 179, .external_lex_state = 2},
  [174] = {.lex_state = 124, .external_lex_state = 4},
  [175] = {.lex_state = 83},
  [176] = {.lex_state = 185, .external_lex_state = 2},
  [177] = {.lex_state = 135, .external_lex_state = 8},
  [178] = {.lex_state = 106},
  [179] = {.lex_state = 104},
  [180] = {.lex_state = 135, .external_lex_state = 4},
  [181] = {.lex_state = 83},
  [182] = {.lex_state = 135, .external_lex_state = 8},
  [183] = {.lex_state = 135, .external_lex_state = 8},
  [184] = {.lex_state = 135, .external_lex_state = 8},
  [185] = {.lex_state = 135, .external_lex_state = 8},
  [186] = {.lex_state = 116},
  [187] = {.lex_state = 83},
  [188] = {.lex_state = 83},
  [189] = {.lex_state = 83},
  [190] = {.lex_state = 154, .external_lex_state = 2},
  [191] = {.lex_state = 83},
  [192] = {.lex_state = 160, .external_lex_state = 2},
  [193] = {.lex_state = 83},
  [194] = {.lex_state = 154, .external_lex_state = 2},
  [195] = {.lex_state = 83},
  [196] = {.lex_state = 164, .external_lex_state = 5},
  [197] = {.lex_state = 131, .external_lex_state = 7},
  [198] = {.lex_state = 83},
  [199] = {.lex_state = 129, .external_lex_state = 3},
  [200] = {.lex_state = 83},
  [201] = {.lex_state = 195, .external_lex_state = 5},
  [202] = {.lex_state = 53, .external_lex_state = 2},
  [203] = {.lex_state = 124, .external_lex_state = 4},
  [204] = {.lex_state = 197, .external_lex_state = 2},
  [205] = {.lex_state = 53, .external_lex_state = 2},
  [206] = {.lex_state = 53},
  [207] = {.lex_state = 104},
  [208] = {.lex_state = 129, .external_lex_state = 3},
  [209] = {.lex_state = 129, .external_lex_state = 5},
  [210] = {.lex_state = 170, .external_lex_state = 5},
  [211] = {.lex_state = 124, .external_lex_state = 4},
  [212] = {.lex_state = 140, .external_lex_state = 6},
  [213] = {.lex_state = 53, .external_lex_state = 2},
  [214] = {.lex_state = 129, .external_lex_state = 5},
  [215] = {.lex_state = 199, .external_lex_state = 9},
  [216] = {.lex_state = 106},
  [217] = {.lex_state = 104},
  [218] = {.lex_state = 142, .external_lex_state = 9},
  [219] = {.lex_state = 199, .external_lex_state = 9},
  [220] = {.lex_state = 199, .external_lex_state = 9},
  [221] = {.lex_state = 199, .external_lex_state = 9},
  [222] = {.lex_state = 116},
  [223] = {.lex_state = 83},
  [224] = {.lex_state = 83},
  [225] = {.lex_state = 83},
  [226] = {.lex_state = 154, .external_lex_state = 2},
  [227] = {.lex_state = 83},
  [228] = {.lex_state = 160, .external_lex_state = 2},
  [229] = {.lex_state = 83},
  [230] = {.lex_state = 154, .external_lex_state = 2},
  [231] = {.lex_state = 124, .external_lex_state = 4},
  [232] = {.lex_state = 142},
  [233] = {.lex_state = 145, .external_lex_state = 9},
  [234] = {.lex_state = 106},
  [235] = {.lex_state = 104},
  [236] = {.lex_state = 145, .external_lex_state = 9},
  [237] = {.lex_state = 145, .external_lex_state = 9},
  [238] = {.lex_state = 145, .external_lex_state = 9},
  [239] = {.lex_state = 145, .external_lex_state = 9},
  [240] = {.lex_state = 116},
  [241] = {.lex_state = 83},
  [242] = {.lex_state = 83},
  [243] = {.lex_state = 83},
  [244] = {.lex_state = 154, .external_lex_state = 2},
  [245] = {.lex_state = 83},
  [246] = {.lex_state = 160, .external_lex_state = 2},
  [247] = {.lex_state = 83},
  [248] = {.lex_state = 154, .external_lex_state = 2},
  [249] = {.lex_state = 145},
  [250] = {.lex_state = 104, .external_lex_state = 10},
  [251] = {.lex_state = 106},
  [252] = {.lex_state = 104},
  [253] = {.lex_state = 104, .external_lex_state = 10},
  [254] = {.lex_state = 104, .external_lex_state = 10},
  [255] = {.lex_state = 104, .external_lex_state = 10},
  [256] = {.lex_state = 104, .external_lex_state = 10},
  [257] = {.lex_state = 116},
  [258] = {.lex_state = 83},
  [259] = {.lex_state = 83},
  [260] = {.lex_state = 83},
  [261] = {.lex_state = 154, .external_lex_state = 2},
  [262] = {.lex_state = 83},
  [263] = {.lex_state = 160, .external_lex_state = 2},
  [264] = {.lex_state = 83},
  [265] = {.lex_state = 154, .external_lex_state = 2},
  [266] = {.lex_state = 106},
  [267] = {.lex_state = 106},
  [268] = {.lex_state = 106},
  [269] = {.lex_state = 116},
  [270] = {.lex_state = 83},
  [271] = {.lex_state = 83},
  [272] = {.lex_state = 83},
  [273] = {.lex_state = 154, .external_lex_state = 2},
  [274] = {.lex_state = 83},
  [275] = {.lex_state = 160, .external_lex_state = 2},
  [276] = {.lex_state = 129, .external_lex_state = 3},
  [277] = {.lex_state = 106},
  [278] = {.lex_state = 129, .external_lex_state = 3},
  [279] = {.lex_state = 111, .external_lex_state = 3},
  [280] = {.lex_state = 83},
  [281] = {.lex_state = 83},
  [282] = {.lex_state = 129, .external_lex_state = 3},
  [283] = {.lex_state = 83},
  [284] = {.lex_state = 104},
  [285] = {.lex_state = 129, .external_lex_state = 3},
  [286] = {.lex_state = 83},
  [287] = {.lex_state = 104},
  [288] = {.lex_state = 131, .external_lex_state = 7},
  [289] = {.lex_state = 83},
  [290] = {.lex_state = 83},
  [291] = {.lex_state = 83},
  [292] = {.lex_state = 135, .external_lex_state = 8},
  [293] = {.lex_state = 135, .external_lex_state = 4},
  [294] = {.lex_state = 83},
  [295] = {.lex_state = 124, .external_lex_state = 4},
  [296] = {.lex_state = 140, .external_lex_state = 6},
  [297] = {.lex_state = 53, .external_lex_state = 2},
  [298] = {.lex_state = 142},
  [299] = {.lex_state = 145},
  [300] = {.lex_state = 149, .external_lex_state = 11},
  [301] = {.lex_state = 106},
  [302] = {.lex_state = 104},
  [303] = {.lex_state = 149, .external_lex_state = 11},
  [304] = {.lex_state = 149, .external_lex_state = 11},
  [305] = {.lex_state = 149, .external_lex_state = 11},
  [306] = {.lex_state = 149, .external_lex_state = 11},
  [307] = {.lex_state = 116},
  [308] = {.lex_state = 83},
  [309] = {.lex_state = 83},
  [310] = {.lex_state = 83},
  [311] = {.lex_state = 154, .external_lex_state = 2},
  [312] = {.lex_state = 83},
  [313] = {.lex_state = 160, .external_lex_state = 2},
  [314] = {.lex_state = 83},
  [315] = {.lex_state = 154, .external_lex_state = 2},
  [316] = {.lex_state = 83},
  [317] = {.lex_state = 162, .external_lex_state = 2},
  [318] = {.lex_state = 201, .external_lex_state = 12},
  [319] = {.lex_state = 53, .external_lex_state = 2},
  [320] = {.lex_state = 129, .external_lex_state = 3},
  [321] = {.lex_state = 53, .external_lex_state = 2},
  [322] = {.lex_state = 53},
  [323] = {.lex_state = 104},
  [324] = {.lex_state = 168, .external_lex_state = 13},
  [325] = {.lex_state = 149, .external_lex_state = 11},
  [326] = {.lex_state = 203, .external_lex_state = 12},
  [327] = {.lex_state = 149, .external_lex_state = 12},
  [328] = {.lex_state = 149, .external_lex_state = 12},
  [329] = {.lex_state = 205, .external_lex_state = 12},
  [330] = {.lex_state = 149, .external_lex_state = 12},
  [331] = {.lex_state = 131, .external_lex_state = 7},
  [332] = {.lex_state = 83},
  [333] = {.lex_state = 156, .external_lex_state = 11},
  [334] = {.lex_state = 83},
  [335] = {.lex_state = 207, .external_lex_state = 12},
  [336] = {.lex_state = 53, .external_lex_state = 2},
  [337] = {.lex_state = 53, .external_lex_state = 2},
  [338] = {.lex_state = 53},
  [339] = {.lex_state = 104},
  [340] = {.lex_state = 156, .external_lex_state = 11},
  [341] = {.lex_state = 156, .external_lex_state = 12},
  [342] = {.lex_state = 209, .external_lex_state = 12},
  [343] = {.lex_state = 156, .external_lex_state = 12},
  [344] = {.lex_state = 129, .external_lex_state = 3},
  [345] = {.lex_state = 83},
  [346] = {.lex_state = 195, .external_lex_state = 5},
  [347] = {.lex_state = 162, .external_lex_state = 2},
  [348] = {.lex_state = 53},
  [349] = {.lex_state = 104},
  [350] = {.lex_state = 124, .external_lex_state = 4},
  [351] = {.lex_state = 124, .external_lex_state = 4},
  [352] = {.lex_state = 140, .external_lex_state = 6},
  [353] = {.lex_state = 124, .external_lex_state = 4},
  [354] = {.lex_state = 127, .external_lex_state = 6},
  [355] = {.lex_state = 104},
  [356] = {.lex_state = 106},
  [357] = {.lex_state = 173, .external_lex_state = 3},
  [358] = {.lex_state = 116},
  [359] = {.lex_state = 116},
  [360] = {.lex_state = 53, .external_lex_state = 2},
  [361] = {.lex_state = 53, .external_lex_state = 2},
  [362] = {.lex_state = 53, .external_lex_state = 2},
  [363] = {.lex_state = 170, .external_lex_state = 5},
  [364] = {.lex_state = 170, .external_lex_state = 5},
  [365] = {.lex_state = 211, .external_lex_state = 15},
  [366] = {.lex_state = 170, .external_lex_state = 5},
  [367] = {.lex_state = 111, .external_lex_state = 5},
  [368] = {.lex_state = 173, .external_lex_state = 5},
  [369] = {.lex_state = 173, .external_lex_state = 5},
  [370] = {.lex_state = 131, .external_lex_state = 7},
  [371] = {.lex_state = 111, .external_lex_state = 5},
  [372] = {.lex_state = 214, .external_lex_state = 9},
  [373] = {.lex_state = 106},
  [374] = {.lex_state = 104},
  [375] = {.lex_state = 83},
  [376] = {.lex_state = 175, .external_lex_state = 9},
  [377] = {.lex_state = 214, .external_lex_state = 9},
  [378] = {.lex_state = 214, .external_lex_state = 9},
  [379] = {.lex_state = 214, .external_lex_state = 9},
  [380] = {.lex_state = 116},
  [381] = {.lex_state = 83},
  [382] = {.lex_state = 83},
  [383] = {.lex_state = 83},
  [384] = {.lex_state = 154, .external_lex_state = 2},
  [385] = {.lex_state = 83},
  [386] = {.lex_state = 160, .external_lex_state = 2},
  [387] = {.lex_state = 83},
  [388] = {.lex_state = 154, .external_lex_state = 2},
  [389] = {.lex_state = 140, .external_lex_state = 6},
  [390] = {.lex_state = 106},
  [391] = {.lex_state = 177, .external_lex_state = 9},
  [392] = {.lex_state = 116},
  [393] = {.lex_state = 116},
  [394] = {.lex_state = 53, .external_lex_state = 2},
  [395] = {.lex_state = 53, .external_lex_state = 2},
  [396] = {.lex_state = 53, .external_lex_state = 2},
  [397] = {.lex_state = 177},
  [398] = {.lex_state = 177},
  [399] = {.lex_state = 140, .external_lex_state = 14},
  [400] = {.lex_state = 106},
  [401] = {.lex_state = 104},
  [402] = {.lex_state = 127, .external_lex_state = 14},
  [403] = {.lex_state = 140, .external_lex_state = 14},
  [404] = {.lex_state = 140, .external_lex_state = 14},
  [405] = {.lex_state = 140, .external_lex_state = 14},
  [406] = {.lex_state = 116},
  [407] = {.lex_state = 83},
  [408] = {.lex_state = 83},
  [409] = {.lex_state = 83},
  [410] = {.lex_state = 154, .external_lex_state = 2},
  [411] = {.lex_state = 83},
  [412] = {.lex_state = 160, .external_lex_state = 2},
  [413] = {.lex_state = 83},
  [414] = {.lex_state = 154, .external_lex_state = 2},
  [415] = {.lex_state = 106},
  [416] = {.lex_state = 217, .external_lex_state = 8},
  [417] = {.lex_state = 116},
  [418] = {.lex_state = 116},
  [419] = {.lex_state = 53, .external_lex_state = 2},
  [420] = {.lex_state = 53, .external_lex_state = 2},
  [421] = {.lex_state = 53, .external_lex_state = 2},
  [422] = {.lex_state = 217, .external_lex_state = 4},
  [423] = {.lex_state = 217, .external_lex_state = 4},
  [424] = {.lex_state = 124, .external_lex_state = 4},
  [425] = {.lex_state = 179, .external_lex_state = 2},
  [426] = {.lex_state = 124, .external_lex_state = 4},
  [427] = {.lex_state = 127, .external_lex_state = 6},
  [428] = {.lex_state = 179, .external_lex_state = 2},
  [429] = {.lex_state = 124, .external_lex_state = 4},
  [430] = {.lex_state = 53, .external_lex_state = 2},
  [431] = {.lex_state = 219, .external_lex_state = 2},
  [432] = {.lex_state = 185, .external_lex_state = 2},
  [433] = {.lex_state = 124, .external_lex_state = 4},
  [434] = {.lex_state = 83},
  [435] = {.lex_state = 83},
  [436] = {.lex_state = 127, .external_lex_state = 6},
  [437] = {.lex_state = 185, .external_lex_state = 2},
  [438] = {.lex_state = 83},
  [439] = {.lex_state = 135, .external_lex_state = 8},
  [440] = {.lex_state = 135, .external_lex_state = 8},
  [441] = {.lex_state = 221},
  [442] = {.lex_state = 135, .external_lex_state = 4},
  [443] = {.lex_state = 135, .external_lex_state = 8},
  [444] = {.lex_state = 83},
  [445] = {.lex_state = 83},
  [446] = {.lex_state = 135, .external_lex_state = 8},
  [447] = {.lex_state = 83},
  [448] = {.lex_state = 104},
  [449] = {.lex_state = 135, .external_lex_state = 8},
  [450] = {.lex_state = 83},
  [451] = {.lex_state = 104},
  [452] = {.lex_state = 135, .external_lex_state = 8},
  [453] = {.lex_state = 135, .external_lex_state = 8},
  [454] = {.lex_state = 83},
  [455] = {.lex_state = 124, .external_lex_state = 4},
  [456] = {.lex_state = 140, .external_lex_state = 14},
  [457] = {.lex_state = 83},
  [458] = {.lex_state = 195, .external_lex_state = 5},
  [459] = {.lex_state = 129, .external_lex_state = 3},
  [460] = {.lex_state = 83},
  [461] = {.lex_state = 53},
  [462] = {.lex_state = 104},
  [463] = {.lex_state = 124, .external_lex_state = 4},
  [464] = {.lex_state = 124, .external_lex_state = 4},
  [465] = {.lex_state = 140, .external_lex_state = 6},
  [466] = {.lex_state = 104},
  [467] = {.lex_state = 170, .external_lex_state = 3},
  [468] = {.lex_state = 129, .external_lex_state = 5},
  [469] = {.lex_state = 170, .external_lex_state = 5},
  [470] = {.lex_state = 170, .external_lex_state = 5},
  [471] = {.lex_state = 197, .external_lex_state = 2},
  [472] = {.lex_state = 129, .external_lex_state = 5},
  [473] = {.lex_state = 199, .external_lex_state = 9},
  [474] = {.lex_state = 199, .external_lex_state = 9},
  [475] = {.lex_state = 142, .external_lex_state = 9},
  [476] = {.lex_state = 83},
  [477] = {.lex_state = 83},
  [478] = {.lex_state = 199, .external_lex_state = 9},
  [479] = {.lex_state = 83},
  [480] = {.lex_state = 104},
  [481] = {.lex_state = 199, .external_lex_state = 9},
  [482] = {.lex_state = 83},
  [483] = {.lex_state = 104},
  [484] = {.lex_state = 199, .external_lex_state = 9},
  [485] = {.lex_state = 199, .external_lex_state = 9},
  [486] = {.lex_state = 145, .external_lex_state = 9},
  [487] = {.lex_state = 145, .external_lex_state = 9},
  [488] = {.lex_state = 145, .external_lex_state = 9},
  [489] = {.lex_state = 83},
  [490] = {.lex_state = 83},
  [491] = {.lex_state = 145, .external_lex_state = 9},
  [492] = {.lex_state = 83},
  [493] = {.lex_state = 104},
  [494] = {.lex_state = 145, .external_lex_state = 9},
  [495] = {.lex_state = 83},
  [496] = {.lex_state = 104},
  [497] = {.lex_state = 145, .external_lex_state = 9},
  [498] = {.lex_state = 145, .external_lex_state = 9},
  [499] = {.lex_state = 104, .external_lex_state = 10},
  [500] = {.lex_state = 104, .external_lex_state = 10},
  [501] = {.lex_state = 104, .external_lex_state = 10},
  [502] = {.lex_state = 83},
  [503] = {.lex_state = 83},
  [504] = {.lex_state = 104, .external_lex_state = 10},
  [505] = {.lex_state = 83},
  [506] = {.lex_state = 104},
  [507] = {.lex_state = 104, .external_lex_state = 10},
  [508] = {.lex_state = 83},
  [509] = {.lex_state = 104},
  [510] = {.lex_state = 104, .external_lex_state = 10},
  [511] = {.lex_state = 104, .external_lex_state = 10},
  [512] = {.lex_state = 83},
  [513] = {.lex_state = 83},
  [514] = {.lex_state = 106},
  [515] = {.lex_state = 83},
  [516] = {.lex_state = 104},
  [517] = {.lex_state = 106},
  [518] = {.lex_state = 83},
  [519] = {.lex_state = 104},
  [520] = {.lex_state = 106},
  [521] = {.lex_state = 129, .external_lex_state = 3},
  [522] = {.lex_state = 83},
  [523] = {.lex_state = 129, .external_lex_state = 3},
  [524] = {.lex_state = 83},
  [525] = {.lex_state = 83},
  [526] = {.lex_state = 227, .external_lex_state = 9},
  [527] = {.lex_state = 83},
  [528] = {.lex_state = 83},
  [529] = {.lex_state = 227, .external_lex_state = 9},
  [530] = {.lex_state = 83},
  [531] = {.lex_state = 154, .external_lex_state = 2},
  [532] = {.lex_state = 177},
  [533] = {.lex_state = 106},
  [534] = {.lex_state = 154, .external_lex_state = 10},
  [535] = {.lex_state = 116},
  [536] = {.lex_state = 116},
  [537] = {.lex_state = 53, .external_lex_state = 2},
  [538] = {.lex_state = 53, .external_lex_state = 2},
  [539] = {.lex_state = 53, .external_lex_state = 2},
  [540] = {.lex_state = 104},
  [541] = {.lex_state = 179, .external_lex_state = 2},
  [542] = {.lex_state = 83},
  [543] = {.lex_state = 185, .external_lex_state = 2},
  [544] = {.lex_state = 135, .external_lex_state = 4},
  [545] = {.lex_state = 83},
  [546] = {.lex_state = 83},
  [547] = {.lex_state = 201, .external_lex_state = 12},
  [548] = {.lex_state = 83},
  [549] = {.lex_state = 197, .external_lex_state = 2},
  [550] = {.lex_state = 124, .external_lex_state = 4},
  [551] = {.lex_state = 140, .external_lex_state = 6},
  [552] = {.lex_state = 83},
  [553] = {.lex_state = 149, .external_lex_state = 11},
  [554] = {.lex_state = 149, .external_lex_state = 11},
  [555] = {.lex_state = 149, .external_lex_state = 11},
  [556] = {.lex_state = 83},
  [557] = {.lex_state = 83},
  [558] = {.lex_state = 149, .external_lex_state = 11},
  [559] = {.lex_state = 83},
  [560] = {.lex_state = 104},
  [561] = {.lex_state = 149, .external_lex_state = 11},
  [562] = {.lex_state = 83},
  [563] = {.lex_state = 104},
  [564] = {.lex_state = 149, .external_lex_state = 11},
  [565] = {.lex_state = 149, .external_lex_state = 11},
  [566] = {.lex_state = 83},
  [567] = {.lex_state = 229, .external_lex_state = 12},
  [568] = {.lex_state = 162, .external_lex_state = 2},
  [569] = {.lex_state = 53},
  [570] = {.lex_state = 104},
  [571] = {.lex_state = 83},
  [572] = {.lex_state = 83},
  [573] = {.lex_state = 154, .external_lex_state = 2},
  [574] = {.lex_state = 83},
  [575] = {.lex_state = 154, .external_lex_state = 2},
  [576] = {.lex_state = 104},
  [577] = {.lex_state = 106},
  [578] = {.lex_state = 205, .external_lex_state = 11},
  [579] = {.lex_state = 116},
  [580] = {.lex_state = 116},
  [581] = {.lex_state = 53, .external_lex_state = 2},
  [582] = {.lex_state = 53, .external_lex_state = 2},
  [583] = {.lex_state = 53, .external_lex_state = 2},
  [584] = {.lex_state = 203, .external_lex_state = 12},
  [585] = {.lex_state = 203, .external_lex_state = 12},
  [586] = {.lex_state = 211, .external_lex_state = 15},
  [587] = {.lex_state = 203, .external_lex_state = 12},
  [588] = {.lex_state = 149, .external_lex_state = 12},
  [589] = {.lex_state = 205, .external_lex_state = 12},
  [590] = {.lex_state = 205, .external_lex_state = 12},
  [591] = {.lex_state = 149, .external_lex_state = 12},
  [592] = {.lex_state = 160, .external_lex_state = 10},
  [593] = {.lex_state = 83},
  [594] = {.lex_state = 207, .external_lex_state = 12},
  [595] = {.lex_state = 156, .external_lex_state = 11},
  [596] = {.lex_state = 83},
  [597] = {.lex_state = 53},
  [598] = {.lex_state = 104},
  [599] = {.lex_state = 160, .external_lex_state = 2},
  [600] = {.lex_state = 83},
  [601] = {.lex_state = 160, .external_lex_state = 2},
  [602] = {.lex_state = 104},
  [603] = {.lex_state = 209, .external_lex_state = 11},
  [604] = {.lex_state = 156, .external_lex_state = 12},
  [605] = {.lex_state = 209, .external_lex_state = 12},
  [606] = {.lex_state = 209, .external_lex_state = 12},
  [607] = {.lex_state = 156, .external_lex_state = 12},
  [608] = {.lex_state = 164, .external_lex_state = 5},
  [609] = {.lex_state = 195, .external_lex_state = 5},
  [610] = {.lex_state = 162, .external_lex_state = 2},
  [611] = {.lex_state = 104},
  [612] = {.lex_state = 106},
  [613] = {.lex_state = 231, .external_lex_state = 8},
  [614] = {.lex_state = 116},
  [615] = {.lex_state = 116},
  [616] = {.lex_state = 53, .external_lex_state = 2},
  [617] = {.lex_state = 53, .external_lex_state = 2},
  [618] = {.lex_state = 53, .external_lex_state = 2},
  [619] = {.lex_state = 124, .external_lex_state = 4},
  [620] = {.lex_state = 173, .external_lex_state = 3},
  [621] = {.lex_state = 170, .external_lex_state = 5},
  [622] = {.lex_state = 170, .external_lex_state = 3},
  [623] = {.lex_state = 106},
  [624] = {.lex_state = 104},
  [625] = {.lex_state = 173, .external_lex_state = 3},
  [626] = {.lex_state = 170, .external_lex_state = 3},
  [627] = {.lex_state = 170, .external_lex_state = 3},
  [628] = {.lex_state = 170, .external_lex_state = 3},
  [629] = {.lex_state = 116},
  [630] = {.lex_state = 83},
  [631] = {.lex_state = 83},
  [632] = {.lex_state = 83},
  [633] = {.lex_state = 154, .external_lex_state = 2},
  [634] = {.lex_state = 83},
  [635] = {.lex_state = 160, .external_lex_state = 2},
  [636] = {.lex_state = 83},
  [637] = {.lex_state = 154, .external_lex_state = 2},
  [638] = {.lex_state = 211, .external_lex_state = 15},
  [639] = {.lex_state = 170, .external_lex_state = 5},
  [640] = {.lex_state = 116},
  [641] = {.lex_state = 116},
  [642] = {.lex_state = 211, .external_lex_state = 15},
  [643] = {.lex_state = 104, .external_lex_state = 2},
  [644] = {.lex_state = 177},
  [645] = {.lex_state = 104, .external_lex_state = 10},
  [646] = {.lex_state = 173, .external_lex_state = 5},
  [647] = {.lex_state = 214, .external_lex_state = 9},
  [648] = {.lex_state = 214, .external_lex_state = 9},
  [649] = {.lex_state = 175, .external_lex_state = 9},
  [650] = {.lex_state = 83},
  [651] = {.lex_state = 83},
  [652] = {.lex_state = 214, .external_lex_state = 9},
  [653] = {.lex_state = 83},
  [654] = {.lex_state = 104},
  [655] = {.lex_state = 214, .external_lex_state = 9},
  [656] = {.lex_state = 83},
  [657] = {.lex_state = 104},
  [658] = {.lex_state = 214, .external_lex_state = 9},
  [659] = {.lex_state = 214, .external_lex_state = 9},
  [660] = {.lex_state = 177, .external_lex_state = 9},
  [661] = {.lex_state = 106},
  [662] = {.lex_state = 104},
  [663] = {.lex_state = 177, .external_lex_state = 9},
  [664] = {.lex_state = 177, .external_lex_state = 9},
  [665] = {.lex_state = 177, .external_lex_state = 9},
  [666] = {.lex_state = 177, .external_lex_state = 9},
  [667] = {.lex_state = 116},
  [668] = {.lex_state = 83},
  [669] = {.lex_state = 83},
  [670] = {.lex_state = 83},
  [671] = {.lex_state = 154, .external_lex_state = 2},
  [672] = {.lex_state = 83},
  [673] = {.lex_state = 160, .external_lex_state = 2},
  [674] = {.lex_state = 83},
  [675] = {.lex_state = 154, .external_lex_state = 2},
  [676] = {.lex_state = 140, .external_lex_state = 6},
  [677] = {.lex_state = 177},
  [678] = {.lex_state = 140, .external_lex_state = 14},
  [679] = {.lex_state = 140, .external_lex_state = 14},
  [680] = {.lex_state = 127, .external_lex_state = 14},
  [681] = {.lex_state = 83},
  [682] = {.lex_state = 83},
  [683] = {.lex_state = 140, .external_lex_state = 14},
  [684] = {.lex_state = 83},
  [685] = {.lex_state = 104},
  [686] = {.lex_state = 140, .external_lex_state = 14},
  [687] = {.lex_state = 83},
  [688] = {.lex_state = 104},
  [689] = {.lex_state = 140, .external_lex_state = 14},
  [690] = {.lex_state = 140, .external_lex_state = 14},
  [691] = {.lex_state = 217, .external_lex_state = 8},
  [692] = {.lex_state = 106},
  [693] = {.lex_state = 104},
  [694] = {.lex_state = 217, .external_lex_state = 8},
  [695] = {.lex_state = 217, .external_lex_state = 8},
  [696] = {.lex_state = 217, .external_lex_state = 8},
  [697] = {.lex_state = 217, .external_lex_state = 8},
  [698] = {.lex_state = 116},
  [699] = {.lex_state = 83},
  [700] = {.lex_state = 83},
  [701] = {.lex_state = 83},
  [702] = {.lex_state = 154, .external_lex_state = 2},
  [703] = {.lex_state = 83},
  [704] = {.lex_state = 160, .external_lex_state = 2},
  [705] = {.lex_state = 83},
  [706] = {.lex_state = 154, .external_lex_state = 2},
  [707] = {.lex_state = 83},
  [708] = {.lex_state = 217, .external_lex_state = 4},
  [709] = {.lex_state = 179, .external_lex_state = 2},
  [710] = {.lex_state = 124, .external_lex_state = 4},
  [711] = {.lex_state = 179, .external_lex_state = 2},
  [712] = {.lex_state = 83},
  [713] = {.lex_state = 219, .external_lex_state = 2},
  [714] = {.lex_state = 124, .external_lex_state = 4},
  [715] = {.lex_state = 127, .external_lex_state = 6},
  [716] = {.lex_state = 219, .external_lex_state = 2},
  [717] = {.lex_state = 185, .external_lex_state = 2},
  [718] = {.lex_state = 124, .external_lex_state = 4},
  [719] = {.lex_state = 83},
  [720] = {.lex_state = 185, .external_lex_state = 2},
  [721] = {.lex_state = 83},
  [722] = {.lex_state = 83},
  [723] = {.lex_state = 124, .external_lex_state = 4},
  [724] = {.lex_state = 233, .external_lex_state = 9},
  [725] = {.lex_state = 221},
  [726] = {.lex_state = 214},
  [727] = {.lex_state = 221},
  [728] = {.lex_state = 221},
  [729] = {.lex_state = 135, .external_lex_state = 8},
  [730] = {.lex_state = 83},
  [731] = {.lex_state = 135, .external_lex_state = 8},
  [732] = {.lex_state = 83},
  [733] = {.lex_state = 83},
  [734] = {.lex_state = 227, .external_lex_state = 9},
  [735] = {.lex_state = 83},
  [736] = {.lex_state = 83},
  [737] = {.lex_state = 227, .external_lex_state = 9},
  [738] = {.lex_state = 83},
  [739] = {.lex_state = 164, .external_lex_state = 5},
  [740] = {.lex_state = 140, .external_lex_state = 14},
  [741] = {.lex_state = 83},
  [742] = {.lex_state = 195, .external_lex_state = 5},
  [743] = {.lex_state = 104},
  [744] = {.lex_state = 124, .external_lex_state = 8},
  [745] = {.lex_state = 170, .external_lex_state = 3},
  [746] = {.lex_state = 170, .external_lex_state = 3},
  [747] = {.lex_state = 124, .external_lex_state = 4},
  [748] = {.lex_state = 170, .external_lex_state = 5},
  [749] = {.lex_state = 199, .external_lex_state = 9},
  [750] = {.lex_state = 83},
  [751] = {.lex_state = 199, .external_lex_state = 9},
  [752] = {.lex_state = 83},
  [753] = {.lex_state = 83},
  [754] = {.lex_state = 227, .external_lex_state = 9},
  [755] = {.lex_state = 83},
  [756] = {.lex_state = 83},
  [757] = {.lex_state = 227, .external_lex_state = 9},
  [758] = {.lex_state = 83},
  [759] = {.lex_state = 145, .external_lex_state = 9},
  [760] = {.lex_state = 83},
  [761] = {.lex_state = 145, .external_lex_state = 9},
  [762] = {.lex_state = 83},
  [763] = {.lex_state = 83},
  [764] = {.lex_state = 227, .external_lex_state = 9},
  [765] = {.lex_state = 83},
  [766] = {.lex_state = 83},
  [767] = {.lex_state = 227, .external_lex_state = 9},
  [768] = {.lex_state = 83},
  [769] = {.lex_state = 104, .external_lex_state = 10},
  [770] = {.lex_state = 83},
  [771] = {.lex_state = 104, .external_lex_state = 10},
  [772] = {.lex_state = 83},
  [773] = {.lex_state = 83},
  [774] = {.lex_state = 227, .external_lex_state = 9},
  [775] = {.lex_state = 83},
  [776] = {.lex_state = 83},
  [777] = {.lex_state = 227, .external_lex_state = 9},
  [778] = {.lex_state = 83},
  [779] = {.lex_state = 106},
  [780] = {.lex_state = 83},
  [781] = {.lex_state = 106},
  [782] = {.lex_state = 83},
  [783] = {.lex_state = 83},
  [784] = {.lex_state = 227, .external_lex_state = 9},
  [785] = {.lex_state = 83},
  [786] = {.lex_state = 83},
  [787] = {.lex_state = 227, .external_lex_state = 9},
  [788] = {.lex_state = 83},
  [789] = {.lex_state = 83},
  [790] = {.lex_state = 83},
  [791] = {.lex_state = 83},
  [792] = {.lex_state = 129, .external_lex_state = 3},
  [793] = {.lex_state = 227, .external_lex_state = 9},
  [794] = {.lex_state = 83},
  [795] = {.lex_state = 129, .external_lex_state = 3},
  [796] = {.lex_state = 154, .external_lex_state = 2},
  [797] = {.lex_state = 177},
  [798] = {.lex_state = 154, .external_lex_state = 10},
  [799] = {.lex_state = 106},
  [800] = {.lex_state = 104},
  [801] = {.lex_state = 154, .external_lex_state = 10},
  [802] = {.lex_state = 154, .external_lex_state = 10},
  [803] = {.lex_state = 154, .external_lex_state = 10},
  [804] = {.lex_state = 154, .external_lex_state = 10},
  [805] = {.lex_state = 116},
  [806] = {.lex_state = 83},
  [807] = {.lex_state = 83},
  [808] = {.lex_state = 83},
  [809] = {.lex_state = 154, .external_lex_state = 2},
  [810] = {.lex_state = 83},
  [811] = {.lex_state = 160, .external_lex_state = 2},
  [812] = {.lex_state = 83},
  [813] = {.lex_state = 154, .external_lex_state = 2},
  [814] = {.lex_state = 217, .external_lex_state = 4},
  [815] = {.lex_state = 83},
  [816] = {.lex_state = 179, .external_lex_state = 2},
  [817] = {.lex_state = 83},
  [818] = {.lex_state = 83},
  [819] = {.lex_state = 185, .external_lex_state = 2},
  [820] = {.lex_state = 83},
  [821] = {.lex_state = 221},
  [822] = {.lex_state = 135, .external_lex_state = 4},
  [823] = {.lex_state = 83},
  [824] = {.lex_state = 83},
  [825] = {.lex_state = 83},
  [826] = {.lex_state = 197, .external_lex_state = 2},
  [827] = {.lex_state = 149, .external_lex_state = 11},
  [828] = {.lex_state = 83},
  [829] = {.lex_state = 149, .external_lex_state = 11},
  [830] = {.lex_state = 83},
  [831] = {.lex_state = 83},
  [832] = {.lex_state = 227, .external_lex_state = 9},
  [833] = {.lex_state = 83},
  [834] = {.lex_state = 83},
  [835] = {.lex_state = 227, .external_lex_state = 9},
  [836] = {.lex_state = 83},
  [837] = {.lex_state = 201, .external_lex_state = 12},
  [838] = {.lex_state = 229, .external_lex_state = 12},
  [839] = {.lex_state = 104},
  [840] = {.lex_state = 106},
  [841] = {.lex_state = 235, .external_lex_state = 9},
  [842] = {.lex_state = 116},
  [843] = {.lex_state = 116},
  [844] = {.lex_state = 53, .external_lex_state = 2},
  [845] = {.lex_state = 53, .external_lex_state = 2},
  [846] = {.lex_state = 53, .external_lex_state = 2},
  [847] = {.lex_state = 83},
  [848] = {.lex_state = 205, .external_lex_state = 11},
  [849] = {.lex_state = 203, .external_lex_state = 12},
  [850] = {.lex_state = 203, .external_lex_state = 11},
  [851] = {.lex_state = 106},
  [852] = {.lex_state = 104},
  [853] = {.lex_state = 205, .external_lex_state = 11},
  [854] = {.lex_state = 203, .external_lex_state = 11},
  [855] = {.lex_state = 203, .external_lex_state = 11},
  [856] = {.lex_state = 203, .external_lex_state = 11},
  [857] = {.lex_state = 116},
  [858] = {.lex_state = 83},
  [859] = {.lex_state = 83},
  [860] = {.lex_state = 83},
  [861] = {.lex_state = 154, .external_lex_state = 2},
  [862] = {.lex_state = 83},
  [863] = {.lex_state = 160, .external_lex_state = 2},
  [864] = {.lex_state = 83},
  [865] = {.lex_state = 154, .external_lex_state = 2},
  [866] = {.lex_state = 203, .external_lex_state = 12},
  [867] = {.lex_state = 211, .external_lex_state = 15},
  [868] = {.lex_state = 205, .external_lex_state = 12},
  [869] = {.lex_state = 160, .external_lex_state = 10},
  [870] = {.lex_state = 83},
  [871] = {.lex_state = 207, .external_lex_state = 12},
  [872] = {.lex_state = 104},
  [873] = {.lex_state = 237, .external_lex_state = 9},
  [874] = {.lex_state = 209, .external_lex_state = 11},
  [875] = {.lex_state = 209, .external_lex_state = 11},
  [876] = {.lex_state = 209, .external_lex_state = 12},
  [877] = {.lex_state = 124, .external_lex_state = 4},
  [878] = {.lex_state = 231, .external_lex_state = 8},
  [879] = {.lex_state = 124, .external_lex_state = 4},
  [880] = {.lex_state = 124, .external_lex_state = 8},
  [881] = {.lex_state = 106},
  [882] = {.lex_state = 104},
  [883] = {.lex_state = 231, .external_lex_state = 8},
  [884] = {.lex_state = 124, .external_lex_state = 8},
  [885] = {.lex_state = 124, .external_lex_state = 8},
  [886] = {.lex_state = 124, .external_lex_state = 8},
  [887] = {.lex_state = 116},
  [888] = {.lex_state = 83},
  [889] = {.lex_state = 83},
  [890] = {.lex_state = 83},
  [891] = {.lex_state = 154, .external_lex_state = 2},
  [892] = {.lex_state = 83},
  [893] = {.lex_state = 160, .external_lex_state = 2},
  [894] = {.lex_state = 83},
  [895] = {.lex_state = 154, .external_lex_state = 2},
  [896] = {.lex_state = 170, .external_lex_state = 3},
  [897] = {.lex_state = 170, .external_lex_state = 3},
  [898] = {.lex_state = 173, .external_lex_state = 3},
  [899] = {.lex_state = 83},
  [900] = {.lex_state = 83},
  [901] = {.lex_state = 170, .external_lex_state = 3},
  [902] = {.lex_state = 83},
  [903] = {.lex_state = 104},
  [904] = {.lex_state = 170, .external_lex_state = 3},
  [905] = {.lex_state = 83},
  [906] = {.lex_state = 104},
  [907] = {.lex_state = 170, .external_lex_state = 3},
  [908] = {.lex_state = 170, .external_lex_state = 3},
  [909] = {.lex_state = 211, .external_lex_state = 15},
  [910] = {.lex_state = 211, .external_lex_state = 15},
  [911] = {.lex_state = 211, .external_lex_state = 15},
  [912] = {.lex_state = 116},
  [913] = {.lex_state = 83},
  [914] = {.lex_state = 83},
  [915] = {.lex_state = 170, .external_lex_state = 5},
  [916] = {.lex_state = 211, .external_lex_state = 15},
  [917] = {.lex_state = 104, .external_lex_state = 2},
  [918] = {.lex_state = 177},
  [919] = {.lex_state = 214, .external_lex_state = 9},
  [920] = {.lex_state = 83},
  [921] = {.lex_state = 214, .external_lex_state = 9},
  [922] = {.lex_state = 83},
  [923] = {.lex_state = 83},
  [924] = {.lex_state = 227, .external_lex_state = 9},
  [925] = {.lex_state = 83},
  [926] = {.lex_state = 83},
  [927] = {.lex_state = 227, .external_lex_state = 9},
  [928] = {.lex_state = 83},
  [929] = {.lex_state = 177, .external_lex_state = 9},
  [930] = {.lex_state = 177, .external_lex_state = 9},
  [931] = {.lex_state = 177, .external_lex_state = 9},
  [932] = {.lex_state = 83},
  [933] = {.lex_state = 83},
  [934] = {.lex_state = 177, .external_lex_state = 9},
  [935] = {.lex_state = 83},
  [936] = {.lex_state = 104},
  [937] = {.lex_state = 177, .external_lex_state = 9},
  [938] = {.lex_state = 83},
  [939] = {.lex_state = 104},
  [940] = {.lex_state = 177, .external_lex_state = 9},
  [941] = {.lex_state = 177, .external_lex_state = 9},
  [942] = {.lex_state = 140, .external_lex_state = 14},
  [943] = {.lex_state = 83},
  [944] = {.lex_state = 140, .external_lex_state = 14},
  [945] = {.lex_state = 83},
  [946] = {.lex_state = 83},
  [947] = {.lex_state = 227, .external_lex_state = 9},
  [948] = {.lex_state = 83},
  [949] = {.lex_state = 83},
  [950] = {.lex_state = 227, .external_lex_state = 9},
  [951] = {.lex_state = 83},
  [952] = {.lex_state = 217, .external_lex_state = 8},
  [953] = {.lex_state = 217, .external_lex_state = 8},
  [954] = {.lex_state = 217, .external_lex_state = 8},
  [955] = {.lex_state = 83},
  [956] = {.lex_state = 83},
  [957] = {.lex_state = 217, .external_lex_state = 8},
  [958] = {.lex_state = 83},
  [959] = {.lex_state = 104},
  [960] = {.lex_state = 217, .external_lex_state = 8},
  [961] = {.lex_state = 83},
  [962] = {.lex_state = 104},
  [963] = {.lex_state = 217, .external_lex_state = 8},
  [964] = {.lex_state = 217, .external_lex_state = 8},
  [965] = {.lex_state = 124, .external_lex_state = 4},
  [966] = {.lex_state = 185, .external_lex_state = 2},
  [967] = {.lex_state = 219, .external_lex_state = 2},
  [968] = {.lex_state = 219, .external_lex_state = 2},
  [969] = {.lex_state = 124, .external_lex_state = 4},
  [970] = {.lex_state = 83},
  [971] = {.lex_state = 104},
  [972] = {.lex_state = 239, .external_lex_state = 2},
  [973] = {.lex_state = 214},
  [974] = {.lex_state = 233, .external_lex_state = 9},
  [975] = {.lex_state = 124, .external_lex_state = 4},
  [976] = {.lex_state = 221},
  [977] = {.lex_state = 221},
  [978] = {.lex_state = 83},
  [979] = {.lex_state = 83},
  [980] = {.lex_state = 83},
  [981] = {.lex_state = 135, .external_lex_state = 8},
  [982] = {.lex_state = 83},
  [983] = {.lex_state = 135, .external_lex_state = 8},
  [984] = {.lex_state = 124, .external_lex_state = 4},
  [985] = {.lex_state = 140, .external_lex_state = 14},
  [986] = {.lex_state = 195, .external_lex_state = 5},
  [987] = {.lex_state = 124, .external_lex_state = 8},
  [988] = {.lex_state = 124, .external_lex_state = 8},
  [989] = {.lex_state = 170, .external_lex_state = 3},
  [990] = {.lex_state = 83},
  [991] = {.lex_state = 83},
  [992] = {.lex_state = 83},
  [993] = {.lex_state = 199, .external_lex_state = 9},
  [994] = {.lex_state = 83},
  [995] = {.lex_state = 199, .external_lex_state = 9},
  [996] = {.lex_state = 83},
  [997] = {.lex_state = 83},
  [998] = {.lex_state = 83},
  [999] = {.lex_state = 145, .external_lex_state = 9},
  [1000] = {.lex_state = 83},
  [1001] = {.lex_state = 145, .external_lex_state = 9},
  [1002] = {.lex_state = 83},
  [1003] = {.lex_state = 83},
  [1004] = {.lex_state = 83},
  [1005] = {.lex_state = 104, .external_lex_state = 10},
  [1006] = {.lex_state = 83},
  [1007] = {.lex_state = 104, .external_lex_state = 10},
  [1008] = {.lex_state = 83},
  [1009] = {.lex_state = 83},
  [1010] = {.lex_state = 83},
  [1011] = {.lex_state = 106},
  [1012] = {.lex_state = 83},
  [1013] = {.lex_state = 106},
  [1014] = {.lex_state = 83},
  [1015] = {.lex_state = 83},
  [1016] = {.lex_state = 129, .external_lex_state = 3},
  [1017] = {.lex_state = 227, .external_lex_state = 9},
  [1018] = {.lex_state = 129, .external_lex_state = 3},
  [1019] = {.lex_state = 154, .external_lex_state = 2},
  [1020] = {.lex_state = 154, .external_lex_state = 10},
  [1021] = {.lex_state = 154, .external_lex_state = 10},
  [1022] = {.lex_state = 154, .external_lex_state = 10},
  [1023] = {.lex_state = 83},
  [1024] = {.lex_state = 83},
  [1025] = {.lex_state = 154, .external_lex_state = 10},
  [1026] = {.lex_state = 83},
  [1027] = {.lex_state = 104},
  [1028] = {.lex_state = 154, .external_lex_state = 10},
  [1029] = {.lex_state = 83},
  [1030] = {.lex_state = 104},
  [1031] = {.lex_state = 154, .external_lex_state = 10},
  [1032] = {.lex_state = 154, .external_lex_state = 10},
  [1033] = {.lex_state = 83},
  [1034] = {.lex_state = 83},
  [1035] = {.lex_state = 83},
  [1036] = {.lex_state = 83},
  [1037] = {.lex_state = 83},
  [1038] = {.lex_state = 83},
  [1039] = {.lex_state = 221},
  [1040] = {.lex_state = 221},
  [1041] = {.lex_state = 201, .external_lex_state = 12},
  [1042] = {.lex_state = 83},
  [1043] = {.lex_state = 83},
  [1044] = {.lex_state = 83},
  [1045] = {.lex_state = 83},
  [1046] = {.lex_state = 149, .external_lex_state = 11},
  [1047] = {.lex_state = 83},
  [1048] = {.lex_state = 149, .external_lex_state = 11},
  [1049] = {.lex_state = 83},
  [1050] = {.lex_state = 235, .external_lex_state = 9},
  [1051] = {.lex_state = 83},
  [1052] = {.lex_state = 241, .external_lex_state = 9},
  [1053] = {.lex_state = 106},
  [1054] = {.lex_state = 104},
  [1055] = {.lex_state = 235, .external_lex_state = 9},
  [1056] = {.lex_state = 241, .external_lex_state = 9},
  [1057] = {.lex_state = 241, .external_lex_state = 9},
  [1058] = {.lex_state = 241, .external_lex_state = 9},
  [1059] = {.lex_state = 116},
  [1060] = {.lex_state = 83},
  [1061] = {.lex_state = 83},
  [1062] = {.lex_state = 83},
  [1063] = {.lex_state = 154, .external_lex_state = 2},
  [1064] = {.lex_state = 83},
  [1065] = {.lex_state = 160, .external_lex_state = 2},
  [1066] = {.lex_state = 83},
  [1067] = {.lex_state = 154, .external_lex_state = 2},
  [1068] = {.lex_state = 203, .external_lex_state = 11},
  [1069] = {.lex_state = 203, .external_lex_state = 11},
  [1070] = {.lex_state = 205, .external_lex_state = 11},
  [1071] = {.lex_state = 83},
  [1072] = {.lex_state = 83},
  [1073] = {.lex_state = 203, .external_lex_state = 11},
  [1074] = {.lex_state = 83},
  [1075] = {.lex_state = 104},
  [1076] = {.lex_state = 203, .external_lex_state = 11},
  [1077] = {.lex_state = 83},
  [1078] = {.lex_state = 104},
  [1079] = {.lex_state = 203, .external_lex_state = 11},
  [1080] = {.lex_state = 203, .external_lex_state = 11},
  [1081] = {.lex_state = 203, .external_lex_state = 12},
  [1082] = {.lex_state = 160, .external_lex_state = 10},
  [1083] = {.lex_state = 207, .external_lex_state = 12},
  [1084] = {.lex_state = 237, .external_lex_state = 9},
  [1085] = {.lex_state = 237, .external_lex_state = 9},
  [1086] = {.lex_state = 209, .external_lex_state = 11},
  [1087] = {.lex_state = 124, .external_lex_state = 8},
  [1088] = {.lex_state = 124, .external_lex_state = 8},
  [1089] = {.lex_state = 231, .external_lex_state = 8},
  [1090] = {.lex_state = 83},
  [1091] = {.lex_state = 83},
  [1092] = {.lex_state = 124, .external_lex_state = 8},
  [1093] = {.lex_state = 83},
  [1094] = {.lex_state = 104},
  [1095] = {.lex_state = 124, .external_lex_state = 8},
  [1096] = {.lex_state = 83},
  [1097] = {.lex_state = 104},
  [1098] = {.lex_state = 124, .external_lex_state = 8},
  [1099] = {.lex_state = 124, .external_lex_state = 8},
  [1100] = {.lex_state = 170, .external_lex_state = 3},
  [1101] = {.lex_state = 83},
  [1102] = {.lex_state = 170, .external_lex_state = 3},
  [1103] = {.lex_state = 83},
  [1104] = {.lex_state = 83},
  [1105] = {.lex_state = 227, .external_lex_state = 9},
  [1106] = {.lex_state = 83},
  [1107] = {.lex_state = 83},
  [1108] = {.lex_state = 227, .external_lex_state = 9},
  [1109] = {.lex_state = 83},
  [1110] = {.lex_state = 83},
  [1111] = {.lex_state = 83},
  [1112] = {.lex_state = 211, .external_lex_state = 15},
  [1113] = {.lex_state = 83},
  [1114] = {.lex_state = 104},
  [1115] = {.lex_state = 211, .external_lex_state = 15},
  [1116] = {.lex_state = 83},
  [1117] = {.lex_state = 104},
  [1118] = {.lex_state = 104, .external_lex_state = 2},
  [1119] = {.lex_state = 83},
  [1120] = {.lex_state = 83},
  [1121] = {.lex_state = 83},
  [1122] = {.lex_state = 214, .external_lex_state = 9},
  [1123] = {.lex_state = 83},
  [1124] = {.lex_state = 214, .external_lex_state = 9},
  [1125] = {.lex_state = 177, .external_lex_state = 9},
  [1126] = {.lex_state = 83},
  [1127] = {.lex_state = 177, .external_lex_state = 9},
  [1128] = {.lex_state = 83},
  [1129] = {.lex_state = 83},
  [1130] = {.lex_state = 227, .external_lex_state = 9},
  [1131] = {.lex_state = 83},
  [1132] = {.lex_state = 83},
  [1133] = {.lex_state = 227, .external_lex_state = 9},
  [1134] = {.lex_state = 83},
  [1135] = {.lex_state = 83},
  [1136] = {.lex_state = 83},
  [1137] = {.lex_state = 83},
  [1138] = {.lex_state = 140, .external_lex_state = 14},
  [1139] = {.lex_state = 83},
  [1140] = {.lex_state = 140, .external_lex_state = 14},
  [1141] = {.lex_state = 217, .external_lex_state = 8},
  [1142] = {.lex_state = 83},
  [1143] = {.lex_state = 217, .external_lex_state = 8},
  [1144] = {.lex_state = 83},
  [1145] = {.lex_state = 83},
  [1146] = {.lex_state = 227, .external_lex_state = 9},
  [1147] = {.lex_state = 83},
  [1148] = {.lex_state = 83},
  [1149] = {.lex_state = 227, .external_lex_state = 9},
  [1150] = {.lex_state = 83},
  [1151] = {.lex_state = 185, .external_lex_state = 2},
  [1152] = {.lex_state = 124, .external_lex_state = 4},
  [1153] = {.lex_state = 233, .external_lex_state = 9},
  [1154] = {.lex_state = 214},
  [1155] = {.lex_state = 221},
  [1156] = {.lex_state = 239, .external_lex_state = 2},
  [1157] = {.lex_state = 239, .external_lex_state = 2},
  [1158] = {.lex_state = 214},
  [1159] = {.lex_state = 233, .external_lex_state = 9},
  [1160] = {.lex_state = 124, .external_lex_state = 4},
  [1161] = {.lex_state = 83},
  [1162] = {.lex_state = 83},
  [1163] = {.lex_state = 135, .external_lex_state = 8},
  [1164] = {.lex_state = 135, .external_lex_state = 8},
  [1165] = {.lex_state = 124, .external_lex_state = 8},
  [1166] = {.lex_state = 83},
  [1167] = {.lex_state = 83},
  [1168] = {.lex_state = 199, .external_lex_state = 9},
  [1169] = {.lex_state = 199, .external_lex_state = 9},
  [1170] = {.lex_state = 83},
  [1171] = {.lex_state = 83},
  [1172] = {.lex_state = 145, .external_lex_state = 9},
  [1173] = {.lex_state = 145, .external_lex_state = 9},
  [1174] = {.lex_state = 83},
  [1175] = {.lex_state = 83},
  [1176] = {.lex_state = 104, .external_lex_state = 10},
  [1177] = {.lex_state = 104, .external_lex_state = 10},
  [1178] = {.lex_state = 83},
  [1179] = {.lex_state = 83},
  [1180] = {.lex_state = 106},
  [1181] = {.lex_state = 106},
  [1182] = {.lex_state = 129, .external_lex_state = 3},
  [1183] = {.lex_state = 129, .external_lex_state = 3},
  [1184] = {.lex_state = 154, .external_lex_state = 10},
  [1185] = {.lex_state = 83},
  [1186] = {.lex_state = 154, .external_lex_state = 10},
  [1187] = {.lex_state = 83},
  [1188] = {.lex_state = 83},
  [1189] = {.lex_state = 227, .external_lex_state = 9},
  [1190] = {.lex_state = 83},
  [1191] = {.lex_state = 83},
  [1192] = {.lex_state = 227, .external_lex_state = 9},
  [1193] = {.lex_state = 83},
  [1194] = {.lex_state = 83},
  [1195] = {.lex_state = 83},
  [1196] = {.lex_state = 83},
  [1197] = {.lex_state = 83},
  [1198] = {.lex_state = 221},
  [1199] = {.lex_state = 83},
  [1200] = {.lex_state = 83},
  [1201] = {.lex_state = 83},
  [1202] = {.lex_state = 149, .external_lex_state = 11},
  [1203] = {.lex_state = 149, .external_lex_state = 11},
  [1204] = {.lex_state = 241, .external_lex_state = 9},
  [1205] = {.lex_state = 241, .external_lex_state = 9},
  [1206] = {.lex_state = 235, .external_lex_state = 9},
  [1207] = {.lex_state = 83},
  [1208] = {.lex_state = 83},
  [1209] = {.lex_state = 241, .external_lex_state = 9},
  [1210] = {.lex_state = 83},
  [1211] = {.lex_state = 104},
  [1212] = {.lex_state = 241, .external_lex_state = 9},
  [1213] = {.lex_state = 83},
  [1214] = {.lex_state = 104},
  [1215] = {.lex_state = 241, .external_lex_state = 9},
  [1216] = {.lex_state = 241, .external_lex_state = 9},
  [1217] = {.lex_state = 203, .external_lex_state = 11},
  [1218] = {.lex_state = 83},
  [1219] = {.lex_state = 203, .external_lex_state = 11},
  [1220] = {.lex_state = 83},
  [1221] = {.lex_state = 83},
  [1222] = {.lex_state = 227, .external_lex_state = 9},
  [1223] = {.lex_state = 83},
  [1224] = {.lex_state = 83},
  [1225] = {.lex_state = 227, .external_lex_state = 9},
  [1226] = {.lex_state = 83},
  [1227] = {.lex_state = 237, .external_lex_state = 9},
  [1228] = {.lex_state = 124, .external_lex_state = 8},
  [1229] = {.lex_state = 83},
  [1230] = {.lex_state = 124, .external_lex_state = 8},
  [1231] = {.lex_state = 83},
  [1232] = {.lex_state = 83},
  [1233] = {.lex_state = 227, .external_lex_state = 9},
  [1234] = {.lex_state = 83},
  [1235] = {.lex_state = 83},
  [1236] = {.lex_state = 227, .external_lex_state = 9},
  [1237] = {.lex_state = 83},
  [1238] = {.lex_state = 83},
  [1239] = {.lex_state = 83},
  [1240] = {.lex_state = 83},
  [1241] = {.lex_state = 170, .external_lex_state = 3},
  [1242] = {.lex_state = 83},
  [1243] = {.lex_state = 170, .external_lex_state = 3},
  [1244] = {.lex_state = 211, .external_lex_state = 15},
  [1245] = {.lex_state = 83},
  [1246] = {.lex_state = 211, .external_lex_state = 15},
  [1247] = {.lex_state = 83},
  [1248] = {.lex_state = 83},
  [1249] = {.lex_state = 227, .external_lex_state = 9},
  [1250] = {.lex_state = 83},
  [1251] = {.lex_state = 83},
  [1252] = {.lex_state = 227, .external_lex_state = 9},
  [1253] = {.lex_state = 83},
  [1254] = {.lex_state = 83},
  [1255] = {.lex_state = 83},
  [1256] = {.lex_state = 214, .external_lex_state = 9},
  [1257] = {.lex_state = 214, .external_lex_state = 9},
  [1258] = {.lex_state = 83},
  [1259] = {.lex_state = 83},
  [1260] = {.lex_state = 83},
  [1261] = {.lex_state = 177, .external_lex_state = 9},
  [1262] = {.lex_state = 83},
  [1263] = {.lex_state = 177, .external_lex_state = 9},
  [1264] = {.lex_state = 83},
  [1265] = {.lex_state = 83},
  [1266] = {.lex_state = 140, .external_lex_state = 14},
  [1267] = {.lex_state = 140, .external_lex_state = 14},
  [1268] = {.lex_state = 83},
  [1269] = {.lex_state = 83},
  [1270] = {.lex_state = 83},
  [1271] = {.lex_state = 217, .external_lex_state = 8},
  [1272] = {.lex_state = 83},
  [1273] = {.lex_state = 217, .external_lex_state = 8},
  [1274] = {.lex_state = 221},
  [1275] = {.lex_state = 239, .external_lex_state = 2},
  [1276] = {.lex_state = 239, .external_lex_state = 2},
  [1277] = {.lex_state = 135, .external_lex_state = 8},
  [1278] = {.lex_state = 135, .external_lex_state = 8},
  [1279] = {.lex_state = 199, .external_lex_state = 9},
  [1280] = {.lex_state = 199, .external_lex_state = 9},
  [1281] = {.lex_state = 145, .external_lex_state = 9},
  [1282] = {.lex_state = 145, .external_lex_state = 9},
  [1283] = {.lex_state = 104, .external_lex_state = 10},
  [1284] = {.lex_state = 104, .external_lex_state = 10},
  [1285] = {.lex_state = 106},
  [1286] = {.lex_state = 106},
  [1287] = {.lex_state = 83},
  [1288] = {.lex_state = 83},
  [1289] = {.lex_state = 83},
  [1290] = {.lex_state = 154, .external_lex_state = 10},
  [1291] = {.lex_state = 83},
  [1292] = {.lex_state = 154, .external_lex_state = 10},
  [1293] = {.lex_state = 83},
  [1294] = {.lex_state = 83},
  [1295] = {.lex_state = 149, .external_lex_state = 11},
  [1296] = {.lex_state = 149, .external_lex_state = 11},
  [1297] = {.lex_state = 241, .external_lex_state = 9},
  [1298] = {.lex_state = 83},
  [1299] = {.lex_state = 241, .external_lex_state = 9},
  [1300] = {.lex_state = 83},
  [1301] = {.lex_state = 83},
  [1302] = {.lex_state = 227, .external_lex_state = 9},
  [1303] = {.lex_state = 83},
  [1304] = {.lex_state = 83},
  [1305] = {.lex_state = 227, .external_lex_state = 9},
  [1306] = {.lex_state = 83},
  [1307] = {.lex_state = 83},
  [1308] = {.lex_state = 83},
  [1309] = {.lex_state = 83},
  [1310] = {.lex_state = 203, .external_lex_state = 11},
  [1311] = {.lex_state = 83},
  [1312] = {.lex_state = 203, .external_lex_state = 11},
  [1313] = {.lex_state = 83},
  [1314] = {.lex_state = 83},
  [1315] = {.lex_state = 83},
  [1316] = {.lex_state = 124, .external_lex_state = 8},
  [1317] = {.lex_state = 83},
  [1318] = {.lex_state = 124, .external_lex_state = 8},
  [1319] = {.lex_state = 83},
  [1320] = {.lex_state = 83},
  [1321] = {.lex_state = 170, .external_lex_state = 3},
  [1322] = {.lex_state = 170, .external_lex_state = 3},
  [1323] = {.lex_state = 83},
  [1324] = {.lex_state = 83},
  [1325] = {.lex_state = 83},
  [1326] = {.lex_state = 211, .external_lex_state = 15},
  [1327] = {.lex_state = 83},
  [1328] = {.lex_state = 211, .external_lex_state = 15},
  [1329] = {.lex_state = 214, .external_lex_state = 9},
  [1330] = {.lex_state = 214, .external_lex_state = 9},
  [1331] = {.lex_state = 83},
  [1332] = {.lex_state = 83},
  [1333] = {.lex_state = 177, .external_lex_state = 9},
  [1334] = {.lex_state = 177, .external_lex_state = 9},
  [1335] = {.lex_state = 140, .external_lex_state = 14},
  [1336] = {.lex_state = 140, .external_lex_state = 14},
  [1337] = {.lex_state = 83},
  [1338] = {.lex_state = 83},
  [1339] = {.lex_state = 217, .external_lex_state = 8},
  [1340] = {.lex_state = 217, .external_lex_state = 8},
  [1341] = {.lex_state = 221},
  [1342] = {.lex_state = 83},
  [1343] = {.lex_state = 83},
  [1344] = {.lex_state = 154, .external_lex_state = 10},
  [1345] = {.lex_state = 154, .external_lex_state = 10},
  [1346] = {.lex_state = 83},
  [1347] = {.lex_state = 83},
  [1348] = {.lex_state = 83},
  [1349] = {.lex_state = 241, .external_lex_state = 9},
  [1350] = {.lex_state = 83},
  [1351] = {.lex_state = 241, .external_lex_state = 9},
  [1352] = {.lex_state = 83},
  [1353] = {.lex_state = 83},
  [1354] = {.lex_state = 203, .external_lex_state = 11},
  [1355] = {.lex_state = 203, .external_lex_state = 11},
  [1356] = {.lex_state = 83},
  [1357] = {.lex_state = 83},
  [1358] = {.lex_state = 124, .external_lex_state = 8},
  [1359] = {.lex_state = 124, .external_lex_state = 8},
  [1360] = {.lex_state = 170, .external_lex_state = 3},
  [1361] = {.lex_state = 170, .external_lex_state = 3},
  [1362] = {.lex_state = 83},
  [1363] = {.lex_state = 83},
  [1364] = {.lex_state = 211, .external_lex_state = 15},
  [1365] = {.lex_state = 211, .external_lex_state = 15},
  [1366] = {.lex_state = 177, .external_lex_state = 9},
  [1367] = {.lex_state = 177, .external_lex_state = 9},
  [1368] = {.lex_state = 217, .external_lex_state = 8},
  [1369] = {.lex_state = 217, .external_lex_state = 8},
  [1370] = {.lex_state = 154, .external_lex_state = 10},
  [1371] = {.lex_state = 154, .external_lex_state = 10},
  [1372] = {.lex_state = 83},
  [1373] = {.lex_state = 83},
  [1374] = {.lex_state = 241, .external_lex_state = 9},
  [1375] = {.lex_state = 241, .external_lex_state = 9},
  [1376] = {.lex_state = 203, .external_lex_state = 11},
  [1377] = {.lex_state = 203, .external_lex_state = 11},
  [1378] = {.lex_state = 124, .external_lex_state = 8},
  [1379] = {.lex_state = 124, .external_lex_state = 8},
  [1380] = {.lex_state = 211, .external_lex_state = 15},
  [1381] = {.lex_state = 211, .external_lex_state = 15},
  [1382] = {.lex_state = 241, .external_lex_state = 9},
  [1383] = {.lex_state = 241, .external_lex_state = 9},
};

enum {
  ts_external_token__simple_heredoc,
  ts_external_token__heredoc_beginning,
  ts_external_token__heredoc_middle,
  ts_external_token__heredoc_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__simple_heredoc] = sym__simple_heredoc,
  [ts_external_token__heredoc_beginning] = sym__heredoc_beginning,
  [ts_external_token__heredoc_middle] = sym__heredoc_middle,
  [ts_external_token__heredoc_end] = sym__heredoc_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[16][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token__empty_value] = true,
  },
  [8] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__concat] = true,
  },
  [10] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [11] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [12] = {
    [ts_external_token_file_descriptor] = true,
  },
  [13] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
  },
  [14] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__simple_heredoc] = ACTIONS(1),
    [sym__heredoc_beginning] = ACTIONS(1),
    [sym__heredoc_middle] = ACTIONS(1),
    [sym__heredoc_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(5),
    [sym_simple_variable_name] = ACTIONS(8),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(3),
    [anon_sym__] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(21),
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [ts_builtin_sym_end] = ACTIONS(14),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(54),
    [anon_sym_GT] = ACTIONS(54),
    [anon_sym_GT_GT] = ACTIONS(56),
    [anon_sym_AMP_GT] = ACTIONS(54),
    [anon_sym_AMP_GT_GT] = ACTIONS(56),
    [anon_sym_LT_AMP] = ACTIONS(56),
    [anon_sym_GT_AMP] = ACTIONS(56),
    [sym_comment] = ACTIONS(52),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(58),
    [anon_sym_EQ] = ACTIONS(60),
    [anon_sym_PLUS_EQ] = ACTIONS(60),
    [sym_comment] = ACTIONS(52),
  },
  [4] = {
    [sym_word] = ACTIONS(62),
    [sym_comment] = ACTIONS(52),
  },
  [5] = {
    [sym__terminated_statement] = STATE(35),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [6] = {
    [sym__terminated_statement] = STATE(38),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [7] = {
    [sym_concatenation] = STATE(46),
    [sym_string] = STATE(40),
    [sym_simple_expansion] = STATE(40),
    [sym_expansion] = STATE(40),
    [sym_command_substitution] = STATE(40),
    [sym_process_substitution] = STATE(40),
    [anon_sym_DQUOTE] = ACTIONS(64),
    [sym_raw_string] = ACTIONS(66),
    [anon_sym_DOLLAR] = ACTIONS(68),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(70),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(72),
    [anon_sym_BQUOTE] = ACTIONS(74),
    [anon_sym_LT_LPAREN] = ACTIONS(76),
    [anon_sym_GT_LPAREN] = ACTIONS(76),
    [sym_word] = ACTIONS(78),
    [sym_comment] = ACTIONS(52),
  },
  [8] = {
    [sym_word] = ACTIONS(80),
    [sym_comment] = ACTIONS(52),
  },
  [9] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(52),
    [sym_while_statement] = STATE(52),
    [sym_if_statement] = STATE(52),
    [sym_case_statement] = STATE(52),
    [sym_function_definition] = STATE(52),
    [sym_subshell] = STATE(52),
    [sym_pipeline] = STATE(52),
    [sym_list] = STATE(52),
    [sym_bracket_command] = STATE(52),
    [sym_command] = STATE(52),
    [sym_command_name] = STATE(53),
    [sym_environment_variable_assignment] = STATE(54),
    [sym_subscript] = STATE(55),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(50),
    [sym_simple_expansion] = STATE(50),
    [sym_expansion] = STATE(50),
    [sym_command_substitution] = STATE(50),
    [sym_process_substitution] = STATE(50),
    [aux_sym_program_repeat1] = STATE(56),
    [aux_sym_command_repeat1] = STATE(57),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(88),
    [sym_comment] = ACTIONS(52),
  },
  [10] = {
    [sym_concatenation] = STATE(65),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_for_statement_repeat1] = STATE(66),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(92),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(104),
    [sym_comment] = ACTIONS(52),
  },
  [11] = {
    [sym_concatenation] = STATE(74),
    [sym_string] = STATE(68),
    [sym_simple_expansion] = STATE(68),
    [sym_expansion] = STATE(68),
    [sym_command_substitution] = STATE(68),
    [sym_process_substitution] = STATE(68),
    [aux_sym_for_statement_repeat1] = STATE(75),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(108),
    [anon_sym_DOLLAR] = ACTIONS(110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(114),
    [anon_sym_BQUOTE] = ACTIONS(116),
    [anon_sym_LT_LPAREN] = ACTIONS(118),
    [anon_sym_GT_LPAREN] = ACTIONS(118),
    [sym_word] = ACTIONS(120),
    [sym_comment] = ACTIONS(52),
  },
  [12] = {
    [sym_concatenation] = STATE(83),
    [sym_string] = STATE(77),
    [sym_simple_expansion] = STATE(77),
    [sym_expansion] = STATE(77),
    [sym_command_substitution] = STATE(77),
    [sym_process_substitution] = STATE(77),
    [anon_sym_DQUOTE] = ACTIONS(122),
    [sym_raw_string] = ACTIONS(124),
    [anon_sym_DOLLAR] = ACTIONS(126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(130),
    [anon_sym_BQUOTE] = ACTIONS(132),
    [anon_sym_LT_LPAREN] = ACTIONS(134),
    [anon_sym_GT_LPAREN] = ACTIONS(134),
    [sym_word] = ACTIONS(136),
    [sym_comment] = ACTIONS(52),
  },
  [13] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(90),
    [anon_sym_DQUOTE] = ACTIONS(138),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [14] = {
    [aux_sym_concatenation_repeat1] = STATE(92),
    [sym_file_descriptor] = ACTIONS(152),
    [sym__concat] = ACTIONS(154),
    [anon_sym_PIPE] = ACTIONS(156),
    [anon_sym_SEMI_SEMI] = ACTIONS(156),
    [anon_sym_PIPE_AMP] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(156),
    [anon_sym_PIPE_PIPE] = ACTIONS(156),
    [anon_sym_LT] = ACTIONS(156),
    [anon_sym_GT] = ACTIONS(156),
    [anon_sym_GT_GT] = ACTIONS(156),
    [anon_sym_AMP_GT] = ACTIONS(156),
    [anon_sym_AMP_GT_GT] = ACTIONS(156),
    [anon_sym_LT_AMP] = ACTIONS(156),
    [anon_sym_GT_AMP] = ACTIONS(156),
    [anon_sym_LT_LT] = ACTIONS(156),
    [anon_sym_LT_LT_DASH] = ACTIONS(156),
    [anon_sym_DQUOTE] = ACTIONS(156),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR] = ACTIONS(156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(156),
    [anon_sym_BQUOTE] = ACTIONS(156),
    [anon_sym_LT_LPAREN] = ACTIONS(156),
    [anon_sym_GT_LPAREN] = ACTIONS(156),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(156),
    [anon_sym_LF] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(156),
  },
  [15] = {
    [sym_special_variable_name] = STATE(95),
    [anon_sym_DOLLAR] = ACTIONS(158),
    [anon_sym_POUND] = ACTIONS(158),
    [anon_sym_AT] = ACTIONS(158),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(160),
    [anon_sym_STAR] = ACTIONS(158),
    [anon_sym_QMARK] = ACTIONS(158),
    [anon_sym_DASH] = ACTIONS(158),
    [anon_sym_BANG] = ACTIONS(158),
    [anon_sym_0] = ACTIONS(162),
    [anon_sym__] = ACTIONS(162),
  },
  [16] = {
    [sym_special_variable_name] = STATE(99),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(166),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(168),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [17] = {
    [sym_for_statement] = STATE(117),
    [sym_while_statement] = STATE(117),
    [sym_if_statement] = STATE(117),
    [sym_case_statement] = STATE(117),
    [sym_function_definition] = STATE(117),
    [sym_subshell] = STATE(117),
    [sym_pipeline] = STATE(117),
    [sym_list] = STATE(117),
    [sym_bracket_command] = STATE(117),
    [sym_command] = STATE(117),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(119),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [18] = {
    [sym_for_statement] = STATE(127),
    [sym_while_statement] = STATE(127),
    [sym_if_statement] = STATE(127),
    [sym_case_statement] = STATE(127),
    [sym_function_definition] = STATE(127),
    [sym_subshell] = STATE(127),
    [sym_pipeline] = STATE(127),
    [sym_list] = STATE(127),
    [sym_bracket_command] = STATE(127),
    [sym_command] = STATE(127),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(129),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [19] = {
    [sym_for_statement] = STATE(132),
    [sym_while_statement] = STATE(132),
    [sym_if_statement] = STATE(132),
    [sym_case_statement] = STATE(132),
    [sym_function_definition] = STATE(132),
    [sym_subshell] = STATE(132),
    [sym_pipeline] = STATE(132),
    [sym_list] = STATE(132),
    [sym_bracket_command] = STATE(132),
    [sym_command] = STATE(132),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(133),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [20] = {
    [sym_compound_statement] = STATE(136),
    [aux_sym_concatenation_repeat1] = STATE(92),
    [sym_file_descriptor] = ACTIONS(152),
    [sym__concat] = ACTIONS(154),
    [anon_sym_PIPE] = ACTIONS(156),
    [anon_sym_SEMI_SEMI] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(216),
    [anon_sym_PIPE_AMP] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(156),
    [anon_sym_PIPE_PIPE] = ACTIONS(156),
    [anon_sym_LT] = ACTIONS(156),
    [anon_sym_GT] = ACTIONS(156),
    [anon_sym_GT_GT] = ACTIONS(156),
    [anon_sym_AMP_GT] = ACTIONS(156),
    [anon_sym_AMP_GT_GT] = ACTIONS(156),
    [anon_sym_LT_AMP] = ACTIONS(156),
    [anon_sym_GT_AMP] = ACTIONS(156),
    [anon_sym_LT_LT] = ACTIONS(156),
    [anon_sym_LT_LT_DASH] = ACTIONS(156),
    [anon_sym_DQUOTE] = ACTIONS(156),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR] = ACTIONS(156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(156),
    [anon_sym_BQUOTE] = ACTIONS(156),
    [anon_sym_LT_LPAREN] = ACTIONS(156),
    [anon_sym_GT_LPAREN] = ACTIONS(156),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(156),
    [anon_sym_LF] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(156),
  },
  [21] = {
    [ts_builtin_sym_end] = ACTIONS(218),
    [sym_comment] = ACTIONS(52),
  },
  [22] = {
    [sym_file_descriptor] = ACTIONS(220),
    [sym_variable_name] = ACTIONS(220),
    [ts_builtin_sym_end] = ACTIONS(220),
    [anon_sym_for] = ACTIONS(222),
    [anon_sym_while] = ACTIONS(222),
    [anon_sym_if] = ACTIONS(222),
    [anon_sym_case] = ACTIONS(222),
    [anon_sym_SEMI_SEMI] = ACTIONS(220),
    [anon_sym_function] = ACTIONS(222),
    [anon_sym_LPAREN] = ACTIONS(220),
    [anon_sym_RBRACE] = ACTIONS(220),
    [anon_sym_LBRACK] = ACTIONS(222),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(222),
    [anon_sym_LT] = ACTIONS(222),
    [anon_sym_GT] = ACTIONS(222),
    [anon_sym_GT_GT] = ACTIONS(220),
    [anon_sym_AMP_GT] = ACTIONS(222),
    [anon_sym_AMP_GT_GT] = ACTIONS(220),
    [anon_sym_LT_AMP] = ACTIONS(220),
    [anon_sym_GT_AMP] = ACTIONS(220),
    [anon_sym_DQUOTE] = ACTIONS(220),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(220),
    [anon_sym_BQUOTE] = ACTIONS(220),
    [anon_sym_LT_LPAREN] = ACTIONS(220),
    [anon_sym_GT_LPAREN] = ACTIONS(220),
    [sym_word] = ACTIONS(224),
    [sym_comment] = ACTIONS(52),
  },
  [23] = {
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(228),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_LF] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(228),
  },
  [24] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(143),
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [sym_process_substitution] = STATE(143),
    [aux_sym_for_statement_repeat1] = STATE(146),
    [aux_sym_command_repeat2] = STATE(147),
    [sym_file_descriptor] = ACTIONS(232),
    [anon_sym_PIPE] = ACTIONS(234),
    [anon_sym_SEMI_SEMI] = ACTIONS(234),
    [anon_sym_PIPE_AMP] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(234),
    [anon_sym_PIPE_PIPE] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [sym_raw_string] = ACTIONS(242),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_word] = ACTIONS(242),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(234),
    [anon_sym_LF] = ACTIONS(234),
    [anon_sym_AMP] = ACTIONS(234),
  },
  [25] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(228),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_LF] = ACTIONS(228),
    [anon_sym_AMP] = ACTIONS(228),
  },
  [26] = {
    [anon_sym_EQ] = ACTIONS(60),
    [anon_sym_PLUS_EQ] = ACTIONS(60),
    [sym_comment] = ACTIONS(52),
  },
  [27] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(258),
    [sym_comment] = ACTIONS(52),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(152),
    [anon_sym_PIPE] = ACTIONS(156),
    [anon_sym_RPAREN] = ACTIONS(156),
    [anon_sym_SEMI_SEMI] = ACTIONS(156),
    [anon_sym_PIPE_AMP] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(156),
    [anon_sym_PIPE_PIPE] = ACTIONS(156),
    [anon_sym_LT] = ACTIONS(156),
    [anon_sym_GT] = ACTIONS(156),
    [anon_sym_GT_GT] = ACTIONS(156),
    [anon_sym_AMP_GT] = ACTIONS(156),
    [anon_sym_AMP_GT_GT] = ACTIONS(156),
    [anon_sym_LT_AMP] = ACTIONS(156),
    [anon_sym_GT_AMP] = ACTIONS(156),
    [anon_sym_LT_LT] = ACTIONS(156),
    [anon_sym_LT_LT_DASH] = ACTIONS(156),
    [anon_sym_DQUOTE] = ACTIONS(156),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR] = ACTIONS(156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(156),
    [anon_sym_BQUOTE] = ACTIONS(156),
    [anon_sym_LT_LPAREN] = ACTIONS(156),
    [anon_sym_GT_LPAREN] = ACTIONS(156),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(156),
    [anon_sym_LF] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(156),
  },
  [29] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(148),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [ts_builtin_sym_end] = ACTIONS(260),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [30] = {
    [sym_command_name] = STATE(150),
    [sym_environment_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(151),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(152),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(264),
    [sym_comment] = ACTIONS(52),
  },
  [31] = {
    [sym_concatenation] = STATE(154),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [anon_sym_DQUOTE] = ACTIONS(122),
    [sym_raw_string] = ACTIONS(266),
    [anon_sym_DOLLAR] = ACTIONS(126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(130),
    [anon_sym_BQUOTE] = ACTIONS(132),
    [anon_sym_LT_LPAREN] = ACTIONS(134),
    [anon_sym_GT_LPAREN] = ACTIONS(134),
    [sym_word] = ACTIONS(268),
    [sym_comment] = ACTIONS(52),
  },
  [32] = {
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(156),
    [sym_simple_expansion] = STATE(156),
    [sym_expansion] = STATE(156),
    [sym_command_substitution] = STATE(156),
    [sym_process_substitution] = STATE(156),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(272),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(284),
    [sym_comment] = ACTIONS(52),
  },
  [33] = {
    [sym_concatenation] = STATE(163),
    [sym_string] = STATE(166),
    [sym_array] = STATE(163),
    [sym_simple_expansion] = STATE(166),
    [sym_expansion] = STATE(166),
    [sym_command_substitution] = STATE(166),
    [sym_process_substitution] = STATE(166),
    [sym__empty_value] = ACTIONS(286),
    [anon_sym_LPAREN] = ACTIONS(288),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(298),
    [anon_sym_BQUOTE] = ACTIONS(300),
    [anon_sym_LT_LPAREN] = ACTIONS(302),
    [anon_sym_GT_LPAREN] = ACTIONS(302),
    [sym_word] = ACTIONS(304),
    [sym_comment] = ACTIONS(52),
  },
  [34] = {
    [anon_sym_in] = ACTIONS(306),
    [sym_comment] = ACTIONS(52),
  },
  [35] = {
    [sym_do_group] = STATE(174),
    [anon_sym_do] = ACTIONS(308),
    [sym_comment] = ACTIONS(52),
  },
  [36] = {
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(310),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
  },
  [37] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(310),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_LF] = ACTIONS(310),
    [anon_sym_AMP] = ACTIONS(310),
  },
  [38] = {
    [anon_sym_then] = ACTIONS(312),
    [sym_comment] = ACTIONS(52),
  },
  [39] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(178),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [40] = {
    [aux_sym_concatenation_repeat1] = STATE(182),
    [sym__concat] = ACTIONS(316),
    [anon_sym_in] = ACTIONS(318),
    [anon_sym_SEMI_SEMI] = ACTIONS(320),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(320),
  },
  [41] = {
    [sym_special_variable_name] = STATE(185),
    [anon_sym_DOLLAR] = ACTIONS(322),
    [anon_sym_POUND] = ACTIONS(322),
    [anon_sym_AT] = ACTIONS(322),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(324),
    [anon_sym_STAR] = ACTIONS(322),
    [anon_sym_QMARK] = ACTIONS(322),
    [anon_sym_DASH] = ACTIONS(322),
    [anon_sym_BANG] = ACTIONS(322),
    [anon_sym_0] = ACTIONS(326),
    [anon_sym__] = ACTIONS(326),
  },
  [42] = {
    [sym_special_variable_name] = STATE(188),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(328),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(330),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [43] = {
    [sym_for_statement] = STATE(189),
    [sym_while_statement] = STATE(189),
    [sym_if_statement] = STATE(189),
    [sym_case_statement] = STATE(189),
    [sym_function_definition] = STATE(189),
    [sym_subshell] = STATE(189),
    [sym_pipeline] = STATE(189),
    [sym_list] = STATE(189),
    [sym_bracket_command] = STATE(189),
    [sym_command] = STATE(189),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(190),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [44] = {
    [sym_for_statement] = STATE(191),
    [sym_while_statement] = STATE(191),
    [sym_if_statement] = STATE(191),
    [sym_case_statement] = STATE(191),
    [sym_function_definition] = STATE(191),
    [sym_subshell] = STATE(191),
    [sym_pipeline] = STATE(191),
    [sym_list] = STATE(191),
    [sym_bracket_command] = STATE(191),
    [sym_command] = STATE(191),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(192),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [45] = {
    [sym_for_statement] = STATE(193),
    [sym_while_statement] = STATE(193),
    [sym_if_statement] = STATE(193),
    [sym_case_statement] = STATE(193),
    [sym_function_definition] = STATE(193),
    [sym_subshell] = STATE(193),
    [sym_pipeline] = STATE(193),
    [sym_list] = STATE(193),
    [sym_bracket_command] = STATE(193),
    [sym_command] = STATE(193),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(194),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [46] = {
    [anon_sym_in] = ACTIONS(318),
    [anon_sym_SEMI_SEMI] = ACTIONS(320),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_LF] = ACTIONS(320),
    [anon_sym_AMP] = ACTIONS(320),
  },
  [47] = {
    [sym_compound_statement] = STATE(196),
    [anon_sym_LPAREN] = ACTIONS(332),
    [anon_sym_LBRACE] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
  },
  [48] = {
    [anon_sym_LBRACK] = ACTIONS(58),
    [anon_sym_EQ] = ACTIONS(336),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [sym_comment] = ACTIONS(52),
  },
  [49] = {
    [sym_word] = ACTIONS(338),
    [sym_comment] = ACTIONS(52),
  },
  [50] = {
    [aux_sym_concatenation_repeat1] = STATE(199),
    [sym_file_descriptor] = ACTIONS(152),
    [sym__concat] = ACTIONS(154),
    [anon_sym_PIPE] = ACTIONS(156),
    [anon_sym_RPAREN] = ACTIONS(156),
    [anon_sym_SEMI_SEMI] = ACTIONS(156),
    [anon_sym_PIPE_AMP] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(156),
    [anon_sym_PIPE_PIPE] = ACTIONS(156),
    [anon_sym_LT] = ACTIONS(156),
    [anon_sym_GT] = ACTIONS(156),
    [anon_sym_GT_GT] = ACTIONS(156),
    [anon_sym_AMP_GT] = ACTIONS(156),
    [anon_sym_AMP_GT_GT] = ACTIONS(156),
    [anon_sym_LT_AMP] = ACTIONS(156),
    [anon_sym_GT_AMP] = ACTIONS(156),
    [anon_sym_LT_LT] = ACTIONS(156),
    [anon_sym_LT_LT_DASH] = ACTIONS(156),
    [anon_sym_DQUOTE] = ACTIONS(156),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR] = ACTIONS(156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(156),
    [anon_sym_BQUOTE] = ACTIONS(156),
    [anon_sym_LT_LPAREN] = ACTIONS(156),
    [anon_sym_GT_LPAREN] = ACTIONS(156),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(156),
    [anon_sym_LF] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(156),
  },
  [51] = {
    [sym_compound_statement] = STATE(201),
    [aux_sym_concatenation_repeat1] = STATE(199),
    [sym_file_descriptor] = ACTIONS(152),
    [sym__concat] = ACTIONS(154),
    [anon_sym_PIPE] = ACTIONS(156),
    [anon_sym_RPAREN] = ACTIONS(156),
    [anon_sym_SEMI_SEMI] = ACTIONS(156),
    [anon_sym_LPAREN] = ACTIONS(340),
    [anon_sym_LBRACE] = ACTIONS(216),
    [anon_sym_PIPE_AMP] = ACTIONS(156),
    [anon_sym_AMP_AMP] = ACTIONS(156),
    [anon_sym_PIPE_PIPE] = ACTIONS(156),
    [anon_sym_LT] = ACTIONS(156),
    [anon_sym_GT] = ACTIONS(156),
    [anon_sym_GT_GT] = ACTIONS(156),
    [anon_sym_AMP_GT] = ACTIONS(156),
    [anon_sym_AMP_GT_GT] = ACTIONS(156),
    [anon_sym_LT_AMP] = ACTIONS(156),
    [anon_sym_GT_AMP] = ACTIONS(156),
    [anon_sym_LT_LT] = ACTIONS(156),
    [anon_sym_LT_LT_DASH] = ACTIONS(156),
    [anon_sym_DQUOTE] = ACTIONS(156),
    [sym_raw_string] = ACTIONS(156),
    [anon_sym_DOLLAR] = ACTIONS(156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(156),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(156),
    [anon_sym_BQUOTE] = ACTIONS(156),
    [anon_sym_LT_LPAREN] = ACTIONS(156),
    [anon_sym_GT_LPAREN] = ACTIONS(156),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(156),
    [anon_sym_LF] = ACTIONS(156),
    [anon_sym_AMP] = ACTIONS(156),
  },
  [52] = {
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(344),
    [anon_sym_SEMI_SEMI] = ACTIONS(346),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(346),
    [anon_sym_LF] = ACTIONS(346),
    [anon_sym_AMP] = ACTIONS(346),
  },
  [53] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(208),
    [sym_simple_expansion] = STATE(208),
    [sym_expansion] = STATE(208),
    [sym_command_substitution] = STATE(208),
    [sym_process_substitution] = STATE(208),
    [aux_sym_for_statement_repeat1] = STATE(209),
    [aux_sym_command_repeat2] = STATE(210),
    [sym_file_descriptor] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(234),
    [anon_sym_RPAREN] = ACTIONS(234),
    [anon_sym_SEMI_SEMI] = ACTIONS(234),
    [anon_sym_PIPE_AMP] = ACTIONS(234),
    [anon_sym_AMP_AMP] = ACTIONS(234),
    [anon_sym_PIPE_PIPE] = ACTIONS(234),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_word] = ACTIONS(354),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(234),
    [anon_sym_LF] = ACTIONS(234),
    [anon_sym_AMP] = ACTIONS(234),
  },
  [54] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(344),
    [anon_sym_SEMI_SEMI] = ACTIONS(346),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(346),
    [anon_sym_LF] = ACTIONS(346),
    [anon_sym_AMP] = ACTIONS(346),
  },
  [55] = {
    [anon_sym_EQ] = ACTIONS(336),
    [anon_sym_PLUS_EQ] = ACTIONS(336),
    [sym_comment] = ACTIONS(52),
  },
  [56] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(211),
    [sym_while_statement] = STATE(211),
    [sym_if_statement] = STATE(211),
    [sym_case_statement] = STATE(211),
    [sym_function_definition] = STATE(211),
    [sym_subshell] = STATE(211),
    [sym_pipeline] = STATE(211),
    [sym_list] = STATE(211),
    [sym_bracket_command] = STATE(211),
    [sym_command] = STATE(211),
    [sym_command_name] = STATE(53),
    [sym_environment_variable_assignment] = STATE(212),
    [sym_subscript] = STATE(55),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(50),
    [sym_simple_expansion] = STATE(50),
    [sym_expansion] = STATE(50),
    [sym_command_substitution] = STATE(50),
    [sym_process_substitution] = STATE(50),
    [aux_sym_program_repeat1] = STATE(213),
    [aux_sym_command_repeat1] = STATE(57),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(88),
    [sym_comment] = ACTIONS(52),
  },
  [57] = {
    [sym_command_name] = STATE(214),
    [sym_environment_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(151),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(50),
    [sym_simple_expansion] = STATE(50),
    [sym_expansion] = STATE(50),
    [sym_command_substitution] = STATE(50),
    [sym_process_substitution] = STATE(50),
    [aux_sym_command_repeat1] = STATE(152),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(356),
    [sym_comment] = ACTIONS(52),
  },
  [58] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(216),
    [anon_sym_DQUOTE] = ACTIONS(358),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [59] = {
    [aux_sym_concatenation_repeat1] = STATE(218),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACK] = ACTIONS(362),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(52),
  },
  [60] = {
    [sym_special_variable_name] = STATE(221),
    [anon_sym_DOLLAR] = ACTIONS(368),
    [anon_sym_POUND] = ACTIONS(368),
    [anon_sym_AT] = ACTIONS(368),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(370),
    [anon_sym_STAR] = ACTIONS(368),
    [anon_sym_QMARK] = ACTIONS(368),
    [anon_sym_DASH] = ACTIONS(368),
    [anon_sym_BANG] = ACTIONS(368),
    [anon_sym_0] = ACTIONS(372),
    [anon_sym__] = ACTIONS(372),
  },
  [61] = {
    [sym_special_variable_name] = STATE(224),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(374),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [62] = {
    [sym_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_bracket_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(226),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [63] = {
    [sym_for_statement] = STATE(227),
    [sym_while_statement] = STATE(227),
    [sym_if_statement] = STATE(227),
    [sym_case_statement] = STATE(227),
    [sym_function_definition] = STATE(227),
    [sym_subshell] = STATE(227),
    [sym_pipeline] = STATE(227),
    [sym_list] = STATE(227),
    [sym_bracket_command] = STATE(227),
    [sym_command] = STATE(227),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(228),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [64] = {
    [sym_for_statement] = STATE(229),
    [sym_while_statement] = STATE(229),
    [sym_if_statement] = STATE(229),
    [sym_case_statement] = STATE(229),
    [sym_function_definition] = STATE(229),
    [sym_subshell] = STATE(229),
    [sym_pipeline] = STATE(229),
    [sym_list] = STATE(229),
    [sym_bracket_command] = STATE(229),
    [sym_command] = STATE(229),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(230),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [65] = {
    [anon_sym_RBRACK] = ACTIONS(362),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(52),
  },
  [66] = {
    [sym_concatenation] = STATE(65),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_for_statement_repeat1] = STATE(232),
    [anon_sym_RBRACK] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(92),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(380),
    [sym_comment] = ACTIONS(52),
  },
  [67] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(234),
    [anon_sym_DQUOTE] = ACTIONS(382),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [68] = {
    [aux_sym_concatenation_repeat1] = STATE(236),
    [sym__concat] = ACTIONS(384),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(362),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(52),
  },
  [69] = {
    [sym_special_variable_name] = STATE(239),
    [anon_sym_DOLLAR] = ACTIONS(386),
    [anon_sym_POUND] = ACTIONS(386),
    [anon_sym_AT] = ACTIONS(386),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(388),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_QMARK] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(386),
    [anon_sym_0] = ACTIONS(390),
    [anon_sym__] = ACTIONS(390),
  },
  [70] = {
    [sym_special_variable_name] = STATE(242),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(392),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(394),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [71] = {
    [sym_for_statement] = STATE(243),
    [sym_while_statement] = STATE(243),
    [sym_if_statement] = STATE(243),
    [sym_case_statement] = STATE(243),
    [sym_function_definition] = STATE(243),
    [sym_subshell] = STATE(243),
    [sym_pipeline] = STATE(243),
    [sym_list] = STATE(243),
    [sym_bracket_command] = STATE(243),
    [sym_command] = STATE(243),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(244),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [72] = {
    [sym_for_statement] = STATE(245),
    [sym_while_statement] = STATE(245),
    [sym_if_statement] = STATE(245),
    [sym_case_statement] = STATE(245),
    [sym_function_definition] = STATE(245),
    [sym_subshell] = STATE(245),
    [sym_pipeline] = STATE(245),
    [sym_list] = STATE(245),
    [sym_bracket_command] = STATE(245),
    [sym_command] = STATE(245),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(246),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [73] = {
    [sym_for_statement] = STATE(247),
    [sym_while_statement] = STATE(247),
    [sym_if_statement] = STATE(247),
    [sym_case_statement] = STATE(247),
    [sym_function_definition] = STATE(247),
    [sym_subshell] = STATE(247),
    [sym_pipeline] = STATE(247),
    [sym_list] = STATE(247),
    [sym_bracket_command] = STATE(247),
    [sym_command] = STATE(247),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(248),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [74] = {
    [anon_sym_RBRACK_RBRACK] = ACTIONS(362),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(52),
  },
  [75] = {
    [sym_concatenation] = STATE(74),
    [sym_string] = STATE(68),
    [sym_simple_expansion] = STATE(68),
    [sym_expansion] = STATE(68),
    [sym_command_substitution] = STATE(68),
    [sym_process_substitution] = STATE(68),
    [aux_sym_for_statement_repeat1] = STATE(249),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(108),
    [anon_sym_DOLLAR] = ACTIONS(110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(114),
    [anon_sym_BQUOTE] = ACTIONS(116),
    [anon_sym_LT_LPAREN] = ACTIONS(118),
    [anon_sym_GT_LPAREN] = ACTIONS(118),
    [sym_word] = ACTIONS(396),
    [sym_comment] = ACTIONS(52),
  },
  [76] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(251),
    [anon_sym_DQUOTE] = ACTIONS(398),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [77] = {
    [aux_sym_concatenation_repeat1] = STATE(253),
    [sym_file_descriptor] = ACTIONS(400),
    [sym__concat] = ACTIONS(402),
    [sym_variable_name] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(404),
    [anon_sym_GT] = ACTIONS(404),
    [anon_sym_GT_GT] = ACTIONS(400),
    [anon_sym_AMP_GT] = ACTIONS(404),
    [anon_sym_AMP_GT_GT] = ACTIONS(400),
    [anon_sym_LT_AMP] = ACTIONS(400),
    [anon_sym_GT_AMP] = ACTIONS(400),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [sym_raw_string] = ACTIONS(400),
    [anon_sym_DOLLAR] = ACTIONS(404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(400),
    [anon_sym_BQUOTE] = ACTIONS(400),
    [anon_sym_LT_LPAREN] = ACTIONS(400),
    [anon_sym_GT_LPAREN] = ACTIONS(400),
    [sym_word] = ACTIONS(404),
    [sym_comment] = ACTIONS(52),
  },
  [78] = {
    [sym_special_variable_name] = STATE(256),
    [anon_sym_DOLLAR] = ACTIONS(406),
    [anon_sym_POUND] = ACTIONS(406),
    [anon_sym_AT] = ACTIONS(406),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(408),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_QMARK] = ACTIONS(406),
    [anon_sym_DASH] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(406),
    [anon_sym_0] = ACTIONS(410),
    [anon_sym__] = ACTIONS(410),
  },
  [79] = {
    [sym_special_variable_name] = STATE(259),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(414),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [80] = {
    [sym_for_statement] = STATE(260),
    [sym_while_statement] = STATE(260),
    [sym_if_statement] = STATE(260),
    [sym_case_statement] = STATE(260),
    [sym_function_definition] = STATE(260),
    [sym_subshell] = STATE(260),
    [sym_pipeline] = STATE(260),
    [sym_list] = STATE(260),
    [sym_bracket_command] = STATE(260),
    [sym_command] = STATE(260),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(261),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [81] = {
    [sym_for_statement] = STATE(262),
    [sym_while_statement] = STATE(262),
    [sym_if_statement] = STATE(262),
    [sym_case_statement] = STATE(262),
    [sym_function_definition] = STATE(262),
    [sym_subshell] = STATE(262),
    [sym_pipeline] = STATE(262),
    [sym_list] = STATE(262),
    [sym_bracket_command] = STATE(262),
    [sym_command] = STATE(262),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(263),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [82] = {
    [sym_for_statement] = STATE(264),
    [sym_while_statement] = STATE(264),
    [sym_if_statement] = STATE(264),
    [sym_case_statement] = STATE(264),
    [sym_function_definition] = STATE(264),
    [sym_subshell] = STATE(264),
    [sym_pipeline] = STATE(264),
    [sym_list] = STATE(264),
    [sym_bracket_command] = STATE(264),
    [sym_command] = STATE(264),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(265),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [83] = {
    [sym_file_descriptor] = ACTIONS(400),
    [sym_variable_name] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(404),
    [anon_sym_GT] = ACTIONS(404),
    [anon_sym_GT_GT] = ACTIONS(400),
    [anon_sym_AMP_GT] = ACTIONS(404),
    [anon_sym_AMP_GT_GT] = ACTIONS(400),
    [anon_sym_LT_AMP] = ACTIONS(400),
    [anon_sym_GT_AMP] = ACTIONS(400),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [sym_raw_string] = ACTIONS(400),
    [anon_sym_DOLLAR] = ACTIONS(404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(400),
    [anon_sym_BQUOTE] = ACTIONS(400),
    [anon_sym_LT_LPAREN] = ACTIONS(400),
    [anon_sym_GT_LPAREN] = ACTIONS(400),
    [sym_word] = ACTIONS(404),
    [sym_comment] = ACTIONS(52),
  },
  [84] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(418),
    [anon_sym_GT_GT] = ACTIONS(418),
    [anon_sym_AMP_GT] = ACTIONS(418),
    [anon_sym_AMP_GT_GT] = ACTIONS(418),
    [anon_sym_LT_AMP] = ACTIONS(418),
    [anon_sym_GT_AMP] = ACTIONS(418),
    [anon_sym_LT_LT] = ACTIONS(418),
    [anon_sym_LT_LT_DASH] = ACTIONS(418),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [sym_raw_string] = ACTIONS(418),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(418),
    [anon_sym_BQUOTE] = ACTIONS(418),
    [anon_sym_LT_LPAREN] = ACTIONS(418),
    [anon_sym_GT_LPAREN] = ACTIONS(418),
    [sym_word] = ACTIONS(418),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [85] = {
    [anon_sym_DQUOTE] = ACTIONS(420),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(422),
    [anon_sym_DOLLAR] = ACTIONS(420),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(420),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(420),
    [anon_sym_BQUOTE] = ACTIONS(420),
    [sym_comment] = ACTIONS(150),
  },
  [86] = {
    [sym_special_variable_name] = STATE(268),
    [anon_sym_DOLLAR] = ACTIONS(424),
    [anon_sym_POUND] = ACTIONS(424),
    [anon_sym_AT] = ACTIONS(424),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(426),
    [anon_sym_STAR] = ACTIONS(424),
    [anon_sym_QMARK] = ACTIONS(424),
    [anon_sym_DASH] = ACTIONS(424),
    [anon_sym_BANG] = ACTIONS(424),
    [anon_sym_0] = ACTIONS(428),
    [anon_sym__] = ACTIONS(428),
  },
  [87] = {
    [sym_special_variable_name] = STATE(271),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(430),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(432),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [88] = {
    [sym_for_statement] = STATE(272),
    [sym_while_statement] = STATE(272),
    [sym_if_statement] = STATE(272),
    [sym_case_statement] = STATE(272),
    [sym_function_definition] = STATE(272),
    [sym_subshell] = STATE(272),
    [sym_pipeline] = STATE(272),
    [sym_list] = STATE(272),
    [sym_bracket_command] = STATE(272),
    [sym_command] = STATE(272),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(273),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [89] = {
    [sym_for_statement] = STATE(274),
    [sym_while_statement] = STATE(274),
    [sym_if_statement] = STATE(274),
    [sym_case_statement] = STATE(274),
    [sym_function_definition] = STATE(274),
    [sym_subshell] = STATE(274),
    [sym_pipeline] = STATE(274),
    [sym_list] = STATE(274),
    [sym_bracket_command] = STATE(274),
    [sym_command] = STATE(274),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(275),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [90] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(434),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [91] = {
    [sym_string] = STATE(278),
    [sym_simple_expansion] = STATE(278),
    [sym_expansion] = STATE(278),
    [sym_command_substitution] = STATE(278),
    [sym_process_substitution] = STATE(278),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(436),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(438),
    [sym_comment] = ACTIONS(52),
  },
  [92] = {
    [aux_sym_concatenation_repeat1] = STATE(279),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(154),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_PIPE_AMP] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(442),
    [anon_sym_AMP_GT] = ACTIONS(442),
    [anon_sym_AMP_GT_GT] = ACTIONS(442),
    [anon_sym_LT_AMP] = ACTIONS(442),
    [anon_sym_GT_AMP] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(442),
    [anon_sym_LT_LT_DASH] = ACTIONS(442),
    [anon_sym_DQUOTE] = ACTIONS(442),
    [sym_raw_string] = ACTIONS(442),
    [anon_sym_DOLLAR] = ACTIONS(442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_LT_LPAREN] = ACTIONS(442),
    [anon_sym_GT_LPAREN] = ACTIONS(442),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [93] = {
    [sym_file_descriptor] = ACTIONS(444),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_SEMI_SEMI] = ACTIONS(446),
    [anon_sym_PIPE_AMP] = ACTIONS(446),
    [anon_sym_AMP_AMP] = ACTIONS(446),
    [anon_sym_PIPE_PIPE] = ACTIONS(446),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(446),
    [anon_sym_LT_LT_DASH] = ACTIONS(446),
    [anon_sym_DQUOTE] = ACTIONS(446),
    [sym_raw_string] = ACTIONS(446),
    [anon_sym_DOLLAR] = ACTIONS(446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(446),
    [anon_sym_BQUOTE] = ACTIONS(446),
    [anon_sym_LT_LPAREN] = ACTIONS(446),
    [anon_sym_GT_LPAREN] = ACTIONS(446),
    [sym_word] = ACTIONS(446),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym_LF] = ACTIONS(446),
    [anon_sym_AMP] = ACTIONS(446),
  },
  [94] = {
    [sym_file_descriptor] = ACTIONS(448),
    [sym__concat] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(450),
    [anon_sym_RPAREN] = ACTIONS(450),
    [anon_sym_SEMI_SEMI] = ACTIONS(450),
    [anon_sym_PIPE_AMP] = ACTIONS(450),
    [anon_sym_AMP_AMP] = ACTIONS(450),
    [anon_sym_PIPE_PIPE] = ACTIONS(450),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_GT] = ACTIONS(450),
    [anon_sym_GT_GT] = ACTIONS(450),
    [anon_sym_AMP_GT] = ACTIONS(450),
    [anon_sym_AMP_GT_GT] = ACTIONS(450),
    [anon_sym_LT_AMP] = ACTIONS(450),
    [anon_sym_GT_AMP] = ACTIONS(450),
    [anon_sym_LT_LT] = ACTIONS(450),
    [anon_sym_LT_LT_DASH] = ACTIONS(450),
    [anon_sym_DQUOTE] = ACTIONS(450),
    [sym_raw_string] = ACTIONS(450),
    [anon_sym_DOLLAR] = ACTIONS(450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(450),
    [anon_sym_BQUOTE] = ACTIONS(450),
    [anon_sym_LT_LPAREN] = ACTIONS(450),
    [anon_sym_GT_LPAREN] = ACTIONS(450),
    [sym_word] = ACTIONS(450),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_LF] = ACTIONS(450),
    [anon_sym_AMP] = ACTIONS(450),
  },
  [95] = {
    [sym_file_descriptor] = ACTIONS(452),
    [sym__concat] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(454),
    [anon_sym_RPAREN] = ACTIONS(454),
    [anon_sym_SEMI_SEMI] = ACTIONS(454),
    [anon_sym_PIPE_AMP] = ACTIONS(454),
    [anon_sym_AMP_AMP] = ACTIONS(454),
    [anon_sym_PIPE_PIPE] = ACTIONS(454),
    [anon_sym_LT] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(454),
    [anon_sym_GT_GT] = ACTIONS(454),
    [anon_sym_AMP_GT] = ACTIONS(454),
    [anon_sym_AMP_GT_GT] = ACTIONS(454),
    [anon_sym_LT_AMP] = ACTIONS(454),
    [anon_sym_GT_AMP] = ACTIONS(454),
    [anon_sym_LT_LT] = ACTIONS(454),
    [anon_sym_LT_LT_DASH] = ACTIONS(454),
    [anon_sym_DQUOTE] = ACTIONS(454),
    [sym_raw_string] = ACTIONS(454),
    [anon_sym_DOLLAR] = ACTIONS(454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(454),
    [anon_sym_BQUOTE] = ACTIONS(454),
    [anon_sym_LT_LPAREN] = ACTIONS(454),
    [anon_sym_GT_LPAREN] = ACTIONS(454),
    [sym_word] = ACTIONS(454),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_LF] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(454),
  },
  [96] = {
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(52),
  },
  [97] = {
    [sym_special_variable_name] = STATE(281),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(458),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [98] = {
    [anon_sym_RBRACE] = ACTIONS(460),
    [anon_sym_LBRACK] = ACTIONS(462),
    [anon_sym_EQ] = ACTIONS(464),
    [anon_sym_COLON] = ACTIONS(466),
    [anon_sym_COLON_QMARK] = ACTIONS(464),
    [anon_sym_COLON_DASH] = ACTIONS(464),
    [anon_sym_PERCENT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(464),
    [sym_comment] = ACTIONS(52),
  },
  [99] = {
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_EQ] = ACTIONS(472),
    [anon_sym_COLON] = ACTIONS(474),
    [anon_sym_COLON_QMARK] = ACTIONS(472),
    [anon_sym_COLON_DASH] = ACTIONS(472),
    [anon_sym_PERCENT] = ACTIONS(472),
    [anon_sym_SLASH] = ACTIONS(472),
    [sym_comment] = ACTIONS(52),
  },
  [100] = {
    [anon_sym_LBRACK] = ACTIONS(58),
    [anon_sym_EQ] = ACTIONS(476),
    [anon_sym_PLUS_EQ] = ACTIONS(476),
    [sym_comment] = ACTIONS(52),
  },
  [101] = {
    [sym_word] = ACTIONS(478),
    [sym_comment] = ACTIONS(52),
  },
  [102] = {
    [sym__terminated_statement] = STATE(290),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [103] = {
    [sym__terminated_statement] = STATE(291),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [104] = {
    [sym_concatenation] = STATE(293),
    [sym_string] = STATE(292),
    [sym_simple_expansion] = STATE(292),
    [sym_expansion] = STATE(292),
    [sym_command_substitution] = STATE(292),
    [sym_process_substitution] = STATE(292),
    [anon_sym_DQUOTE] = ACTIONS(64),
    [sym_raw_string] = ACTIONS(480),
    [anon_sym_DOLLAR] = ACTIONS(68),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(70),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(72),
    [anon_sym_BQUOTE] = ACTIONS(74),
    [anon_sym_LT_LPAREN] = ACTIONS(76),
    [anon_sym_GT_LPAREN] = ACTIONS(76),
    [sym_word] = ACTIONS(482),
    [sym_comment] = ACTIONS(52),
  },
  [105] = {
    [sym_word] = ACTIONS(484),
    [sym_comment] = ACTIONS(52),
  },
  [106] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(295),
    [sym_while_statement] = STATE(295),
    [sym_if_statement] = STATE(295),
    [sym_case_statement] = STATE(295),
    [sym_function_definition] = STATE(295),
    [sym_subshell] = STATE(295),
    [sym_pipeline] = STATE(295),
    [sym_list] = STATE(295),
    [sym_bracket_command] = STATE(295),
    [sym_command] = STATE(295),
    [sym_command_name] = STATE(53),
    [sym_environment_variable_assignment] = STATE(296),
    [sym_subscript] = STATE(55),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(50),
    [sym_simple_expansion] = STATE(50),
    [sym_expansion] = STATE(50),
    [sym_command_substitution] = STATE(50),
    [sym_process_substitution] = STATE(50),
    [aux_sym_program_repeat1] = STATE(297),
    [aux_sym_command_repeat1] = STATE(57),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(88),
    [sym_comment] = ACTIONS(52),
  },
  [107] = {
    [sym_concatenation] = STATE(65),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_for_statement_repeat1] = STATE(298),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(92),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(104),
    [sym_comment] = ACTIONS(52),
  },
  [108] = {
    [sym_concatenation] = STATE(74),
    [sym_string] = STATE(68),
    [sym_simple_expansion] = STATE(68),
    [sym_expansion] = STATE(68),
    [sym_command_substitution] = STATE(68),
    [sym_process_substitution] = STATE(68),
    [aux_sym_for_statement_repeat1] = STATE(299),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(108),
    [anon_sym_DOLLAR] = ACTIONS(110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(114),
    [anon_sym_BQUOTE] = ACTIONS(116),
    [anon_sym_LT_LPAREN] = ACTIONS(118),
    [anon_sym_GT_LPAREN] = ACTIONS(118),
    [sym_word] = ACTIONS(120),
    [sym_comment] = ACTIONS(52),
  },
  [109] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(301),
    [anon_sym_DQUOTE] = ACTIONS(486),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [110] = {
    [aux_sym_concatenation_repeat1] = STATE(303),
    [sym_file_descriptor] = ACTIONS(152),
    [sym__concat] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_RPAREN] = ACTIONS(152),
    [anon_sym_PIPE_AMP] = ACTIONS(152),
    [anon_sym_AMP_AMP] = ACTIONS(152),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(152),
    [anon_sym_AMP_GT] = ACTIONS(490),
    [anon_sym_AMP_GT_GT] = ACTIONS(152),
    [anon_sym_LT_AMP] = ACTIONS(152),
    [anon_sym_GT_AMP] = ACTIONS(152),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT_LT_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [sym_raw_string] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_LT_LPAREN] = ACTIONS(152),
    [anon_sym_GT_LPAREN] = ACTIONS(152),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(52),
  },
  [111] = {
    [sym_special_variable_name] = STATE(306),
    [anon_sym_DOLLAR] = ACTIONS(492),
    [anon_sym_POUND] = ACTIONS(492),
    [anon_sym_AT] = ACTIONS(492),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(492),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_0] = ACTIONS(496),
    [anon_sym__] = ACTIONS(496),
  },
  [112] = {
    [sym_special_variable_name] = STATE(309),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(498),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(500),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [113] = {
    [sym_for_statement] = STATE(310),
    [sym_while_statement] = STATE(310),
    [sym_if_statement] = STATE(310),
    [sym_case_statement] = STATE(310),
    [sym_function_definition] = STATE(310),
    [sym_subshell] = STATE(310),
    [sym_pipeline] = STATE(310),
    [sym_list] = STATE(310),
    [sym_bracket_command] = STATE(310),
    [sym_command] = STATE(310),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(311),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [114] = {
    [sym_for_statement] = STATE(312),
    [sym_while_statement] = STATE(312),
    [sym_if_statement] = STATE(312),
    [sym_case_statement] = STATE(312),
    [sym_function_definition] = STATE(312),
    [sym_subshell] = STATE(312),
    [sym_pipeline] = STATE(312),
    [sym_list] = STATE(312),
    [sym_bracket_command] = STATE(312),
    [sym_command] = STATE(312),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(313),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [115] = {
    [sym_for_statement] = STATE(314),
    [sym_while_statement] = STATE(314),
    [sym_if_statement] = STATE(314),
    [sym_case_statement] = STATE(314),
    [sym_function_definition] = STATE(314),
    [sym_subshell] = STATE(314),
    [sym_pipeline] = STATE(314),
    [sym_list] = STATE(314),
    [sym_bracket_command] = STATE(314),
    [sym_command] = STATE(314),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(315),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [116] = {
    [sym_compound_statement] = STATE(318),
    [aux_sym_concatenation_repeat1] = STATE(303),
    [sym_file_descriptor] = ACTIONS(152),
    [sym__concat] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_RPAREN] = ACTIONS(152),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_LBRACE] = ACTIONS(504),
    [anon_sym_PIPE_AMP] = ACTIONS(152),
    [anon_sym_AMP_AMP] = ACTIONS(152),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(152),
    [anon_sym_AMP_GT] = ACTIONS(490),
    [anon_sym_AMP_GT_GT] = ACTIONS(152),
    [anon_sym_LT_AMP] = ACTIONS(152),
    [anon_sym_GT_AMP] = ACTIONS(152),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT_LT_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [sym_raw_string] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_LT_LPAREN] = ACTIONS(152),
    [anon_sym_GT_LPAREN] = ACTIONS(152),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(52),
  },
  [117] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(508),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [118] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(325),
    [sym_simple_expansion] = STATE(325),
    [sym_expansion] = STATE(325),
    [sym_command_substitution] = STATE(325),
    [sym_process_substitution] = STATE(325),
    [aux_sym_for_statement_repeat1] = STATE(328),
    [aux_sym_command_repeat2] = STATE(329),
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_RPAREN] = ACTIONS(518),
    [anon_sym_PIPE_AMP] = ACTIONS(518),
    [anon_sym_AMP_AMP] = ACTIONS(518),
    [anon_sym_PIPE_PIPE] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
  },
  [119] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(508),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [120] = {
    [anon_sym_EQ] = ACTIONS(476),
    [anon_sym_PLUS_EQ] = ACTIONS(476),
    [sym_comment] = ACTIONS(52),
  },
  [121] = {
    [sym_file_descriptor] = ACTIONS(152),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_RPAREN] = ACTIONS(152),
    [anon_sym_PIPE_AMP] = ACTIONS(152),
    [anon_sym_AMP_AMP] = ACTIONS(152),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(152),
    [anon_sym_AMP_GT] = ACTIONS(490),
    [anon_sym_AMP_GT_GT] = ACTIONS(152),
    [anon_sym_LT_AMP] = ACTIONS(152),
    [anon_sym_GT_AMP] = ACTIONS(152),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT_LT_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [sym_raw_string] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_LT_LPAREN] = ACTIONS(152),
    [anon_sym_GT_LPAREN] = ACTIONS(152),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(52),
  },
  [122] = {
    [sym_command_name] = STATE(330),
    [sym_environment_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(151),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(152),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(534),
    [sym_comment] = ACTIONS(52),
  },
  [123] = {
    [anon_sym_LBRACK] = ACTIONS(58),
    [anon_sym_EQ] = ACTIONS(536),
    [anon_sym_PLUS_EQ] = ACTIONS(536),
    [sym_comment] = ACTIONS(52),
  },
  [124] = {
    [sym_word] = ACTIONS(538),
    [sym_comment] = ACTIONS(52),
  },
  [125] = {
    [aux_sym_concatenation_repeat1] = STATE(333),
    [sym_file_descriptor] = ACTIONS(152),
    [sym__concat] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_PIPE_AMP] = ACTIONS(152),
    [anon_sym_AMP_AMP] = ACTIONS(152),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(152),
    [anon_sym_AMP_GT] = ACTIONS(490),
    [anon_sym_AMP_GT_GT] = ACTIONS(152),
    [anon_sym_LT_AMP] = ACTIONS(152),
    [anon_sym_GT_AMP] = ACTIONS(152),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT_LT_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [sym_raw_string] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_LT_LPAREN] = ACTIONS(152),
    [anon_sym_GT_LPAREN] = ACTIONS(152),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(52),
  },
  [126] = {
    [sym_compound_statement] = STATE(335),
    [aux_sym_concatenation_repeat1] = STATE(333),
    [sym_file_descriptor] = ACTIONS(152),
    [sym__concat] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_LBRACE] = ACTIONS(504),
    [anon_sym_PIPE_AMP] = ACTIONS(152),
    [anon_sym_AMP_AMP] = ACTIONS(152),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(152),
    [anon_sym_AMP_GT] = ACTIONS(490),
    [anon_sym_AMP_GT_GT] = ACTIONS(152),
    [anon_sym_LT_AMP] = ACTIONS(152),
    [anon_sym_GT_AMP] = ACTIONS(152),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT_LT_DASH] = ACTIONS(152),
    [anon_sym_DQUOTE] = ACTIONS(152),
    [sym_raw_string] = ACTIONS(152),
    [anon_sym_DOLLAR] = ACTIONS(490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(152),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(152),
    [anon_sym_BQUOTE] = ACTIONS(152),
    [anon_sym_LT_LPAREN] = ACTIONS(152),
    [anon_sym_GT_LPAREN] = ACTIONS(152),
    [sym_word] = ACTIONS(156),
    [sym_comment] = ACTIONS(52),
  },
  [127] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [sym_comment] = ACTIONS(52),
  },
  [128] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(340),
    [sym_simple_expansion] = STATE(340),
    [sym_expansion] = STATE(340),
    [sym_command_substitution] = STATE(340),
    [sym_process_substitution] = STATE(340),
    [aux_sym_for_statement_repeat1] = STATE(341),
    [aux_sym_command_repeat2] = STATE(342),
    [sym_file_descriptor] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_PIPE_AMP] = ACTIONS(518),
    [anon_sym_AMP_AMP] = ACTIONS(518),
    [anon_sym_PIPE_PIPE] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(550),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_AMP_GT] = ACTIONS(550),
    [anon_sym_AMP_GT_GT] = ACTIONS(552),
    [anon_sym_LT_AMP] = ACTIONS(552),
    [anon_sym_GT_AMP] = ACTIONS(552),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(554),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(518),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(556),
    [sym_comment] = ACTIONS(52),
  },
  [129] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(508),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [130] = {
    [anon_sym_EQ] = ACTIONS(536),
    [anon_sym_PLUS_EQ] = ACTIONS(536),
    [sym_comment] = ACTIONS(52),
  },
  [131] = {
    [sym_command_name] = STATE(343),
    [sym_environment_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(151),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(152),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(560),
    [sym_comment] = ACTIONS(52),
  },
  [132] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(562),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [133] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(562),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [134] = {
    [anon_sym_RPAREN] = ACTIONS(564),
    [sym_comment] = ACTIONS(52),
  },
  [135] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(347),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [136] = {
    [sym_file_redirect] = STATE(350),
    [sym_file_descriptor] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(570),
    [anon_sym_SEMI_SEMI] = ACTIONS(570),
    [anon_sym_PIPE_AMP] = ACTIONS(570),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(572),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_LF] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(570),
  },
  [137] = {
    [sym_for_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_function_definition] = STATE(351),
    [sym_subshell] = STATE(351),
    [sym_pipeline] = STATE(351),
    [sym_list] = STATE(351),
    [sym_bracket_command] = STATE(351),
    [sym_command] = STATE(351),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(352),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [138] = {
    [sym_file_descriptor] = ACTIONS(574),
    [sym_variable_name] = ACTIONS(574),
    [ts_builtin_sym_end] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(576),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_word] = ACTIONS(578),
    [sym_comment] = ACTIONS(52),
  },
  [139] = {
    [sym_for_statement] = STATE(353),
    [sym_while_statement] = STATE(353),
    [sym_if_statement] = STATE(353),
    [sym_case_statement] = STATE(353),
    [sym_function_definition] = STATE(353),
    [sym_subshell] = STATE(353),
    [sym_pipeline] = STATE(353),
    [sym_list] = STATE(353),
    [sym_bracket_command] = STATE(353),
    [sym_command] = STATE(353),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(354),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [140] = {
    [anon_sym_LT] = ACTIONS(580),
    [anon_sym_GT] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(580),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [sym_comment] = ACTIONS(52),
  },
  [141] = {
    [sym_concatenation] = STATE(363),
    [sym_string] = STATE(357),
    [sym_simple_expansion] = STATE(357),
    [sym_expansion] = STATE(357),
    [sym_command_substitution] = STATE(357),
    [sym_process_substitution] = STATE(357),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(586),
    [anon_sym_DOLLAR] = ACTIONS(588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(592),
    [anon_sym_BQUOTE] = ACTIONS(594),
    [anon_sym_LT_LPAREN] = ACTIONS(596),
    [anon_sym_GT_LPAREN] = ACTIONS(596),
    [sym_word] = ACTIONS(598),
    [sym_comment] = ACTIONS(52),
  },
  [142] = {
    [sym_heredoc] = STATE(366),
    [sym__simple_heredoc] = ACTIONS(600),
    [sym__heredoc_beginning] = ACTIONS(602),
    [sym_comment] = ACTIONS(52),
  },
  [143] = {
    [aux_sym_concatenation_repeat1] = STATE(92),
    [sym_file_descriptor] = ACTIONS(364),
    [sym__concat] = ACTIONS(154),
    [anon_sym_PIPE] = ACTIONS(366),
    [anon_sym_SEMI_SEMI] = ACTIONS(366),
    [anon_sym_PIPE_AMP] = ACTIONS(366),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_PIPE_PIPE] = ACTIONS(366),
    [anon_sym_LT] = ACTIONS(366),
    [anon_sym_GT] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(366),
    [anon_sym_AMP_GT] = ACTIONS(366),
    [anon_sym_AMP_GT_GT] = ACTIONS(366),
    [anon_sym_LT_AMP] = ACTIONS(366),
    [anon_sym_GT_AMP] = ACTIONS(366),
    [anon_sym_LT_LT] = ACTIONS(366),
    [anon_sym_LT_LT_DASH] = ACTIONS(366),
    [anon_sym_DQUOTE] = ACTIONS(366),
    [sym_raw_string] = ACTIONS(366),
    [anon_sym_DOLLAR] = ACTIONS(366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(366),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(366),
    [anon_sym_GT_LPAREN] = ACTIONS(366),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(366),
    [anon_sym_LF] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(366),
  },
  [144] = {
    [sym_file_descriptor] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(606),
    [anon_sym_SEMI_SEMI] = ACTIONS(606),
    [anon_sym_PIPE_AMP] = ACTIONS(606),
    [anon_sym_AMP_AMP] = ACTIONS(606),
    [anon_sym_PIPE_PIPE] = ACTIONS(606),
    [anon_sym_LT] = ACTIONS(606),
    [anon_sym_GT] = ACTIONS(606),
    [anon_sym_GT_GT] = ACTIONS(606),
    [anon_sym_AMP_GT] = ACTIONS(606),
    [anon_sym_AMP_GT_GT] = ACTIONS(606),
    [anon_sym_LT_AMP] = ACTIONS(606),
    [anon_sym_GT_AMP] = ACTIONS(606),
    [anon_sym_LT_LT] = ACTIONS(606),
    [anon_sym_LT_LT_DASH] = ACTIONS(606),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(606),
    [anon_sym_LF] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(606),
  },
  [145] = {
    [sym_file_descriptor] = ACTIONS(364),
    [anon_sym_PIPE] = ACTIONS(366),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_SEMI_SEMI] = ACTIONS(366),
    [anon_sym_PIPE_AMP] = ACTIONS(366),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_PIPE_PIPE] = ACTIONS(366),
    [anon_sym_LT] = ACTIONS(366),
    [anon_sym_GT] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(366),
    [anon_sym_AMP_GT] = ACTIONS(366),
    [anon_sym_AMP_GT_GT] = ACTIONS(366),
    [anon_sym_LT_AMP] = ACTIONS(366),
    [anon_sym_GT_AMP] = ACTIONS(366),
    [anon_sym_LT_LT] = ACTIONS(366),
    [anon_sym_LT_LT_DASH] = ACTIONS(366),
    [anon_sym_DQUOTE] = ACTIONS(366),
    [sym_raw_string] = ACTIONS(366),
    [anon_sym_DOLLAR] = ACTIONS(366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(366),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(366),
    [anon_sym_GT_LPAREN] = ACTIONS(366),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(366),
    [anon_sym_LF] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(366),
  },
  [146] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(143),
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [sym_process_substitution] = STATE(143),
    [aux_sym_for_statement_repeat1] = STATE(367),
    [aux_sym_command_repeat2] = STATE(368),
    [sym_file_descriptor] = ACTIONS(232),
    [anon_sym_PIPE] = ACTIONS(608),
    [anon_sym_SEMI_SEMI] = ACTIONS(608),
    [anon_sym_PIPE_AMP] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(608),
    [anon_sym_PIPE_PIPE] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [sym_raw_string] = ACTIONS(242),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_word] = ACTIONS(242),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_LF] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(608),
  },
  [147] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [aux_sym_command_repeat2] = STATE(369),
    [sym_file_descriptor] = ACTIONS(232),
    [anon_sym_PIPE] = ACTIONS(608),
    [anon_sym_SEMI_SEMI] = ACTIONS(608),
    [anon_sym_PIPE_AMP] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(608),
    [anon_sym_PIPE_PIPE] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_LF] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(608),
  },
  [148] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(148),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(610),
    [sym_variable_name] = ACTIONS(613),
    [ts_builtin_sym_end] = ACTIONS(616),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_case] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(645),
    [anon_sym_LT_AMP] = ACTIONS(645),
    [anon_sym_GT_AMP] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(663),
    [anon_sym_LT_LPAREN] = ACTIONS(666),
    [anon_sym_GT_LPAREN] = ACTIONS(666),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(52),
  },
  [149] = {
    [anon_sym_LBRACK] = ACTIONS(58),
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [sym_comment] = ACTIONS(52),
  },
  [150] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(143),
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [sym_process_substitution] = STATE(143),
    [aux_sym_for_statement_repeat1] = STATE(371),
    [aux_sym_command_repeat2] = STATE(368),
    [sym_file_descriptor] = ACTIONS(232),
    [anon_sym_PIPE] = ACTIONS(608),
    [anon_sym_SEMI_SEMI] = ACTIONS(608),
    [anon_sym_PIPE_AMP] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(608),
    [anon_sym_PIPE_PIPE] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [sym_raw_string] = ACTIONS(242),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_word] = ACTIONS(242),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_LF] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(608),
  },
  [151] = {
    [anon_sym_EQ] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [sym_comment] = ACTIONS(52),
  },
  [152] = {
    [sym_environment_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(151),
    [sym_file_redirect] = STATE(27),
    [aux_sym_command_repeat1] = STATE(152),
    [sym_file_descriptor] = ACTIONS(674),
    [sym_variable_name] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(680),
    [anon_sym_GT_GT] = ACTIONS(683),
    [anon_sym_AMP_GT] = ACTIONS(680),
    [anon_sym_AMP_GT_GT] = ACTIONS(683),
    [anon_sym_LT_AMP] = ACTIONS(683),
    [anon_sym_GT_AMP] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(686),
    [sym_raw_string] = ACTIONS(686),
    [anon_sym_DOLLAR] = ACTIONS(688),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(686),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(686),
    [anon_sym_BQUOTE] = ACTIONS(686),
    [anon_sym_LT_LPAREN] = ACTIONS(686),
    [anon_sym_GT_LPAREN] = ACTIONS(686),
    [sym_word] = ACTIONS(688),
    [sym_comment] = ACTIONS(52),
  },
  [153] = {
    [aux_sym_concatenation_repeat1] = STATE(253),
    [sym_file_descriptor] = ACTIONS(690),
    [sym__concat] = ACTIONS(402),
    [sym_variable_name] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(692),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_word] = ACTIONS(692),
    [sym_comment] = ACTIONS(52),
  },
  [154] = {
    [sym_file_descriptor] = ACTIONS(690),
    [sym_variable_name] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(692),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_DQUOTE] = ACTIONS(690),
    [sym_raw_string] = ACTIONS(690),
    [anon_sym_DOLLAR] = ACTIONS(692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(690),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(690),
    [sym_word] = ACTIONS(692),
    [sym_comment] = ACTIONS(52),
  },
  [155] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(373),
    [anon_sym_DQUOTE] = ACTIONS(694),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [156] = {
    [aux_sym_concatenation_repeat1] = STATE(376),
    [sym__concat] = ACTIONS(696),
    [anon_sym_RBRACK] = ACTIONS(698),
    [sym_comment] = ACTIONS(52),
  },
  [157] = {
    [sym_special_variable_name] = STATE(379),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_POUND] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(700),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_BANG] = ACTIONS(700),
    [anon_sym_0] = ACTIONS(704),
    [anon_sym__] = ACTIONS(704),
  },
  [158] = {
    [sym_special_variable_name] = STATE(382),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(708),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [159] = {
    [sym_for_statement] = STATE(383),
    [sym_while_statement] = STATE(383),
    [sym_if_statement] = STATE(383),
    [sym_case_statement] = STATE(383),
    [sym_function_definition] = STATE(383),
    [sym_subshell] = STATE(383),
    [sym_pipeline] = STATE(383),
    [sym_list] = STATE(383),
    [sym_bracket_command] = STATE(383),
    [sym_command] = STATE(383),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(384),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [160] = {
    [sym_for_statement] = STATE(385),
    [sym_while_statement] = STATE(385),
    [sym_if_statement] = STATE(385),
    [sym_case_statement] = STATE(385),
    [sym_function_definition] = STATE(385),
    [sym_subshell] = STATE(385),
    [sym_pipeline] = STATE(385),
    [sym_list] = STATE(385),
    [sym_bracket_command] = STATE(385),
    [sym_command] = STATE(385),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(386),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [161] = {
    [sym_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_if_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_bracket_command] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [162] = {
    [anon_sym_RBRACK] = ACTIONS(698),
    [sym_comment] = ACTIONS(52),
  },
  [163] = {
    [sym_file_descriptor] = ACTIONS(710),
    [sym_variable_name] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(712),
    [anon_sym_RPAREN] = ACTIONS(712),
    [anon_sym_SEMI_SEMI] = ACTIONS(712),
    [anon_sym_PIPE_AMP] = ACTIONS(712),
    [anon_sym_AMP_AMP] = ACTIONS(712),
    [anon_sym_PIPE_PIPE] = ACTIONS(712),
    [anon_sym_LT] = ACTIONS(712),
    [anon_sym_GT] = ACTIONS(712),
    [anon_sym_GT_GT] = ACTIONS(712),
    [anon_sym_AMP_GT] = ACTIONS(712),
    [anon_sym_AMP_GT_GT] = ACTIONS(712),
    [anon_sym_LT_AMP] = ACTIONS(712),
    [anon_sym_GT_AMP] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(712),
    [sym_raw_string] = ACTIONS(712),
    [anon_sym_DOLLAR] = ACTIONS(712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(712),
    [anon_sym_LT_LPAREN] = ACTIONS(712),
    [anon_sym_GT_LPAREN] = ACTIONS(712),
    [sym_word] = ACTIONS(712),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(712),
    [anon_sym_LF] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(712),
  },
  [164] = {
    [sym_concatenation] = STATE(397),
    [sym_string] = STATE(391),
    [sym_simple_expansion] = STATE(391),
    [sym_expansion] = STATE(391),
    [sym_command_substitution] = STATE(391),
    [sym_process_substitution] = STATE(391),
    [aux_sym_for_statement_repeat1] = STATE(398),
    [anon_sym_RPAREN] = ACTIONS(714),
    [anon_sym_DQUOTE] = ACTIONS(716),
    [sym_raw_string] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_word] = ACTIONS(730),
    [sym_comment] = ACTIONS(52),
  },
  [165] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(400),
    [anon_sym_DQUOTE] = ACTIONS(732),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [166] = {
    [aux_sym_concatenation_repeat1] = STATE(402),
    [sym_file_descriptor] = ACTIONS(710),
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(712),
    [anon_sym_SEMI_SEMI] = ACTIONS(712),
    [anon_sym_PIPE_AMP] = ACTIONS(712),
    [anon_sym_AMP_AMP] = ACTIONS(712),
    [anon_sym_PIPE_PIPE] = ACTIONS(712),
    [anon_sym_LT] = ACTIONS(712),
    [anon_sym_GT] = ACTIONS(712),
    [anon_sym_GT_GT] = ACTIONS(712),
    [anon_sym_AMP_GT] = ACTIONS(712),
    [anon_sym_AMP_GT_GT] = ACTIONS(712),
    [anon_sym_LT_AMP] = ACTIONS(712),
    [anon_sym_GT_AMP] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(712),
    [sym_raw_string] = ACTIONS(712),
    [anon_sym_DOLLAR] = ACTIONS(712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(712),
    [anon_sym_LT_LPAREN] = ACTIONS(712),
    [anon_sym_GT_LPAREN] = ACTIONS(712),
    [sym_word] = ACTIONS(712),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(712),
    [anon_sym_LF] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(712),
  },
  [167] = {
    [sym_special_variable_name] = STATE(405),
    [anon_sym_DOLLAR] = ACTIONS(736),
    [anon_sym_POUND] = ACTIONS(736),
    [anon_sym_AT] = ACTIONS(736),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(738),
    [anon_sym_STAR] = ACTIONS(736),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_DASH] = ACTIONS(736),
    [anon_sym_BANG] = ACTIONS(736),
    [anon_sym_0] = ACTIONS(740),
    [anon_sym__] = ACTIONS(740),
  },
  [168] = {
    [sym_special_variable_name] = STATE(408),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(742),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(744),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [169] = {
    [sym_for_statement] = STATE(409),
    [sym_while_statement] = STATE(409),
    [sym_if_statement] = STATE(409),
    [sym_case_statement] = STATE(409),
    [sym_function_definition] = STATE(409),
    [sym_subshell] = STATE(409),
    [sym_pipeline] = STATE(409),
    [sym_list] = STATE(409),
    [sym_bracket_command] = STATE(409),
    [sym_command] = STATE(409),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(410),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [170] = {
    [sym_for_statement] = STATE(411),
    [sym_while_statement] = STATE(411),
    [sym_if_statement] = STATE(411),
    [sym_case_statement] = STATE(411),
    [sym_function_definition] = STATE(411),
    [sym_subshell] = STATE(411),
    [sym_pipeline] = STATE(411),
    [sym_list] = STATE(411),
    [sym_bracket_command] = STATE(411),
    [sym_command] = STATE(411),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(412),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [171] = {
    [sym_for_statement] = STATE(413),
    [sym_while_statement] = STATE(413),
    [sym_if_statement] = STATE(413),
    [sym_case_statement] = STATE(413),
    [sym_function_definition] = STATE(413),
    [sym_subshell] = STATE(413),
    [sym_pipeline] = STATE(413),
    [sym_list] = STATE(413),
    [sym_bracket_command] = STATE(413),
    [sym_command] = STATE(413),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(414),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [172] = {
    [sym_concatenation] = STATE(422),
    [sym_string] = STATE(416),
    [sym_simple_expansion] = STATE(416),
    [sym_expansion] = STATE(416),
    [sym_command_substitution] = STATE(416),
    [sym_process_substitution] = STATE(416),
    [aux_sym_for_statement_repeat1] = STATE(423),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [sym_raw_string] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(754),
    [anon_sym_BQUOTE] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(758),
    [anon_sym_GT_LPAREN] = ACTIONS(758),
    [sym_word] = ACTIONS(760),
    [sym_comment] = ACTIONS(52),
  },
  [173] = {
    [sym__terminated_statement] = STATE(425),
    [sym_for_statement] = STATE(426),
    [sym_while_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_case_statement] = STATE(426),
    [sym_function_definition] = STATE(426),
    [sym_subshell] = STATE(426),
    [sym_pipeline] = STATE(426),
    [sym_list] = STATE(426),
    [sym_bracket_command] = STATE(426),
    [sym_command] = STATE(426),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(427),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(428),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [174] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_RPAREN] = ACTIONS(764),
    [anon_sym_SEMI_SEMI] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(764),
    [anon_sym_AMP_AMP] = ACTIONS(764),
    [anon_sym_PIPE_PIPE] = ACTIONS(764),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(764),
    [anon_sym_LF] = ACTIONS(764),
    [anon_sym_AMP] = ACTIONS(764),
  },
  [175] = {
    [anon_sym_do] = ACTIONS(574),
    [anon_sym_then] = ACTIONS(574),
    [sym_comment] = ACTIONS(52),
  },
  [176] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(433),
    [sym_while_statement] = STATE(433),
    [sym_if_statement] = STATE(433),
    [sym_elif_clause] = STATE(434),
    [sym_else_clause] = STATE(435),
    [sym_case_statement] = STATE(433),
    [sym_function_definition] = STATE(433),
    [sym_subshell] = STATE(433),
    [sym_pipeline] = STATE(433),
    [sym_list] = STATE(433),
    [sym_bracket_command] = STATE(433),
    [sym_command] = STATE(433),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(436),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(437),
    [aux_sym_if_statement_repeat1] = STATE(438),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(766),
    [anon_sym_elif] = ACTIONS(768),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [177] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_in] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [178] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(772),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [179] = {
    [sym_string] = STATE(440),
    [sym_simple_expansion] = STATE(440),
    [sym_expansion] = STATE(440),
    [sym_command_substitution] = STATE(440),
    [sym_process_substitution] = STATE(440),
    [anon_sym_DQUOTE] = ACTIONS(64),
    [sym_raw_string] = ACTIONS(774),
    [anon_sym_DOLLAR] = ACTIONS(68),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(70),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(72),
    [anon_sym_BQUOTE] = ACTIONS(74),
    [anon_sym_LT_LPAREN] = ACTIONS(76),
    [anon_sym_GT_LPAREN] = ACTIONS(76),
    [sym_word] = ACTIONS(776),
    [sym_comment] = ACTIONS(52),
  },
  [180] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(778),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(778),
    [anon_sym_LF] = ACTIONS(778),
    [anon_sym_AMP] = ACTIONS(778),
  },
  [181] = {
    [anon_sym_in] = ACTIONS(780),
    [sym_comment] = ACTIONS(52),
  },
  [182] = {
    [aux_sym_concatenation_repeat1] = STATE(443),
    [sym__concat] = ACTIONS(316),
    [anon_sym_in] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [183] = {
    [sym__concat] = ACTIONS(444),
    [anon_sym_in] = ACTIONS(446),
    [anon_sym_SEMI_SEMI] = ACTIONS(446),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym_LF] = ACTIONS(446),
    [anon_sym_AMP] = ACTIONS(446),
  },
  [184] = {
    [sym__concat] = ACTIONS(448),
    [anon_sym_in] = ACTIONS(450),
    [anon_sym_SEMI_SEMI] = ACTIONS(450),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_LF] = ACTIONS(450),
    [anon_sym_AMP] = ACTIONS(450),
  },
  [185] = {
    [sym__concat] = ACTIONS(452),
    [anon_sym_in] = ACTIONS(454),
    [anon_sym_SEMI_SEMI] = ACTIONS(454),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_LF] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(454),
  },
  [186] = {
    [sym_special_variable_name] = STATE(445),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(782),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [187] = {
    [anon_sym_RBRACE] = ACTIONS(784),
    [anon_sym_LBRACK] = ACTIONS(786),
    [anon_sym_EQ] = ACTIONS(788),
    [anon_sym_COLON] = ACTIONS(790),
    [anon_sym_COLON_QMARK] = ACTIONS(788),
    [anon_sym_COLON_DASH] = ACTIONS(788),
    [anon_sym_PERCENT] = ACTIONS(788),
    [anon_sym_SLASH] = ACTIONS(788),
    [sym_comment] = ACTIONS(52),
  },
  [188] = {
    [anon_sym_RBRACE] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_EQ] = ACTIONS(796),
    [anon_sym_COLON] = ACTIONS(798),
    [anon_sym_COLON_QMARK] = ACTIONS(796),
    [anon_sym_COLON_DASH] = ACTIONS(796),
    [anon_sym_PERCENT] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(796),
    [sym_comment] = ACTIONS(52),
  },
  [189] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(800),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [190] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(800),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [191] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(800),
    [sym_comment] = ACTIONS(52),
  },
  [192] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(800),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [193] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(802),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [194] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(802),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [195] = {
    [anon_sym_RPAREN] = ACTIONS(804),
    [sym_comment] = ACTIONS(52),
  },
  [196] = {
    [sym_file_redirect] = STATE(455),
    [sym_file_descriptor] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_SEMI_SEMI] = ACTIONS(806),
    [anon_sym_PIPE_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(806),
    [anon_sym_PIPE_PIPE] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(572),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_LF] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
  },
  [197] = {
    [sym_concatenation] = STATE(163),
    [sym_string] = STATE(456),
    [sym_array] = STATE(163),
    [sym_simple_expansion] = STATE(456),
    [sym_expansion] = STATE(456),
    [sym_command_substitution] = STATE(456),
    [sym_process_substitution] = STATE(456),
    [sym__empty_value] = ACTIONS(286),
    [anon_sym_LPAREN] = ACTIONS(288),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(808),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(298),
    [anon_sym_BQUOTE] = ACTIONS(300),
    [anon_sym_LT_LPAREN] = ACTIONS(302),
    [anon_sym_GT_LPAREN] = ACTIONS(302),
    [sym_word] = ACTIONS(810),
    [sym_comment] = ACTIONS(52),
  },
  [198] = {
    [sym_compound_statement] = STATE(458),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
  },
  [199] = {
    [aux_sym_concatenation_repeat1] = STATE(459),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(154),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_PIPE_AMP] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(442),
    [anon_sym_AMP_GT] = ACTIONS(442),
    [anon_sym_AMP_GT_GT] = ACTIONS(442),
    [anon_sym_LT_AMP] = ACTIONS(442),
    [anon_sym_GT_AMP] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(442),
    [anon_sym_LT_LT_DASH] = ACTIONS(442),
    [anon_sym_DQUOTE] = ACTIONS(442),
    [sym_raw_string] = ACTIONS(442),
    [anon_sym_DOLLAR] = ACTIONS(442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_LT_LPAREN] = ACTIONS(442),
    [anon_sym_GT_LPAREN] = ACTIONS(442),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [200] = {
    [anon_sym_RPAREN] = ACTIONS(814),
    [sym_comment] = ACTIONS(52),
  },
  [201] = {
    [sym_file_redirect] = STATE(350),
    [sym_file_descriptor] = ACTIONS(816),
    [anon_sym_PIPE] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(570),
    [anon_sym_SEMI_SEMI] = ACTIONS(570),
    [anon_sym_PIPE_AMP] = ACTIONS(570),
    [anon_sym_AMP_AMP] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_AMP_GT] = ACTIONS(818),
    [anon_sym_AMP_GT_GT] = ACTIONS(818),
    [anon_sym_LT_AMP] = ACTIONS(818),
    [anon_sym_GT_AMP] = ACTIONS(818),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_LF] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(570),
  },
  [202] = {
    [sym_for_statement] = STATE(351),
    [sym_while_statement] = STATE(351),
    [sym_if_statement] = STATE(351),
    [sym_case_statement] = STATE(351),
    [sym_function_definition] = STATE(351),
    [sym_subshell] = STATE(351),
    [sym_pipeline] = STATE(351),
    [sym_list] = STATE(351),
    [sym_bracket_command] = STATE(351),
    [sym_command] = STATE(351),
    [sym_command_name] = STATE(53),
    [sym_environment_variable_assignment] = STATE(352),
    [sym_subscript] = STATE(55),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(50),
    [sym_simple_expansion] = STATE(50),
    [sym_expansion] = STATE(50),
    [sym_command_substitution] = STATE(50),
    [sym_process_substitution] = STATE(50),
    [aux_sym_command_repeat1] = STATE(57),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(88),
    [sym_comment] = ACTIONS(52),
  },
  [203] = {
    [anon_sym_PIPE] = ACTIONS(820),
    [anon_sym_RPAREN] = ACTIONS(820),
    [anon_sym_SEMI_SEMI] = ACTIONS(820),
    [anon_sym_PIPE_AMP] = ACTIONS(820),
    [anon_sym_AMP_AMP] = ACTIONS(820),
    [anon_sym_PIPE_PIPE] = ACTIONS(820),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(820),
    [anon_sym_LF] = ACTIONS(820),
    [anon_sym_AMP] = ACTIONS(820),
  },
  [204] = {
    [sym_file_descriptor] = ACTIONS(574),
    [sym_variable_name] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(822),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(576),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_word] = ACTIONS(578),
    [sym_comment] = ACTIONS(52),
  },
  [205] = {
    [sym_for_statement] = STATE(464),
    [sym_while_statement] = STATE(464),
    [sym_if_statement] = STATE(464),
    [sym_case_statement] = STATE(464),
    [sym_function_definition] = STATE(464),
    [sym_subshell] = STATE(464),
    [sym_pipeline] = STATE(464),
    [sym_list] = STATE(464),
    [sym_bracket_command] = STATE(464),
    [sym_command] = STATE(464),
    [sym_command_name] = STATE(53),
    [sym_environment_variable_assignment] = STATE(465),
    [sym_subscript] = STATE(55),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(50),
    [sym_simple_expansion] = STATE(50),
    [sym_expansion] = STATE(50),
    [sym_command_substitution] = STATE(50),
    [sym_process_substitution] = STATE(50),
    [aux_sym_command_repeat1] = STATE(57),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(88),
    [sym_comment] = ACTIONS(52),
  },
  [206] = {
    [anon_sym_LT] = ACTIONS(824),
    [anon_sym_GT] = ACTIONS(824),
    [anon_sym_GT_GT] = ACTIONS(826),
    [anon_sym_AMP_GT] = ACTIONS(824),
    [anon_sym_AMP_GT_GT] = ACTIONS(826),
    [anon_sym_LT_AMP] = ACTIONS(826),
    [anon_sym_GT_AMP] = ACTIONS(826),
    [sym_comment] = ACTIONS(52),
  },
  [207] = {
    [sym_concatenation] = STATE(363),
    [sym_string] = STATE(467),
    [sym_simple_expansion] = STATE(467),
    [sym_expansion] = STATE(467),
    [sym_command_substitution] = STATE(467),
    [sym_process_substitution] = STATE(467),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(828),
    [anon_sym_DOLLAR] = ACTIONS(588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(592),
    [anon_sym_BQUOTE] = ACTIONS(594),
    [anon_sym_LT_LPAREN] = ACTIONS(596),
    [anon_sym_GT_LPAREN] = ACTIONS(596),
    [sym_word] = ACTIONS(830),
    [sym_comment] = ACTIONS(52),
  },
  [208] = {
    [aux_sym_concatenation_repeat1] = STATE(199),
    [sym_file_descriptor] = ACTIONS(364),
    [sym__concat] = ACTIONS(154),
    [anon_sym_PIPE] = ACTIONS(366),
    [anon_sym_RPAREN] = ACTIONS(366),
    [anon_sym_SEMI_SEMI] = ACTIONS(366),
    [anon_sym_PIPE_AMP] = ACTIONS(366),
    [anon_sym_AMP_AMP] = ACTIONS(366),
    [anon_sym_PIPE_PIPE] = ACTIONS(366),
    [anon_sym_LT] = ACTIONS(366),
    [anon_sym_GT] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(366),
    [anon_sym_AMP_GT] = ACTIONS(366),
    [anon_sym_AMP_GT_GT] = ACTIONS(366),
    [anon_sym_LT_AMP] = ACTIONS(366),
    [anon_sym_GT_AMP] = ACTIONS(366),
    [anon_sym_LT_LT] = ACTIONS(366),
    [anon_sym_LT_LT_DASH] = ACTIONS(366),
    [anon_sym_DQUOTE] = ACTIONS(366),
    [sym_raw_string] = ACTIONS(366),
    [anon_sym_DOLLAR] = ACTIONS(366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(366),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(366),
    [anon_sym_GT_LPAREN] = ACTIONS(366),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(366),
    [anon_sym_LF] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(366),
  },
  [209] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(208),
    [sym_simple_expansion] = STATE(208),
    [sym_expansion] = STATE(208),
    [sym_command_substitution] = STATE(208),
    [sym_process_substitution] = STATE(208),
    [aux_sym_for_statement_repeat1] = STATE(468),
    [aux_sym_command_repeat2] = STATE(469),
    [sym_file_descriptor] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_SEMI_SEMI] = ACTIONS(608),
    [anon_sym_PIPE_AMP] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(608),
    [anon_sym_PIPE_PIPE] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_word] = ACTIONS(354),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_LF] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(608),
  },
  [210] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [aux_sym_command_repeat2] = STATE(470),
    [sym_file_descriptor] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_SEMI_SEMI] = ACTIONS(608),
    [anon_sym_PIPE_AMP] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(608),
    [anon_sym_PIPE_PIPE] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_LF] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(608),
  },
  [211] = {
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(832),
    [anon_sym_SEMI_SEMI] = ACTIONS(834),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(834),
    [anon_sym_LF] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(834),
  },
  [212] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(832),
    [anon_sym_SEMI_SEMI] = ACTIONS(834),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(834),
    [anon_sym_LF] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(834),
  },
  [213] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(213),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(610),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_case] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(645),
    [anon_sym_LT_AMP] = ACTIONS(645),
    [anon_sym_GT_AMP] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(663),
    [anon_sym_LT_LPAREN] = ACTIONS(666),
    [anon_sym_GT_LPAREN] = ACTIONS(666),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(52),
  },
  [214] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(208),
    [sym_simple_expansion] = STATE(208),
    [sym_expansion] = STATE(208),
    [sym_command_substitution] = STATE(208),
    [sym_process_substitution] = STATE(208),
    [aux_sym_for_statement_repeat1] = STATE(472),
    [aux_sym_command_repeat2] = STATE(469),
    [sym_file_descriptor] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(608),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_SEMI_SEMI] = ACTIONS(608),
    [anon_sym_PIPE_AMP] = ACTIONS(608),
    [anon_sym_AMP_AMP] = ACTIONS(608),
    [anon_sym_PIPE_PIPE] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_word] = ACTIONS(354),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(608),
    [anon_sym_LF] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(608),
  },
  [215] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_RBRACE] = ACTIONS(416),
    [anon_sym_RBRACK] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_word] = ACTIONS(418),
    [sym_comment] = ACTIONS(52),
  },
  [216] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [217] = {
    [sym_string] = STATE(474),
    [sym_simple_expansion] = STATE(474),
    [sym_expansion] = STATE(474),
    [sym_command_substitution] = STATE(474),
    [sym_process_substitution] = STATE(474),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(840),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(842),
    [sym_comment] = ACTIONS(52),
  },
  [218] = {
    [aux_sym_concatenation_repeat1] = STATE(475),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACK] = ACTIONS(844),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [sym_raw_string] = ACTIONS(440),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [anon_sym_LT_LPAREN] = ACTIONS(440),
    [anon_sym_GT_LPAREN] = ACTIONS(440),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(52),
  },
  [219] = {
    [sym__concat] = ACTIONS(444),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(456),
    [anon_sym_DQUOTE] = ACTIONS(444),
    [sym_raw_string] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(444),
    [anon_sym_BQUOTE] = ACTIONS(444),
    [anon_sym_LT_LPAREN] = ACTIONS(444),
    [anon_sym_GT_LPAREN] = ACTIONS(444),
    [sym_word] = ACTIONS(446),
    [sym_comment] = ACTIONS(52),
  },
  [220] = {
    [sym__concat] = ACTIONS(448),
    [anon_sym_RBRACE] = ACTIONS(448),
    [anon_sym_RBRACK] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(448),
    [sym_raw_string] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(448),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(448),
    [anon_sym_BQUOTE] = ACTIONS(448),
    [anon_sym_LT_LPAREN] = ACTIONS(448),
    [anon_sym_GT_LPAREN] = ACTIONS(448),
    [sym_word] = ACTIONS(450),
    [sym_comment] = ACTIONS(52),
  },
  [221] = {
    [sym__concat] = ACTIONS(452),
    [anon_sym_RBRACE] = ACTIONS(452),
    [anon_sym_RBRACK] = ACTIONS(848),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(452),
    [anon_sym_DOLLAR] = ACTIONS(848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(452),
    [anon_sym_BQUOTE] = ACTIONS(452),
    [anon_sym_LT_LPAREN] = ACTIONS(452),
    [anon_sym_GT_LPAREN] = ACTIONS(452),
    [sym_word] = ACTIONS(454),
    [sym_comment] = ACTIONS(52),
  },
  [222] = {
    [sym_special_variable_name] = STATE(477),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(850),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [223] = {
    [anon_sym_RBRACE] = ACTIONS(852),
    [anon_sym_LBRACK] = ACTIONS(854),
    [anon_sym_EQ] = ACTIONS(856),
    [anon_sym_COLON] = ACTIONS(858),
    [anon_sym_COLON_QMARK] = ACTIONS(856),
    [anon_sym_COLON_DASH] = ACTIONS(856),
    [anon_sym_PERCENT] = ACTIONS(856),
    [anon_sym_SLASH] = ACTIONS(856),
    [sym_comment] = ACTIONS(52),
  },
  [224] = {
    [anon_sym_RBRACE] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(862),
    [anon_sym_EQ] = ACTIONS(864),
    [anon_sym_COLON] = ACTIONS(866),
    [anon_sym_COLON_QMARK] = ACTIONS(864),
    [anon_sym_COLON_DASH] = ACTIONS(864),
    [anon_sym_PERCENT] = ACTIONS(864),
    [anon_sym_SLASH] = ACTIONS(864),
    [sym_comment] = ACTIONS(52),
  },
  [225] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(868),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [226] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(868),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [227] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(868),
    [sym_comment] = ACTIONS(52),
  },
  [228] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(868),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [229] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(870),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [230] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(870),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [231] = {
    [anon_sym_PIPE] = ACTIONS(872),
    [anon_sym_RPAREN] = ACTIONS(872),
    [anon_sym_SEMI_SEMI] = ACTIONS(872),
    [anon_sym_PIPE_AMP] = ACTIONS(872),
    [anon_sym_AMP_AMP] = ACTIONS(872),
    [anon_sym_PIPE_PIPE] = ACTIONS(872),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(872),
    [anon_sym_LF] = ACTIONS(872),
    [anon_sym_AMP] = ACTIONS(872),
  },
  [232] = {
    [sym_concatenation] = STATE(65),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_for_statement_repeat1] = STATE(232),
    [anon_sym_RBRACK] = ACTIONS(874),
    [anon_sym_DQUOTE] = ACTIONS(876),
    [sym_raw_string] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(882),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(888),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [anon_sym_LT_LPAREN] = ACTIONS(894),
    [anon_sym_GT_LPAREN] = ACTIONS(894),
    [sym_word] = ACTIONS(897),
    [sym_comment] = ACTIONS(52),
  },
  [233] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_word] = ACTIONS(418),
    [sym_comment] = ACTIONS(52),
  },
  [234] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(900),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [235] = {
    [sym_string] = STATE(487),
    [sym_simple_expansion] = STATE(487),
    [sym_expansion] = STATE(487),
    [sym_command_substitution] = STATE(487),
    [sym_process_substitution] = STATE(487),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(902),
    [anon_sym_DOLLAR] = ACTIONS(110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(114),
    [anon_sym_BQUOTE] = ACTIONS(116),
    [anon_sym_LT_LPAREN] = ACTIONS(118),
    [anon_sym_GT_LPAREN] = ACTIONS(118),
    [sym_word] = ACTIONS(904),
    [sym_comment] = ACTIONS(52),
  },
  [236] = {
    [aux_sym_concatenation_repeat1] = STATE(488),
    [sym__concat] = ACTIONS(384),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(844),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [sym_raw_string] = ACTIONS(440),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [anon_sym_LT_LPAREN] = ACTIONS(440),
    [anon_sym_GT_LPAREN] = ACTIONS(440),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(52),
  },
  [237] = {
    [sym__concat] = ACTIONS(444),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(456),
    [anon_sym_DQUOTE] = ACTIONS(444),
    [sym_raw_string] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(444),
    [anon_sym_BQUOTE] = ACTIONS(444),
    [anon_sym_LT_LPAREN] = ACTIONS(444),
    [anon_sym_GT_LPAREN] = ACTIONS(444),
    [sym_word] = ACTIONS(446),
    [sym_comment] = ACTIONS(52),
  },
  [238] = {
    [sym__concat] = ACTIONS(448),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(846),
    [anon_sym_DQUOTE] = ACTIONS(448),
    [sym_raw_string] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(448),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(448),
    [anon_sym_BQUOTE] = ACTIONS(448),
    [anon_sym_LT_LPAREN] = ACTIONS(448),
    [anon_sym_GT_LPAREN] = ACTIONS(448),
    [sym_word] = ACTIONS(450),
    [sym_comment] = ACTIONS(52),
  },
  [239] = {
    [sym__concat] = ACTIONS(452),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(848),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(452),
    [anon_sym_DOLLAR] = ACTIONS(848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(452),
    [anon_sym_BQUOTE] = ACTIONS(452),
    [anon_sym_LT_LPAREN] = ACTIONS(452),
    [anon_sym_GT_LPAREN] = ACTIONS(452),
    [sym_word] = ACTIONS(454),
    [sym_comment] = ACTIONS(52),
  },
  [240] = {
    [sym_special_variable_name] = STATE(490),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(906),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [241] = {
    [anon_sym_RBRACE] = ACTIONS(908),
    [anon_sym_LBRACK] = ACTIONS(910),
    [anon_sym_EQ] = ACTIONS(912),
    [anon_sym_COLON] = ACTIONS(914),
    [anon_sym_COLON_QMARK] = ACTIONS(912),
    [anon_sym_COLON_DASH] = ACTIONS(912),
    [anon_sym_PERCENT] = ACTIONS(912),
    [anon_sym_SLASH] = ACTIONS(912),
    [sym_comment] = ACTIONS(52),
  },
  [242] = {
    [anon_sym_RBRACE] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(918),
    [anon_sym_EQ] = ACTIONS(920),
    [anon_sym_COLON] = ACTIONS(922),
    [anon_sym_COLON_QMARK] = ACTIONS(920),
    [anon_sym_COLON_DASH] = ACTIONS(920),
    [anon_sym_PERCENT] = ACTIONS(920),
    [anon_sym_SLASH] = ACTIONS(920),
    [sym_comment] = ACTIONS(52),
  },
  [243] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(924),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [244] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(924),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [245] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(924),
    [sym_comment] = ACTIONS(52),
  },
  [246] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(924),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [247] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [248] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [249] = {
    [sym_concatenation] = STATE(74),
    [sym_string] = STATE(68),
    [sym_simple_expansion] = STATE(68),
    [sym_expansion] = STATE(68),
    [sym_command_substitution] = STATE(68),
    [sym_process_substitution] = STATE(68),
    [aux_sym_for_statement_repeat1] = STATE(249),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(874),
    [anon_sym_DQUOTE] = ACTIONS(928),
    [sym_raw_string] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(934),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(937),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(940),
    [anon_sym_BQUOTE] = ACTIONS(943),
    [anon_sym_LT_LPAREN] = ACTIONS(946),
    [anon_sym_GT_LPAREN] = ACTIONS(946),
    [sym_word] = ACTIONS(949),
    [sym_comment] = ACTIONS(52),
  },
  [250] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [sym_variable_name] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(836),
    [anon_sym_GT] = ACTIONS(836),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_AMP_GT] = ACTIONS(836),
    [anon_sym_AMP_GT_GT] = ACTIONS(416),
    [anon_sym_LT_AMP] = ACTIONS(416),
    [anon_sym_GT_AMP] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_word] = ACTIONS(836),
    [sym_comment] = ACTIONS(52),
  },
  [251] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(952),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [252] = {
    [sym_string] = STATE(500),
    [sym_simple_expansion] = STATE(500),
    [sym_expansion] = STATE(500),
    [sym_command_substitution] = STATE(500),
    [sym_process_substitution] = STATE(500),
    [anon_sym_DQUOTE] = ACTIONS(122),
    [sym_raw_string] = ACTIONS(954),
    [anon_sym_DOLLAR] = ACTIONS(126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(130),
    [anon_sym_BQUOTE] = ACTIONS(132),
    [anon_sym_LT_LPAREN] = ACTIONS(134),
    [anon_sym_GT_LPAREN] = ACTIONS(134),
    [sym_word] = ACTIONS(956),
    [sym_comment] = ACTIONS(52),
  },
  [253] = {
    [aux_sym_concatenation_repeat1] = STATE(501),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(402),
    [sym_variable_name] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_AMP_GT] = ACTIONS(844),
    [anon_sym_AMP_GT_GT] = ACTIONS(440),
    [anon_sym_LT_AMP] = ACTIONS(440),
    [anon_sym_GT_AMP] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [sym_raw_string] = ACTIONS(440),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [anon_sym_LT_LPAREN] = ACTIONS(440),
    [anon_sym_GT_LPAREN] = ACTIONS(440),
    [sym_word] = ACTIONS(844),
    [sym_comment] = ACTIONS(52),
  },
  [254] = {
    [sym_file_descriptor] = ACTIONS(444),
    [sym__concat] = ACTIONS(444),
    [sym_variable_name] = ACTIONS(444),
    [anon_sym_LT] = ACTIONS(456),
    [anon_sym_GT] = ACTIONS(456),
    [anon_sym_GT_GT] = ACTIONS(444),
    [anon_sym_AMP_GT] = ACTIONS(456),
    [anon_sym_AMP_GT_GT] = ACTIONS(444),
    [anon_sym_LT_AMP] = ACTIONS(444),
    [anon_sym_GT_AMP] = ACTIONS(444),
    [anon_sym_DQUOTE] = ACTIONS(444),
    [sym_raw_string] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(444),
    [anon_sym_BQUOTE] = ACTIONS(444),
    [anon_sym_LT_LPAREN] = ACTIONS(444),
    [anon_sym_GT_LPAREN] = ACTIONS(444),
    [sym_word] = ACTIONS(456),
    [sym_comment] = ACTIONS(52),
  },
  [255] = {
    [sym_file_descriptor] = ACTIONS(448),
    [sym__concat] = ACTIONS(448),
    [sym_variable_name] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(846),
    [anon_sym_GT_GT] = ACTIONS(448),
    [anon_sym_AMP_GT] = ACTIONS(846),
    [anon_sym_AMP_GT_GT] = ACTIONS(448),
    [anon_sym_LT_AMP] = ACTIONS(448),
    [anon_sym_GT_AMP] = ACTIONS(448),
    [anon_sym_DQUOTE] = ACTIONS(448),
    [sym_raw_string] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(448),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(448),
    [anon_sym_BQUOTE] = ACTIONS(448),
    [anon_sym_LT_LPAREN] = ACTIONS(448),
    [anon_sym_GT_LPAREN] = ACTIONS(448),
    [sym_word] = ACTIONS(846),
    [sym_comment] = ACTIONS(52),
  },
  [256] = {
    [sym_file_descriptor] = ACTIONS(452),
    [sym__concat] = ACTIONS(452),
    [sym_variable_name] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(848),
    [anon_sym_GT] = ACTIONS(848),
    [anon_sym_GT_GT] = ACTIONS(452),
    [anon_sym_AMP_GT] = ACTIONS(848),
    [anon_sym_AMP_GT_GT] = ACTIONS(452),
    [anon_sym_LT_AMP] = ACTIONS(452),
    [anon_sym_GT_AMP] = ACTIONS(452),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(452),
    [anon_sym_DOLLAR] = ACTIONS(848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(452),
    [anon_sym_BQUOTE] = ACTIONS(452),
    [anon_sym_LT_LPAREN] = ACTIONS(452),
    [anon_sym_GT_LPAREN] = ACTIONS(452),
    [sym_word] = ACTIONS(848),
    [sym_comment] = ACTIONS(52),
  },
  [257] = {
    [sym_special_variable_name] = STATE(503),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(958),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [258] = {
    [anon_sym_RBRACE] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_EQ] = ACTIONS(964),
    [anon_sym_COLON] = ACTIONS(966),
    [anon_sym_COLON_QMARK] = ACTIONS(964),
    [anon_sym_COLON_DASH] = ACTIONS(964),
    [anon_sym_PERCENT] = ACTIONS(964),
    [anon_sym_SLASH] = ACTIONS(964),
    [sym_comment] = ACTIONS(52),
  },
  [259] = {
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_LBRACK] = ACTIONS(970),
    [anon_sym_EQ] = ACTIONS(972),
    [anon_sym_COLON] = ACTIONS(974),
    [anon_sym_COLON_QMARK] = ACTIONS(972),
    [anon_sym_COLON_DASH] = ACTIONS(972),
    [anon_sym_PERCENT] = ACTIONS(972),
    [anon_sym_SLASH] = ACTIONS(972),
    [sym_comment] = ACTIONS(52),
  },
  [260] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(976),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [261] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(976),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [262] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(976),
    [sym_comment] = ACTIONS(52),
  },
  [263] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(976),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [264] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(978),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [265] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(978),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [266] = {
    [anon_sym_DQUOTE] = ACTIONS(446),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(456),
    [anon_sym_DOLLAR] = ACTIONS(446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(446),
    [anon_sym_BQUOTE] = ACTIONS(446),
    [sym_comment] = ACTIONS(150),
  },
  [267] = {
    [anon_sym_DQUOTE] = ACTIONS(450),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(846),
    [anon_sym_DOLLAR] = ACTIONS(450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(450),
    [anon_sym_BQUOTE] = ACTIONS(450),
    [sym_comment] = ACTIONS(150),
  },
  [268] = {
    [anon_sym_DQUOTE] = ACTIONS(454),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(848),
    [anon_sym_DOLLAR] = ACTIONS(454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(454),
    [anon_sym_BQUOTE] = ACTIONS(454),
    [sym_comment] = ACTIONS(150),
  },
  [269] = {
    [sym_special_variable_name] = STATE(513),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(980),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [270] = {
    [anon_sym_RBRACE] = ACTIONS(982),
    [anon_sym_LBRACK] = ACTIONS(984),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_COLON] = ACTIONS(988),
    [anon_sym_COLON_QMARK] = ACTIONS(986),
    [anon_sym_COLON_DASH] = ACTIONS(986),
    [anon_sym_PERCENT] = ACTIONS(986),
    [anon_sym_SLASH] = ACTIONS(986),
    [sym_comment] = ACTIONS(52),
  },
  [271] = {
    [anon_sym_RBRACE] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_EQ] = ACTIONS(994),
    [anon_sym_COLON] = ACTIONS(996),
    [anon_sym_COLON_QMARK] = ACTIONS(994),
    [anon_sym_COLON_DASH] = ACTIONS(994),
    [anon_sym_PERCENT] = ACTIONS(994),
    [anon_sym_SLASH] = ACTIONS(994),
    [sym_comment] = ACTIONS(52),
  },
  [272] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [273] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(998),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [274] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(998),
    [sym_comment] = ACTIONS(52),
  },
  [275] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(998),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [276] = {
    [sym_file_descriptor] = ACTIONS(1000),
    [sym__concat] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1002),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [anon_sym_SEMI_SEMI] = ACTIONS(1002),
    [anon_sym_PIPE_AMP] = ACTIONS(1002),
    [anon_sym_AMP_AMP] = ACTIONS(1002),
    [anon_sym_PIPE_PIPE] = ACTIONS(1002),
    [anon_sym_LT] = ACTIONS(1002),
    [anon_sym_GT] = ACTIONS(1002),
    [anon_sym_GT_GT] = ACTIONS(1002),
    [anon_sym_AMP_GT] = ACTIONS(1002),
    [anon_sym_AMP_GT_GT] = ACTIONS(1002),
    [anon_sym_LT_AMP] = ACTIONS(1002),
    [anon_sym_GT_AMP] = ACTIONS(1002),
    [anon_sym_LT_LT] = ACTIONS(1002),
    [anon_sym_LT_LT_DASH] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_raw_string] = ACTIONS(1002),
    [anon_sym_DOLLAR] = ACTIONS(1002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1002),
    [anon_sym_LT_LPAREN] = ACTIONS(1002),
    [anon_sym_GT_LPAREN] = ACTIONS(1002),
    [sym_word] = ACTIONS(1002),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_LF] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
  },
  [277] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(1004),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1006),
    [anon_sym_DOLLAR] = ACTIONS(1009),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1012),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1015),
    [anon_sym_BQUOTE] = ACTIONS(1018),
    [sym_comment] = ACTIONS(150),
  },
  [278] = {
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_LT_LT_DASH] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [sym_raw_string] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LPAREN] = ACTIONS(1023),
    [anon_sym_GT_LPAREN] = ACTIONS(1023),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [279] = {
    [aux_sym_concatenation_repeat1] = STATE(279),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_LT_LT_DASH] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [sym_raw_string] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LPAREN] = ACTIONS(1023),
    [anon_sym_GT_LPAREN] = ACTIONS(1023),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [280] = {
    [anon_sym_RBRACE] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1030),
    [sym_comment] = ACTIONS(52),
  },
  [281] = {
    [anon_sym_RBRACE] = ACTIONS(1032),
    [anon_sym_LBRACK] = ACTIONS(1034),
    [sym_comment] = ACTIONS(52),
  },
  [282] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT_GT] = ACTIONS(1038),
    [anon_sym_LT_AMP] = ACTIONS(1038),
    [anon_sym_GT_AMP] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_LT_LT_DASH] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_raw_string] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LPAREN] = ACTIONS(1038),
    [anon_sym_GT_LPAREN] = ACTIONS(1038),
    [sym_word] = ACTIONS(1038),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
  },
  [283] = {
    [anon_sym_AT] = ACTIONS(1040),
    [sym_comment] = ACTIONS(52),
  },
  [284] = {
    [sym_concatenation] = STATE(527),
    [sym_string] = STATE(526),
    [sym_simple_expansion] = STATE(526),
    [sym_expansion] = STATE(526),
    [sym_command_substitution] = STATE(526),
    [sym_process_substitution] = STATE(526),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1044),
    [sym_comment] = ACTIONS(52),
  },
  [285] = {
    [sym_file_descriptor] = ACTIONS(1046),
    [sym__concat] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1048),
    [anon_sym_RPAREN] = ACTIONS(1048),
    [anon_sym_SEMI_SEMI] = ACTIONS(1048),
    [anon_sym_PIPE_AMP] = ACTIONS(1048),
    [anon_sym_AMP_AMP] = ACTIONS(1048),
    [anon_sym_PIPE_PIPE] = ACTIONS(1048),
    [anon_sym_LT] = ACTIONS(1048),
    [anon_sym_GT] = ACTIONS(1048),
    [anon_sym_GT_GT] = ACTIONS(1048),
    [anon_sym_AMP_GT] = ACTIONS(1048),
    [anon_sym_AMP_GT_GT] = ACTIONS(1048),
    [anon_sym_LT_AMP] = ACTIONS(1048),
    [anon_sym_GT_AMP] = ACTIONS(1048),
    [anon_sym_LT_LT] = ACTIONS(1048),
    [anon_sym_LT_LT_DASH] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1048),
    [sym_raw_string] = ACTIONS(1048),
    [anon_sym_DOLLAR] = ACTIONS(1048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1048),
    [anon_sym_BQUOTE] = ACTIONS(1048),
    [anon_sym_LT_LPAREN] = ACTIONS(1048),
    [anon_sym_GT_LPAREN] = ACTIONS(1048),
    [sym_word] = ACTIONS(1048),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1048),
    [anon_sym_LF] = ACTIONS(1048),
    [anon_sym_AMP] = ACTIONS(1048),
  },
  [286] = {
    [anon_sym_AT] = ACTIONS(1050),
    [sym_comment] = ACTIONS(52),
  },
  [287] = {
    [sym_concatenation] = STATE(530),
    [sym_string] = STATE(529),
    [sym_simple_expansion] = STATE(529),
    [sym_expansion] = STATE(529),
    [sym_command_substitution] = STATE(529),
    [sym_process_substitution] = STATE(529),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1052),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1054),
    [sym_comment] = ACTIONS(52),
  },
  [288] = {
    [sym_concatenation] = STATE(531),
    [sym_string] = STATE(534),
    [sym_array] = STATE(531),
    [sym_simple_expansion] = STATE(534),
    [sym_expansion] = STATE(534),
    [sym_command_substitution] = STATE(534),
    [sym_process_substitution] = STATE(534),
    [sym__empty_value] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1060),
    [sym_raw_string] = ACTIONS(1062),
    [anon_sym_DOLLAR] = ACTIONS(1064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1074),
    [sym_comment] = ACTIONS(52),
  },
  [289] = {
    [anon_sym_in] = ACTIONS(1076),
    [sym_comment] = ACTIONS(52),
  },
  [290] = {
    [sym_do_group] = STATE(542),
    [anon_sym_do] = ACTIONS(1078),
    [sym_comment] = ACTIONS(52),
  },
  [291] = {
    [anon_sym_then] = ACTIONS(1080),
    [sym_comment] = ACTIONS(52),
  },
  [292] = {
    [aux_sym_concatenation_repeat1] = STATE(182),
    [sym__concat] = ACTIONS(316),
    [anon_sym_in] = ACTIONS(1082),
    [anon_sym_SEMI_SEMI] = ACTIONS(1084),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1084),
    [anon_sym_LF] = ACTIONS(1084),
    [anon_sym_AMP] = ACTIONS(1084),
  },
  [293] = {
    [anon_sym_in] = ACTIONS(1082),
    [anon_sym_SEMI_SEMI] = ACTIONS(1084),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1084),
    [anon_sym_LF] = ACTIONS(1084),
    [anon_sym_AMP] = ACTIONS(1084),
  },
  [294] = {
    [sym_compound_statement] = STATE(547),
    [anon_sym_LPAREN] = ACTIONS(1086),
    [anon_sym_LBRACE] = ACTIONS(504),
    [sym_comment] = ACTIONS(52),
  },
  [295] = {
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(1088),
    [anon_sym_SEMI_SEMI] = ACTIONS(1090),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_LF] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
  },
  [296] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(1088),
    [anon_sym_SEMI_SEMI] = ACTIONS(1090),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1090),
    [anon_sym_LF] = ACTIONS(1090),
    [anon_sym_AMP] = ACTIONS(1090),
  },
  [297] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(550),
    [sym_while_statement] = STATE(550),
    [sym_if_statement] = STATE(550),
    [sym_case_statement] = STATE(550),
    [sym_function_definition] = STATE(550),
    [sym_subshell] = STATE(550),
    [sym_pipeline] = STATE(550),
    [sym_list] = STATE(550),
    [sym_bracket_command] = STATE(550),
    [sym_command] = STATE(550),
    [sym_command_name] = STATE(53),
    [sym_environment_variable_assignment] = STATE(551),
    [sym_subscript] = STATE(55),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(50),
    [sym_simple_expansion] = STATE(50),
    [sym_expansion] = STATE(50),
    [sym_command_substitution] = STATE(50),
    [sym_process_substitution] = STATE(50),
    [aux_sym_program_repeat1] = STATE(213),
    [aux_sym_command_repeat1] = STATE(57),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(86),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(88),
    [sym_comment] = ACTIONS(52),
  },
  [298] = {
    [sym_concatenation] = STATE(65),
    [sym_string] = STATE(59),
    [sym_simple_expansion] = STATE(59),
    [sym_expansion] = STATE(59),
    [sym_command_substitution] = STATE(59),
    [sym_process_substitution] = STATE(59),
    [aux_sym_for_statement_repeat1] = STATE(232),
    [anon_sym_RBRACK] = ACTIONS(1092),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(92),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(380),
    [sym_comment] = ACTIONS(52),
  },
  [299] = {
    [sym_concatenation] = STATE(74),
    [sym_string] = STATE(68),
    [sym_simple_expansion] = STATE(68),
    [sym_expansion] = STATE(68),
    [sym_command_substitution] = STATE(68),
    [sym_process_substitution] = STATE(68),
    [aux_sym_for_statement_repeat1] = STATE(249),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1092),
    [anon_sym_DQUOTE] = ACTIONS(106),
    [sym_raw_string] = ACTIONS(108),
    [anon_sym_DOLLAR] = ACTIONS(110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(114),
    [anon_sym_BQUOTE] = ACTIONS(116),
    [anon_sym_LT_LPAREN] = ACTIONS(118),
    [anon_sym_GT_LPAREN] = ACTIONS(118),
    [sym_word] = ACTIONS(396),
    [sym_comment] = ACTIONS(52),
  },
  [300] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(836),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(836),
    [anon_sym_GT] = ACTIONS(836),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_AMP_GT] = ACTIONS(836),
    [anon_sym_AMP_GT_GT] = ACTIONS(416),
    [anon_sym_LT_AMP] = ACTIONS(416),
    [anon_sym_GT_AMP] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(836),
    [anon_sym_LT_LT_DASH] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_word] = ACTIONS(418),
    [sym_comment] = ACTIONS(52),
  },
  [301] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(1094),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [302] = {
    [sym_string] = STATE(554),
    [sym_simple_expansion] = STATE(554),
    [sym_expansion] = STATE(554),
    [sym_command_substitution] = STATE(554),
    [sym_process_substitution] = STATE(554),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(1096),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(1098),
    [sym_comment] = ACTIONS(52),
  },
  [303] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_PIPE_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_PIPE_PIPE] = ACTIONS(844),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_AMP_GT] = ACTIONS(844),
    [anon_sym_AMP_GT_GT] = ACTIONS(440),
    [anon_sym_LT_AMP] = ACTIONS(440),
    [anon_sym_GT_AMP] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(844),
    [anon_sym_LT_LT_DASH] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [sym_raw_string] = ACTIONS(440),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [anon_sym_LT_LPAREN] = ACTIONS(440),
    [anon_sym_GT_LPAREN] = ACTIONS(440),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(52),
  },
  [304] = {
    [sym_file_descriptor] = ACTIONS(444),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(456),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_PIPE_AMP] = ACTIONS(444),
    [anon_sym_AMP_AMP] = ACTIONS(444),
    [anon_sym_PIPE_PIPE] = ACTIONS(456),
    [anon_sym_LT] = ACTIONS(456),
    [anon_sym_GT] = ACTIONS(456),
    [anon_sym_GT_GT] = ACTIONS(444),
    [anon_sym_AMP_GT] = ACTIONS(456),
    [anon_sym_AMP_GT_GT] = ACTIONS(444),
    [anon_sym_LT_AMP] = ACTIONS(444),
    [anon_sym_GT_AMP] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(456),
    [anon_sym_LT_LT_DASH] = ACTIONS(444),
    [anon_sym_DQUOTE] = ACTIONS(444),
    [sym_raw_string] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(444),
    [anon_sym_BQUOTE] = ACTIONS(444),
    [anon_sym_LT_LPAREN] = ACTIONS(444),
    [anon_sym_GT_LPAREN] = ACTIONS(444),
    [sym_word] = ACTIONS(446),
    [sym_comment] = ACTIONS(52),
  },
  [305] = {
    [sym_file_descriptor] = ACTIONS(448),
    [sym__concat] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(846),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_PIPE_AMP] = ACTIONS(448),
    [anon_sym_AMP_AMP] = ACTIONS(448),
    [anon_sym_PIPE_PIPE] = ACTIONS(846),
    [anon_sym_LT] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(846),
    [anon_sym_GT_GT] = ACTIONS(448),
    [anon_sym_AMP_GT] = ACTIONS(846),
    [anon_sym_AMP_GT_GT] = ACTIONS(448),
    [anon_sym_LT_AMP] = ACTIONS(448),
    [anon_sym_GT_AMP] = ACTIONS(448),
    [anon_sym_LT_LT] = ACTIONS(846),
    [anon_sym_LT_LT_DASH] = ACTIONS(448),
    [anon_sym_DQUOTE] = ACTIONS(448),
    [sym_raw_string] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(448),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(448),
    [anon_sym_BQUOTE] = ACTIONS(448),
    [anon_sym_LT_LPAREN] = ACTIONS(448),
    [anon_sym_GT_LPAREN] = ACTIONS(448),
    [sym_word] = ACTIONS(450),
    [sym_comment] = ACTIONS(52),
  },
  [306] = {
    [sym_file_descriptor] = ACTIONS(452),
    [sym__concat] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_PIPE_AMP] = ACTIONS(452),
    [anon_sym_AMP_AMP] = ACTIONS(452),
    [anon_sym_PIPE_PIPE] = ACTIONS(848),
    [anon_sym_LT] = ACTIONS(848),
    [anon_sym_GT] = ACTIONS(848),
    [anon_sym_GT_GT] = ACTIONS(452),
    [anon_sym_AMP_GT] = ACTIONS(848),
    [anon_sym_AMP_GT_GT] = ACTIONS(452),
    [anon_sym_LT_AMP] = ACTIONS(452),
    [anon_sym_GT_AMP] = ACTIONS(452),
    [anon_sym_LT_LT] = ACTIONS(848),
    [anon_sym_LT_LT_DASH] = ACTIONS(452),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(452),
    [anon_sym_DOLLAR] = ACTIONS(848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(452),
    [anon_sym_BQUOTE] = ACTIONS(452),
    [anon_sym_LT_LPAREN] = ACTIONS(452),
    [anon_sym_GT_LPAREN] = ACTIONS(452),
    [sym_word] = ACTIONS(454),
    [sym_comment] = ACTIONS(52),
  },
  [307] = {
    [sym_special_variable_name] = STATE(557),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [308] = {
    [anon_sym_RBRACE] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1104),
    [anon_sym_EQ] = ACTIONS(1106),
    [anon_sym_COLON] = ACTIONS(1108),
    [anon_sym_COLON_QMARK] = ACTIONS(1106),
    [anon_sym_COLON_DASH] = ACTIONS(1106),
    [anon_sym_PERCENT] = ACTIONS(1106),
    [anon_sym_SLASH] = ACTIONS(1106),
    [sym_comment] = ACTIONS(52),
  },
  [309] = {
    [anon_sym_RBRACE] = ACTIONS(1110),
    [anon_sym_LBRACK] = ACTIONS(1112),
    [anon_sym_EQ] = ACTIONS(1114),
    [anon_sym_COLON] = ACTIONS(1116),
    [anon_sym_COLON_QMARK] = ACTIONS(1114),
    [anon_sym_COLON_DASH] = ACTIONS(1114),
    [anon_sym_PERCENT] = ACTIONS(1114),
    [anon_sym_SLASH] = ACTIONS(1114),
    [sym_comment] = ACTIONS(52),
  },
  [310] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1118),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [311] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1118),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [312] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(1118),
    [sym_comment] = ACTIONS(52),
  },
  [313] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(1118),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [314] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1120),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [315] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1120),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [316] = {
    [anon_sym_RPAREN] = ACTIONS(1122),
    [sym_comment] = ACTIONS(52),
  },
  [317] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(568),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [318] = {
    [sym_file_redirect] = STATE(571),
    [sym_file_descriptor] = ACTIONS(1126),
    [anon_sym_PIPE] = ACTIONS(1128),
    [anon_sym_RPAREN] = ACTIONS(1130),
    [anon_sym_PIPE_AMP] = ACTIONS(1130),
    [anon_sym_AMP_AMP] = ACTIONS(1130),
    [anon_sym_PIPE_PIPE] = ACTIONS(1130),
    [anon_sym_LT] = ACTIONS(1132),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_GT_GT] = ACTIONS(1134),
    [anon_sym_AMP_GT] = ACTIONS(1132),
    [anon_sym_AMP_GT_GT] = ACTIONS(1134),
    [anon_sym_LT_AMP] = ACTIONS(1134),
    [anon_sym_GT_AMP] = ACTIONS(1134),
    [sym_comment] = ACTIONS(52),
  },
  [319] = {
    [sym_for_statement] = STATE(572),
    [sym_while_statement] = STATE(572),
    [sym_if_statement] = STATE(572),
    [sym_case_statement] = STATE(572),
    [sym_function_definition] = STATE(572),
    [sym_subshell] = STATE(572),
    [sym_pipeline] = STATE(572),
    [sym_list] = STATE(572),
    [sym_bracket_command] = STATE(572),
    [sym_command] = STATE(572),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(573),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [320] = {
    [sym_file_descriptor] = ACTIONS(1136),
    [sym__concat] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1138),
    [anon_sym_RPAREN] = ACTIONS(1138),
    [anon_sym_SEMI_SEMI] = ACTIONS(1138),
    [anon_sym_PIPE_AMP] = ACTIONS(1138),
    [anon_sym_AMP_AMP] = ACTIONS(1138),
    [anon_sym_PIPE_PIPE] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1138),
    [anon_sym_GT] = ACTIONS(1138),
    [anon_sym_GT_GT] = ACTIONS(1138),
    [anon_sym_AMP_GT] = ACTIONS(1138),
    [anon_sym_AMP_GT_GT] = ACTIONS(1138),
    [anon_sym_LT_AMP] = ACTIONS(1138),
    [anon_sym_GT_AMP] = ACTIONS(1138),
    [anon_sym_LT_LT] = ACTIONS(1138),
    [anon_sym_LT_LT_DASH] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [sym_raw_string] = ACTIONS(1138),
    [anon_sym_DOLLAR] = ACTIONS(1138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1138),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [anon_sym_LT_LPAREN] = ACTIONS(1138),
    [anon_sym_GT_LPAREN] = ACTIONS(1138),
    [sym_word] = ACTIONS(1138),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_LF] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1138),
  },
  [321] = {
    [sym_for_statement] = STATE(574),
    [sym_while_statement] = STATE(574),
    [sym_if_statement] = STATE(574),
    [sym_case_statement] = STATE(574),
    [sym_function_definition] = STATE(574),
    [sym_subshell] = STATE(574),
    [sym_pipeline] = STATE(574),
    [sym_list] = STATE(574),
    [sym_bracket_command] = STATE(574),
    [sym_command] = STATE(574),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(575),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [322] = {
    [anon_sym_LT] = ACTIONS(1140),
    [anon_sym_GT] = ACTIONS(1140),
    [anon_sym_GT_GT] = ACTIONS(1142),
    [anon_sym_AMP_GT] = ACTIONS(1140),
    [anon_sym_AMP_GT_GT] = ACTIONS(1142),
    [anon_sym_LT_AMP] = ACTIONS(1142),
    [anon_sym_GT_AMP] = ACTIONS(1142),
    [sym_comment] = ACTIONS(52),
  },
  [323] = {
    [sym_concatenation] = STATE(584),
    [sym_string] = STATE(578),
    [sym_simple_expansion] = STATE(578),
    [sym_expansion] = STATE(578),
    [sym_command_substitution] = STATE(578),
    [sym_process_substitution] = STATE(578),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [sym_raw_string] = ACTIONS(1146),
    [anon_sym_DOLLAR] = ACTIONS(1148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1152),
    [anon_sym_BQUOTE] = ACTIONS(1154),
    [anon_sym_LT_LPAREN] = ACTIONS(1156),
    [anon_sym_GT_LPAREN] = ACTIONS(1156),
    [sym_word] = ACTIONS(1158),
    [sym_comment] = ACTIONS(52),
  },
  [324] = {
    [sym_heredoc] = STATE(587),
    [sym__simple_heredoc] = ACTIONS(1160),
    [sym__heredoc_beginning] = ACTIONS(1162),
    [sym_comment] = ACTIONS(52),
  },
  [325] = {
    [aux_sym_concatenation_repeat1] = STATE(303),
    [sym_file_descriptor] = ACTIONS(364),
    [sym__concat] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(362),
    [anon_sym_RPAREN] = ACTIONS(364),
    [anon_sym_PIPE_AMP] = ACTIONS(364),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(362),
    [anon_sym_LT] = ACTIONS(362),
    [anon_sym_GT] = ACTIONS(362),
    [anon_sym_GT_GT] = ACTIONS(364),
    [anon_sym_AMP_GT] = ACTIONS(362),
    [anon_sym_AMP_GT_GT] = ACTIONS(364),
    [anon_sym_LT_AMP] = ACTIONS(364),
    [anon_sym_GT_AMP] = ACTIONS(364),
    [anon_sym_LT_LT] = ACTIONS(362),
    [anon_sym_LT_LT_DASH] = ACTIONS(364),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(52),
  },
  [326] = {
    [sym_file_descriptor] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(1164),
    [anon_sym_RPAREN] = ACTIONS(604),
    [anon_sym_PIPE_AMP] = ACTIONS(604),
    [anon_sym_AMP_AMP] = ACTIONS(604),
    [anon_sym_PIPE_PIPE] = ACTIONS(604),
    [anon_sym_LT] = ACTIONS(1164),
    [anon_sym_GT] = ACTIONS(1164),
    [anon_sym_GT_GT] = ACTIONS(604),
    [anon_sym_AMP_GT] = ACTIONS(1164),
    [anon_sym_AMP_GT_GT] = ACTIONS(604),
    [anon_sym_LT_AMP] = ACTIONS(604),
    [anon_sym_GT_AMP] = ACTIONS(604),
    [anon_sym_LT_LT] = ACTIONS(1164),
    [anon_sym_LT_LT_DASH] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(604),
    [sym_comment] = ACTIONS(52),
  },
  [327] = {
    [sym_file_descriptor] = ACTIONS(364),
    [anon_sym_PIPE] = ACTIONS(362),
    [anon_sym_RPAREN] = ACTIONS(364),
    [anon_sym_PIPE_AMP] = ACTIONS(364),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(362),
    [anon_sym_LT] = ACTIONS(362),
    [anon_sym_GT] = ACTIONS(362),
    [anon_sym_GT_GT] = ACTIONS(364),
    [anon_sym_AMP_GT] = ACTIONS(362),
    [anon_sym_AMP_GT_GT] = ACTIONS(364),
    [anon_sym_LT_AMP] = ACTIONS(364),
    [anon_sym_GT_AMP] = ACTIONS(364),
    [anon_sym_LT_LT] = ACTIONS(362),
    [anon_sym_LT_LT_DASH] = ACTIONS(364),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(52),
  },
  [328] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(325),
    [sym_simple_expansion] = STATE(325),
    [sym_expansion] = STATE(325),
    [sym_command_substitution] = STATE(325),
    [sym_process_substitution] = STATE(325),
    [aux_sym_for_statement_repeat1] = STATE(588),
    [aux_sym_command_repeat2] = STATE(589),
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(1166),
    [anon_sym_RPAREN] = ACTIONS(1168),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_PIPE_PIPE] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
  },
  [329] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [aux_sym_command_repeat2] = STATE(590),
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(1166),
    [anon_sym_RPAREN] = ACTIONS(1168),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_PIPE_PIPE] = ACTIONS(1168),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [sym_comment] = ACTIONS(52),
  },
  [330] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(325),
    [sym_simple_expansion] = STATE(325),
    [sym_expansion] = STATE(325),
    [sym_command_substitution] = STATE(325),
    [sym_process_substitution] = STATE(325),
    [aux_sym_for_statement_repeat1] = STATE(591),
    [aux_sym_command_repeat2] = STATE(589),
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(1166),
    [anon_sym_RPAREN] = ACTIONS(1168),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_PIPE_PIPE] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
  },
  [331] = {
    [sym_concatenation] = STATE(531),
    [sym_string] = STATE(592),
    [sym_array] = STATE(531),
    [sym_simple_expansion] = STATE(592),
    [sym_expansion] = STATE(592),
    [sym_command_substitution] = STATE(592),
    [sym_process_substitution] = STATE(592),
    [sym__empty_value] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_DQUOTE] = ACTIONS(1060),
    [sym_raw_string] = ACTIONS(1170),
    [anon_sym_DOLLAR] = ACTIONS(1064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(1172),
    [sym_comment] = ACTIONS(52),
  },
  [332] = {
    [sym_compound_statement] = STATE(594),
    [anon_sym_LPAREN] = ACTIONS(1174),
    [anon_sym_LBRACE] = ACTIONS(504),
    [sym_comment] = ACTIONS(52),
  },
  [333] = {
    [aux_sym_concatenation_repeat1] = STATE(595),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_PIPE_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_PIPE_PIPE] = ACTIONS(844),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_AMP_GT] = ACTIONS(844),
    [anon_sym_AMP_GT_GT] = ACTIONS(440),
    [anon_sym_LT_AMP] = ACTIONS(440),
    [anon_sym_GT_AMP] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(844),
    [anon_sym_LT_LT_DASH] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [sym_raw_string] = ACTIONS(440),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [anon_sym_LT_LPAREN] = ACTIONS(440),
    [anon_sym_GT_LPAREN] = ACTIONS(440),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(52),
  },
  [334] = {
    [anon_sym_RPAREN] = ACTIONS(1176),
    [sym_comment] = ACTIONS(52),
  },
  [335] = {
    [sym_file_redirect] = STATE(571),
    [sym_file_descriptor] = ACTIONS(1178),
    [anon_sym_PIPE] = ACTIONS(1128),
    [anon_sym_PIPE_AMP] = ACTIONS(1130),
    [anon_sym_AMP_AMP] = ACTIONS(1130),
    [anon_sym_PIPE_PIPE] = ACTIONS(1130),
    [anon_sym_LT] = ACTIONS(1180),
    [anon_sym_GT] = ACTIONS(1180),
    [anon_sym_GT_GT] = ACTIONS(1182),
    [anon_sym_AMP_GT] = ACTIONS(1180),
    [anon_sym_AMP_GT_GT] = ACTIONS(1182),
    [anon_sym_LT_AMP] = ACTIONS(1182),
    [anon_sym_GT_AMP] = ACTIONS(1182),
    [anon_sym_BQUOTE] = ACTIONS(1130),
    [sym_comment] = ACTIONS(52),
  },
  [336] = {
    [sym_for_statement] = STATE(572),
    [sym_while_statement] = STATE(572),
    [sym_if_statement] = STATE(572),
    [sym_case_statement] = STATE(572),
    [sym_function_definition] = STATE(572),
    [sym_subshell] = STATE(572),
    [sym_pipeline] = STATE(572),
    [sym_list] = STATE(572),
    [sym_bracket_command] = STATE(572),
    [sym_command] = STATE(572),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(599),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [337] = {
    [sym_for_statement] = STATE(600),
    [sym_while_statement] = STATE(600),
    [sym_if_statement] = STATE(600),
    [sym_case_statement] = STATE(600),
    [sym_function_definition] = STATE(600),
    [sym_subshell] = STATE(600),
    [sym_pipeline] = STATE(600),
    [sym_list] = STATE(600),
    [sym_bracket_command] = STATE(600),
    [sym_command] = STATE(600),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(601),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [338] = {
    [anon_sym_LT] = ACTIONS(1184),
    [anon_sym_GT] = ACTIONS(1184),
    [anon_sym_GT_GT] = ACTIONS(1186),
    [anon_sym_AMP_GT] = ACTIONS(1184),
    [anon_sym_AMP_GT_GT] = ACTIONS(1186),
    [anon_sym_LT_AMP] = ACTIONS(1186),
    [anon_sym_GT_AMP] = ACTIONS(1186),
    [sym_comment] = ACTIONS(52),
  },
  [339] = {
    [sym_concatenation] = STATE(584),
    [sym_string] = STATE(603),
    [sym_simple_expansion] = STATE(603),
    [sym_expansion] = STATE(603),
    [sym_command_substitution] = STATE(603),
    [sym_process_substitution] = STATE(603),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [sym_raw_string] = ACTIONS(1188),
    [anon_sym_DOLLAR] = ACTIONS(1148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1152),
    [anon_sym_BQUOTE] = ACTIONS(1154),
    [anon_sym_LT_LPAREN] = ACTIONS(1156),
    [anon_sym_GT_LPAREN] = ACTIONS(1156),
    [sym_word] = ACTIONS(1190),
    [sym_comment] = ACTIONS(52),
  },
  [340] = {
    [aux_sym_concatenation_repeat1] = STATE(333),
    [sym_file_descriptor] = ACTIONS(364),
    [sym__concat] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(362),
    [anon_sym_PIPE_AMP] = ACTIONS(364),
    [anon_sym_AMP_AMP] = ACTIONS(364),
    [anon_sym_PIPE_PIPE] = ACTIONS(362),
    [anon_sym_LT] = ACTIONS(362),
    [anon_sym_GT] = ACTIONS(362),
    [anon_sym_GT_GT] = ACTIONS(364),
    [anon_sym_AMP_GT] = ACTIONS(362),
    [anon_sym_AMP_GT_GT] = ACTIONS(364),
    [anon_sym_LT_AMP] = ACTIONS(364),
    [anon_sym_GT_AMP] = ACTIONS(364),
    [anon_sym_LT_LT] = ACTIONS(362),
    [anon_sym_LT_LT_DASH] = ACTIONS(364),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(52),
  },
  [341] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(340),
    [sym_simple_expansion] = STATE(340),
    [sym_expansion] = STATE(340),
    [sym_command_substitution] = STATE(340),
    [sym_process_substitution] = STATE(340),
    [aux_sym_for_statement_repeat1] = STATE(604),
    [aux_sym_command_repeat2] = STATE(605),
    [sym_file_descriptor] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(1166),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_PIPE_PIPE] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(550),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_AMP_GT] = ACTIONS(550),
    [anon_sym_AMP_GT_GT] = ACTIONS(552),
    [anon_sym_LT_AMP] = ACTIONS(552),
    [anon_sym_GT_AMP] = ACTIONS(552),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(554),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(1168),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(556),
    [sym_comment] = ACTIONS(52),
  },
  [342] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [aux_sym_command_repeat2] = STATE(606),
    [sym_file_descriptor] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(1166),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_PIPE_PIPE] = ACTIONS(1168),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(550),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_AMP_GT] = ACTIONS(550),
    [anon_sym_AMP_GT_GT] = ACTIONS(552),
    [anon_sym_LT_AMP] = ACTIONS(552),
    [anon_sym_GT_AMP] = ACTIONS(552),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_BQUOTE] = ACTIONS(1168),
    [sym_comment] = ACTIONS(52),
  },
  [343] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(340),
    [sym_simple_expansion] = STATE(340),
    [sym_expansion] = STATE(340),
    [sym_command_substitution] = STATE(340),
    [sym_process_substitution] = STATE(340),
    [aux_sym_for_statement_repeat1] = STATE(607),
    [aux_sym_command_repeat2] = STATE(605),
    [sym_file_descriptor] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(1166),
    [anon_sym_PIPE_AMP] = ACTIONS(1168),
    [anon_sym_AMP_AMP] = ACTIONS(1168),
    [anon_sym_PIPE_PIPE] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(550),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_AMP_GT] = ACTIONS(550),
    [anon_sym_AMP_GT_GT] = ACTIONS(552),
    [anon_sym_LT_AMP] = ACTIONS(552),
    [anon_sym_GT_AMP] = ACTIONS(552),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(554),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(1168),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(556),
    [sym_comment] = ACTIONS(52),
  },
  [344] = {
    [sym_file_descriptor] = ACTIONS(1192),
    [sym__concat] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_RPAREN] = ACTIONS(1194),
    [anon_sym_SEMI_SEMI] = ACTIONS(1194),
    [anon_sym_PIPE_AMP] = ACTIONS(1194),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [anon_sym_LT] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_AMP_GT] = ACTIONS(1194),
    [anon_sym_AMP_GT_GT] = ACTIONS(1194),
    [anon_sym_LT_AMP] = ACTIONS(1194),
    [anon_sym_GT_AMP] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_LT_LT_DASH] = ACTIONS(1194),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [sym_raw_string] = ACTIONS(1194),
    [anon_sym_DOLLAR] = ACTIONS(1194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1194),
    [anon_sym_BQUOTE] = ACTIONS(1194),
    [anon_sym_LT_LPAREN] = ACTIONS(1194),
    [anon_sym_GT_LPAREN] = ACTIONS(1194),
    [sym_word] = ACTIONS(1194),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_AMP] = ACTIONS(1194),
  },
  [345] = {
    [sym_compound_statement] = STATE(608),
    [anon_sym_LBRACE] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
  },
  [346] = {
    [sym_file_descriptor] = ACTIONS(1196),
    [anon_sym_PIPE] = ACTIONS(1198),
    [anon_sym_RPAREN] = ACTIONS(1198),
    [anon_sym_SEMI_SEMI] = ACTIONS(1198),
    [anon_sym_PIPE_AMP] = ACTIONS(1198),
    [anon_sym_AMP_AMP] = ACTIONS(1198),
    [anon_sym_PIPE_PIPE] = ACTIONS(1198),
    [anon_sym_LT] = ACTIONS(1198),
    [anon_sym_GT] = ACTIONS(1198),
    [anon_sym_GT_GT] = ACTIONS(1198),
    [anon_sym_AMP_GT] = ACTIONS(1198),
    [anon_sym_AMP_GT_GT] = ACTIONS(1198),
    [anon_sym_LT_AMP] = ACTIONS(1198),
    [anon_sym_GT_AMP] = ACTIONS(1198),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1198),
    [anon_sym_LF] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1198),
  },
  [347] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(610),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [348] = {
    [anon_sym_LT] = ACTIONS(1202),
    [anon_sym_GT] = ACTIONS(1202),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1202),
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [sym_comment] = ACTIONS(52),
  },
  [349] = {
    [sym_concatenation] = STATE(619),
    [sym_string] = STATE(613),
    [sym_simple_expansion] = STATE(613),
    [sym_expansion] = STATE(613),
    [sym_command_substitution] = STATE(613),
    [sym_process_substitution] = STATE(613),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [sym_raw_string] = ACTIONS(1208),
    [anon_sym_DOLLAR] = ACTIONS(1210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [anon_sym_LT_LPAREN] = ACTIONS(1218),
    [anon_sym_GT_LPAREN] = ACTIONS(1218),
    [sym_word] = ACTIONS(1220),
    [sym_comment] = ACTIONS(52),
  },
  [350] = {
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_RPAREN] = ACTIONS(806),
    [anon_sym_SEMI_SEMI] = ACTIONS(806),
    [anon_sym_PIPE_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(806),
    [anon_sym_PIPE_PIPE] = ACTIONS(806),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_LF] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
  },
  [351] = {
    [anon_sym_PIPE] = ACTIONS(1222),
    [anon_sym_RPAREN] = ACTIONS(1222),
    [anon_sym_SEMI_SEMI] = ACTIONS(1222),
    [anon_sym_PIPE_AMP] = ACTIONS(1222),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_LF] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1222),
  },
  [352] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(1222),
    [anon_sym_RPAREN] = ACTIONS(1222),
    [anon_sym_SEMI_SEMI] = ACTIONS(1222),
    [anon_sym_PIPE_AMP] = ACTIONS(1222),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_LF] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1222),
  },
  [353] = {
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(1224),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(1224),
    [anon_sym_PIPE_PIPE] = ACTIONS(1224),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1224),
    [anon_sym_LF] = ACTIONS(1224),
    [anon_sym_AMP] = ACTIONS(1224),
  },
  [354] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(1224),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(1224),
    [anon_sym_PIPE_PIPE] = ACTIONS(1224),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1224),
    [anon_sym_LF] = ACTIONS(1224),
    [anon_sym_AMP] = ACTIONS(1224),
  },
  [355] = {
    [sym_concatenation] = STATE(621),
    [sym_string] = STATE(620),
    [sym_simple_expansion] = STATE(620),
    [sym_expansion] = STATE(620),
    [sym_command_substitution] = STATE(620),
    [sym_process_substitution] = STATE(620),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(1226),
    [anon_sym_DOLLAR] = ACTIONS(588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(592),
    [anon_sym_BQUOTE] = ACTIONS(594),
    [anon_sym_LT_LPAREN] = ACTIONS(596),
    [anon_sym_GT_LPAREN] = ACTIONS(596),
    [sym_word] = ACTIONS(1228),
    [sym_comment] = ACTIONS(52),
  },
  [356] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(623),
    [anon_sym_DQUOTE] = ACTIONS(1230),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [357] = {
    [aux_sym_concatenation_repeat1] = STATE(625),
    [sym_file_descriptor] = ACTIONS(400),
    [sym__concat] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_SEMI_SEMI] = ACTIONS(1234),
    [anon_sym_PIPE_AMP] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_PIPE_PIPE] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_AMP_GT] = ACTIONS(1234),
    [anon_sym_AMP_GT_GT] = ACTIONS(1234),
    [anon_sym_LT_AMP] = ACTIONS(1234),
    [anon_sym_GT_AMP] = ACTIONS(1234),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_LT_LT_DASH] = ACTIONS(1234),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1234),
    [anon_sym_LF] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
  },
  [358] = {
    [sym_special_variable_name] = STATE(628),
    [anon_sym_DOLLAR] = ACTIONS(1236),
    [anon_sym_POUND] = ACTIONS(1236),
    [anon_sym_AT] = ACTIONS(1236),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1238),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_BANG] = ACTIONS(1236),
    [anon_sym_0] = ACTIONS(1240),
    [anon_sym__] = ACTIONS(1240),
  },
  [359] = {
    [sym_special_variable_name] = STATE(631),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1244),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [360] = {
    [sym_for_statement] = STATE(632),
    [sym_while_statement] = STATE(632),
    [sym_if_statement] = STATE(632),
    [sym_case_statement] = STATE(632),
    [sym_function_definition] = STATE(632),
    [sym_subshell] = STATE(632),
    [sym_pipeline] = STATE(632),
    [sym_list] = STATE(632),
    [sym_bracket_command] = STATE(632),
    [sym_command] = STATE(632),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(633),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [361] = {
    [sym_for_statement] = STATE(634),
    [sym_while_statement] = STATE(634),
    [sym_if_statement] = STATE(634),
    [sym_case_statement] = STATE(634),
    [sym_function_definition] = STATE(634),
    [sym_subshell] = STATE(634),
    [sym_pipeline] = STATE(634),
    [sym_list] = STATE(634),
    [sym_bracket_command] = STATE(634),
    [sym_command] = STATE(634),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(635),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [362] = {
    [sym_for_statement] = STATE(636),
    [sym_while_statement] = STATE(636),
    [sym_if_statement] = STATE(636),
    [sym_case_statement] = STATE(636),
    [sym_function_definition] = STATE(636),
    [sym_subshell] = STATE(636),
    [sym_pipeline] = STATE(636),
    [sym_list] = STATE(636),
    [sym_bracket_command] = STATE(636),
    [sym_command] = STATE(636),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(637),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [363] = {
    [sym_file_descriptor] = ACTIONS(400),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_RPAREN] = ACTIONS(1234),
    [anon_sym_SEMI_SEMI] = ACTIONS(1234),
    [anon_sym_PIPE_AMP] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_PIPE_PIPE] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_AMP_GT] = ACTIONS(1234),
    [anon_sym_AMP_GT_GT] = ACTIONS(1234),
    [anon_sym_LT_AMP] = ACTIONS(1234),
    [anon_sym_GT_AMP] = ACTIONS(1234),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_LT_LT_DASH] = ACTIONS(1234),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1234),
    [anon_sym_LF] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
  },
  [364] = {
    [sym_file_descriptor] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1248),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_SEMI_SEMI] = ACTIONS(1248),
    [anon_sym_PIPE_AMP] = ACTIONS(1248),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1248),
    [anon_sym_GT_GT] = ACTIONS(1248),
    [anon_sym_AMP_GT] = ACTIONS(1248),
    [anon_sym_AMP_GT_GT] = ACTIONS(1248),
    [anon_sym_LT_AMP] = ACTIONS(1248),
    [anon_sym_GT_AMP] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1248),
    [anon_sym_LT_LT_DASH] = ACTIONS(1248),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_LF] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1248),
  },
  [365] = {
    [sym_simple_expansion] = STATE(638),
    [sym_expansion] = STATE(638),
    [aux_sym_heredoc_repeat1] = STATE(642),
    [sym__heredoc_middle] = ACTIONS(1250),
    [sym__heredoc_end] = ACTIONS(1252),
    [anon_sym_DOLLAR] = ACTIONS(1254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1256),
    [sym_comment] = ACTIONS(52),
  },
  [366] = {
    [sym_file_descriptor] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1260),
    [anon_sym_RPAREN] = ACTIONS(1260),
    [anon_sym_SEMI_SEMI] = ACTIONS(1260),
    [anon_sym_PIPE_AMP] = ACTIONS(1260),
    [anon_sym_AMP_AMP] = ACTIONS(1260),
    [anon_sym_PIPE_PIPE] = ACTIONS(1260),
    [anon_sym_LT] = ACTIONS(1260),
    [anon_sym_GT] = ACTIONS(1260),
    [anon_sym_GT_GT] = ACTIONS(1260),
    [anon_sym_AMP_GT] = ACTIONS(1260),
    [anon_sym_AMP_GT_GT] = ACTIONS(1260),
    [anon_sym_LT_AMP] = ACTIONS(1260),
    [anon_sym_GT_AMP] = ACTIONS(1260),
    [anon_sym_LT_LT] = ACTIONS(1260),
    [anon_sym_LT_LT_DASH] = ACTIONS(1260),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_LF] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1260),
  },
  [367] = {
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(143),
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [sym_process_substitution] = STATE(143),
    [aux_sym_for_statement_repeat1] = STATE(367),
    [sym_file_descriptor] = ACTIONS(1262),
    [anon_sym_PIPE] = ACTIONS(1264),
    [anon_sym_SEMI_SEMI] = ACTIONS(1264),
    [anon_sym_PIPE_AMP] = ACTIONS(1264),
    [anon_sym_AMP_AMP] = ACTIONS(1264),
    [anon_sym_PIPE_PIPE] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(1264),
    [anon_sym_GT] = ACTIONS(1264),
    [anon_sym_GT_GT] = ACTIONS(1264),
    [anon_sym_AMP_GT] = ACTIONS(1264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1264),
    [anon_sym_LT_AMP] = ACTIONS(1264),
    [anon_sym_GT_AMP] = ACTIONS(1264),
    [anon_sym_LT_LT] = ACTIONS(1264),
    [anon_sym_LT_LT_DASH] = ACTIONS(1264),
    [anon_sym_DQUOTE] = ACTIONS(1266),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1281),
    [anon_sym_LT_LPAREN] = ACTIONS(1284),
    [anon_sym_GT_LPAREN] = ACTIONS(1284),
    [sym_word] = ACTIONS(1269),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1264),
    [anon_sym_LF] = ACTIONS(1264),
    [anon_sym_AMP] = ACTIONS(1264),
  },
  [368] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [aux_sym_command_repeat2] = STATE(369),
    [sym_file_descriptor] = ACTIONS(232),
    [anon_sym_PIPE] = ACTIONS(1287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
  },
  [369] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [aux_sym_command_repeat2] = STATE(369),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_SEMI_SEMI] = ACTIONS(1292),
    [anon_sym_PIPE_AMP] = ACTIONS(1292),
    [anon_sym_AMP_AMP] = ACTIONS(1292),
    [anon_sym_PIPE_PIPE] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(1294),
    [anon_sym_GT] = ACTIONS(1294),
    [anon_sym_GT_GT] = ACTIONS(1294),
    [anon_sym_AMP_GT] = ACTIONS(1294),
    [anon_sym_AMP_GT_GT] = ACTIONS(1294),
    [anon_sym_LT_AMP] = ACTIONS(1294),
    [anon_sym_GT_AMP] = ACTIONS(1294),
    [anon_sym_LT_LT] = ACTIONS(1297),
    [anon_sym_LT_LT_DASH] = ACTIONS(1297),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1292),
    [anon_sym_LF] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1292),
  },
  [370] = {
    [sym_concatenation] = STATE(643),
    [sym_string] = STATE(645),
    [sym_array] = STATE(643),
    [sym_simple_expansion] = STATE(645),
    [sym_expansion] = STATE(645),
    [sym_command_substitution] = STATE(645),
    [sym_process_substitution] = STATE(645),
    [sym__empty_value] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_DQUOTE] = ACTIONS(122),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(130),
    [anon_sym_BQUOTE] = ACTIONS(132),
    [anon_sym_LT_LPAREN] = ACTIONS(134),
    [anon_sym_GT_LPAREN] = ACTIONS(134),
    [sym_word] = ACTIONS(1306),
    [sym_comment] = ACTIONS(52),
  },
  [371] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(143),
    [sym_simple_expansion] = STATE(143),
    [sym_expansion] = STATE(143),
    [sym_command_substitution] = STATE(143),
    [sym_process_substitution] = STATE(143),
    [aux_sym_for_statement_repeat1] = STATE(367),
    [aux_sym_command_repeat2] = STATE(646),
    [sym_file_descriptor] = ACTIONS(232),
    [anon_sym_PIPE] = ACTIONS(1287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [sym_raw_string] = ACTIONS(242),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_word] = ACTIONS(242),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
  },
  [372] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_RBRACK] = ACTIONS(416),
    [sym_comment] = ACTIONS(52),
  },
  [373] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [374] = {
    [sym_string] = STATE(648),
    [sym_simple_expansion] = STATE(648),
    [sym_expansion] = STATE(648),
    [sym_command_substitution] = STATE(648),
    [sym_process_substitution] = STATE(648),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1310),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1312),
    [sym_comment] = ACTIONS(52),
  },
  [375] = {
    [anon_sym_EQ] = ACTIONS(1314),
    [anon_sym_PLUS_EQ] = ACTIONS(1314),
    [sym_comment] = ACTIONS(52),
  },
  [376] = {
    [aux_sym_concatenation_repeat1] = STATE(649),
    [sym__concat] = ACTIONS(696),
    [anon_sym_RBRACK] = ACTIONS(440),
    [sym_comment] = ACTIONS(52),
  },
  [377] = {
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_RBRACK] = ACTIONS(444),
    [sym_comment] = ACTIONS(52),
  },
  [378] = {
    [sym__concat] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(448),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_RBRACK] = ACTIONS(448),
    [sym_comment] = ACTIONS(52),
  },
  [379] = {
    [sym__concat] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(452),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_RBRACK] = ACTIONS(452),
    [sym_comment] = ACTIONS(52),
  },
  [380] = {
    [sym_special_variable_name] = STATE(651),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [381] = {
    [anon_sym_RBRACE] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_EQ] = ACTIONS(1322),
    [anon_sym_COLON] = ACTIONS(1324),
    [anon_sym_COLON_QMARK] = ACTIONS(1322),
    [anon_sym_COLON_DASH] = ACTIONS(1322),
    [anon_sym_PERCENT] = ACTIONS(1322),
    [anon_sym_SLASH] = ACTIONS(1322),
    [sym_comment] = ACTIONS(52),
  },
  [382] = {
    [anon_sym_RBRACE] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_EQ] = ACTIONS(1330),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_COLON_QMARK] = ACTIONS(1330),
    [anon_sym_COLON_DASH] = ACTIONS(1330),
    [anon_sym_PERCENT] = ACTIONS(1330),
    [anon_sym_SLASH] = ACTIONS(1330),
    [sym_comment] = ACTIONS(52),
  },
  [383] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [384] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1334),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [385] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [sym_comment] = ACTIONS(52),
  },
  [386] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(1334),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [387] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [388] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [389] = {
    [sym_file_descriptor] = ACTIONS(1338),
    [sym_variable_name] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_RPAREN] = ACTIONS(1340),
    [anon_sym_SEMI_SEMI] = ACTIONS(1340),
    [anon_sym_PIPE_AMP] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1340),
    [anon_sym_PIPE_PIPE] = ACTIONS(1340),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_AMP_GT] = ACTIONS(1340),
    [anon_sym_AMP_GT_GT] = ACTIONS(1340),
    [anon_sym_LT_AMP] = ACTIONS(1340),
    [anon_sym_GT_AMP] = ACTIONS(1340),
    [anon_sym_DQUOTE] = ACTIONS(1340),
    [sym_raw_string] = ACTIONS(1340),
    [anon_sym_DOLLAR] = ACTIONS(1340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1340),
    [anon_sym_BQUOTE] = ACTIONS(1340),
    [anon_sym_LT_LPAREN] = ACTIONS(1340),
    [anon_sym_GT_LPAREN] = ACTIONS(1340),
    [sym_word] = ACTIONS(1340),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1340),
    [anon_sym_LF] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
  },
  [390] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(661),
    [anon_sym_DQUOTE] = ACTIONS(1342),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [391] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__concat] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(364),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(362),
    [sym_comment] = ACTIONS(52),
  },
  [392] = {
    [sym_special_variable_name] = STATE(666),
    [anon_sym_DOLLAR] = ACTIONS(1346),
    [anon_sym_POUND] = ACTIONS(1346),
    [anon_sym_AT] = ACTIONS(1346),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1348),
    [anon_sym_STAR] = ACTIONS(1346),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1346),
    [anon_sym_0] = ACTIONS(1350),
    [anon_sym__] = ACTIONS(1350),
  },
  [393] = {
    [sym_special_variable_name] = STATE(669),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(1352),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [394] = {
    [sym_for_statement] = STATE(670),
    [sym_while_statement] = STATE(670),
    [sym_if_statement] = STATE(670),
    [sym_case_statement] = STATE(670),
    [sym_function_definition] = STATE(670),
    [sym_subshell] = STATE(670),
    [sym_pipeline] = STATE(670),
    [sym_list] = STATE(670),
    [sym_bracket_command] = STATE(670),
    [sym_command] = STATE(670),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(671),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [395] = {
    [sym_for_statement] = STATE(672),
    [sym_while_statement] = STATE(672),
    [sym_if_statement] = STATE(672),
    [sym_case_statement] = STATE(672),
    [sym_function_definition] = STATE(672),
    [sym_subshell] = STATE(672),
    [sym_pipeline] = STATE(672),
    [sym_list] = STATE(672),
    [sym_bracket_command] = STATE(672),
    [sym_command] = STATE(672),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(673),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [396] = {
    [sym_for_statement] = STATE(674),
    [sym_while_statement] = STATE(674),
    [sym_if_statement] = STATE(674),
    [sym_case_statement] = STATE(674),
    [sym_function_definition] = STATE(674),
    [sym_subshell] = STATE(674),
    [sym_pipeline] = STATE(674),
    [sym_list] = STATE(674),
    [sym_bracket_command] = STATE(674),
    [sym_command] = STATE(674),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(675),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [397] = {
    [anon_sym_RPAREN] = ACTIONS(364),
    [anon_sym_DQUOTE] = ACTIONS(364),
    [sym_raw_string] = ACTIONS(364),
    [anon_sym_DOLLAR] = ACTIONS(362),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(364),
    [anon_sym_BQUOTE] = ACTIONS(364),
    [anon_sym_LT_LPAREN] = ACTIONS(364),
    [anon_sym_GT_LPAREN] = ACTIONS(364),
    [sym_word] = ACTIONS(362),
    [sym_comment] = ACTIONS(52),
  },
  [398] = {
    [sym_concatenation] = STATE(397),
    [sym_string] = STATE(391),
    [sym_simple_expansion] = STATE(391),
    [sym_expansion] = STATE(391),
    [sym_command_substitution] = STATE(391),
    [sym_process_substitution] = STATE(391),
    [aux_sym_for_statement_repeat1] = STATE(677),
    [anon_sym_RPAREN] = ACTIONS(1356),
    [anon_sym_DQUOTE] = ACTIONS(716),
    [sym_raw_string] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_word] = ACTIONS(730),
    [sym_comment] = ACTIONS(52),
  },
  [399] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [sym_variable_name] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(418),
    [anon_sym_GT_GT] = ACTIONS(418),
    [anon_sym_AMP_GT] = ACTIONS(418),
    [anon_sym_AMP_GT_GT] = ACTIONS(418),
    [anon_sym_LT_AMP] = ACTIONS(418),
    [anon_sym_GT_AMP] = ACTIONS(418),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [sym_raw_string] = ACTIONS(418),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(418),
    [anon_sym_BQUOTE] = ACTIONS(418),
    [anon_sym_LT_LPAREN] = ACTIONS(418),
    [anon_sym_GT_LPAREN] = ACTIONS(418),
    [sym_word] = ACTIONS(418),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [400] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(1358),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [401] = {
    [sym_string] = STATE(679),
    [sym_simple_expansion] = STATE(679),
    [sym_expansion] = STATE(679),
    [sym_command_substitution] = STATE(679),
    [sym_process_substitution] = STATE(679),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(298),
    [anon_sym_BQUOTE] = ACTIONS(300),
    [anon_sym_LT_LPAREN] = ACTIONS(302),
    [anon_sym_GT_LPAREN] = ACTIONS(302),
    [sym_word] = ACTIONS(1362),
    [sym_comment] = ACTIONS(52),
  },
  [402] = {
    [aux_sym_concatenation_repeat1] = STATE(680),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_PIPE_AMP] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(442),
    [anon_sym_AMP_GT] = ACTIONS(442),
    [anon_sym_AMP_GT_GT] = ACTIONS(442),
    [anon_sym_LT_AMP] = ACTIONS(442),
    [anon_sym_GT_AMP] = ACTIONS(442),
    [anon_sym_DQUOTE] = ACTIONS(442),
    [sym_raw_string] = ACTIONS(442),
    [anon_sym_DOLLAR] = ACTIONS(442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_LT_LPAREN] = ACTIONS(442),
    [anon_sym_GT_LPAREN] = ACTIONS(442),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [403] = {
    [sym_file_descriptor] = ACTIONS(444),
    [sym__concat] = ACTIONS(444),
    [sym_variable_name] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_SEMI_SEMI] = ACTIONS(446),
    [anon_sym_PIPE_AMP] = ACTIONS(446),
    [anon_sym_AMP_AMP] = ACTIONS(446),
    [anon_sym_PIPE_PIPE] = ACTIONS(446),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_DQUOTE] = ACTIONS(446),
    [sym_raw_string] = ACTIONS(446),
    [anon_sym_DOLLAR] = ACTIONS(446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(446),
    [anon_sym_BQUOTE] = ACTIONS(446),
    [anon_sym_LT_LPAREN] = ACTIONS(446),
    [anon_sym_GT_LPAREN] = ACTIONS(446),
    [sym_word] = ACTIONS(446),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym_LF] = ACTIONS(446),
    [anon_sym_AMP] = ACTIONS(446),
  },
  [404] = {
    [sym_file_descriptor] = ACTIONS(448),
    [sym__concat] = ACTIONS(448),
    [sym_variable_name] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(450),
    [anon_sym_RPAREN] = ACTIONS(450),
    [anon_sym_SEMI_SEMI] = ACTIONS(450),
    [anon_sym_PIPE_AMP] = ACTIONS(450),
    [anon_sym_AMP_AMP] = ACTIONS(450),
    [anon_sym_PIPE_PIPE] = ACTIONS(450),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_GT] = ACTIONS(450),
    [anon_sym_GT_GT] = ACTIONS(450),
    [anon_sym_AMP_GT] = ACTIONS(450),
    [anon_sym_AMP_GT_GT] = ACTIONS(450),
    [anon_sym_LT_AMP] = ACTIONS(450),
    [anon_sym_GT_AMP] = ACTIONS(450),
    [anon_sym_DQUOTE] = ACTIONS(450),
    [sym_raw_string] = ACTIONS(450),
    [anon_sym_DOLLAR] = ACTIONS(450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(450),
    [anon_sym_BQUOTE] = ACTIONS(450),
    [anon_sym_LT_LPAREN] = ACTIONS(450),
    [anon_sym_GT_LPAREN] = ACTIONS(450),
    [sym_word] = ACTIONS(450),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_LF] = ACTIONS(450),
    [anon_sym_AMP] = ACTIONS(450),
  },
  [405] = {
    [sym_file_descriptor] = ACTIONS(452),
    [sym__concat] = ACTIONS(452),
    [sym_variable_name] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(454),
    [anon_sym_RPAREN] = ACTIONS(454),
    [anon_sym_SEMI_SEMI] = ACTIONS(454),
    [anon_sym_PIPE_AMP] = ACTIONS(454),
    [anon_sym_AMP_AMP] = ACTIONS(454),
    [anon_sym_PIPE_PIPE] = ACTIONS(454),
    [anon_sym_LT] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(454),
    [anon_sym_GT_GT] = ACTIONS(454),
    [anon_sym_AMP_GT] = ACTIONS(454),
    [anon_sym_AMP_GT_GT] = ACTIONS(454),
    [anon_sym_LT_AMP] = ACTIONS(454),
    [anon_sym_GT_AMP] = ACTIONS(454),
    [anon_sym_DQUOTE] = ACTIONS(454),
    [sym_raw_string] = ACTIONS(454),
    [anon_sym_DOLLAR] = ACTIONS(454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(454),
    [anon_sym_BQUOTE] = ACTIONS(454),
    [anon_sym_LT_LPAREN] = ACTIONS(454),
    [anon_sym_GT_LPAREN] = ACTIONS(454),
    [sym_word] = ACTIONS(454),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_LF] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(454),
  },
  [406] = {
    [sym_special_variable_name] = STATE(682),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [407] = {
    [anon_sym_RBRACE] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1368),
    [anon_sym_EQ] = ACTIONS(1370),
    [anon_sym_COLON] = ACTIONS(1372),
    [anon_sym_COLON_QMARK] = ACTIONS(1370),
    [anon_sym_COLON_DASH] = ACTIONS(1370),
    [anon_sym_PERCENT] = ACTIONS(1370),
    [anon_sym_SLASH] = ACTIONS(1370),
    [sym_comment] = ACTIONS(52),
  },
  [408] = {
    [anon_sym_RBRACE] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_EQ] = ACTIONS(1378),
    [anon_sym_COLON] = ACTIONS(1380),
    [anon_sym_COLON_QMARK] = ACTIONS(1378),
    [anon_sym_COLON_DASH] = ACTIONS(1378),
    [anon_sym_PERCENT] = ACTIONS(1378),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(52),
  },
  [409] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [410] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [411] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [sym_comment] = ACTIONS(52),
  },
  [412] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [413] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [414] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1384),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [415] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(692),
    [anon_sym_DQUOTE] = ACTIONS(1386),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [416] = {
    [aux_sym_concatenation_repeat1] = STATE(694),
    [sym__concat] = ACTIONS(1388),
    [anon_sym_SEMI_SEMI] = ACTIONS(366),
    [anon_sym_DQUOTE] = ACTIONS(366),
    [sym_raw_string] = ACTIONS(366),
    [anon_sym_DOLLAR] = ACTIONS(366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(366),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(366),
    [anon_sym_GT_LPAREN] = ACTIONS(366),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(366),
    [anon_sym_LF] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(366),
  },
  [417] = {
    [sym_special_variable_name] = STATE(697),
    [anon_sym_DOLLAR] = ACTIONS(1390),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_AT] = ACTIONS(1390),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1392),
    [anon_sym_STAR] = ACTIONS(1390),
    [anon_sym_QMARK] = ACTIONS(1390),
    [anon_sym_DASH] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(1390),
    [anon_sym_0] = ACTIONS(1394),
    [anon_sym__] = ACTIONS(1394),
  },
  [418] = {
    [sym_special_variable_name] = STATE(700),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(1396),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [419] = {
    [sym_for_statement] = STATE(701),
    [sym_while_statement] = STATE(701),
    [sym_if_statement] = STATE(701),
    [sym_case_statement] = STATE(701),
    [sym_function_definition] = STATE(701),
    [sym_subshell] = STATE(701),
    [sym_pipeline] = STATE(701),
    [sym_list] = STATE(701),
    [sym_bracket_command] = STATE(701),
    [sym_command] = STATE(701),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(702),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [420] = {
    [sym_for_statement] = STATE(703),
    [sym_while_statement] = STATE(703),
    [sym_if_statement] = STATE(703),
    [sym_case_statement] = STATE(703),
    [sym_function_definition] = STATE(703),
    [sym_subshell] = STATE(703),
    [sym_pipeline] = STATE(703),
    [sym_list] = STATE(703),
    [sym_bracket_command] = STATE(703),
    [sym_command] = STATE(703),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(704),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [421] = {
    [sym_for_statement] = STATE(705),
    [sym_while_statement] = STATE(705),
    [sym_if_statement] = STATE(705),
    [sym_case_statement] = STATE(705),
    [sym_function_definition] = STATE(705),
    [sym_subshell] = STATE(705),
    [sym_pipeline] = STATE(705),
    [sym_list] = STATE(705),
    [sym_bracket_command] = STATE(705),
    [sym_command] = STATE(705),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(706),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [422] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(366),
    [anon_sym_DQUOTE] = ACTIONS(366),
    [sym_raw_string] = ACTIONS(366),
    [anon_sym_DOLLAR] = ACTIONS(366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(366),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(366),
    [anon_sym_BQUOTE] = ACTIONS(366),
    [anon_sym_LT_LPAREN] = ACTIONS(366),
    [anon_sym_GT_LPAREN] = ACTIONS(366),
    [sym_word] = ACTIONS(366),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(366),
    [anon_sym_LF] = ACTIONS(366),
    [anon_sym_AMP] = ACTIONS(366),
  },
  [423] = {
    [sym_concatenation] = STATE(422),
    [sym_string] = STATE(416),
    [sym_simple_expansion] = STATE(416),
    [sym_expansion] = STATE(416),
    [sym_command_substitution] = STATE(416),
    [sym_process_substitution] = STATE(416),
    [aux_sym_for_statement_repeat1] = STATE(708),
    [anon_sym_SEMI_SEMI] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1402),
    [sym_raw_string] = ACTIONS(1404),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1410),
    [anon_sym_BQUOTE] = ACTIONS(1412),
    [anon_sym_LT_LPAREN] = ACTIONS(1414),
    [anon_sym_GT_LPAREN] = ACTIONS(1414),
    [sym_word] = ACTIONS(1404),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1400),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [424] = {
    [anon_sym_PIPE] = ACTIONS(1416),
    [anon_sym_RPAREN] = ACTIONS(1416),
    [anon_sym_SEMI_SEMI] = ACTIONS(1416),
    [anon_sym_PIPE_AMP] = ACTIONS(1416),
    [anon_sym_AMP_AMP] = ACTIONS(1416),
    [anon_sym_PIPE_PIPE] = ACTIONS(1416),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1416),
    [anon_sym_LF] = ACTIONS(1416),
    [anon_sym_AMP] = ACTIONS(1416),
  },
  [425] = {
    [sym_file_descriptor] = ACTIONS(220),
    [sym_variable_name] = ACTIONS(220),
    [anon_sym_for] = ACTIONS(222),
    [anon_sym_while] = ACTIONS(222),
    [anon_sym_done] = ACTIONS(222),
    [anon_sym_if] = ACTIONS(222),
    [anon_sym_case] = ACTIONS(222),
    [anon_sym_function] = ACTIONS(222),
    [anon_sym_LPAREN] = ACTIONS(220),
    [anon_sym_LBRACK] = ACTIONS(222),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(222),
    [anon_sym_LT] = ACTIONS(222),
    [anon_sym_GT] = ACTIONS(222),
    [anon_sym_GT_GT] = ACTIONS(220),
    [anon_sym_AMP_GT] = ACTIONS(222),
    [anon_sym_AMP_GT_GT] = ACTIONS(220),
    [anon_sym_LT_AMP] = ACTIONS(220),
    [anon_sym_GT_AMP] = ACTIONS(220),
    [anon_sym_DQUOTE] = ACTIONS(220),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(220),
    [anon_sym_BQUOTE] = ACTIONS(220),
    [anon_sym_LT_LPAREN] = ACTIONS(220),
    [anon_sym_GT_LPAREN] = ACTIONS(220),
    [sym_word] = ACTIONS(224),
    [sym_comment] = ACTIONS(52),
  },
  [426] = {
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(1418),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_LF] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
  },
  [427] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(1418),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_LF] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1418),
  },
  [428] = {
    [sym__terminated_statement] = STATE(425),
    [sym_for_statement] = STATE(426),
    [sym_while_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_case_statement] = STATE(426),
    [sym_function_definition] = STATE(426),
    [sym_subshell] = STATE(426),
    [sym_pipeline] = STATE(426),
    [sym_list] = STATE(426),
    [sym_bracket_command] = STATE(426),
    [sym_command] = STATE(426),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(427),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(711),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(1420),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [429] = {
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [anon_sym_SEMI_SEMI] = ACTIONS(1422),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1422),
    [anon_sym_LF] = ACTIONS(1422),
    [anon_sym_AMP] = ACTIONS(1422),
  },
  [430] = {
    [sym__terminated_statement] = STATE(712),
    [sym_for_statement] = STATE(36),
    [sym_while_statement] = STATE(36),
    [sym_if_statement] = STATE(36),
    [sym_case_statement] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_subshell] = STATE(36),
    [sym_pipeline] = STATE(36),
    [sym_list] = STATE(36),
    [sym_bracket_command] = STATE(36),
    [sym_command] = STATE(36),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [431] = {
    [sym__terminated_statement] = STATE(713),
    [sym_for_statement] = STATE(714),
    [sym_while_statement] = STATE(714),
    [sym_if_statement] = STATE(714),
    [sym_case_statement] = STATE(714),
    [sym_function_definition] = STATE(714),
    [sym_subshell] = STATE(714),
    [sym_pipeline] = STATE(714),
    [sym_list] = STATE(714),
    [sym_bracket_command] = STATE(714),
    [sym_command] = STATE(714),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(715),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(716),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1424),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [432] = {
    [sym_file_descriptor] = ACTIONS(220),
    [sym_variable_name] = ACTIONS(220),
    [anon_sym_for] = ACTIONS(222),
    [anon_sym_while] = ACTIONS(222),
    [anon_sym_if] = ACTIONS(222),
    [anon_sym_fi] = ACTIONS(222),
    [anon_sym_elif] = ACTIONS(222),
    [anon_sym_else] = ACTIONS(222),
    [anon_sym_case] = ACTIONS(222),
    [anon_sym_function] = ACTIONS(222),
    [anon_sym_LPAREN] = ACTIONS(220),
    [anon_sym_LBRACK] = ACTIONS(222),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(222),
    [anon_sym_LT] = ACTIONS(222),
    [anon_sym_GT] = ACTIONS(222),
    [anon_sym_GT_GT] = ACTIONS(220),
    [anon_sym_AMP_GT] = ACTIONS(222),
    [anon_sym_AMP_GT_GT] = ACTIONS(220),
    [anon_sym_LT_AMP] = ACTIONS(220),
    [anon_sym_GT_AMP] = ACTIONS(220),
    [anon_sym_DQUOTE] = ACTIONS(220),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(220),
    [anon_sym_BQUOTE] = ACTIONS(220),
    [anon_sym_LT_LPAREN] = ACTIONS(220),
    [anon_sym_GT_LPAREN] = ACTIONS(220),
    [sym_word] = ACTIONS(224),
    [sym_comment] = ACTIONS(52),
  },
  [433] = {
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(1426),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1426),
    [anon_sym_LF] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
  },
  [434] = {
    [anon_sym_fi] = ACTIONS(1428),
    [anon_sym_elif] = ACTIONS(1428),
    [anon_sym_else] = ACTIONS(1428),
    [sym_comment] = ACTIONS(52),
  },
  [435] = {
    [anon_sym_fi] = ACTIONS(1430),
    [sym_comment] = ACTIONS(52),
  },
  [436] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(1426),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1426),
    [anon_sym_LF] = ACTIONS(1426),
    [anon_sym_AMP] = ACTIONS(1426),
  },
  [437] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(433),
    [sym_while_statement] = STATE(433),
    [sym_if_statement] = STATE(433),
    [sym_elif_clause] = STATE(434),
    [sym_else_clause] = STATE(719),
    [sym_case_statement] = STATE(433),
    [sym_function_definition] = STATE(433),
    [sym_subshell] = STATE(433),
    [sym_pipeline] = STATE(433),
    [sym_list] = STATE(433),
    [sym_bracket_command] = STATE(433),
    [sym_command] = STATE(433),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(436),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(720),
    [aux_sym_if_statement_repeat1] = STATE(721),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1432),
    [anon_sym_elif] = ACTIONS(768),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [438] = {
    [sym_elif_clause] = STATE(434),
    [sym_else_clause] = STATE(719),
    [aux_sym_if_statement_repeat1] = STATE(722),
    [anon_sym_fi] = ACTIONS(1430),
    [anon_sym_elif] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1436),
    [sym_comment] = ACTIONS(52),
  },
  [439] = {
    [sym__concat] = ACTIONS(1000),
    [anon_sym_in] = ACTIONS(1002),
    [anon_sym_SEMI_SEMI] = ACTIONS(1002),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_LF] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
  },
  [440] = {
    [sym__concat] = ACTIONS(1021),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [441] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(727),
    [anon_sym_esac] = ACTIONS(1438),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1442),
    [sym_comment] = ACTIONS(52),
  },
  [442] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1444),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1444),
  },
  [443] = {
    [aux_sym_concatenation_repeat1] = STATE(443),
    [sym__concat] = ACTIONS(1446),
    [anon_sym_in] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [444] = {
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [sym_comment] = ACTIONS(52),
  },
  [445] = {
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_LBRACK] = ACTIONS(1455),
    [sym_comment] = ACTIONS(52),
  },
  [446] = {
    [sym__concat] = ACTIONS(1036),
    [anon_sym_in] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
  },
  [447] = {
    [anon_sym_AT] = ACTIONS(1457),
    [sym_comment] = ACTIONS(52),
  },
  [448] = {
    [sym_concatenation] = STATE(735),
    [sym_string] = STATE(734),
    [sym_simple_expansion] = STATE(734),
    [sym_expansion] = STATE(734),
    [sym_command_substitution] = STATE(734),
    [sym_process_substitution] = STATE(734),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1461),
    [sym_comment] = ACTIONS(52),
  },
  [449] = {
    [sym__concat] = ACTIONS(1046),
    [anon_sym_in] = ACTIONS(1048),
    [anon_sym_SEMI_SEMI] = ACTIONS(1048),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1048),
    [anon_sym_LF] = ACTIONS(1048),
    [anon_sym_AMP] = ACTIONS(1048),
  },
  [450] = {
    [anon_sym_AT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(52),
  },
  [451] = {
    [sym_concatenation] = STATE(738),
    [sym_string] = STATE(737),
    [sym_simple_expansion] = STATE(737),
    [sym_expansion] = STATE(737),
    [sym_command_substitution] = STATE(737),
    [sym_process_substitution] = STATE(737),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1465),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1467),
    [sym_comment] = ACTIONS(52),
  },
  [452] = {
    [sym__concat] = ACTIONS(1136),
    [anon_sym_in] = ACTIONS(1138),
    [anon_sym_SEMI_SEMI] = ACTIONS(1138),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_LF] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1138),
  },
  [453] = {
    [sym__concat] = ACTIONS(1192),
    [anon_sym_in] = ACTIONS(1194),
    [anon_sym_SEMI_SEMI] = ACTIONS(1194),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_AMP] = ACTIONS(1194),
  },
  [454] = {
    [sym_compound_statement] = STATE(739),
    [anon_sym_LBRACE] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
  },
  [455] = {
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_SEMI_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE_AMP] = ACTIONS(1469),
    [anon_sym_AMP_AMP] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1469),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [456] = {
    [aux_sym_concatenation_repeat1] = STATE(740),
    [sym_file_descriptor] = ACTIONS(710),
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(712),
    [anon_sym_RPAREN] = ACTIONS(712),
    [anon_sym_SEMI_SEMI] = ACTIONS(712),
    [anon_sym_PIPE_AMP] = ACTIONS(712),
    [anon_sym_AMP_AMP] = ACTIONS(712),
    [anon_sym_PIPE_PIPE] = ACTIONS(712),
    [anon_sym_LT] = ACTIONS(712),
    [anon_sym_GT] = ACTIONS(712),
    [anon_sym_GT_GT] = ACTIONS(712),
    [anon_sym_AMP_GT] = ACTIONS(712),
    [anon_sym_AMP_GT_GT] = ACTIONS(712),
    [anon_sym_LT_AMP] = ACTIONS(712),
    [anon_sym_GT_AMP] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(712),
    [sym_raw_string] = ACTIONS(712),
    [anon_sym_DOLLAR] = ACTIONS(712),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(712),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(712),
    [anon_sym_BQUOTE] = ACTIONS(712),
    [anon_sym_LT_LPAREN] = ACTIONS(712),
    [anon_sym_GT_LPAREN] = ACTIONS(712),
    [sym_word] = ACTIONS(712),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(712),
    [anon_sym_LF] = ACTIONS(712),
    [anon_sym_AMP] = ACTIONS(712),
  },
  [457] = {
    [anon_sym_RPAREN] = ACTIONS(1471),
    [sym_comment] = ACTIONS(52),
  },
  [458] = {
    [sym_file_redirect] = STATE(455),
    [sym_file_descriptor] = ACTIONS(816),
    [anon_sym_PIPE] = ACTIONS(806),
    [anon_sym_RPAREN] = ACTIONS(806),
    [anon_sym_SEMI_SEMI] = ACTIONS(806),
    [anon_sym_PIPE_AMP] = ACTIONS(806),
    [anon_sym_AMP_AMP] = ACTIONS(806),
    [anon_sym_PIPE_PIPE] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_AMP_GT] = ACTIONS(818),
    [anon_sym_AMP_GT_GT] = ACTIONS(818),
    [anon_sym_LT_AMP] = ACTIONS(818),
    [anon_sym_GT_AMP] = ACTIONS(818),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(806),
    [anon_sym_LF] = ACTIONS(806),
    [anon_sym_AMP] = ACTIONS(806),
  },
  [459] = {
    [aux_sym_concatenation_repeat1] = STATE(459),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1025),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_LT_LT_DASH] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [sym_raw_string] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LPAREN] = ACTIONS(1023),
    [anon_sym_GT_LPAREN] = ACTIONS(1023),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [460] = {
    [sym_compound_statement] = STATE(742),
    [anon_sym_LBRACE] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
  },
  [461] = {
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1473),
    [anon_sym_GT_GT] = ACTIONS(1475),
    [anon_sym_AMP_GT] = ACTIONS(1473),
    [anon_sym_AMP_GT_GT] = ACTIONS(1475),
    [anon_sym_LT_AMP] = ACTIONS(1475),
    [anon_sym_GT_AMP] = ACTIONS(1475),
    [sym_comment] = ACTIONS(52),
  },
  [462] = {
    [sym_concatenation] = STATE(619),
    [sym_string] = STATE(744),
    [sym_simple_expansion] = STATE(744),
    [sym_expansion] = STATE(744),
    [sym_command_substitution] = STATE(744),
    [sym_process_substitution] = STATE(744),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [sym_raw_string] = ACTIONS(1477),
    [anon_sym_DOLLAR] = ACTIONS(1210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [anon_sym_LT_LPAREN] = ACTIONS(1218),
    [anon_sym_GT_LPAREN] = ACTIONS(1218),
    [sym_word] = ACTIONS(1479),
    [sym_comment] = ACTIONS(52),
  },
  [463] = {
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [anon_sym_SEMI_SEMI] = ACTIONS(1481),
    [anon_sym_PIPE_AMP] = ACTIONS(1481),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_LF] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
  },
  [464] = {
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(1224),
    [anon_sym_SEMI_SEMI] = ACTIONS(1224),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(1224),
    [anon_sym_PIPE_PIPE] = ACTIONS(1224),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1224),
    [anon_sym_LF] = ACTIONS(1224),
    [anon_sym_AMP] = ACTIONS(1224),
  },
  [465] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(1224),
    [anon_sym_SEMI_SEMI] = ACTIONS(1224),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(1224),
    [anon_sym_PIPE_PIPE] = ACTIONS(1224),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1224),
    [anon_sym_LF] = ACTIONS(1224),
    [anon_sym_AMP] = ACTIONS(1224),
  },
  [466] = {
    [sym_concatenation] = STATE(621),
    [sym_string] = STATE(745),
    [sym_simple_expansion] = STATE(745),
    [sym_expansion] = STATE(745),
    [sym_command_substitution] = STATE(745),
    [sym_process_substitution] = STATE(745),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(1483),
    [anon_sym_DOLLAR] = ACTIONS(588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(592),
    [anon_sym_BQUOTE] = ACTIONS(594),
    [anon_sym_LT_LPAREN] = ACTIONS(596),
    [anon_sym_GT_LPAREN] = ACTIONS(596),
    [sym_word] = ACTIONS(1485),
    [sym_comment] = ACTIONS(52),
  },
  [467] = {
    [aux_sym_concatenation_repeat1] = STATE(746),
    [sym_file_descriptor] = ACTIONS(400),
    [sym__concat] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_RPAREN] = ACTIONS(1234),
    [anon_sym_SEMI_SEMI] = ACTIONS(1234),
    [anon_sym_PIPE_AMP] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_PIPE_PIPE] = ACTIONS(1234),
    [anon_sym_LT] = ACTIONS(1234),
    [anon_sym_GT] = ACTIONS(1234),
    [anon_sym_GT_GT] = ACTIONS(1234),
    [anon_sym_AMP_GT] = ACTIONS(1234),
    [anon_sym_AMP_GT_GT] = ACTIONS(1234),
    [anon_sym_LT_AMP] = ACTIONS(1234),
    [anon_sym_GT_AMP] = ACTIONS(1234),
    [anon_sym_LT_LT] = ACTIONS(1234),
    [anon_sym_LT_LT_DASH] = ACTIONS(1234),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1234),
    [anon_sym_LF] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
  },
  [468] = {
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(208),
    [sym_simple_expansion] = STATE(208),
    [sym_expansion] = STATE(208),
    [sym_command_substitution] = STATE(208),
    [sym_process_substitution] = STATE(208),
    [aux_sym_for_statement_repeat1] = STATE(468),
    [sym_file_descriptor] = ACTIONS(1262),
    [anon_sym_PIPE] = ACTIONS(1264),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_SEMI_SEMI] = ACTIONS(1264),
    [anon_sym_PIPE_AMP] = ACTIONS(1264),
    [anon_sym_AMP_AMP] = ACTIONS(1264),
    [anon_sym_PIPE_PIPE] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(1264),
    [anon_sym_GT] = ACTIONS(1264),
    [anon_sym_GT_GT] = ACTIONS(1264),
    [anon_sym_AMP_GT] = ACTIONS(1264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1264),
    [anon_sym_LT_AMP] = ACTIONS(1264),
    [anon_sym_GT_AMP] = ACTIONS(1264),
    [anon_sym_LT_LT] = ACTIONS(1264),
    [anon_sym_LT_LT_DASH] = ACTIONS(1264),
    [anon_sym_DQUOTE] = ACTIONS(1266),
    [sym_raw_string] = ACTIONS(1487),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1278),
    [anon_sym_BQUOTE] = ACTIONS(1281),
    [anon_sym_LT_LPAREN] = ACTIONS(1284),
    [anon_sym_GT_LPAREN] = ACTIONS(1284),
    [sym_word] = ACTIONS(1487),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1264),
    [anon_sym_LF] = ACTIONS(1264),
    [anon_sym_AMP] = ACTIONS(1264),
  },
  [469] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [aux_sym_command_repeat2] = STATE(470),
    [sym_file_descriptor] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
  },
  [470] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [aux_sym_command_repeat2] = STATE(470),
    [sym_file_descriptor] = ACTIONS(1490),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_RPAREN] = ACTIONS(1292),
    [anon_sym_SEMI_SEMI] = ACTIONS(1292),
    [anon_sym_PIPE_AMP] = ACTIONS(1292),
    [anon_sym_AMP_AMP] = ACTIONS(1292),
    [anon_sym_PIPE_PIPE] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(1493),
    [anon_sym_GT] = ACTIONS(1493),
    [anon_sym_GT_GT] = ACTIONS(1493),
    [anon_sym_AMP_GT] = ACTIONS(1493),
    [anon_sym_AMP_GT_GT] = ACTIONS(1493),
    [anon_sym_LT_AMP] = ACTIONS(1493),
    [anon_sym_GT_AMP] = ACTIONS(1493),
    [anon_sym_LT_LT] = ACTIONS(1297),
    [anon_sym_LT_LT_DASH] = ACTIONS(1297),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1292),
    [anon_sym_LF] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1292),
  },
  [471] = {
    [sym_file_descriptor] = ACTIONS(574),
    [sym_variable_name] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(1496),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(576),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_word] = ACTIONS(578),
    [sym_comment] = ACTIONS(52),
  },
  [472] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [sym_concatenation] = STATE(145),
    [sym_string] = STATE(208),
    [sym_simple_expansion] = STATE(208),
    [sym_expansion] = STATE(208),
    [sym_command_substitution] = STATE(208),
    [sym_process_substitution] = STATE(208),
    [aux_sym_for_statement_repeat1] = STATE(468),
    [aux_sym_command_repeat2] = STATE(748),
    [sym_file_descriptor] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(1287),
    [anon_sym_RPAREN] = ACTIONS(1287),
    [anon_sym_SEMI_SEMI] = ACTIONS(1287),
    [anon_sym_PIPE_AMP] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [anon_sym_DQUOTE] = ACTIONS(240),
    [sym_raw_string] = ACTIONS(354),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_word] = ACTIONS(354),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1287),
    [anon_sym_LF] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
  },
  [473] = {
    [sym__concat] = ACTIONS(1000),
    [anon_sym_RBRACE] = ACTIONS(1000),
    [anon_sym_RBRACK] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [sym_raw_string] = ACTIONS(1000),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1000),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1000),
    [anon_sym_GT_LPAREN] = ACTIONS(1000),
    [sym_word] = ACTIONS(1002),
    [sym_comment] = ACTIONS(52),
  },
  [474] = {
    [sym__concat] = ACTIONS(1021),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [475] = {
    [aux_sym_concatenation_repeat1] = STATE(475),
    [sym__concat] = ACTIONS(1502),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [476] = {
    [anon_sym_RBRACE] = ACTIONS(1505),
    [anon_sym_LBRACK] = ACTIONS(1507),
    [sym_comment] = ACTIONS(52),
  },
  [477] = {
    [anon_sym_RBRACE] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [sym_comment] = ACTIONS(52),
  },
  [478] = {
    [sym__concat] = ACTIONS(1036),
    [anon_sym_RBRACE] = ACTIONS(1036),
    [anon_sym_RBRACK] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LT_LPAREN] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1036),
    [sym_word] = ACTIONS(1038),
    [sym_comment] = ACTIONS(52),
  },
  [479] = {
    [anon_sym_AT] = ACTIONS(1515),
    [sym_comment] = ACTIONS(52),
  },
  [480] = {
    [sym_concatenation] = STATE(755),
    [sym_string] = STATE(754),
    [sym_simple_expansion] = STATE(754),
    [sym_expansion] = STATE(754),
    [sym_command_substitution] = STATE(754),
    [sym_process_substitution] = STATE(754),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1517),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1519),
    [sym_comment] = ACTIONS(52),
  },
  [481] = {
    [sym__concat] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [anon_sym_RBRACK] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_raw_string] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_LT_LPAREN] = ACTIONS(1046),
    [anon_sym_GT_LPAREN] = ACTIONS(1046),
    [sym_word] = ACTIONS(1048),
    [sym_comment] = ACTIONS(52),
  },
  [482] = {
    [anon_sym_AT] = ACTIONS(1523),
    [sym_comment] = ACTIONS(52),
  },
  [483] = {
    [sym_concatenation] = STATE(758),
    [sym_string] = STATE(757),
    [sym_simple_expansion] = STATE(757),
    [sym_expansion] = STATE(757),
    [sym_command_substitution] = STATE(757),
    [sym_process_substitution] = STATE(757),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1525),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1527),
    [sym_comment] = ACTIONS(52),
  },
  [484] = {
    [sym__concat] = ACTIONS(1136),
    [anon_sym_RBRACE] = ACTIONS(1136),
    [anon_sym_RBRACK] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [sym_raw_string] = ACTIONS(1136),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [anon_sym_LT_LPAREN] = ACTIONS(1136),
    [anon_sym_GT_LPAREN] = ACTIONS(1136),
    [sym_word] = ACTIONS(1138),
    [sym_comment] = ACTIONS(52),
  },
  [485] = {
    [sym__concat] = ACTIONS(1192),
    [anon_sym_RBRACE] = ACTIONS(1192),
    [anon_sym_RBRACK] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [sym_word] = ACTIONS(1194),
    [sym_comment] = ACTIONS(52),
  },
  [486] = {
    [sym__concat] = ACTIONS(1000),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1498),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [sym_raw_string] = ACTIONS(1000),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1000),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1000),
    [anon_sym_GT_LPAREN] = ACTIONS(1000),
    [sym_word] = ACTIONS(1002),
    [sym_comment] = ACTIONS(52),
  },
  [487] = {
    [sym__concat] = ACTIONS(1021),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [488] = {
    [aux_sym_concatenation_repeat1] = STATE(488),
    [sym__concat] = ACTIONS(1533),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1500),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [489] = {
    [anon_sym_RBRACE] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1538),
    [sym_comment] = ACTIONS(52),
  },
  [490] = {
    [anon_sym_RBRACE] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [sym_comment] = ACTIONS(52),
  },
  [491] = {
    [sym__concat] = ACTIONS(1036),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1513),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LT_LPAREN] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1036),
    [sym_word] = ACTIONS(1038),
    [sym_comment] = ACTIONS(52),
  },
  [492] = {
    [anon_sym_AT] = ACTIONS(1544),
    [sym_comment] = ACTIONS(52),
  },
  [493] = {
    [sym_concatenation] = STATE(765),
    [sym_string] = STATE(764),
    [sym_simple_expansion] = STATE(764),
    [sym_expansion] = STATE(764),
    [sym_command_substitution] = STATE(764),
    [sym_process_substitution] = STATE(764),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1546),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1548),
    [sym_comment] = ACTIONS(52),
  },
  [494] = {
    [sym__concat] = ACTIONS(1046),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_raw_string] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_LT_LPAREN] = ACTIONS(1046),
    [anon_sym_GT_LPAREN] = ACTIONS(1046),
    [sym_word] = ACTIONS(1048),
    [sym_comment] = ACTIONS(52),
  },
  [495] = {
    [anon_sym_AT] = ACTIONS(1550),
    [sym_comment] = ACTIONS(52),
  },
  [496] = {
    [sym_concatenation] = STATE(768),
    [sym_string] = STATE(767),
    [sym_simple_expansion] = STATE(767),
    [sym_expansion] = STATE(767),
    [sym_command_substitution] = STATE(767),
    [sym_process_substitution] = STATE(767),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1552),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1554),
    [sym_comment] = ACTIONS(52),
  },
  [497] = {
    [sym__concat] = ACTIONS(1136),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1529),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [sym_raw_string] = ACTIONS(1136),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [anon_sym_LT_LPAREN] = ACTIONS(1136),
    [anon_sym_GT_LPAREN] = ACTIONS(1136),
    [sym_word] = ACTIONS(1138),
    [sym_comment] = ACTIONS(52),
  },
  [498] = {
    [sym__concat] = ACTIONS(1192),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1531),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [sym_word] = ACTIONS(1194),
    [sym_comment] = ACTIONS(52),
  },
  [499] = {
    [sym_file_descriptor] = ACTIONS(1000),
    [sym__concat] = ACTIONS(1000),
    [sym_variable_name] = ACTIONS(1000),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1000),
    [anon_sym_AMP_GT] = ACTIONS(1498),
    [anon_sym_AMP_GT_GT] = ACTIONS(1000),
    [anon_sym_LT_AMP] = ACTIONS(1000),
    [anon_sym_GT_AMP] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [sym_raw_string] = ACTIONS(1000),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1000),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1000),
    [anon_sym_GT_LPAREN] = ACTIONS(1000),
    [sym_word] = ACTIONS(1498),
    [sym_comment] = ACTIONS(52),
  },
  [500] = {
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1021),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1500),
    [sym_comment] = ACTIONS(52),
  },
  [501] = {
    [aux_sym_concatenation_repeat1] = STATE(501),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1556),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1500),
    [sym_comment] = ACTIONS(52),
  },
  [502] = {
    [anon_sym_RBRACE] = ACTIONS(1559),
    [anon_sym_LBRACK] = ACTIONS(1561),
    [sym_comment] = ACTIONS(52),
  },
  [503] = {
    [anon_sym_RBRACE] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(1565),
    [sym_comment] = ACTIONS(52),
  },
  [504] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1036),
    [sym_variable_name] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1513),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LT_LPAREN] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1036),
    [sym_word] = ACTIONS(1513),
    [sym_comment] = ACTIONS(52),
  },
  [505] = {
    [anon_sym_AT] = ACTIONS(1567),
    [sym_comment] = ACTIONS(52),
  },
  [506] = {
    [sym_concatenation] = STATE(775),
    [sym_string] = STATE(774),
    [sym_simple_expansion] = STATE(774),
    [sym_expansion] = STATE(774),
    [sym_command_substitution] = STATE(774),
    [sym_process_substitution] = STATE(774),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1569),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1571),
    [sym_comment] = ACTIONS(52),
  },
  [507] = {
    [sym_file_descriptor] = ACTIONS(1046),
    [sym__concat] = ACTIONS(1046),
    [sym_variable_name] = ACTIONS(1046),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_AMP_GT] = ACTIONS(1521),
    [anon_sym_AMP_GT_GT] = ACTIONS(1046),
    [anon_sym_LT_AMP] = ACTIONS(1046),
    [anon_sym_GT_AMP] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_raw_string] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_LT_LPAREN] = ACTIONS(1046),
    [anon_sym_GT_LPAREN] = ACTIONS(1046),
    [sym_word] = ACTIONS(1521),
    [sym_comment] = ACTIONS(52),
  },
  [508] = {
    [anon_sym_AT] = ACTIONS(1573),
    [sym_comment] = ACTIONS(52),
  },
  [509] = {
    [sym_concatenation] = STATE(778),
    [sym_string] = STATE(777),
    [sym_simple_expansion] = STATE(777),
    [sym_expansion] = STATE(777),
    [sym_command_substitution] = STATE(777),
    [sym_process_substitution] = STATE(777),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1575),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1577),
    [sym_comment] = ACTIONS(52),
  },
  [510] = {
    [sym_file_descriptor] = ACTIONS(1136),
    [sym__concat] = ACTIONS(1136),
    [sym_variable_name] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT] = ACTIONS(1529),
    [anon_sym_AMP_GT_GT] = ACTIONS(1136),
    [anon_sym_LT_AMP] = ACTIONS(1136),
    [anon_sym_GT_AMP] = ACTIONS(1136),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [sym_raw_string] = ACTIONS(1136),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [anon_sym_LT_LPAREN] = ACTIONS(1136),
    [anon_sym_GT_LPAREN] = ACTIONS(1136),
    [sym_word] = ACTIONS(1529),
    [sym_comment] = ACTIONS(52),
  },
  [511] = {
    [sym_file_descriptor] = ACTIONS(1192),
    [sym__concat] = ACTIONS(1192),
    [sym_variable_name] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1192),
    [anon_sym_AMP_GT] = ACTIONS(1531),
    [anon_sym_AMP_GT_GT] = ACTIONS(1192),
    [anon_sym_LT_AMP] = ACTIONS(1192),
    [anon_sym_GT_AMP] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [sym_word] = ACTIONS(1531),
    [sym_comment] = ACTIONS(52),
  },
  [512] = {
    [anon_sym_RBRACE] = ACTIONS(1579),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [sym_comment] = ACTIONS(52),
  },
  [513] = {
    [anon_sym_RBRACE] = ACTIONS(1583),
    [anon_sym_LBRACK] = ACTIONS(1585),
    [sym_comment] = ACTIONS(52),
  },
  [514] = {
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1513),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [sym_comment] = ACTIONS(150),
  },
  [515] = {
    [anon_sym_AT] = ACTIONS(1587),
    [sym_comment] = ACTIONS(52),
  },
  [516] = {
    [sym_concatenation] = STATE(785),
    [sym_string] = STATE(784),
    [sym_simple_expansion] = STATE(784),
    [sym_expansion] = STATE(784),
    [sym_command_substitution] = STATE(784),
    [sym_process_substitution] = STATE(784),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1589),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1591),
    [sym_comment] = ACTIONS(52),
  },
  [517] = {
    [anon_sym_DQUOTE] = ACTIONS(1048),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1521),
    [anon_sym_DOLLAR] = ACTIONS(1048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1048),
    [anon_sym_BQUOTE] = ACTIONS(1048),
    [sym_comment] = ACTIONS(150),
  },
  [518] = {
    [anon_sym_AT] = ACTIONS(1593),
    [sym_comment] = ACTIONS(52),
  },
  [519] = {
    [sym_concatenation] = STATE(788),
    [sym_string] = STATE(787),
    [sym_simple_expansion] = STATE(787),
    [sym_expansion] = STATE(787),
    [sym_command_substitution] = STATE(787),
    [sym_process_substitution] = STATE(787),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1595),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1597),
    [sym_comment] = ACTIONS(52),
  },
  [520] = {
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(1529),
    [anon_sym_DOLLAR] = ACTIONS(1138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1138),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [sym_comment] = ACTIONS(150),
  },
  [521] = {
    [sym_file_descriptor] = ACTIONS(1599),
    [sym__concat] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1601),
    [anon_sym_SEMI_SEMI] = ACTIONS(1601),
    [anon_sym_PIPE_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_GT] = ACTIONS(1601),
    [anon_sym_AMP_GT_GT] = ACTIONS(1601),
    [anon_sym_LT_AMP] = ACTIONS(1601),
    [anon_sym_GT_AMP] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_LT_LT_DASH] = ACTIONS(1601),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [sym_raw_string] = ACTIONS(1601),
    [anon_sym_DOLLAR] = ACTIONS(1601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1601),
    [anon_sym_LT_LPAREN] = ACTIONS(1601),
    [anon_sym_GT_LPAREN] = ACTIONS(1601),
    [sym_word] = ACTIONS(1601),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_LF] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
  },
  [522] = {
    [anon_sym_AT] = ACTIONS(1603),
    [sym_comment] = ACTIONS(52),
  },
  [523] = {
    [sym_file_descriptor] = ACTIONS(1605),
    [sym__concat] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1607),
    [anon_sym_RPAREN] = ACTIONS(1607),
    [anon_sym_SEMI_SEMI] = ACTIONS(1607),
    [anon_sym_PIPE_AMP] = ACTIONS(1607),
    [anon_sym_AMP_AMP] = ACTIONS(1607),
    [anon_sym_PIPE_PIPE] = ACTIONS(1607),
    [anon_sym_LT] = ACTIONS(1607),
    [anon_sym_GT] = ACTIONS(1607),
    [anon_sym_GT_GT] = ACTIONS(1607),
    [anon_sym_AMP_GT] = ACTIONS(1607),
    [anon_sym_AMP_GT_GT] = ACTIONS(1607),
    [anon_sym_LT_AMP] = ACTIONS(1607),
    [anon_sym_GT_AMP] = ACTIONS(1607),
    [anon_sym_LT_LT] = ACTIONS(1607),
    [anon_sym_LT_LT_DASH] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_raw_string] = ACTIONS(1607),
    [anon_sym_DOLLAR] = ACTIONS(1607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1607),
    [anon_sym_BQUOTE] = ACTIONS(1607),
    [anon_sym_LT_LPAREN] = ACTIONS(1607),
    [anon_sym_GT_LPAREN] = ACTIONS(1607),
    [sym_word] = ACTIONS(1607),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_LF] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
  },
  [524] = {
    [anon_sym_AT] = ACTIONS(1609),
    [sym_comment] = ACTIONS(52),
  },
  [525] = {
    [anon_sym_RBRACK] = ACTIONS(1611),
    [sym_comment] = ACTIONS(52),
  },
  [526] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(1613),
    [sym_comment] = ACTIONS(52),
  },
  [527] = {
    [anon_sym_RBRACE] = ACTIONS(1613),
    [sym_comment] = ACTIONS(52),
  },
  [528] = {
    [anon_sym_RBRACK] = ACTIONS(1615),
    [sym_comment] = ACTIONS(52),
  },
  [529] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(1617),
    [sym_comment] = ACTIONS(52),
  },
  [530] = {
    [anon_sym_RBRACE] = ACTIONS(1617),
    [sym_comment] = ACTIONS(52),
  },
  [531] = {
    [sym_file_descriptor] = ACTIONS(710),
    [sym_variable_name] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(710),
    [anon_sym_PIPE_AMP] = ACTIONS(710),
    [anon_sym_AMP_AMP] = ACTIONS(710),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(710),
    [anon_sym_LT_AMP] = ACTIONS(710),
    [anon_sym_GT_AMP] = ACTIONS(710),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [sym_raw_string] = ACTIONS(710),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(710),
    [anon_sym_BQUOTE] = ACTIONS(710),
    [anon_sym_LT_LPAREN] = ACTIONS(710),
    [anon_sym_GT_LPAREN] = ACTIONS(710),
    [sym_word] = ACTIONS(712),
    [sym_comment] = ACTIONS(52),
  },
  [532] = {
    [sym_concatenation] = STATE(397),
    [sym_string] = STATE(391),
    [sym_simple_expansion] = STATE(391),
    [sym_expansion] = STATE(391),
    [sym_command_substitution] = STATE(391),
    [sym_process_substitution] = STATE(391),
    [aux_sym_for_statement_repeat1] = STATE(797),
    [anon_sym_RPAREN] = ACTIONS(1621),
    [anon_sym_DQUOTE] = ACTIONS(716),
    [sym_raw_string] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_word] = ACTIONS(730),
    [sym_comment] = ACTIONS(52),
  },
  [533] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(799),
    [anon_sym_DQUOTE] = ACTIONS(1623),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [534] = {
    [aux_sym_concatenation_repeat1] = STATE(801),
    [sym_file_descriptor] = ACTIONS(710),
    [sym__concat] = ACTIONS(1625),
    [sym_variable_name] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_RPAREN] = ACTIONS(710),
    [anon_sym_PIPE_AMP] = ACTIONS(710),
    [anon_sym_AMP_AMP] = ACTIONS(710),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(710),
    [anon_sym_LT_AMP] = ACTIONS(710),
    [anon_sym_GT_AMP] = ACTIONS(710),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [sym_raw_string] = ACTIONS(710),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(710),
    [anon_sym_BQUOTE] = ACTIONS(710),
    [anon_sym_LT_LPAREN] = ACTIONS(710),
    [anon_sym_GT_LPAREN] = ACTIONS(710),
    [sym_word] = ACTIONS(712),
    [sym_comment] = ACTIONS(52),
  },
  [535] = {
    [sym_special_variable_name] = STATE(804),
    [anon_sym_DOLLAR] = ACTIONS(1627),
    [anon_sym_POUND] = ACTIONS(1627),
    [anon_sym_AT] = ACTIONS(1627),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(1627),
    [anon_sym_0] = ACTIONS(1631),
    [anon_sym__] = ACTIONS(1631),
  },
  [536] = {
    [sym_special_variable_name] = STATE(807),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(1633),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1635),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [537] = {
    [sym_for_statement] = STATE(808),
    [sym_while_statement] = STATE(808),
    [sym_if_statement] = STATE(808),
    [sym_case_statement] = STATE(808),
    [sym_function_definition] = STATE(808),
    [sym_subshell] = STATE(808),
    [sym_pipeline] = STATE(808),
    [sym_list] = STATE(808),
    [sym_bracket_command] = STATE(808),
    [sym_command] = STATE(808),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(809),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [538] = {
    [sym_for_statement] = STATE(810),
    [sym_while_statement] = STATE(810),
    [sym_if_statement] = STATE(810),
    [sym_case_statement] = STATE(810),
    [sym_function_definition] = STATE(810),
    [sym_subshell] = STATE(810),
    [sym_pipeline] = STATE(810),
    [sym_list] = STATE(810),
    [sym_bracket_command] = STATE(810),
    [sym_command] = STATE(810),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(811),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [539] = {
    [sym_for_statement] = STATE(812),
    [sym_while_statement] = STATE(812),
    [sym_if_statement] = STATE(812),
    [sym_case_statement] = STATE(812),
    [sym_function_definition] = STATE(812),
    [sym_subshell] = STATE(812),
    [sym_pipeline] = STATE(812),
    [sym_list] = STATE(812),
    [sym_bracket_command] = STATE(812),
    [sym_command] = STATE(812),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(813),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [540] = {
    [sym_concatenation] = STATE(422),
    [sym_string] = STATE(416),
    [sym_simple_expansion] = STATE(416),
    [sym_expansion] = STATE(416),
    [sym_command_substitution] = STATE(416),
    [sym_process_substitution] = STATE(416),
    [aux_sym_for_statement_repeat1] = STATE(814),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [sym_raw_string] = ACTIONS(748),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(754),
    [anon_sym_BQUOTE] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(758),
    [anon_sym_GT_LPAREN] = ACTIONS(758),
    [sym_word] = ACTIONS(760),
    [sym_comment] = ACTIONS(52),
  },
  [541] = {
    [sym__terminated_statement] = STATE(425),
    [sym_for_statement] = STATE(426),
    [sym_while_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_case_statement] = STATE(426),
    [sym_function_definition] = STATE(426),
    [sym_subshell] = STATE(426),
    [sym_pipeline] = STATE(426),
    [sym_list] = STATE(426),
    [sym_bracket_command] = STATE(426),
    [sym_command] = STATE(426),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(427),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(816),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [542] = {
    [anon_sym_PIPE] = ACTIONS(1639),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_PIPE_AMP] = ACTIONS(1641),
    [anon_sym_AMP_AMP] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(1641),
    [anon_sym_BQUOTE] = ACTIONS(1641),
    [sym_comment] = ACTIONS(52),
  },
  [543] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(433),
    [sym_while_statement] = STATE(433),
    [sym_if_statement] = STATE(433),
    [sym_elif_clause] = STATE(434),
    [sym_else_clause] = STATE(818),
    [sym_case_statement] = STATE(433),
    [sym_function_definition] = STATE(433),
    [sym_subshell] = STATE(433),
    [sym_pipeline] = STATE(433),
    [sym_list] = STATE(433),
    [sym_bracket_command] = STATE(433),
    [sym_command] = STATE(433),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(436),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(819),
    [aux_sym_if_statement_repeat1] = STATE(820),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(1643),
    [anon_sym_elif] = ACTIONS(768),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [544] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1645),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1645),
    [anon_sym_LF] = ACTIONS(1645),
    [anon_sym_AMP] = ACTIONS(1645),
  },
  [545] = {
    [anon_sym_in] = ACTIONS(1647),
    [sym_comment] = ACTIONS(52),
  },
  [546] = {
    [anon_sym_RPAREN] = ACTIONS(1649),
    [sym_comment] = ACTIONS(52),
  },
  [547] = {
    [sym_file_redirect] = STATE(824),
    [sym_file_descriptor] = ACTIONS(1126),
    [anon_sym_PIPE] = ACTIONS(1651),
    [anon_sym_RPAREN] = ACTIONS(1653),
    [anon_sym_PIPE_AMP] = ACTIONS(1653),
    [anon_sym_AMP_AMP] = ACTIONS(1653),
    [anon_sym_PIPE_PIPE] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1132),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_GT_GT] = ACTIONS(1134),
    [anon_sym_AMP_GT] = ACTIONS(1132),
    [anon_sym_AMP_GT_GT] = ACTIONS(1134),
    [anon_sym_LT_AMP] = ACTIONS(1134),
    [anon_sym_GT_AMP] = ACTIONS(1134),
    [sym_comment] = ACTIONS(52),
  },
  [548] = {
    [anon_sym_PIPE] = ACTIONS(1655),
    [anon_sym_RPAREN] = ACTIONS(1657),
    [anon_sym_PIPE_AMP] = ACTIONS(1657),
    [anon_sym_AMP_AMP] = ACTIONS(1657),
    [anon_sym_PIPE_PIPE] = ACTIONS(1657),
    [anon_sym_BQUOTE] = ACTIONS(1657),
    [sym_comment] = ACTIONS(52),
  },
  [549] = {
    [sym_file_descriptor] = ACTIONS(574),
    [sym_variable_name] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(1659),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(576),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_word] = ACTIONS(578),
    [sym_comment] = ACTIONS(52),
  },
  [550] = {
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(1661),
    [anon_sym_SEMI_SEMI] = ACTIONS(1663),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1663),
    [anon_sym_LF] = ACTIONS(1663),
    [anon_sym_AMP] = ACTIONS(1663),
  },
  [551] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(342),
    [anon_sym_RPAREN] = ACTIONS(1661),
    [anon_sym_SEMI_SEMI] = ACTIONS(1663),
    [anon_sym_PIPE_AMP] = ACTIONS(342),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1663),
    [anon_sym_LF] = ACTIONS(1663),
    [anon_sym_AMP] = ACTIONS(1663),
  },
  [552] = {
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_RPAREN] = ACTIONS(1667),
    [anon_sym_PIPE_AMP] = ACTIONS(1667),
    [anon_sym_AMP_AMP] = ACTIONS(1667),
    [anon_sym_PIPE_PIPE] = ACTIONS(1667),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_comment] = ACTIONS(52),
  },
  [553] = {
    [sym_file_descriptor] = ACTIONS(1000),
    [sym__concat] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_PIPE_AMP] = ACTIONS(1000),
    [anon_sym_AMP_AMP] = ACTIONS(1000),
    [anon_sym_PIPE_PIPE] = ACTIONS(1498),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1000),
    [anon_sym_AMP_GT] = ACTIONS(1498),
    [anon_sym_AMP_GT_GT] = ACTIONS(1000),
    [anon_sym_LT_AMP] = ACTIONS(1000),
    [anon_sym_GT_AMP] = ACTIONS(1000),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_LT_LT_DASH] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [sym_raw_string] = ACTIONS(1000),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1000),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1000),
    [anon_sym_GT_LPAREN] = ACTIONS(1000),
    [sym_word] = ACTIONS(1002),
    [sym_comment] = ACTIONS(52),
  },
  [554] = {
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_LT_LT] = ACTIONS(1500),
    [anon_sym_LT_LT_DASH] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [555] = {
    [aux_sym_concatenation_repeat1] = STATE(555),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1669),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_LT_LT] = ACTIONS(1500),
    [anon_sym_LT_LT_DASH] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [556] = {
    [anon_sym_RBRACE] = ACTIONS(1672),
    [anon_sym_LBRACK] = ACTIONS(1674),
    [sym_comment] = ACTIONS(52),
  },
  [557] = {
    [anon_sym_RBRACE] = ACTIONS(1676),
    [anon_sym_LBRACK] = ACTIONS(1678),
    [sym_comment] = ACTIONS(52),
  },
  [558] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1513),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1513),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LT_LPAREN] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1036),
    [sym_word] = ACTIONS(1038),
    [sym_comment] = ACTIONS(52),
  },
  [559] = {
    [anon_sym_AT] = ACTIONS(1680),
    [sym_comment] = ACTIONS(52),
  },
  [560] = {
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(832),
    [sym_simple_expansion] = STATE(832),
    [sym_expansion] = STATE(832),
    [sym_command_substitution] = STATE(832),
    [sym_process_substitution] = STATE(832),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1684),
    [sym_comment] = ACTIONS(52),
  },
  [561] = {
    [sym_file_descriptor] = ACTIONS(1046),
    [sym__concat] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [anon_sym_PIPE_AMP] = ACTIONS(1046),
    [anon_sym_AMP_AMP] = ACTIONS(1046),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_AMP_GT] = ACTIONS(1521),
    [anon_sym_AMP_GT_GT] = ACTIONS(1046),
    [anon_sym_LT_AMP] = ACTIONS(1046),
    [anon_sym_GT_AMP] = ACTIONS(1046),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_raw_string] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_LT_LPAREN] = ACTIONS(1046),
    [anon_sym_GT_LPAREN] = ACTIONS(1046),
    [sym_word] = ACTIONS(1048),
    [sym_comment] = ACTIONS(52),
  },
  [562] = {
    [anon_sym_AT] = ACTIONS(1686),
    [sym_comment] = ACTIONS(52),
  },
  [563] = {
    [sym_concatenation] = STATE(836),
    [sym_string] = STATE(835),
    [sym_simple_expansion] = STATE(835),
    [sym_expansion] = STATE(835),
    [sym_command_substitution] = STATE(835),
    [sym_process_substitution] = STATE(835),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1688),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1690),
    [sym_comment] = ACTIONS(52),
  },
  [564] = {
    [sym_file_descriptor] = ACTIONS(1136),
    [sym__concat] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT] = ACTIONS(1529),
    [anon_sym_AMP_GT_GT] = ACTIONS(1136),
    [anon_sym_LT_AMP] = ACTIONS(1136),
    [anon_sym_GT_AMP] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1136),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [sym_raw_string] = ACTIONS(1136),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [anon_sym_LT_LPAREN] = ACTIONS(1136),
    [anon_sym_GT_LPAREN] = ACTIONS(1136),
    [sym_word] = ACTIONS(1138),
    [sym_comment] = ACTIONS(52),
  },
  [565] = {
    [sym_file_descriptor] = ACTIONS(1192),
    [sym__concat] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_PIPE_AMP] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1192),
    [anon_sym_AMP_GT] = ACTIONS(1531),
    [anon_sym_AMP_GT_GT] = ACTIONS(1192),
    [anon_sym_LT_AMP] = ACTIONS(1192),
    [anon_sym_GT_AMP] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [sym_word] = ACTIONS(1194),
    [sym_comment] = ACTIONS(52),
  },
  [566] = {
    [sym_compound_statement] = STATE(837),
    [anon_sym_LBRACE] = ACTIONS(504),
    [sym_comment] = ACTIONS(52),
  },
  [567] = {
    [sym_file_descriptor] = ACTIONS(1196),
    [anon_sym_PIPE] = ACTIONS(1692),
    [anon_sym_RPAREN] = ACTIONS(1196),
    [anon_sym_PIPE_AMP] = ACTIONS(1196),
    [anon_sym_AMP_AMP] = ACTIONS(1196),
    [anon_sym_PIPE_PIPE] = ACTIONS(1196),
    [anon_sym_LT] = ACTIONS(1692),
    [anon_sym_GT] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1196),
    [anon_sym_AMP_GT] = ACTIONS(1692),
    [anon_sym_AMP_GT_GT] = ACTIONS(1196),
    [anon_sym_LT_AMP] = ACTIONS(1196),
    [anon_sym_GT_AMP] = ACTIONS(1196),
    [anon_sym_BQUOTE] = ACTIONS(1196),
    [sym_comment] = ACTIONS(52),
  },
  [568] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(610),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_RBRACE] = ACTIONS(1694),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [569] = {
    [anon_sym_LT] = ACTIONS(1696),
    [anon_sym_GT] = ACTIONS(1696),
    [anon_sym_GT_GT] = ACTIONS(1698),
    [anon_sym_AMP_GT] = ACTIONS(1696),
    [anon_sym_AMP_GT_GT] = ACTIONS(1698),
    [anon_sym_LT_AMP] = ACTIONS(1698),
    [anon_sym_GT_AMP] = ACTIONS(1698),
    [sym_comment] = ACTIONS(52),
  },
  [570] = {
    [sym_concatenation] = STATE(847),
    [sym_string] = STATE(841),
    [sym_simple_expansion] = STATE(841),
    [sym_expansion] = STATE(841),
    [sym_command_substitution] = STATE(841),
    [sym_process_substitution] = STATE(841),
    [anon_sym_DQUOTE] = ACTIONS(1700),
    [sym_raw_string] = ACTIONS(1702),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1706),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [anon_sym_LT_LPAREN] = ACTIONS(1712),
    [anon_sym_GT_LPAREN] = ACTIONS(1712),
    [sym_word] = ACTIONS(1714),
    [sym_comment] = ACTIONS(52),
  },
  [571] = {
    [anon_sym_PIPE] = ACTIONS(1651),
    [anon_sym_RPAREN] = ACTIONS(1653),
    [anon_sym_PIPE_AMP] = ACTIONS(1653),
    [anon_sym_AMP_AMP] = ACTIONS(1653),
    [anon_sym_PIPE_PIPE] = ACTIONS(1653),
    [anon_sym_BQUOTE] = ACTIONS(1653),
    [sym_comment] = ACTIONS(52),
  },
  [572] = {
    [anon_sym_PIPE] = ACTIONS(1716),
    [anon_sym_RPAREN] = ACTIONS(1718),
    [anon_sym_PIPE_AMP] = ACTIONS(1718),
    [anon_sym_AMP_AMP] = ACTIONS(1718),
    [anon_sym_PIPE_PIPE] = ACTIONS(1718),
    [anon_sym_BQUOTE] = ACTIONS(1718),
    [sym_comment] = ACTIONS(52),
  },
  [573] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(1716),
    [anon_sym_RPAREN] = ACTIONS(1718),
    [anon_sym_PIPE_AMP] = ACTIONS(1718),
    [anon_sym_AMP_AMP] = ACTIONS(1718),
    [anon_sym_PIPE_PIPE] = ACTIONS(1716),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [574] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1720),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(1720),
    [anon_sym_PIPE_PIPE] = ACTIONS(1720),
    [sym_comment] = ACTIONS(52),
  },
  [575] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1720),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(1720),
    [anon_sym_PIPE_PIPE] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [576] = {
    [sym_concatenation] = STATE(849),
    [sym_string] = STATE(848),
    [sym_simple_expansion] = STATE(848),
    [sym_expansion] = STATE(848),
    [sym_command_substitution] = STATE(848),
    [sym_process_substitution] = STATE(848),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [sym_raw_string] = ACTIONS(1724),
    [anon_sym_DOLLAR] = ACTIONS(1148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1152),
    [anon_sym_BQUOTE] = ACTIONS(1154),
    [anon_sym_LT_LPAREN] = ACTIONS(1156),
    [anon_sym_GT_LPAREN] = ACTIONS(1156),
    [sym_word] = ACTIONS(1726),
    [sym_comment] = ACTIONS(52),
  },
  [577] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(851),
    [anon_sym_DQUOTE] = ACTIONS(1728),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [578] = {
    [aux_sym_concatenation_repeat1] = STATE(853),
    [sym_file_descriptor] = ACTIONS(400),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(404),
    [anon_sym_RPAREN] = ACTIONS(400),
    [anon_sym_PIPE_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(400),
    [anon_sym_PIPE_PIPE] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(404),
    [anon_sym_GT] = ACTIONS(404),
    [anon_sym_GT_GT] = ACTIONS(400),
    [anon_sym_AMP_GT] = ACTIONS(404),
    [anon_sym_AMP_GT_GT] = ACTIONS(400),
    [anon_sym_LT_AMP] = ACTIONS(400),
    [anon_sym_GT_AMP] = ACTIONS(400),
    [anon_sym_LT_LT] = ACTIONS(404),
    [anon_sym_LT_LT_DASH] = ACTIONS(400),
    [sym_comment] = ACTIONS(52),
  },
  [579] = {
    [sym_special_variable_name] = STATE(856),
    [anon_sym_DOLLAR] = ACTIONS(1732),
    [anon_sym_POUND] = ACTIONS(1732),
    [anon_sym_AT] = ACTIONS(1732),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1734),
    [anon_sym_STAR] = ACTIONS(1732),
    [anon_sym_QMARK] = ACTIONS(1732),
    [anon_sym_DASH] = ACTIONS(1732),
    [anon_sym_BANG] = ACTIONS(1732),
    [anon_sym_0] = ACTIONS(1736),
    [anon_sym__] = ACTIONS(1736),
  },
  [580] = {
    [sym_special_variable_name] = STATE(859),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(1738),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1740),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [581] = {
    [sym_for_statement] = STATE(860),
    [sym_while_statement] = STATE(860),
    [sym_if_statement] = STATE(860),
    [sym_case_statement] = STATE(860),
    [sym_function_definition] = STATE(860),
    [sym_subshell] = STATE(860),
    [sym_pipeline] = STATE(860),
    [sym_list] = STATE(860),
    [sym_bracket_command] = STATE(860),
    [sym_command] = STATE(860),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(861),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [582] = {
    [sym_for_statement] = STATE(862),
    [sym_while_statement] = STATE(862),
    [sym_if_statement] = STATE(862),
    [sym_case_statement] = STATE(862),
    [sym_function_definition] = STATE(862),
    [sym_subshell] = STATE(862),
    [sym_pipeline] = STATE(862),
    [sym_list] = STATE(862),
    [sym_bracket_command] = STATE(862),
    [sym_command] = STATE(862),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(863),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [583] = {
    [sym_for_statement] = STATE(864),
    [sym_while_statement] = STATE(864),
    [sym_if_statement] = STATE(864),
    [sym_case_statement] = STATE(864),
    [sym_function_definition] = STATE(864),
    [sym_subshell] = STATE(864),
    [sym_pipeline] = STATE(864),
    [sym_list] = STATE(864),
    [sym_bracket_command] = STATE(864),
    [sym_command] = STATE(864),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(865),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [584] = {
    [sym_file_descriptor] = ACTIONS(400),
    [anon_sym_PIPE] = ACTIONS(404),
    [anon_sym_RPAREN] = ACTIONS(400),
    [anon_sym_PIPE_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(400),
    [anon_sym_PIPE_PIPE] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(404),
    [anon_sym_GT] = ACTIONS(404),
    [anon_sym_GT_GT] = ACTIONS(400),
    [anon_sym_AMP_GT] = ACTIONS(404),
    [anon_sym_AMP_GT_GT] = ACTIONS(400),
    [anon_sym_LT_AMP] = ACTIONS(400),
    [anon_sym_GT_AMP] = ACTIONS(400),
    [anon_sym_LT_LT] = ACTIONS(404),
    [anon_sym_LT_LT_DASH] = ACTIONS(400),
    [anon_sym_BQUOTE] = ACTIONS(400),
    [sym_comment] = ACTIONS(52),
  },
  [585] = {
    [sym_file_descriptor] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_RPAREN] = ACTIONS(1246),
    [anon_sym_PIPE_AMP] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1246),
    [anon_sym_PIPE_PIPE] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_GT] = ACTIONS(1742),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_AMP_GT] = ACTIONS(1742),
    [anon_sym_AMP_GT_GT] = ACTIONS(1246),
    [anon_sym_LT_AMP] = ACTIONS(1246),
    [anon_sym_GT_AMP] = ACTIONS(1246),
    [anon_sym_LT_LT] = ACTIONS(1742),
    [anon_sym_LT_LT_DASH] = ACTIONS(1246),
    [anon_sym_BQUOTE] = ACTIONS(1246),
    [sym_comment] = ACTIONS(52),
  },
  [586] = {
    [sym_simple_expansion] = STATE(638),
    [sym_expansion] = STATE(638),
    [aux_sym_heredoc_repeat1] = STATE(867),
    [sym__heredoc_middle] = ACTIONS(1250),
    [sym__heredoc_end] = ACTIONS(1744),
    [anon_sym_DOLLAR] = ACTIONS(1254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1256),
    [sym_comment] = ACTIONS(52),
  },
  [587] = {
    [sym_file_descriptor] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1258),
    [anon_sym_PIPE_AMP] = ACTIONS(1258),
    [anon_sym_AMP_AMP] = ACTIONS(1258),
    [anon_sym_PIPE_PIPE] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1258),
    [anon_sym_LT_AMP] = ACTIONS(1258),
    [anon_sym_GT_AMP] = ACTIONS(1258),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1258),
    [anon_sym_BQUOTE] = ACTIONS(1258),
    [sym_comment] = ACTIONS(52),
  },
  [588] = {
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(325),
    [sym_simple_expansion] = STATE(325),
    [sym_expansion] = STATE(325),
    [sym_command_substitution] = STATE(325),
    [sym_process_substitution] = STATE(325),
    [aux_sym_for_statement_repeat1] = STATE(588),
    [sym_file_descriptor] = ACTIONS(1262),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_RPAREN] = ACTIONS(1262),
    [anon_sym_PIPE_AMP] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1262),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(874),
    [anon_sym_GT] = ACTIONS(874),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_AMP_GT] = ACTIONS(874),
    [anon_sym_AMP_GT_GT] = ACTIONS(1262),
    [anon_sym_LT_AMP] = ACTIONS(1262),
    [anon_sym_GT_AMP] = ACTIONS(1262),
    [anon_sym_LT_LT] = ACTIONS(874),
    [anon_sym_LT_LT_DASH] = ACTIONS(1262),
    [anon_sym_DQUOTE] = ACTIONS(1748),
    [sym_raw_string] = ACTIONS(1751),
    [anon_sym_DOLLAR] = ACTIONS(1754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1760),
    [anon_sym_BQUOTE] = ACTIONS(1763),
    [anon_sym_LT_LPAREN] = ACTIONS(1766),
    [anon_sym_GT_LPAREN] = ACTIONS(1766),
    [sym_word] = ACTIONS(1769),
    [sym_comment] = ACTIONS(52),
  },
  [589] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [aux_sym_command_repeat2] = STATE(590),
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_RPAREN] = ACTIONS(1774),
    [anon_sym_PIPE_AMP] = ACTIONS(1774),
    [anon_sym_AMP_AMP] = ACTIONS(1774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [sym_comment] = ACTIONS(52),
  },
  [590] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [aux_sym_command_repeat2] = STATE(590),
    [sym_file_descriptor] = ACTIONS(1776),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_PIPE_AMP] = ACTIONS(1781),
    [anon_sym_AMP_AMP] = ACTIONS(1781),
    [anon_sym_PIPE_PIPE] = ACTIONS(1781),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_GT] = ACTIONS(1783),
    [anon_sym_GT_GT] = ACTIONS(1786),
    [anon_sym_AMP_GT] = ACTIONS(1783),
    [anon_sym_AMP_GT_GT] = ACTIONS(1786),
    [anon_sym_LT_AMP] = ACTIONS(1786),
    [anon_sym_GT_AMP] = ACTIONS(1786),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1792),
    [sym_comment] = ACTIONS(52),
  },
  [591] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(325),
    [sym_simple_expansion] = STATE(325),
    [sym_expansion] = STATE(325),
    [sym_command_substitution] = STATE(325),
    [sym_process_substitution] = STATE(325),
    [aux_sym_for_statement_repeat1] = STATE(588),
    [aux_sym_command_repeat2] = STATE(868),
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_RPAREN] = ACTIONS(1774),
    [anon_sym_PIPE_AMP] = ACTIONS(1774),
    [anon_sym_AMP_AMP] = ACTIONS(1774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(528),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(530),
    [sym_comment] = ACTIONS(52),
  },
  [592] = {
    [aux_sym_concatenation_repeat1] = STATE(869),
    [sym_file_descriptor] = ACTIONS(710),
    [sym__concat] = ACTIONS(1625),
    [sym_variable_name] = ACTIONS(710),
    [anon_sym_PIPE] = ACTIONS(1619),
    [anon_sym_PIPE_AMP] = ACTIONS(710),
    [anon_sym_AMP_AMP] = ACTIONS(710),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(710),
    [anon_sym_LT_AMP] = ACTIONS(710),
    [anon_sym_GT_AMP] = ACTIONS(710),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [sym_raw_string] = ACTIONS(710),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(710),
    [anon_sym_BQUOTE] = ACTIONS(710),
    [anon_sym_LT_LPAREN] = ACTIONS(710),
    [anon_sym_GT_LPAREN] = ACTIONS(710),
    [sym_word] = ACTIONS(712),
    [sym_comment] = ACTIONS(52),
  },
  [593] = {
    [anon_sym_RPAREN] = ACTIONS(1795),
    [sym_comment] = ACTIONS(52),
  },
  [594] = {
    [sym_file_redirect] = STATE(824),
    [sym_file_descriptor] = ACTIONS(1178),
    [anon_sym_PIPE] = ACTIONS(1651),
    [anon_sym_PIPE_AMP] = ACTIONS(1653),
    [anon_sym_AMP_AMP] = ACTIONS(1653),
    [anon_sym_PIPE_PIPE] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1180),
    [anon_sym_GT] = ACTIONS(1180),
    [anon_sym_GT_GT] = ACTIONS(1182),
    [anon_sym_AMP_GT] = ACTIONS(1180),
    [anon_sym_AMP_GT_GT] = ACTIONS(1182),
    [anon_sym_LT_AMP] = ACTIONS(1182),
    [anon_sym_GT_AMP] = ACTIONS(1182),
    [anon_sym_BQUOTE] = ACTIONS(1653),
    [sym_comment] = ACTIONS(52),
  },
  [595] = {
    [aux_sym_concatenation_repeat1] = STATE(595),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1669),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_LT_LT] = ACTIONS(1500),
    [anon_sym_LT_LT_DASH] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [596] = {
    [sym_compound_statement] = STATE(871),
    [anon_sym_LBRACE] = ACTIONS(504),
    [sym_comment] = ACTIONS(52),
  },
  [597] = {
    [anon_sym_LT] = ACTIONS(1797),
    [anon_sym_GT] = ACTIONS(1797),
    [anon_sym_GT_GT] = ACTIONS(1799),
    [anon_sym_AMP_GT] = ACTIONS(1797),
    [anon_sym_AMP_GT_GT] = ACTIONS(1799),
    [anon_sym_LT_AMP] = ACTIONS(1799),
    [anon_sym_GT_AMP] = ACTIONS(1799),
    [sym_comment] = ACTIONS(52),
  },
  [598] = {
    [sym_concatenation] = STATE(847),
    [sym_string] = STATE(873),
    [sym_simple_expansion] = STATE(873),
    [sym_expansion] = STATE(873),
    [sym_command_substitution] = STATE(873),
    [sym_process_substitution] = STATE(873),
    [anon_sym_DQUOTE] = ACTIONS(1700),
    [sym_raw_string] = ACTIONS(1801),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1706),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [anon_sym_LT_LPAREN] = ACTIONS(1712),
    [anon_sym_GT_LPAREN] = ACTIONS(1712),
    [sym_word] = ACTIONS(1803),
    [sym_comment] = ACTIONS(52),
  },
  [599] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(1716),
    [anon_sym_PIPE_AMP] = ACTIONS(1718),
    [anon_sym_AMP_AMP] = ACTIONS(1718),
    [anon_sym_PIPE_PIPE] = ACTIONS(1716),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(1718),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [600] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(1720),
    [anon_sym_PIPE_PIPE] = ACTIONS(1720),
    [anon_sym_BQUOTE] = ACTIONS(1720),
    [sym_comment] = ACTIONS(52),
  },
  [601] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(1720),
    [anon_sym_PIPE_PIPE] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [602] = {
    [sym_concatenation] = STATE(849),
    [sym_string] = STATE(874),
    [sym_simple_expansion] = STATE(874),
    [sym_expansion] = STATE(874),
    [sym_command_substitution] = STATE(874),
    [sym_process_substitution] = STATE(874),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [sym_raw_string] = ACTIONS(1805),
    [anon_sym_DOLLAR] = ACTIONS(1148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1152),
    [anon_sym_BQUOTE] = ACTIONS(1154),
    [anon_sym_LT_LPAREN] = ACTIONS(1156),
    [anon_sym_GT_LPAREN] = ACTIONS(1156),
    [sym_word] = ACTIONS(1807),
    [sym_comment] = ACTIONS(52),
  },
  [603] = {
    [aux_sym_concatenation_repeat1] = STATE(875),
    [sym_file_descriptor] = ACTIONS(400),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(404),
    [anon_sym_PIPE_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(400),
    [anon_sym_PIPE_PIPE] = ACTIONS(400),
    [anon_sym_LT] = ACTIONS(404),
    [anon_sym_GT] = ACTIONS(404),
    [anon_sym_GT_GT] = ACTIONS(400),
    [anon_sym_AMP_GT] = ACTIONS(404),
    [anon_sym_AMP_GT_GT] = ACTIONS(400),
    [anon_sym_LT_AMP] = ACTIONS(400),
    [anon_sym_GT_AMP] = ACTIONS(400),
    [anon_sym_LT_LT] = ACTIONS(404),
    [anon_sym_LT_LT_DASH] = ACTIONS(400),
    [anon_sym_BQUOTE] = ACTIONS(400),
    [sym_comment] = ACTIONS(52),
  },
  [604] = {
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(340),
    [sym_simple_expansion] = STATE(340),
    [sym_expansion] = STATE(340),
    [sym_command_substitution] = STATE(340),
    [sym_process_substitution] = STATE(340),
    [aux_sym_for_statement_repeat1] = STATE(604),
    [sym_file_descriptor] = ACTIONS(1262),
    [anon_sym_PIPE] = ACTIONS(874),
    [anon_sym_PIPE_AMP] = ACTIONS(1262),
    [anon_sym_AMP_AMP] = ACTIONS(1262),
    [anon_sym_PIPE_PIPE] = ACTIONS(874),
    [anon_sym_LT] = ACTIONS(874),
    [anon_sym_GT] = ACTIONS(874),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_AMP_GT] = ACTIONS(874),
    [anon_sym_AMP_GT_GT] = ACTIONS(1262),
    [anon_sym_LT_AMP] = ACTIONS(1262),
    [anon_sym_GT_AMP] = ACTIONS(1262),
    [anon_sym_LT_LT] = ACTIONS(874),
    [anon_sym_LT_LT_DASH] = ACTIONS(1262),
    [anon_sym_DQUOTE] = ACTIONS(1748),
    [sym_raw_string] = ACTIONS(1809),
    [anon_sym_DOLLAR] = ACTIONS(1754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1760),
    [anon_sym_BQUOTE] = ACTIONS(1763),
    [anon_sym_LT_LPAREN] = ACTIONS(1766),
    [anon_sym_GT_LPAREN] = ACTIONS(1766),
    [sym_word] = ACTIONS(1812),
    [sym_comment] = ACTIONS(52),
  },
  [605] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [aux_sym_command_repeat2] = STATE(606),
    [sym_file_descriptor] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_PIPE_AMP] = ACTIONS(1774),
    [anon_sym_AMP_AMP] = ACTIONS(1774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(550),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_AMP_GT] = ACTIONS(550),
    [anon_sym_AMP_GT_GT] = ACTIONS(552),
    [anon_sym_LT_AMP] = ACTIONS(552),
    [anon_sym_GT_AMP] = ACTIONS(552),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_BQUOTE] = ACTIONS(1774),
    [sym_comment] = ACTIONS(52),
  },
  [606] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [aux_sym_command_repeat2] = STATE(606),
    [sym_file_descriptor] = ACTIONS(1815),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_PIPE_AMP] = ACTIONS(1781),
    [anon_sym_AMP_AMP] = ACTIONS(1781),
    [anon_sym_PIPE_PIPE] = ACTIONS(1781),
    [anon_sym_LT] = ACTIONS(1818),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_GT_GT] = ACTIONS(1821),
    [anon_sym_AMP_GT] = ACTIONS(1818),
    [anon_sym_AMP_GT_GT] = ACTIONS(1821),
    [anon_sym_LT_AMP] = ACTIONS(1821),
    [anon_sym_GT_AMP] = ACTIONS(1821),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1792),
    [anon_sym_BQUOTE] = ACTIONS(1781),
    [sym_comment] = ACTIONS(52),
  },
  [607] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(340),
    [sym_simple_expansion] = STATE(340),
    [sym_expansion] = STATE(340),
    [sym_command_substitution] = STATE(340),
    [sym_process_substitution] = STATE(340),
    [aux_sym_for_statement_repeat1] = STATE(604),
    [aux_sym_command_repeat2] = STATE(876),
    [sym_file_descriptor] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_PIPE_AMP] = ACTIONS(1774),
    [anon_sym_AMP_AMP] = ACTIONS(1774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(550),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_AMP_GT] = ACTIONS(550),
    [anon_sym_AMP_GT_GT] = ACTIONS(552),
    [anon_sym_LT_AMP] = ACTIONS(552),
    [anon_sym_GT_AMP] = ACTIONS(552),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(554),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(1774),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(556),
    [sym_comment] = ACTIONS(52),
  },
  [608] = {
    [sym_file_redirect] = STATE(877),
    [sym_file_descriptor] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_SEMI_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE_AMP] = ACTIONS(1469),
    [anon_sym_AMP_AMP] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1469),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(572),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [609] = {
    [sym_file_descriptor] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(1826),
    [anon_sym_RPAREN] = ACTIONS(1826),
    [anon_sym_SEMI_SEMI] = ACTIONS(1826),
    [anon_sym_PIPE_AMP] = ACTIONS(1826),
    [anon_sym_AMP_AMP] = ACTIONS(1826),
    [anon_sym_PIPE_PIPE] = ACTIONS(1826),
    [anon_sym_LT] = ACTIONS(1826),
    [anon_sym_GT] = ACTIONS(1826),
    [anon_sym_GT_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT] = ACTIONS(1826),
    [anon_sym_AMP_GT_GT] = ACTIONS(1826),
    [anon_sym_LT_AMP] = ACTIONS(1826),
    [anon_sym_GT_AMP] = ACTIONS(1826),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1826),
    [anon_sym_LF] = ACTIONS(1826),
    [anon_sym_AMP] = ACTIONS(1826),
  },
  [610] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(610),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(610),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_case] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(645),
    [anon_sym_LT_AMP] = ACTIONS(645),
    [anon_sym_GT_AMP] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(663),
    [anon_sym_LT_LPAREN] = ACTIONS(666),
    [anon_sym_GT_LPAREN] = ACTIONS(666),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(52),
  },
  [611] = {
    [sym_concatenation] = STATE(879),
    [sym_string] = STATE(878),
    [sym_simple_expansion] = STATE(878),
    [sym_expansion] = STATE(878),
    [sym_command_substitution] = STATE(878),
    [sym_process_substitution] = STATE(878),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [sym_raw_string] = ACTIONS(1828),
    [anon_sym_DOLLAR] = ACTIONS(1210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [anon_sym_LT_LPAREN] = ACTIONS(1218),
    [anon_sym_GT_LPAREN] = ACTIONS(1218),
    [sym_word] = ACTIONS(1830),
    [sym_comment] = ACTIONS(52),
  },
  [612] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(881),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [613] = {
    [aux_sym_concatenation_repeat1] = STATE(883),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_SEMI_SEMI] = ACTIONS(1234),
    [anon_sym_PIPE_AMP] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_PIPE_PIPE] = ACTIONS(1234),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1234),
    [anon_sym_LF] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
  },
  [614] = {
    [sym_special_variable_name] = STATE(886),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [anon_sym_POUND] = ACTIONS(1836),
    [anon_sym_AT] = ACTIONS(1836),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1838),
    [anon_sym_STAR] = ACTIONS(1836),
    [anon_sym_QMARK] = ACTIONS(1836),
    [anon_sym_DASH] = ACTIONS(1836),
    [anon_sym_BANG] = ACTIONS(1836),
    [anon_sym_0] = ACTIONS(1840),
    [anon_sym__] = ACTIONS(1840),
  },
  [615] = {
    [sym_special_variable_name] = STATE(889),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(1842),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1844),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [616] = {
    [sym_for_statement] = STATE(890),
    [sym_while_statement] = STATE(890),
    [sym_if_statement] = STATE(890),
    [sym_case_statement] = STATE(890),
    [sym_function_definition] = STATE(890),
    [sym_subshell] = STATE(890),
    [sym_pipeline] = STATE(890),
    [sym_list] = STATE(890),
    [sym_bracket_command] = STATE(890),
    [sym_command] = STATE(890),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(891),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [617] = {
    [sym_for_statement] = STATE(892),
    [sym_while_statement] = STATE(892),
    [sym_if_statement] = STATE(892),
    [sym_case_statement] = STATE(892),
    [sym_function_definition] = STATE(892),
    [sym_subshell] = STATE(892),
    [sym_pipeline] = STATE(892),
    [sym_list] = STATE(892),
    [sym_bracket_command] = STATE(892),
    [sym_command] = STATE(892),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(893),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [618] = {
    [sym_for_statement] = STATE(894),
    [sym_while_statement] = STATE(894),
    [sym_if_statement] = STATE(894),
    [sym_case_statement] = STATE(894),
    [sym_function_definition] = STATE(894),
    [sym_subshell] = STATE(894),
    [sym_pipeline] = STATE(894),
    [sym_list] = STATE(894),
    [sym_bracket_command] = STATE(894),
    [sym_command] = STATE(894),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(895),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [619] = {
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_RPAREN] = ACTIONS(1234),
    [anon_sym_SEMI_SEMI] = ACTIONS(1234),
    [anon_sym_PIPE_AMP] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_PIPE_PIPE] = ACTIONS(1234),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1234),
    [anon_sym_LF] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
  },
  [620] = {
    [aux_sym_concatenation_repeat1] = STATE(625),
    [sym_file_descriptor] = ACTIONS(690),
    [sym__concat] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1846),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [anon_sym_LT_LT] = ACTIONS(1846),
    [anon_sym_LT_LT_DASH] = ACTIONS(1846),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [621] = {
    [sym_file_descriptor] = ACTIONS(690),
    [anon_sym_PIPE] = ACTIONS(1846),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1846),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [anon_sym_LT_LT] = ACTIONS(1846),
    [anon_sym_LT_LT_DASH] = ACTIONS(1846),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [622] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [anon_sym_LT] = ACTIONS(418),
    [anon_sym_GT] = ACTIONS(418),
    [anon_sym_GT_GT] = ACTIONS(418),
    [anon_sym_AMP_GT] = ACTIONS(418),
    [anon_sym_AMP_GT_GT] = ACTIONS(418),
    [anon_sym_LT_AMP] = ACTIONS(418),
    [anon_sym_GT_AMP] = ACTIONS(418),
    [anon_sym_LT_LT] = ACTIONS(418),
    [anon_sym_LT_LT_DASH] = ACTIONS(418),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [623] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(1848),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [624] = {
    [sym_string] = STATE(897),
    [sym_simple_expansion] = STATE(897),
    [sym_expansion] = STATE(897),
    [sym_command_substitution] = STATE(897),
    [sym_process_substitution] = STATE(897),
    [anon_sym_DQUOTE] = ACTIONS(584),
    [sym_raw_string] = ACTIONS(1850),
    [anon_sym_DOLLAR] = ACTIONS(588),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(592),
    [anon_sym_BQUOTE] = ACTIONS(594),
    [anon_sym_LT_LPAREN] = ACTIONS(596),
    [anon_sym_GT_LPAREN] = ACTIONS(596),
    [sym_word] = ACTIONS(1852),
    [sym_comment] = ACTIONS(52),
  },
  [625] = {
    [aux_sym_concatenation_repeat1] = STATE(898),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_PIPE_AMP] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(442),
    [anon_sym_AMP_GT] = ACTIONS(442),
    [anon_sym_AMP_GT_GT] = ACTIONS(442),
    [anon_sym_LT_AMP] = ACTIONS(442),
    [anon_sym_GT_AMP] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(442),
    [anon_sym_LT_LT_DASH] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [626] = {
    [sym_file_descriptor] = ACTIONS(444),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_SEMI_SEMI] = ACTIONS(446),
    [anon_sym_PIPE_AMP] = ACTIONS(446),
    [anon_sym_AMP_AMP] = ACTIONS(446),
    [anon_sym_PIPE_PIPE] = ACTIONS(446),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(446),
    [anon_sym_LT_LT_DASH] = ACTIONS(446),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym_LF] = ACTIONS(446),
    [anon_sym_AMP] = ACTIONS(446),
  },
  [627] = {
    [sym_file_descriptor] = ACTIONS(448),
    [sym__concat] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(450),
    [anon_sym_RPAREN] = ACTIONS(450),
    [anon_sym_SEMI_SEMI] = ACTIONS(450),
    [anon_sym_PIPE_AMP] = ACTIONS(450),
    [anon_sym_AMP_AMP] = ACTIONS(450),
    [anon_sym_PIPE_PIPE] = ACTIONS(450),
    [anon_sym_LT] = ACTIONS(450),
    [anon_sym_GT] = ACTIONS(450),
    [anon_sym_GT_GT] = ACTIONS(450),
    [anon_sym_AMP_GT] = ACTIONS(450),
    [anon_sym_AMP_GT_GT] = ACTIONS(450),
    [anon_sym_LT_AMP] = ACTIONS(450),
    [anon_sym_GT_AMP] = ACTIONS(450),
    [anon_sym_LT_LT] = ACTIONS(450),
    [anon_sym_LT_LT_DASH] = ACTIONS(450),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_LF] = ACTIONS(450),
    [anon_sym_AMP] = ACTIONS(450),
  },
  [628] = {
    [sym_file_descriptor] = ACTIONS(452),
    [sym__concat] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(454),
    [anon_sym_RPAREN] = ACTIONS(454),
    [anon_sym_SEMI_SEMI] = ACTIONS(454),
    [anon_sym_PIPE_AMP] = ACTIONS(454),
    [anon_sym_AMP_AMP] = ACTIONS(454),
    [anon_sym_PIPE_PIPE] = ACTIONS(454),
    [anon_sym_LT] = ACTIONS(454),
    [anon_sym_GT] = ACTIONS(454),
    [anon_sym_GT_GT] = ACTIONS(454),
    [anon_sym_AMP_GT] = ACTIONS(454),
    [anon_sym_AMP_GT_GT] = ACTIONS(454),
    [anon_sym_LT_AMP] = ACTIONS(454),
    [anon_sym_GT_AMP] = ACTIONS(454),
    [anon_sym_LT_LT] = ACTIONS(454),
    [anon_sym_LT_LT_DASH] = ACTIONS(454),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_LF] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(454),
  },
  [629] = {
    [sym_special_variable_name] = STATE(900),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1854),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [630] = {
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_LBRACK] = ACTIONS(1858),
    [anon_sym_EQ] = ACTIONS(1860),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_COLON_QMARK] = ACTIONS(1860),
    [anon_sym_COLON_DASH] = ACTIONS(1860),
    [anon_sym_PERCENT] = ACTIONS(1860),
    [anon_sym_SLASH] = ACTIONS(1860),
    [sym_comment] = ACTIONS(52),
  },
  [631] = {
    [anon_sym_RBRACE] = ACTIONS(1864),
    [anon_sym_LBRACK] = ACTIONS(1866),
    [anon_sym_EQ] = ACTIONS(1868),
    [anon_sym_COLON] = ACTIONS(1870),
    [anon_sym_COLON_QMARK] = ACTIONS(1868),
    [anon_sym_COLON_DASH] = ACTIONS(1868),
    [anon_sym_PERCENT] = ACTIONS(1868),
    [anon_sym_SLASH] = ACTIONS(1868),
    [sym_comment] = ACTIONS(52),
  },
  [632] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1872),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [633] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1872),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [634] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(1872),
    [sym_comment] = ACTIONS(52),
  },
  [635] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(1872),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [636] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1874),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [637] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1874),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [638] = {
    [sym__heredoc_middle] = ACTIONS(1876),
    [sym__heredoc_end] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1878),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1876),
    [sym_comment] = ACTIONS(52),
  },
  [639] = {
    [sym_file_descriptor] = ACTIONS(1880),
    [anon_sym_PIPE] = ACTIONS(1882),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
    [anon_sym_PIPE_AMP] = ACTIONS(1882),
    [anon_sym_AMP_AMP] = ACTIONS(1882),
    [anon_sym_PIPE_PIPE] = ACTIONS(1882),
    [anon_sym_LT] = ACTIONS(1882),
    [anon_sym_GT] = ACTIONS(1882),
    [anon_sym_GT_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT] = ACTIONS(1882),
    [anon_sym_AMP_GT_GT] = ACTIONS(1882),
    [anon_sym_LT_AMP] = ACTIONS(1882),
    [anon_sym_GT_AMP] = ACTIONS(1882),
    [anon_sym_LT_LT] = ACTIONS(1882),
    [anon_sym_LT_LT_DASH] = ACTIONS(1882),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1882),
    [anon_sym_LF] = ACTIONS(1882),
    [anon_sym_AMP] = ACTIONS(1882),
  },
  [640] = {
    [sym_special_variable_name] = STATE(911),
    [anon_sym_DOLLAR] = ACTIONS(1884),
    [anon_sym_POUND] = ACTIONS(1884),
    [anon_sym_AT] = ACTIONS(1884),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1886),
    [anon_sym_STAR] = ACTIONS(1884),
    [anon_sym_QMARK] = ACTIONS(1884),
    [anon_sym_DASH] = ACTIONS(1884),
    [anon_sym_BANG] = ACTIONS(1884),
    [anon_sym_0] = ACTIONS(1888),
    [anon_sym__] = ACTIONS(1888),
  },
  [641] = {
    [sym_special_variable_name] = STATE(914),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(1890),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1892),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [642] = {
    [sym_simple_expansion] = STATE(638),
    [sym_expansion] = STATE(638),
    [aux_sym_heredoc_repeat1] = STATE(916),
    [sym__heredoc_middle] = ACTIONS(1250),
    [sym__heredoc_end] = ACTIONS(1894),
    [anon_sym_DOLLAR] = ACTIONS(1254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1256),
    [sym_comment] = ACTIONS(52),
  },
  [643] = {
    [sym_file_descriptor] = ACTIONS(710),
    [sym_variable_name] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(710),
    [anon_sym_LT_AMP] = ACTIONS(710),
    [anon_sym_GT_AMP] = ACTIONS(710),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [sym_raw_string] = ACTIONS(710),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(710),
    [anon_sym_BQUOTE] = ACTIONS(710),
    [anon_sym_LT_LPAREN] = ACTIONS(710),
    [anon_sym_GT_LPAREN] = ACTIONS(710),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(52),
  },
  [644] = {
    [sym_concatenation] = STATE(397),
    [sym_string] = STATE(391),
    [sym_simple_expansion] = STATE(391),
    [sym_expansion] = STATE(391),
    [sym_command_substitution] = STATE(391),
    [sym_process_substitution] = STATE(391),
    [aux_sym_for_statement_repeat1] = STATE(918),
    [anon_sym_RPAREN] = ACTIONS(1896),
    [anon_sym_DQUOTE] = ACTIONS(716),
    [sym_raw_string] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_word] = ACTIONS(730),
    [sym_comment] = ACTIONS(52),
  },
  [645] = {
    [aux_sym_concatenation_repeat1] = STATE(253),
    [sym_file_descriptor] = ACTIONS(710),
    [sym__concat] = ACTIONS(402),
    [sym_variable_name] = ACTIONS(710),
    [anon_sym_LT] = ACTIONS(1619),
    [anon_sym_GT] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(710),
    [anon_sym_AMP_GT] = ACTIONS(1619),
    [anon_sym_AMP_GT_GT] = ACTIONS(710),
    [anon_sym_LT_AMP] = ACTIONS(710),
    [anon_sym_GT_AMP] = ACTIONS(710),
    [anon_sym_DQUOTE] = ACTIONS(710),
    [sym_raw_string] = ACTIONS(710),
    [anon_sym_DOLLAR] = ACTIONS(1619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(710),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(710),
    [anon_sym_BQUOTE] = ACTIONS(710),
    [anon_sym_LT_LPAREN] = ACTIONS(710),
    [anon_sym_GT_LPAREN] = ACTIONS(710),
    [sym_word] = ACTIONS(1619),
    [sym_comment] = ACTIONS(52),
  },
  [646] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [aux_sym_command_repeat2] = STATE(369),
    [sym_file_descriptor] = ACTIONS(232),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_SEMI_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE_AMP] = ACTIONS(1898),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [anon_sym_LT] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(236),
    [anon_sym_AMP_GT] = ACTIONS(236),
    [anon_sym_AMP_GT_GT] = ACTIONS(236),
    [anon_sym_LT_AMP] = ACTIONS(236),
    [anon_sym_GT_AMP] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_LF] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1898),
  },
  [647] = {
    [sym__concat] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_RBRACK] = ACTIONS(1000),
    [sym_comment] = ACTIONS(52),
  },
  [648] = {
    [sym__concat] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1021),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_RBRACK] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [649] = {
    [aux_sym_concatenation_repeat1] = STATE(649),
    [sym__concat] = ACTIONS(1900),
    [anon_sym_RBRACK] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [650] = {
    [anon_sym_RBRACE] = ACTIONS(1903),
    [anon_sym_LBRACK] = ACTIONS(1905),
    [sym_comment] = ACTIONS(52),
  },
  [651] = {
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [sym_comment] = ACTIONS(52),
  },
  [652] = {
    [sym__concat] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_RBRACK] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [653] = {
    [anon_sym_AT] = ACTIONS(1911),
    [sym_comment] = ACTIONS(52),
  },
  [654] = {
    [sym_concatenation] = STATE(925),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1913),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1915),
    [sym_comment] = ACTIONS(52),
  },
  [655] = {
    [sym__concat] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1046),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [anon_sym_RBRACK] = ACTIONS(1046),
    [sym_comment] = ACTIONS(52),
  },
  [656] = {
    [anon_sym_AT] = ACTIONS(1917),
    [sym_comment] = ACTIONS(52),
  },
  [657] = {
    [sym_concatenation] = STATE(928),
    [sym_string] = STATE(927),
    [sym_simple_expansion] = STATE(927),
    [sym_expansion] = STATE(927),
    [sym_command_substitution] = STATE(927),
    [sym_process_substitution] = STATE(927),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1919),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1921),
    [sym_comment] = ACTIONS(52),
  },
  [658] = {
    [sym__concat] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_RBRACK] = ACTIONS(1136),
    [sym_comment] = ACTIONS(52),
  },
  [659] = {
    [sym__concat] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_RBRACK] = ACTIONS(1192),
    [sym_comment] = ACTIONS(52),
  },
  [660] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_word] = ACTIONS(836),
    [sym_comment] = ACTIONS(52),
  },
  [661] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(1923),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [662] = {
    [sym_string] = STATE(930),
    [sym_simple_expansion] = STATE(930),
    [sym_expansion] = STATE(930),
    [sym_command_substitution] = STATE(930),
    [sym_process_substitution] = STATE(930),
    [anon_sym_DQUOTE] = ACTIONS(716),
    [sym_raw_string] = ACTIONS(1925),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_word] = ACTIONS(1927),
    [sym_comment] = ACTIONS(52),
  },
  [663] = {
    [aux_sym_concatenation_repeat1] = STATE(931),
    [sym__concat] = ACTIONS(1344),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [sym_raw_string] = ACTIONS(440),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [anon_sym_LT_LPAREN] = ACTIONS(440),
    [anon_sym_GT_LPAREN] = ACTIONS(440),
    [sym_word] = ACTIONS(844),
    [sym_comment] = ACTIONS(52),
  },
  [664] = {
    [sym__concat] = ACTIONS(444),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_DQUOTE] = ACTIONS(444),
    [sym_raw_string] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(444),
    [anon_sym_BQUOTE] = ACTIONS(444),
    [anon_sym_LT_LPAREN] = ACTIONS(444),
    [anon_sym_GT_LPAREN] = ACTIONS(444),
    [sym_word] = ACTIONS(456),
    [sym_comment] = ACTIONS(52),
  },
  [665] = {
    [sym__concat] = ACTIONS(448),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_DQUOTE] = ACTIONS(448),
    [sym_raw_string] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(448),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(448),
    [anon_sym_BQUOTE] = ACTIONS(448),
    [anon_sym_LT_LPAREN] = ACTIONS(448),
    [anon_sym_GT_LPAREN] = ACTIONS(448),
    [sym_word] = ACTIONS(846),
    [sym_comment] = ACTIONS(52),
  },
  [666] = {
    [sym__concat] = ACTIONS(452),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(452),
    [anon_sym_DOLLAR] = ACTIONS(848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(452),
    [anon_sym_BQUOTE] = ACTIONS(452),
    [anon_sym_LT_LPAREN] = ACTIONS(452),
    [anon_sym_GT_LPAREN] = ACTIONS(452),
    [sym_word] = ACTIONS(848),
    [sym_comment] = ACTIONS(52),
  },
  [667] = {
    [sym_special_variable_name] = STATE(933),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(1929),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [668] = {
    [anon_sym_RBRACE] = ACTIONS(1931),
    [anon_sym_LBRACK] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1935),
    [anon_sym_COLON] = ACTIONS(1937),
    [anon_sym_COLON_QMARK] = ACTIONS(1935),
    [anon_sym_COLON_DASH] = ACTIONS(1935),
    [anon_sym_PERCENT] = ACTIONS(1935),
    [anon_sym_SLASH] = ACTIONS(1935),
    [sym_comment] = ACTIONS(52),
  },
  [669] = {
    [anon_sym_RBRACE] = ACTIONS(1939),
    [anon_sym_LBRACK] = ACTIONS(1941),
    [anon_sym_EQ] = ACTIONS(1943),
    [anon_sym_COLON] = ACTIONS(1945),
    [anon_sym_COLON_QMARK] = ACTIONS(1943),
    [anon_sym_COLON_DASH] = ACTIONS(1943),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1943),
    [sym_comment] = ACTIONS(52),
  },
  [670] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1947),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [671] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1947),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [672] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(1947),
    [sym_comment] = ACTIONS(52),
  },
  [673] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(1947),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [674] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1949),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [675] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(1949),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [676] = {
    [sym_file_descriptor] = ACTIONS(1951),
    [sym_variable_name] = ACTIONS(1951),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_SEMI_SEMI] = ACTIONS(1953),
    [anon_sym_PIPE_AMP] = ACTIONS(1953),
    [anon_sym_AMP_AMP] = ACTIONS(1953),
    [anon_sym_PIPE_PIPE] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_GT] = ACTIONS(1953),
    [anon_sym_AMP_GT] = ACTIONS(1953),
    [anon_sym_AMP_GT_GT] = ACTIONS(1953),
    [anon_sym_LT_AMP] = ACTIONS(1953),
    [anon_sym_GT_AMP] = ACTIONS(1953),
    [anon_sym_DQUOTE] = ACTIONS(1953),
    [sym_raw_string] = ACTIONS(1953),
    [anon_sym_DOLLAR] = ACTIONS(1953),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1953),
    [anon_sym_BQUOTE] = ACTIONS(1953),
    [anon_sym_LT_LPAREN] = ACTIONS(1953),
    [anon_sym_GT_LPAREN] = ACTIONS(1953),
    [sym_word] = ACTIONS(1953),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [677] = {
    [sym_concatenation] = STATE(397),
    [sym_string] = STATE(391),
    [sym_simple_expansion] = STATE(391),
    [sym_expansion] = STATE(391),
    [sym_command_substitution] = STATE(391),
    [sym_process_substitution] = STATE(391),
    [aux_sym_for_statement_repeat1] = STATE(677),
    [anon_sym_RPAREN] = ACTIONS(1262),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1964),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1967),
    [anon_sym_BQUOTE] = ACTIONS(1970),
    [anon_sym_LT_LPAREN] = ACTIONS(1973),
    [anon_sym_GT_LPAREN] = ACTIONS(1973),
    [sym_word] = ACTIONS(1976),
    [sym_comment] = ACTIONS(52),
  },
  [678] = {
    [sym_file_descriptor] = ACTIONS(1000),
    [sym__concat] = ACTIONS(1000),
    [sym_variable_name] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1002),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [anon_sym_SEMI_SEMI] = ACTIONS(1002),
    [anon_sym_PIPE_AMP] = ACTIONS(1002),
    [anon_sym_AMP_AMP] = ACTIONS(1002),
    [anon_sym_PIPE_PIPE] = ACTIONS(1002),
    [anon_sym_LT] = ACTIONS(1002),
    [anon_sym_GT] = ACTIONS(1002),
    [anon_sym_GT_GT] = ACTIONS(1002),
    [anon_sym_AMP_GT] = ACTIONS(1002),
    [anon_sym_AMP_GT_GT] = ACTIONS(1002),
    [anon_sym_LT_AMP] = ACTIONS(1002),
    [anon_sym_GT_AMP] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_raw_string] = ACTIONS(1002),
    [anon_sym_DOLLAR] = ACTIONS(1002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1002),
    [anon_sym_LT_LPAREN] = ACTIONS(1002),
    [anon_sym_GT_LPAREN] = ACTIONS(1002),
    [sym_word] = ACTIONS(1002),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_LF] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
  },
  [679] = {
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1021),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [sym_raw_string] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LPAREN] = ACTIONS(1023),
    [anon_sym_GT_LPAREN] = ACTIONS(1023),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [680] = {
    [aux_sym_concatenation_repeat1] = STATE(680),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1979),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [sym_raw_string] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LPAREN] = ACTIONS(1023),
    [anon_sym_GT_LPAREN] = ACTIONS(1023),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [681] = {
    [anon_sym_RBRACE] = ACTIONS(1982),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(52),
  },
  [682] = {
    [anon_sym_RBRACE] = ACTIONS(1986),
    [anon_sym_LBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(52),
  },
  [683] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1036),
    [sym_variable_name] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT_GT] = ACTIONS(1038),
    [anon_sym_LT_AMP] = ACTIONS(1038),
    [anon_sym_GT_AMP] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_raw_string] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LPAREN] = ACTIONS(1038),
    [anon_sym_GT_LPAREN] = ACTIONS(1038),
    [sym_word] = ACTIONS(1038),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
  },
  [684] = {
    [anon_sym_AT] = ACTIONS(1990),
    [sym_comment] = ACTIONS(52),
  },
  [685] = {
    [sym_concatenation] = STATE(948),
    [sym_string] = STATE(947),
    [sym_simple_expansion] = STATE(947),
    [sym_expansion] = STATE(947),
    [sym_command_substitution] = STATE(947),
    [sym_process_substitution] = STATE(947),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1992),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(1994),
    [sym_comment] = ACTIONS(52),
  },
  [686] = {
    [sym_file_descriptor] = ACTIONS(1046),
    [sym__concat] = ACTIONS(1046),
    [sym_variable_name] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1048),
    [anon_sym_RPAREN] = ACTIONS(1048),
    [anon_sym_SEMI_SEMI] = ACTIONS(1048),
    [anon_sym_PIPE_AMP] = ACTIONS(1048),
    [anon_sym_AMP_AMP] = ACTIONS(1048),
    [anon_sym_PIPE_PIPE] = ACTIONS(1048),
    [anon_sym_LT] = ACTIONS(1048),
    [anon_sym_GT] = ACTIONS(1048),
    [anon_sym_GT_GT] = ACTIONS(1048),
    [anon_sym_AMP_GT] = ACTIONS(1048),
    [anon_sym_AMP_GT_GT] = ACTIONS(1048),
    [anon_sym_LT_AMP] = ACTIONS(1048),
    [anon_sym_GT_AMP] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1048),
    [sym_raw_string] = ACTIONS(1048),
    [anon_sym_DOLLAR] = ACTIONS(1048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1048),
    [anon_sym_BQUOTE] = ACTIONS(1048),
    [anon_sym_LT_LPAREN] = ACTIONS(1048),
    [anon_sym_GT_LPAREN] = ACTIONS(1048),
    [sym_word] = ACTIONS(1048),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1048),
    [anon_sym_LF] = ACTIONS(1048),
    [anon_sym_AMP] = ACTIONS(1048),
  },
  [687] = {
    [anon_sym_AT] = ACTIONS(1996),
    [sym_comment] = ACTIONS(52),
  },
  [688] = {
    [sym_concatenation] = STATE(951),
    [sym_string] = STATE(950),
    [sym_simple_expansion] = STATE(950),
    [sym_expansion] = STATE(950),
    [sym_command_substitution] = STATE(950),
    [sym_process_substitution] = STATE(950),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(1998),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2000),
    [sym_comment] = ACTIONS(52),
  },
  [689] = {
    [sym_file_descriptor] = ACTIONS(1136),
    [sym__concat] = ACTIONS(1136),
    [sym_variable_name] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1138),
    [anon_sym_RPAREN] = ACTIONS(1138),
    [anon_sym_SEMI_SEMI] = ACTIONS(1138),
    [anon_sym_PIPE_AMP] = ACTIONS(1138),
    [anon_sym_AMP_AMP] = ACTIONS(1138),
    [anon_sym_PIPE_PIPE] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1138),
    [anon_sym_GT] = ACTIONS(1138),
    [anon_sym_GT_GT] = ACTIONS(1138),
    [anon_sym_AMP_GT] = ACTIONS(1138),
    [anon_sym_AMP_GT_GT] = ACTIONS(1138),
    [anon_sym_LT_AMP] = ACTIONS(1138),
    [anon_sym_GT_AMP] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [sym_raw_string] = ACTIONS(1138),
    [anon_sym_DOLLAR] = ACTIONS(1138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1138),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [anon_sym_LT_LPAREN] = ACTIONS(1138),
    [anon_sym_GT_LPAREN] = ACTIONS(1138),
    [sym_word] = ACTIONS(1138),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_LF] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1138),
  },
  [690] = {
    [sym_file_descriptor] = ACTIONS(1192),
    [sym__concat] = ACTIONS(1192),
    [sym_variable_name] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_RPAREN] = ACTIONS(1194),
    [anon_sym_SEMI_SEMI] = ACTIONS(1194),
    [anon_sym_PIPE_AMP] = ACTIONS(1194),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [anon_sym_LT] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_AMP_GT] = ACTIONS(1194),
    [anon_sym_AMP_GT_GT] = ACTIONS(1194),
    [anon_sym_LT_AMP] = ACTIONS(1194),
    [anon_sym_GT_AMP] = ACTIONS(1194),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [sym_raw_string] = ACTIONS(1194),
    [anon_sym_DOLLAR] = ACTIONS(1194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1194),
    [anon_sym_BQUOTE] = ACTIONS(1194),
    [anon_sym_LT_LPAREN] = ACTIONS(1194),
    [anon_sym_GT_LPAREN] = ACTIONS(1194),
    [sym_word] = ACTIONS(1194),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_AMP] = ACTIONS(1194),
  },
  [691] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [sym_raw_string] = ACTIONS(418),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(418),
    [anon_sym_BQUOTE] = ACTIONS(418),
    [anon_sym_LT_LPAREN] = ACTIONS(418),
    [anon_sym_GT_LPAREN] = ACTIONS(418),
    [sym_word] = ACTIONS(418),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [692] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(2002),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [693] = {
    [sym_string] = STATE(953),
    [sym_simple_expansion] = STATE(953),
    [sym_expansion] = STATE(953),
    [sym_command_substitution] = STATE(953),
    [sym_process_substitution] = STATE(953),
    [anon_sym_DQUOTE] = ACTIONS(746),
    [sym_raw_string] = ACTIONS(2004),
    [anon_sym_DOLLAR] = ACTIONS(750),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(754),
    [anon_sym_BQUOTE] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(758),
    [anon_sym_GT_LPAREN] = ACTIONS(758),
    [sym_word] = ACTIONS(2006),
    [sym_comment] = ACTIONS(52),
  },
  [694] = {
    [aux_sym_concatenation_repeat1] = STATE(954),
    [sym__concat] = ACTIONS(1388),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_DQUOTE] = ACTIONS(442),
    [sym_raw_string] = ACTIONS(442),
    [anon_sym_DOLLAR] = ACTIONS(442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_LT_LPAREN] = ACTIONS(442),
    [anon_sym_GT_LPAREN] = ACTIONS(442),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [695] = {
    [sym__concat] = ACTIONS(444),
    [anon_sym_SEMI_SEMI] = ACTIONS(446),
    [anon_sym_DQUOTE] = ACTIONS(446),
    [sym_raw_string] = ACTIONS(446),
    [anon_sym_DOLLAR] = ACTIONS(446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(446),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(446),
    [anon_sym_BQUOTE] = ACTIONS(446),
    [anon_sym_LT_LPAREN] = ACTIONS(446),
    [anon_sym_GT_LPAREN] = ACTIONS(446),
    [sym_word] = ACTIONS(446),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym_LF] = ACTIONS(446),
    [anon_sym_AMP] = ACTIONS(446),
  },
  [696] = {
    [sym__concat] = ACTIONS(448),
    [anon_sym_SEMI_SEMI] = ACTIONS(450),
    [anon_sym_DQUOTE] = ACTIONS(450),
    [sym_raw_string] = ACTIONS(450),
    [anon_sym_DOLLAR] = ACTIONS(450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(450),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(450),
    [anon_sym_BQUOTE] = ACTIONS(450),
    [anon_sym_LT_LPAREN] = ACTIONS(450),
    [anon_sym_GT_LPAREN] = ACTIONS(450),
    [sym_word] = ACTIONS(450),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_LF] = ACTIONS(450),
    [anon_sym_AMP] = ACTIONS(450),
  },
  [697] = {
    [sym__concat] = ACTIONS(452),
    [anon_sym_SEMI_SEMI] = ACTIONS(454),
    [anon_sym_DQUOTE] = ACTIONS(454),
    [sym_raw_string] = ACTIONS(454),
    [anon_sym_DOLLAR] = ACTIONS(454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(454),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(454),
    [anon_sym_BQUOTE] = ACTIONS(454),
    [anon_sym_LT_LPAREN] = ACTIONS(454),
    [anon_sym_GT_LPAREN] = ACTIONS(454),
    [sym_word] = ACTIONS(454),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_LF] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(454),
  },
  [698] = {
    [sym_special_variable_name] = STATE(956),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [699] = {
    [anon_sym_RBRACE] = ACTIONS(2010),
    [anon_sym_LBRACK] = ACTIONS(2012),
    [anon_sym_EQ] = ACTIONS(2014),
    [anon_sym_COLON] = ACTIONS(2016),
    [anon_sym_COLON_QMARK] = ACTIONS(2014),
    [anon_sym_COLON_DASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2014),
    [anon_sym_SLASH] = ACTIONS(2014),
    [sym_comment] = ACTIONS(52),
  },
  [700] = {
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [anon_sym_EQ] = ACTIONS(2022),
    [anon_sym_COLON] = ACTIONS(2024),
    [anon_sym_COLON_QMARK] = ACTIONS(2022),
    [anon_sym_COLON_DASH] = ACTIONS(2022),
    [anon_sym_PERCENT] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2022),
    [sym_comment] = ACTIONS(52),
  },
  [701] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [702] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [703] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [sym_comment] = ACTIONS(52),
  },
  [704] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(2026),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [705] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [706] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2028),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [707] = {
    [sym_do_group] = STATE(965),
    [anon_sym_do] = ACTIONS(308),
    [sym_comment] = ACTIONS(52),
  },
  [708] = {
    [sym_concatenation] = STATE(422),
    [sym_string] = STATE(416),
    [sym_simple_expansion] = STATE(416),
    [sym_expansion] = STATE(416),
    [sym_command_substitution] = STATE(416),
    [sym_process_substitution] = STATE(416),
    [aux_sym_for_statement_repeat1] = STATE(708),
    [anon_sym_SEMI_SEMI] = ACTIONS(1264),
    [anon_sym_DQUOTE] = ACTIONS(2030),
    [sym_raw_string] = ACTIONS(2033),
    [anon_sym_DOLLAR] = ACTIONS(2036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2039),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2042),
    [anon_sym_BQUOTE] = ACTIONS(2045),
    [anon_sym_LT_LPAREN] = ACTIONS(2048),
    [anon_sym_GT_LPAREN] = ACTIONS(2048),
    [sym_word] = ACTIONS(2033),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1264),
    [anon_sym_LF] = ACTIONS(1264),
    [anon_sym_AMP] = ACTIONS(1264),
  },
  [709] = {
    [sym_file_descriptor] = ACTIONS(574),
    [sym_variable_name] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_done] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(576),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_word] = ACTIONS(578),
    [sym_comment] = ACTIONS(52),
  },
  [710] = {
    [anon_sym_PIPE] = ACTIONS(2051),
    [anon_sym_RPAREN] = ACTIONS(2051),
    [anon_sym_SEMI_SEMI] = ACTIONS(2051),
    [anon_sym_PIPE_AMP] = ACTIONS(2051),
    [anon_sym_AMP_AMP] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2051),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2051),
    [anon_sym_LF] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
  },
  [711] = {
    [sym__terminated_statement] = STATE(425),
    [sym_for_statement] = STATE(426),
    [sym_while_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_case_statement] = STATE(426),
    [sym_function_definition] = STATE(426),
    [sym_subshell] = STATE(426),
    [sym_pipeline] = STATE(426),
    [sym_list] = STATE(426),
    [sym_bracket_command] = STATE(426),
    [sym_command] = STATE(426),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(427),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(711),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(610),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(621),
    [anon_sym_done] = ACTIONS(2053),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_case] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(645),
    [anon_sym_LT_AMP] = ACTIONS(645),
    [anon_sym_GT_AMP] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(663),
    [anon_sym_LT_LPAREN] = ACTIONS(666),
    [anon_sym_GT_LPAREN] = ACTIONS(666),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(52),
  },
  [712] = {
    [anon_sym_then] = ACTIONS(2055),
    [sym_comment] = ACTIONS(52),
  },
  [713] = {
    [sym_file_descriptor] = ACTIONS(220),
    [sym_variable_name] = ACTIONS(220),
    [anon_sym_for] = ACTIONS(222),
    [anon_sym_while] = ACTIONS(222),
    [anon_sym_if] = ACTIONS(222),
    [anon_sym_fi] = ACTIONS(222),
    [anon_sym_case] = ACTIONS(222),
    [anon_sym_function] = ACTIONS(222),
    [anon_sym_LPAREN] = ACTIONS(220),
    [anon_sym_LBRACK] = ACTIONS(222),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(222),
    [anon_sym_LT] = ACTIONS(222),
    [anon_sym_GT] = ACTIONS(222),
    [anon_sym_GT_GT] = ACTIONS(220),
    [anon_sym_AMP_GT] = ACTIONS(222),
    [anon_sym_AMP_GT_GT] = ACTIONS(220),
    [anon_sym_LT_AMP] = ACTIONS(220),
    [anon_sym_GT_AMP] = ACTIONS(220),
    [anon_sym_DQUOTE] = ACTIONS(220),
    [sym_raw_string] = ACTIONS(220),
    [anon_sym_DOLLAR] = ACTIONS(222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(220),
    [anon_sym_BQUOTE] = ACTIONS(220),
    [anon_sym_LT_LPAREN] = ACTIONS(220),
    [anon_sym_GT_LPAREN] = ACTIONS(220),
    [sym_word] = ACTIONS(224),
    [sym_comment] = ACTIONS(52),
  },
  [714] = {
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(2057),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_LF] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
  },
  [715] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(226),
    [anon_sym_SEMI_SEMI] = ACTIONS(2057),
    [anon_sym_PIPE_AMP] = ACTIONS(226),
    [anon_sym_AMP_AMP] = ACTIONS(230),
    [anon_sym_PIPE_PIPE] = ACTIONS(230),
    [anon_sym_LT] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(256),
    [anon_sym_AMP_GT] = ACTIONS(256),
    [anon_sym_AMP_GT_GT] = ACTIONS(256),
    [anon_sym_LT_AMP] = ACTIONS(256),
    [anon_sym_GT_AMP] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(256),
    [sym_raw_string] = ACTIONS(256),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(256),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(256),
    [anon_sym_BQUOTE] = ACTIONS(256),
    [anon_sym_LT_LPAREN] = ACTIONS(256),
    [anon_sym_GT_LPAREN] = ACTIONS(256),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_LF] = ACTIONS(2057),
    [anon_sym_AMP] = ACTIONS(2057),
  },
  [716] = {
    [sym__terminated_statement] = STATE(713),
    [sym_for_statement] = STATE(714),
    [sym_while_statement] = STATE(714),
    [sym_if_statement] = STATE(714),
    [sym_case_statement] = STATE(714),
    [sym_function_definition] = STATE(714),
    [sym_subshell] = STATE(714),
    [sym_pipeline] = STATE(714),
    [sym_list] = STATE(714),
    [sym_bracket_command] = STATE(714),
    [sym_command] = STATE(714),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(715),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(968),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2059),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [717] = {
    [sym_file_descriptor] = ACTIONS(574),
    [sym_variable_name] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_fi] = ACTIONS(576),
    [anon_sym_elif] = ACTIONS(576),
    [anon_sym_else] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(576),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_word] = ACTIONS(578),
    [sym_comment] = ACTIONS(52),
  },
  [718] = {
    [anon_sym_PIPE] = ACTIONS(2061),
    [anon_sym_RPAREN] = ACTIONS(2061),
    [anon_sym_SEMI_SEMI] = ACTIONS(2061),
    [anon_sym_PIPE_AMP] = ACTIONS(2061),
    [anon_sym_AMP_AMP] = ACTIONS(2061),
    [anon_sym_PIPE_PIPE] = ACTIONS(2061),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2061),
    [anon_sym_LF] = ACTIONS(2061),
    [anon_sym_AMP] = ACTIONS(2061),
  },
  [719] = {
    [anon_sym_fi] = ACTIONS(2063),
    [sym_comment] = ACTIONS(52),
  },
  [720] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(433),
    [sym_while_statement] = STATE(433),
    [sym_if_statement] = STATE(433),
    [sym_case_statement] = STATE(433),
    [sym_function_definition] = STATE(433),
    [sym_subshell] = STATE(433),
    [sym_pipeline] = STATE(433),
    [sym_list] = STATE(433),
    [sym_bracket_command] = STATE(433),
    [sym_command] = STATE(433),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(436),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(720),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(610),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_fi] = ACTIONS(2053),
    [anon_sym_elif] = ACTIONS(2053),
    [anon_sym_else] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(645),
    [anon_sym_LT_AMP] = ACTIONS(645),
    [anon_sym_GT_AMP] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(663),
    [anon_sym_LT_LPAREN] = ACTIONS(666),
    [anon_sym_GT_LPAREN] = ACTIONS(666),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(52),
  },
  [721] = {
    [sym_elif_clause] = STATE(434),
    [sym_else_clause] = STATE(970),
    [aux_sym_if_statement_repeat1] = STATE(722),
    [anon_sym_fi] = ACTIONS(2063),
    [anon_sym_elif] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1436),
    [sym_comment] = ACTIONS(52),
  },
  [722] = {
    [sym_elif_clause] = STATE(434),
    [aux_sym_if_statement_repeat1] = STATE(722),
    [anon_sym_fi] = ACTIONS(2065),
    [anon_sym_elif] = ACTIONS(2067),
    [anon_sym_else] = ACTIONS(2065),
    [sym_comment] = ACTIONS(52),
  },
  [723] = {
    [anon_sym_PIPE] = ACTIONS(2070),
    [anon_sym_RPAREN] = ACTIONS(2070),
    [anon_sym_SEMI_SEMI] = ACTIONS(2070),
    [anon_sym_PIPE_AMP] = ACTIONS(2070),
    [anon_sym_AMP_AMP] = ACTIONS(2070),
    [anon_sym_PIPE_PIPE] = ACTIONS(2070),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2070),
    [anon_sym_LF] = ACTIONS(2070),
    [anon_sym_AMP] = ACTIONS(2070),
  },
  [724] = {
    [aux_sym_case_item_repeat1] = STATE(973),
    [aux_sym_concatenation_repeat1] = STATE(974),
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [sym_comment] = ACTIONS(52),
  },
  [725] = {
    [anon_sym_esac] = ACTIONS(2076),
    [anon_sym_DQUOTE] = ACTIONS(2078),
    [sym_raw_string] = ACTIONS(2078),
    [anon_sym_DOLLAR] = ACTIONS(2076),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2078),
    [anon_sym_BQUOTE] = ACTIONS(2078),
    [anon_sym_LT_LPAREN] = ACTIONS(2078),
    [anon_sym_GT_LPAREN] = ACTIONS(2078),
    [sym_word] = ACTIONS(2080),
    [sym_comment] = ACTIONS(52),
  },
  [726] = {
    [aux_sym_case_item_repeat1] = STATE(973),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [sym_comment] = ACTIONS(52),
  },
  [727] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(976),
    [anon_sym_esac] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1442),
    [sym_comment] = ACTIONS(52),
  },
  [728] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(977),
    [anon_sym_esac] = ACTIONS(2082),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1442),
    [sym_comment] = ACTIONS(52),
  },
  [729] = {
    [sym__concat] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
    [anon_sym_SEMI_SEMI] = ACTIONS(1601),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_LF] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
  },
  [730] = {
    [anon_sym_AT] = ACTIONS(2084),
    [sym_comment] = ACTIONS(52),
  },
  [731] = {
    [sym__concat] = ACTIONS(1605),
    [anon_sym_in] = ACTIONS(1607),
    [anon_sym_SEMI_SEMI] = ACTIONS(1607),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_LF] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
  },
  [732] = {
    [anon_sym_AT] = ACTIONS(2086),
    [sym_comment] = ACTIONS(52),
  },
  [733] = {
    [anon_sym_RBRACK] = ACTIONS(2088),
    [sym_comment] = ACTIONS(52),
  },
  [734] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [sym_comment] = ACTIONS(52),
  },
  [735] = {
    [anon_sym_RBRACE] = ACTIONS(2090),
    [sym_comment] = ACTIONS(52),
  },
  [736] = {
    [anon_sym_RBRACK] = ACTIONS(2092),
    [sym_comment] = ACTIONS(52),
  },
  [737] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2094),
    [sym_comment] = ACTIONS(52),
  },
  [738] = {
    [anon_sym_RBRACE] = ACTIONS(2094),
    [sym_comment] = ACTIONS(52),
  },
  [739] = {
    [sym_file_redirect] = STATE(984),
    [sym_file_descriptor] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(2096),
    [anon_sym_SEMI_SEMI] = ACTIONS(2096),
    [anon_sym_PIPE_AMP] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2096),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(572),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym_LF] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2096),
  },
  [740] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(734),
    [sym_variable_name] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_PIPE_AMP] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(442),
    [anon_sym_AMP_GT] = ACTIONS(442),
    [anon_sym_AMP_GT_GT] = ACTIONS(442),
    [anon_sym_LT_AMP] = ACTIONS(442),
    [anon_sym_GT_AMP] = ACTIONS(442),
    [anon_sym_DQUOTE] = ACTIONS(442),
    [sym_raw_string] = ACTIONS(442),
    [anon_sym_DOLLAR] = ACTIONS(442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_LT_LPAREN] = ACTIONS(442),
    [anon_sym_GT_LPAREN] = ACTIONS(442),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [741] = {
    [sym_compound_statement] = STATE(986),
    [anon_sym_LBRACE] = ACTIONS(334),
    [sym_comment] = ACTIONS(52),
  },
  [742] = {
    [sym_file_redirect] = STATE(877),
    [sym_file_descriptor] = ACTIONS(816),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_SEMI_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE_AMP] = ACTIONS(1469),
    [anon_sym_AMP_AMP] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1469),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_AMP_GT] = ACTIONS(818),
    [anon_sym_AMP_GT_GT] = ACTIONS(818),
    [anon_sym_LT_AMP] = ACTIONS(818),
    [anon_sym_GT_AMP] = ACTIONS(818),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1469),
  },
  [743] = {
    [sym_concatenation] = STATE(879),
    [sym_string] = STATE(987),
    [sym_simple_expansion] = STATE(987),
    [sym_expansion] = STATE(987),
    [sym_command_substitution] = STATE(987),
    [sym_process_substitution] = STATE(987),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [sym_raw_string] = ACTIONS(2098),
    [anon_sym_DOLLAR] = ACTIONS(1210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [anon_sym_LT_LPAREN] = ACTIONS(1218),
    [anon_sym_GT_LPAREN] = ACTIONS(1218),
    [sym_word] = ACTIONS(2100),
    [sym_comment] = ACTIONS(52),
  },
  [744] = {
    [aux_sym_concatenation_repeat1] = STATE(988),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1234),
    [anon_sym_RPAREN] = ACTIONS(1234),
    [anon_sym_SEMI_SEMI] = ACTIONS(1234),
    [anon_sym_PIPE_AMP] = ACTIONS(1234),
    [anon_sym_AMP_AMP] = ACTIONS(1234),
    [anon_sym_PIPE_PIPE] = ACTIONS(1234),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1234),
    [anon_sym_LF] = ACTIONS(1234),
    [anon_sym_AMP] = ACTIONS(1234),
  },
  [745] = {
    [aux_sym_concatenation_repeat1] = STATE(746),
    [sym_file_descriptor] = ACTIONS(690),
    [sym__concat] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(1846),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [anon_sym_LT] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1846),
    [anon_sym_GT_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT] = ACTIONS(1846),
    [anon_sym_AMP_GT_GT] = ACTIONS(1846),
    [anon_sym_LT_AMP] = ACTIONS(1846),
    [anon_sym_GT_AMP] = ACTIONS(1846),
    [anon_sym_LT_LT] = ACTIONS(1846),
    [anon_sym_LT_LT_DASH] = ACTIONS(1846),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [746] = {
    [aux_sym_concatenation_repeat1] = STATE(989),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(1232),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_PIPE_AMP] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(442),
    [anon_sym_GT] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(442),
    [anon_sym_AMP_GT] = ACTIONS(442),
    [anon_sym_AMP_GT_GT] = ACTIONS(442),
    [anon_sym_LT_AMP] = ACTIONS(442),
    [anon_sym_GT_AMP] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(442),
    [anon_sym_LT_LT_DASH] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [747] = {
    [anon_sym_PIPE] = ACTIONS(2102),
    [anon_sym_RPAREN] = ACTIONS(2102),
    [anon_sym_SEMI_SEMI] = ACTIONS(2102),
    [anon_sym_PIPE_AMP] = ACTIONS(2102),
    [anon_sym_AMP_AMP] = ACTIONS(2102),
    [anon_sym_PIPE_PIPE] = ACTIONS(2102),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2102),
    [anon_sym_LF] = ACTIONS(2102),
    [anon_sym_AMP] = ACTIONS(2102),
  },
  [748] = {
    [sym_file_redirect] = STATE(144),
    [sym_heredoc_redirect] = STATE(144),
    [aux_sym_command_repeat2] = STATE(470),
    [sym_file_descriptor] = ACTIONS(350),
    [anon_sym_PIPE] = ACTIONS(1898),
    [anon_sym_RPAREN] = ACTIONS(1898),
    [anon_sym_SEMI_SEMI] = ACTIONS(1898),
    [anon_sym_PIPE_AMP] = ACTIONS(1898),
    [anon_sym_AMP_AMP] = ACTIONS(1898),
    [anon_sym_PIPE_PIPE] = ACTIONS(1898),
    [anon_sym_LT] = ACTIONS(352),
    [anon_sym_GT] = ACTIONS(352),
    [anon_sym_GT_GT] = ACTIONS(352),
    [anon_sym_AMP_GT] = ACTIONS(352),
    [anon_sym_AMP_GT_GT] = ACTIONS(352),
    [anon_sym_LT_AMP] = ACTIONS(352),
    [anon_sym_GT_AMP] = ACTIONS(352),
    [anon_sym_LT_LT] = ACTIONS(238),
    [anon_sym_LT_LT_DASH] = ACTIONS(238),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_LF] = ACTIONS(1898),
    [anon_sym_AMP] = ACTIONS(1898),
  },
  [749] = {
    [sym__concat] = ACTIONS(1599),
    [anon_sym_RBRACE] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_raw_string] = ACTIONS(1599),
    [anon_sym_DOLLAR] = ACTIONS(2104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1599),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_LT_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_LPAREN] = ACTIONS(1599),
    [sym_word] = ACTIONS(1601),
    [sym_comment] = ACTIONS(52),
  },
  [750] = {
    [anon_sym_AT] = ACTIONS(2106),
    [sym_comment] = ACTIONS(52),
  },
  [751] = {
    [sym__concat] = ACTIONS(1605),
    [anon_sym_RBRACE] = ACTIONS(1605),
    [anon_sym_RBRACK] = ACTIONS(2108),
    [anon_sym_DQUOTE] = ACTIONS(1605),
    [sym_raw_string] = ACTIONS(1605),
    [anon_sym_DOLLAR] = ACTIONS(2108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [anon_sym_LT_LPAREN] = ACTIONS(1605),
    [anon_sym_GT_LPAREN] = ACTIONS(1605),
    [sym_word] = ACTIONS(1607),
    [sym_comment] = ACTIONS(52),
  },
  [752] = {
    [anon_sym_AT] = ACTIONS(2110),
    [sym_comment] = ACTIONS(52),
  },
  [753] = {
    [anon_sym_RBRACK] = ACTIONS(2112),
    [sym_comment] = ACTIONS(52),
  },
  [754] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2114),
    [sym_comment] = ACTIONS(52),
  },
  [755] = {
    [anon_sym_RBRACE] = ACTIONS(2114),
    [sym_comment] = ACTIONS(52),
  },
  [756] = {
    [anon_sym_RBRACK] = ACTIONS(2116),
    [sym_comment] = ACTIONS(52),
  },
  [757] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2118),
    [sym_comment] = ACTIONS(52),
  },
  [758] = {
    [anon_sym_RBRACE] = ACTIONS(2118),
    [sym_comment] = ACTIONS(52),
  },
  [759] = {
    [sym__concat] = ACTIONS(1599),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2104),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_raw_string] = ACTIONS(1599),
    [anon_sym_DOLLAR] = ACTIONS(2104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1599),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_LT_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_LPAREN] = ACTIONS(1599),
    [sym_word] = ACTIONS(1601),
    [sym_comment] = ACTIONS(52),
  },
  [760] = {
    [anon_sym_AT] = ACTIONS(2120),
    [sym_comment] = ACTIONS(52),
  },
  [761] = {
    [sym__concat] = ACTIONS(1605),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2108),
    [anon_sym_DQUOTE] = ACTIONS(1605),
    [sym_raw_string] = ACTIONS(1605),
    [anon_sym_DOLLAR] = ACTIONS(2108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [anon_sym_LT_LPAREN] = ACTIONS(1605),
    [anon_sym_GT_LPAREN] = ACTIONS(1605),
    [sym_word] = ACTIONS(1607),
    [sym_comment] = ACTIONS(52),
  },
  [762] = {
    [anon_sym_AT] = ACTIONS(2122),
    [sym_comment] = ACTIONS(52),
  },
  [763] = {
    [anon_sym_RBRACK] = ACTIONS(2124),
    [sym_comment] = ACTIONS(52),
  },
  [764] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(52),
  },
  [765] = {
    [anon_sym_RBRACE] = ACTIONS(2126),
    [sym_comment] = ACTIONS(52),
  },
  [766] = {
    [anon_sym_RBRACK] = ACTIONS(2128),
    [sym_comment] = ACTIONS(52),
  },
  [767] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [sym_comment] = ACTIONS(52),
  },
  [768] = {
    [anon_sym_RBRACE] = ACTIONS(2130),
    [sym_comment] = ACTIONS(52),
  },
  [769] = {
    [sym_file_descriptor] = ACTIONS(1599),
    [sym__concat] = ACTIONS(1599),
    [sym_variable_name] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(2104),
    [anon_sym_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_GT] = ACTIONS(2104),
    [anon_sym_AMP_GT_GT] = ACTIONS(1599),
    [anon_sym_LT_AMP] = ACTIONS(1599),
    [anon_sym_GT_AMP] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_raw_string] = ACTIONS(1599),
    [anon_sym_DOLLAR] = ACTIONS(2104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1599),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_LT_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_LPAREN] = ACTIONS(1599),
    [sym_word] = ACTIONS(2104),
    [sym_comment] = ACTIONS(52),
  },
  [770] = {
    [anon_sym_AT] = ACTIONS(2132),
    [sym_comment] = ACTIONS(52),
  },
  [771] = {
    [sym_file_descriptor] = ACTIONS(1605),
    [sym__concat] = ACTIONS(1605),
    [sym_variable_name] = ACTIONS(1605),
    [anon_sym_LT] = ACTIONS(2108),
    [anon_sym_GT] = ACTIONS(2108),
    [anon_sym_GT_GT] = ACTIONS(1605),
    [anon_sym_AMP_GT] = ACTIONS(2108),
    [anon_sym_AMP_GT_GT] = ACTIONS(1605),
    [anon_sym_LT_AMP] = ACTIONS(1605),
    [anon_sym_GT_AMP] = ACTIONS(1605),
    [anon_sym_DQUOTE] = ACTIONS(1605),
    [sym_raw_string] = ACTIONS(1605),
    [anon_sym_DOLLAR] = ACTIONS(2108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [anon_sym_LT_LPAREN] = ACTIONS(1605),
    [anon_sym_GT_LPAREN] = ACTIONS(1605),
    [sym_word] = ACTIONS(2108),
    [sym_comment] = ACTIONS(52),
  },
  [772] = {
    [anon_sym_AT] = ACTIONS(2134),
    [sym_comment] = ACTIONS(52),
  },
  [773] = {
    [anon_sym_RBRACK] = ACTIONS(2136),
    [sym_comment] = ACTIONS(52),
  },
  [774] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2138),
    [sym_comment] = ACTIONS(52),
  },
  [775] = {
    [anon_sym_RBRACE] = ACTIONS(2138),
    [sym_comment] = ACTIONS(52),
  },
  [776] = {
    [anon_sym_RBRACK] = ACTIONS(2140),
    [sym_comment] = ACTIONS(52),
  },
  [777] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2142),
    [sym_comment] = ACTIONS(52),
  },
  [778] = {
    [anon_sym_RBRACE] = ACTIONS(2142),
    [sym_comment] = ACTIONS(52),
  },
  [779] = {
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2104),
    [anon_sym_DOLLAR] = ACTIONS(1601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(150),
  },
  [780] = {
    [anon_sym_AT] = ACTIONS(2144),
    [sym_comment] = ACTIONS(52),
  },
  [781] = {
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2108),
    [anon_sym_DOLLAR] = ACTIONS(1607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1607),
    [anon_sym_BQUOTE] = ACTIONS(1607),
    [sym_comment] = ACTIONS(150),
  },
  [782] = {
    [anon_sym_AT] = ACTIONS(2146),
    [sym_comment] = ACTIONS(52),
  },
  [783] = {
    [anon_sym_RBRACK] = ACTIONS(2148),
    [sym_comment] = ACTIONS(52),
  },
  [784] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2150),
    [sym_comment] = ACTIONS(52),
  },
  [785] = {
    [anon_sym_RBRACE] = ACTIONS(2150),
    [sym_comment] = ACTIONS(52),
  },
  [786] = {
    [anon_sym_RBRACK] = ACTIONS(2152),
    [sym_comment] = ACTIONS(52),
  },
  [787] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2154),
    [sym_comment] = ACTIONS(52),
  },
  [788] = {
    [anon_sym_RBRACE] = ACTIONS(2154),
    [sym_comment] = ACTIONS(52),
  },
  [789] = {
    [anon_sym_RBRACK] = ACTIONS(2156),
    [sym_comment] = ACTIONS(52),
  },
  [790] = {
    [anon_sym_RBRACK] = ACTIONS(2158),
    [sym_comment] = ACTIONS(52),
  },
  [791] = {
    [anon_sym_RBRACE] = ACTIONS(2160),
    [sym_comment] = ACTIONS(52),
  },
  [792] = {
    [sym_file_descriptor] = ACTIONS(2162),
    [sym__concat] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2164),
    [anon_sym_RPAREN] = ACTIONS(2164),
    [anon_sym_SEMI_SEMI] = ACTIONS(2164),
    [anon_sym_PIPE_AMP] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_PIPE_PIPE] = ACTIONS(2164),
    [anon_sym_LT] = ACTIONS(2164),
    [anon_sym_GT] = ACTIONS(2164),
    [anon_sym_GT_GT] = ACTIONS(2164),
    [anon_sym_AMP_GT] = ACTIONS(2164),
    [anon_sym_AMP_GT_GT] = ACTIONS(2164),
    [anon_sym_LT_AMP] = ACTIONS(2164),
    [anon_sym_GT_AMP] = ACTIONS(2164),
    [anon_sym_LT_LT] = ACTIONS(2164),
    [anon_sym_LT_LT_DASH] = ACTIONS(2164),
    [anon_sym_DQUOTE] = ACTIONS(2164),
    [sym_raw_string] = ACTIONS(2164),
    [anon_sym_DOLLAR] = ACTIONS(2164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2164),
    [anon_sym_BQUOTE] = ACTIONS(2164),
    [anon_sym_LT_LPAREN] = ACTIONS(2164),
    [anon_sym_GT_LPAREN] = ACTIONS(2164),
    [sym_word] = ACTIONS(2164),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym_LF] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2164),
  },
  [793] = {
    [aux_sym_concatenation_repeat1] = STATE(1017),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(440),
    [sym_comment] = ACTIONS(52),
  },
  [794] = {
    [anon_sym_RBRACE] = ACTIONS(2166),
    [sym_comment] = ACTIONS(52),
  },
  [795] = {
    [sym_file_descriptor] = ACTIONS(2168),
    [sym__concat] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_SEMI_SEMI] = ACTIONS(2170),
    [anon_sym_PIPE_AMP] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2170),
    [anon_sym_GT_GT] = ACTIONS(2170),
    [anon_sym_AMP_GT] = ACTIONS(2170),
    [anon_sym_AMP_GT_GT] = ACTIONS(2170),
    [anon_sym_LT_AMP] = ACTIONS(2170),
    [anon_sym_GT_AMP] = ACTIONS(2170),
    [anon_sym_LT_LT] = ACTIONS(2170),
    [anon_sym_LT_LT_DASH] = ACTIONS(2170),
    [anon_sym_DQUOTE] = ACTIONS(2170),
    [sym_raw_string] = ACTIONS(2170),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2170),
    [anon_sym_BQUOTE] = ACTIONS(2170),
    [anon_sym_LT_LPAREN] = ACTIONS(2170),
    [anon_sym_GT_LPAREN] = ACTIONS(2170),
    [sym_word] = ACTIONS(2170),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_LF] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
  },
  [796] = {
    [sym_file_descriptor] = ACTIONS(1338),
    [sym_variable_name] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_RPAREN] = ACTIONS(1338),
    [anon_sym_PIPE_AMP] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1338),
    [anon_sym_PIPE_PIPE] = ACTIONS(2172),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_GT_GT] = ACTIONS(1338),
    [anon_sym_AMP_GT] = ACTIONS(2172),
    [anon_sym_AMP_GT_GT] = ACTIONS(1338),
    [anon_sym_LT_AMP] = ACTIONS(1338),
    [anon_sym_GT_AMP] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(1338),
    [sym_raw_string] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1338),
    [anon_sym_BQUOTE] = ACTIONS(1338),
    [anon_sym_LT_LPAREN] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(1338),
    [sym_word] = ACTIONS(1340),
    [sym_comment] = ACTIONS(52),
  },
  [797] = {
    [sym_concatenation] = STATE(397),
    [sym_string] = STATE(391),
    [sym_simple_expansion] = STATE(391),
    [sym_expansion] = STATE(391),
    [sym_command_substitution] = STATE(391),
    [sym_process_substitution] = STATE(391),
    [aux_sym_for_statement_repeat1] = STATE(677),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_DQUOTE] = ACTIONS(716),
    [sym_raw_string] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_word] = ACTIONS(730),
    [sym_comment] = ACTIONS(52),
  },
  [798] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [sym_variable_name] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(836),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(836),
    [anon_sym_GT] = ACTIONS(836),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_AMP_GT] = ACTIONS(836),
    [anon_sym_AMP_GT_GT] = ACTIONS(416),
    [anon_sym_LT_AMP] = ACTIONS(416),
    [anon_sym_GT_AMP] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym_raw_string] = ACTIONS(416),
    [anon_sym_DOLLAR] = ACTIONS(836),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(416),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [anon_sym_LT_LPAREN] = ACTIONS(416),
    [anon_sym_GT_LPAREN] = ACTIONS(416),
    [sym_word] = ACTIONS(418),
    [sym_comment] = ACTIONS(52),
  },
  [799] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(2176),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [800] = {
    [sym_string] = STATE(1021),
    [sym_simple_expansion] = STATE(1021),
    [sym_expansion] = STATE(1021),
    [sym_command_substitution] = STATE(1021),
    [sym_process_substitution] = STATE(1021),
    [anon_sym_DQUOTE] = ACTIONS(1060),
    [sym_raw_string] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(1064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1068),
    [anon_sym_BQUOTE] = ACTIONS(1070),
    [anon_sym_LT_LPAREN] = ACTIONS(1072),
    [anon_sym_GT_LPAREN] = ACTIONS(1072),
    [sym_word] = ACTIONS(2180),
    [sym_comment] = ACTIONS(52),
  },
  [801] = {
    [aux_sym_concatenation_repeat1] = STATE(1022),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(1625),
    [sym_variable_name] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_PIPE_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_PIPE_PIPE] = ACTIONS(844),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_AMP_GT] = ACTIONS(844),
    [anon_sym_AMP_GT_GT] = ACTIONS(440),
    [anon_sym_LT_AMP] = ACTIONS(440),
    [anon_sym_GT_AMP] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [sym_raw_string] = ACTIONS(440),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [anon_sym_LT_LPAREN] = ACTIONS(440),
    [anon_sym_GT_LPAREN] = ACTIONS(440),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(52),
  },
  [802] = {
    [sym_file_descriptor] = ACTIONS(444),
    [sym__concat] = ACTIONS(444),
    [sym_variable_name] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(456),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_PIPE_AMP] = ACTIONS(444),
    [anon_sym_AMP_AMP] = ACTIONS(444),
    [anon_sym_PIPE_PIPE] = ACTIONS(456),
    [anon_sym_LT] = ACTIONS(456),
    [anon_sym_GT] = ACTIONS(456),
    [anon_sym_GT_GT] = ACTIONS(444),
    [anon_sym_AMP_GT] = ACTIONS(456),
    [anon_sym_AMP_GT_GT] = ACTIONS(444),
    [anon_sym_LT_AMP] = ACTIONS(444),
    [anon_sym_GT_AMP] = ACTIONS(444),
    [anon_sym_DQUOTE] = ACTIONS(444),
    [sym_raw_string] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(444),
    [anon_sym_BQUOTE] = ACTIONS(444),
    [anon_sym_LT_LPAREN] = ACTIONS(444),
    [anon_sym_GT_LPAREN] = ACTIONS(444),
    [sym_word] = ACTIONS(446),
    [sym_comment] = ACTIONS(52),
  },
  [803] = {
    [sym_file_descriptor] = ACTIONS(448),
    [sym__concat] = ACTIONS(448),
    [sym_variable_name] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(846),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_PIPE_AMP] = ACTIONS(448),
    [anon_sym_AMP_AMP] = ACTIONS(448),
    [anon_sym_PIPE_PIPE] = ACTIONS(846),
    [anon_sym_LT] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(846),
    [anon_sym_GT_GT] = ACTIONS(448),
    [anon_sym_AMP_GT] = ACTIONS(846),
    [anon_sym_AMP_GT_GT] = ACTIONS(448),
    [anon_sym_LT_AMP] = ACTIONS(448),
    [anon_sym_GT_AMP] = ACTIONS(448),
    [anon_sym_DQUOTE] = ACTIONS(448),
    [sym_raw_string] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(448),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(448),
    [anon_sym_BQUOTE] = ACTIONS(448),
    [anon_sym_LT_LPAREN] = ACTIONS(448),
    [anon_sym_GT_LPAREN] = ACTIONS(448),
    [sym_word] = ACTIONS(450),
    [sym_comment] = ACTIONS(52),
  },
  [804] = {
    [sym_file_descriptor] = ACTIONS(452),
    [sym__concat] = ACTIONS(452),
    [sym_variable_name] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_PIPE_AMP] = ACTIONS(452),
    [anon_sym_AMP_AMP] = ACTIONS(452),
    [anon_sym_PIPE_PIPE] = ACTIONS(848),
    [anon_sym_LT] = ACTIONS(848),
    [anon_sym_GT] = ACTIONS(848),
    [anon_sym_GT_GT] = ACTIONS(452),
    [anon_sym_AMP_GT] = ACTIONS(848),
    [anon_sym_AMP_GT_GT] = ACTIONS(452),
    [anon_sym_LT_AMP] = ACTIONS(452),
    [anon_sym_GT_AMP] = ACTIONS(452),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(452),
    [anon_sym_DOLLAR] = ACTIONS(848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(452),
    [anon_sym_BQUOTE] = ACTIONS(452),
    [anon_sym_LT_LPAREN] = ACTIONS(452),
    [anon_sym_GT_LPAREN] = ACTIONS(452),
    [sym_word] = ACTIONS(454),
    [sym_comment] = ACTIONS(52),
  },
  [805] = {
    [sym_special_variable_name] = STATE(1024),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [806] = {
    [anon_sym_RBRACE] = ACTIONS(2184),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2188),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_COLON_QMARK] = ACTIONS(2188),
    [anon_sym_COLON_DASH] = ACTIONS(2188),
    [anon_sym_PERCENT] = ACTIONS(2188),
    [anon_sym_SLASH] = ACTIONS(2188),
    [sym_comment] = ACTIONS(52),
  },
  [807] = {
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2196),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_COLON_QMARK] = ACTIONS(2196),
    [anon_sym_COLON_DASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [sym_comment] = ACTIONS(52),
  },
  [808] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [809] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [810] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(2200),
    [sym_comment] = ACTIONS(52),
  },
  [811] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(2200),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [812] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2202),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [813] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2202),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [814] = {
    [sym_concatenation] = STATE(422),
    [sym_string] = STATE(416),
    [sym_simple_expansion] = STATE(416),
    [sym_expansion] = STATE(416),
    [sym_command_substitution] = STATE(416),
    [sym_process_substitution] = STATE(416),
    [aux_sym_for_statement_repeat1] = STATE(708),
    [anon_sym_SEMI_SEMI] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(1402),
    [sym_raw_string] = ACTIONS(1404),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1410),
    [anon_sym_BQUOTE] = ACTIONS(1412),
    [anon_sym_LT_LPAREN] = ACTIONS(1414),
    [anon_sym_GT_LPAREN] = ACTIONS(1414),
    [sym_word] = ACTIONS(1404),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2204),
    [anon_sym_LF] = ACTIONS(2204),
    [anon_sym_AMP] = ACTIONS(2204),
  },
  [815] = {
    [anon_sym_PIPE] = ACTIONS(2206),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_PIPE_AMP] = ACTIONS(2208),
    [anon_sym_AMP_AMP] = ACTIONS(2208),
    [anon_sym_PIPE_PIPE] = ACTIONS(2208),
    [anon_sym_BQUOTE] = ACTIONS(2208),
    [sym_comment] = ACTIONS(52),
  },
  [816] = {
    [sym__terminated_statement] = STATE(425),
    [sym_for_statement] = STATE(426),
    [sym_while_statement] = STATE(426),
    [sym_if_statement] = STATE(426),
    [sym_case_statement] = STATE(426),
    [sym_function_definition] = STATE(426),
    [sym_subshell] = STATE(426),
    [sym_pipeline] = STATE(426),
    [sym_list] = STATE(426),
    [sym_bracket_command] = STATE(426),
    [sym_command] = STATE(426),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(427),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(711),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_done] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [817] = {
    [anon_sym_PIPE] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_PIPE_AMP] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_BQUOTE] = ACTIONS(2214),
    [sym_comment] = ACTIONS(52),
  },
  [818] = {
    [anon_sym_fi] = ACTIONS(2216),
    [sym_comment] = ACTIONS(52),
  },
  [819] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(433),
    [sym_while_statement] = STATE(433),
    [sym_if_statement] = STATE(433),
    [sym_elif_clause] = STATE(434),
    [sym_else_clause] = STATE(1036),
    [sym_case_statement] = STATE(433),
    [sym_function_definition] = STATE(433),
    [sym_subshell] = STATE(433),
    [sym_pipeline] = STATE(433),
    [sym_list] = STATE(433),
    [sym_bracket_command] = STATE(433),
    [sym_command] = STATE(433),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(436),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(720),
    [aux_sym_if_statement_repeat1] = STATE(1037),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2218),
    [anon_sym_elif] = ACTIONS(768),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [820] = {
    [sym_elif_clause] = STATE(434),
    [sym_else_clause] = STATE(1036),
    [aux_sym_if_statement_repeat1] = STATE(722),
    [anon_sym_fi] = ACTIONS(2216),
    [anon_sym_elif] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1436),
    [sym_comment] = ACTIONS(52),
  },
  [821] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(1039),
    [anon_sym_esac] = ACTIONS(2220),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1442),
    [sym_comment] = ACTIONS(52),
  },
  [822] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2222),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_LF] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
  },
  [823] = {
    [sym_compound_statement] = STATE(1041),
    [anon_sym_LBRACE] = ACTIONS(504),
    [sym_comment] = ACTIONS(52),
  },
  [824] = {
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_comment] = ACTIONS(52),
  },
  [825] = {
    [anon_sym_PIPE] = ACTIONS(2228),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_PIPE_AMP] = ACTIONS(2230),
    [anon_sym_AMP_AMP] = ACTIONS(2230),
    [anon_sym_PIPE_PIPE] = ACTIONS(2230),
    [anon_sym_BQUOTE] = ACTIONS(2230),
    [sym_comment] = ACTIONS(52),
  },
  [826] = {
    [sym_file_descriptor] = ACTIONS(574),
    [sym_variable_name] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(2232),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(576),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_word] = ACTIONS(578),
    [sym_comment] = ACTIONS(52),
  },
  [827] = {
    [sym_file_descriptor] = ACTIONS(1599),
    [sym__concat] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(2104),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_PIPE_AMP] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(2104),
    [anon_sym_LT] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(2104),
    [anon_sym_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_GT] = ACTIONS(2104),
    [anon_sym_AMP_GT_GT] = ACTIONS(1599),
    [anon_sym_LT_AMP] = ACTIONS(1599),
    [anon_sym_GT_AMP] = ACTIONS(1599),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_raw_string] = ACTIONS(1599),
    [anon_sym_DOLLAR] = ACTIONS(2104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1599),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_LT_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_LPAREN] = ACTIONS(1599),
    [sym_word] = ACTIONS(1601),
    [sym_comment] = ACTIONS(52),
  },
  [828] = {
    [anon_sym_AT] = ACTIONS(2234),
    [sym_comment] = ACTIONS(52),
  },
  [829] = {
    [sym_file_descriptor] = ACTIONS(1605),
    [sym__concat] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(2108),
    [anon_sym_RPAREN] = ACTIONS(1605),
    [anon_sym_PIPE_AMP] = ACTIONS(1605),
    [anon_sym_AMP_AMP] = ACTIONS(1605),
    [anon_sym_PIPE_PIPE] = ACTIONS(2108),
    [anon_sym_LT] = ACTIONS(2108),
    [anon_sym_GT] = ACTIONS(2108),
    [anon_sym_GT_GT] = ACTIONS(1605),
    [anon_sym_AMP_GT] = ACTIONS(2108),
    [anon_sym_AMP_GT_GT] = ACTIONS(1605),
    [anon_sym_LT_AMP] = ACTIONS(1605),
    [anon_sym_GT_AMP] = ACTIONS(1605),
    [anon_sym_LT_LT] = ACTIONS(2108),
    [anon_sym_LT_LT_DASH] = ACTIONS(1605),
    [anon_sym_DQUOTE] = ACTIONS(1605),
    [sym_raw_string] = ACTIONS(1605),
    [anon_sym_DOLLAR] = ACTIONS(2108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [anon_sym_LT_LPAREN] = ACTIONS(1605),
    [anon_sym_GT_LPAREN] = ACTIONS(1605),
    [sym_word] = ACTIONS(1607),
    [sym_comment] = ACTIONS(52),
  },
  [830] = {
    [anon_sym_AT] = ACTIONS(2236),
    [sym_comment] = ACTIONS(52),
  },
  [831] = {
    [anon_sym_RBRACK] = ACTIONS(2238),
    [sym_comment] = ACTIONS(52),
  },
  [832] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(52),
  },
  [833] = {
    [anon_sym_RBRACE] = ACTIONS(2240),
    [sym_comment] = ACTIONS(52),
  },
  [834] = {
    [anon_sym_RBRACK] = ACTIONS(2242),
    [sym_comment] = ACTIONS(52),
  },
  [835] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2244),
    [sym_comment] = ACTIONS(52),
  },
  [836] = {
    [anon_sym_RBRACE] = ACTIONS(2244),
    [sym_comment] = ACTIONS(52),
  },
  [837] = {
    [sym_file_redirect] = STATE(1049),
    [sym_file_descriptor] = ACTIONS(1126),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(1132),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_GT_GT] = ACTIONS(1134),
    [anon_sym_AMP_GT] = ACTIONS(1132),
    [anon_sym_AMP_GT_GT] = ACTIONS(1134),
    [anon_sym_LT_AMP] = ACTIONS(1134),
    [anon_sym_GT_AMP] = ACTIONS(1134),
    [sym_comment] = ACTIONS(52),
  },
  [838] = {
    [sym_file_descriptor] = ACTIONS(1824),
    [anon_sym_PIPE] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(1824),
    [anon_sym_PIPE_AMP] = ACTIONS(1824),
    [anon_sym_AMP_AMP] = ACTIONS(1824),
    [anon_sym_PIPE_PIPE] = ACTIONS(1824),
    [anon_sym_LT] = ACTIONS(2246),
    [anon_sym_GT] = ACTIONS(2246),
    [anon_sym_GT_GT] = ACTIONS(1824),
    [anon_sym_AMP_GT] = ACTIONS(2246),
    [anon_sym_AMP_GT_GT] = ACTIONS(1824),
    [anon_sym_LT_AMP] = ACTIONS(1824),
    [anon_sym_GT_AMP] = ACTIONS(1824),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [sym_comment] = ACTIONS(52),
  },
  [839] = {
    [sym_concatenation] = STATE(1051),
    [sym_string] = STATE(1050),
    [sym_simple_expansion] = STATE(1050),
    [sym_expansion] = STATE(1050),
    [sym_command_substitution] = STATE(1050),
    [sym_process_substitution] = STATE(1050),
    [anon_sym_DQUOTE] = ACTIONS(1700),
    [sym_raw_string] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1706),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [anon_sym_LT_LPAREN] = ACTIONS(1712),
    [anon_sym_GT_LPAREN] = ACTIONS(1712),
    [sym_word] = ACTIONS(2250),
    [sym_comment] = ACTIONS(52),
  },
  [840] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(1053),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [841] = {
    [aux_sym_concatenation_repeat1] = STATE(1055),
    [sym__concat] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(404),
    [anon_sym_RPAREN] = ACTIONS(400),
    [anon_sym_PIPE_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(400),
    [anon_sym_PIPE_PIPE] = ACTIONS(400),
    [sym_comment] = ACTIONS(52),
  },
  [842] = {
    [sym_special_variable_name] = STATE(1058),
    [anon_sym_DOLLAR] = ACTIONS(2256),
    [anon_sym_POUND] = ACTIONS(2256),
    [anon_sym_AT] = ACTIONS(2256),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_QMARK] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_0] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2260),
  },
  [843] = {
    [sym_special_variable_name] = STATE(1061),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(2262),
    [anon_sym_AT] = ACTIONS(164),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [844] = {
    [sym_for_statement] = STATE(1062),
    [sym_while_statement] = STATE(1062),
    [sym_if_statement] = STATE(1062),
    [sym_case_statement] = STATE(1062),
    [sym_function_definition] = STATE(1062),
    [sym_subshell] = STATE(1062),
    [sym_pipeline] = STATE(1062),
    [sym_list] = STATE(1062),
    [sym_bracket_command] = STATE(1062),
    [sym_command] = STATE(1062),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(1063),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [845] = {
    [sym_for_statement] = STATE(1064),
    [sym_while_statement] = STATE(1064),
    [sym_if_statement] = STATE(1064),
    [sym_case_statement] = STATE(1064),
    [sym_function_definition] = STATE(1064),
    [sym_subshell] = STATE(1064),
    [sym_pipeline] = STATE(1064),
    [sym_list] = STATE(1064),
    [sym_bracket_command] = STATE(1064),
    [sym_command] = STATE(1064),
    [sym_command_name] = STATE(128),
    [sym_environment_variable_assignment] = STATE(1065),
    [sym_subscript] = STATE(130),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(125),
    [sym_simple_expansion] = STATE(125),
    [sym_expansion] = STATE(125),
    [sym_command_substitution] = STATE(125),
    [sym_process_substitution] = STATE(125),
    [aux_sym_command_repeat1] = STATE(131),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(206),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(210),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(212),
    [sym_comment] = ACTIONS(52),
  },
  [846] = {
    [sym_for_statement] = STATE(1066),
    [sym_while_statement] = STATE(1066),
    [sym_if_statement] = STATE(1066),
    [sym_case_statement] = STATE(1066),
    [sym_function_definition] = STATE(1066),
    [sym_subshell] = STATE(1066),
    [sym_pipeline] = STATE(1066),
    [sym_list] = STATE(1066),
    [sym_bracket_command] = STATE(1066),
    [sym_command] = STATE(1066),
    [sym_command_name] = STATE(118),
    [sym_environment_variable_assignment] = STATE(1067),
    [sym_subscript] = STATE(120),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(121),
    [sym_string] = STATE(110),
    [sym_simple_expansion] = STATE(110),
    [sym_expansion] = STATE(110),
    [sym_command_substitution] = STATE(110),
    [sym_process_substitution] = STATE(110),
    [aux_sym_command_repeat1] = STATE(122),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(172),
    [anon_sym_for] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(176),
    [anon_sym_if] = ACTIONS(178),
    [anon_sym_case] = ACTIONS(180),
    [anon_sym_function] = ACTIONS(182),
    [anon_sym_LPAREN] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(186),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(188),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(190),
    [sym_raw_string] = ACTIONS(192),
    [anon_sym_DOLLAR] = ACTIONS(194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(196),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(198),
    [anon_sym_BQUOTE] = ACTIONS(200),
    [anon_sym_LT_LPAREN] = ACTIONS(202),
    [anon_sym_GT_LPAREN] = ACTIONS(202),
    [sym_word] = ACTIONS(204),
    [sym_comment] = ACTIONS(52),
  },
  [847] = {
    [anon_sym_PIPE] = ACTIONS(404),
    [anon_sym_RPAREN] = ACTIONS(400),
    [anon_sym_PIPE_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(400),
    [anon_sym_PIPE_PIPE] = ACTIONS(400),
    [anon_sym_BQUOTE] = ACTIONS(400),
    [sym_comment] = ACTIONS(52),
  },
  [848] = {
    [aux_sym_concatenation_repeat1] = STATE(853),
    [sym_file_descriptor] = ACTIONS(690),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(692),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(692),
    [anon_sym_LT_LT_DASH] = ACTIONS(690),
    [sym_comment] = ACTIONS(52),
  },
  [849] = {
    [sym_file_descriptor] = ACTIONS(690),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(692),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(692),
    [anon_sym_LT_LT_DASH] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_comment] = ACTIONS(52),
  },
  [850] = {
    [sym_file_descriptor] = ACTIONS(416),
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(836),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(416),
    [anon_sym_LT] = ACTIONS(836),
    [anon_sym_GT] = ACTIONS(836),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_AMP_GT] = ACTIONS(836),
    [anon_sym_AMP_GT_GT] = ACTIONS(416),
    [anon_sym_LT_AMP] = ACTIONS(416),
    [anon_sym_GT_AMP] = ACTIONS(416),
    [anon_sym_LT_LT] = ACTIONS(836),
    [anon_sym_LT_LT_DASH] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [sym_comment] = ACTIONS(52),
  },
  [851] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [852] = {
    [sym_string] = STATE(1069),
    [sym_simple_expansion] = STATE(1069),
    [sym_expansion] = STATE(1069),
    [sym_command_substitution] = STATE(1069),
    [sym_process_substitution] = STATE(1069),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [sym_raw_string] = ACTIONS(2268),
    [anon_sym_DOLLAR] = ACTIONS(1148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1152),
    [anon_sym_BQUOTE] = ACTIONS(1154),
    [anon_sym_LT_LPAREN] = ACTIONS(1156),
    [anon_sym_GT_LPAREN] = ACTIONS(1156),
    [sym_word] = ACTIONS(2270),
    [sym_comment] = ACTIONS(52),
  },
  [853] = {
    [aux_sym_concatenation_repeat1] = STATE(1070),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_PIPE_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_PIPE_PIPE] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_AMP_GT] = ACTIONS(844),
    [anon_sym_AMP_GT_GT] = ACTIONS(440),
    [anon_sym_LT_AMP] = ACTIONS(440),
    [anon_sym_GT_AMP] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(844),
    [anon_sym_LT_LT_DASH] = ACTIONS(440),
    [sym_comment] = ACTIONS(52),
  },
  [854] = {
    [sym_file_descriptor] = ACTIONS(444),
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(456),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_PIPE_AMP] = ACTIONS(444),
    [anon_sym_AMP_AMP] = ACTIONS(444),
    [anon_sym_PIPE_PIPE] = ACTIONS(444),
    [anon_sym_LT] = ACTIONS(456),
    [anon_sym_GT] = ACTIONS(456),
    [anon_sym_GT_GT] = ACTIONS(444),
    [anon_sym_AMP_GT] = ACTIONS(456),
    [anon_sym_AMP_GT_GT] = ACTIONS(444),
    [anon_sym_LT_AMP] = ACTIONS(444),
    [anon_sym_GT_AMP] = ACTIONS(444),
    [anon_sym_LT_LT] = ACTIONS(456),
    [anon_sym_LT_LT_DASH] = ACTIONS(444),
    [anon_sym_BQUOTE] = ACTIONS(444),
    [sym_comment] = ACTIONS(52),
  },
  [855] = {
    [sym_file_descriptor] = ACTIONS(448),
    [sym__concat] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(846),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_PIPE_AMP] = ACTIONS(448),
    [anon_sym_AMP_AMP] = ACTIONS(448),
    [anon_sym_PIPE_PIPE] = ACTIONS(448),
    [anon_sym_LT] = ACTIONS(846),
    [anon_sym_GT] = ACTIONS(846),
    [anon_sym_GT_GT] = ACTIONS(448),
    [anon_sym_AMP_GT] = ACTIONS(846),
    [anon_sym_AMP_GT_GT] = ACTIONS(448),
    [anon_sym_LT_AMP] = ACTIONS(448),
    [anon_sym_GT_AMP] = ACTIONS(448),
    [anon_sym_LT_LT] = ACTIONS(846),
    [anon_sym_LT_LT_DASH] = ACTIONS(448),
    [anon_sym_BQUOTE] = ACTIONS(448),
    [sym_comment] = ACTIONS(52),
  },
  [856] = {
    [sym_file_descriptor] = ACTIONS(452),
    [sym__concat] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_PIPE_AMP] = ACTIONS(452),
    [anon_sym_AMP_AMP] = ACTIONS(452),
    [anon_sym_PIPE_PIPE] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(848),
    [anon_sym_GT] = ACTIONS(848),
    [anon_sym_GT_GT] = ACTIONS(452),
    [anon_sym_AMP_GT] = ACTIONS(848),
    [anon_sym_AMP_GT_GT] = ACTIONS(452),
    [anon_sym_LT_AMP] = ACTIONS(452),
    [anon_sym_GT_AMP] = ACTIONS(452),
    [anon_sym_LT_LT] = ACTIONS(848),
    [anon_sym_LT_LT_DASH] = ACTIONS(452),
    [anon_sym_BQUOTE] = ACTIONS(452),
    [sym_comment] = ACTIONS(52),
  },
  [857] = {
    [sym_special_variable_name] = STATE(1072),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [858] = {
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2276),
    [anon_sym_EQ] = ACTIONS(2278),
    [anon_sym_COLON] = ACTIONS(2280),
    [anon_sym_COLON_QMARK] = ACTIONS(2278),
    [anon_sym_COLON_DASH] = ACTIONS(2278),
    [anon_sym_PERCENT] = ACTIONS(2278),
    [anon_sym_SLASH] = ACTIONS(2278),
    [sym_comment] = ACTIONS(52),
  },
  [859] = {
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2286),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_COLON_QMARK] = ACTIONS(2286),
    [anon_sym_COLON_DASH] = ACTIONS(2286),
    [anon_sym_PERCENT] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2286),
    [sym_comment] = ACTIONS(52),
  },
  [860] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [861] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [862] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [sym_comment] = ACTIONS(52),
  },
  [863] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [864] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [865] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [866] = {
    [sym_file_descriptor] = ACTIONS(1880),
    [anon_sym_PIPE] = ACTIONS(2294),
    [anon_sym_RPAREN] = ACTIONS(1880),
    [anon_sym_PIPE_AMP] = ACTIONS(1880),
    [anon_sym_AMP_AMP] = ACTIONS(1880),
    [anon_sym_PIPE_PIPE] = ACTIONS(1880),
    [anon_sym_LT] = ACTIONS(2294),
    [anon_sym_GT] = ACTIONS(2294),
    [anon_sym_GT_GT] = ACTIONS(1880),
    [anon_sym_AMP_GT] = ACTIONS(2294),
    [anon_sym_AMP_GT_GT] = ACTIONS(1880),
    [anon_sym_LT_AMP] = ACTIONS(1880),
    [anon_sym_GT_AMP] = ACTIONS(1880),
    [anon_sym_LT_LT] = ACTIONS(2294),
    [anon_sym_LT_LT_DASH] = ACTIONS(1880),
    [anon_sym_BQUOTE] = ACTIONS(1880),
    [sym_comment] = ACTIONS(52),
  },
  [867] = {
    [sym_simple_expansion] = STATE(638),
    [sym_expansion] = STATE(638),
    [aux_sym_heredoc_repeat1] = STATE(916),
    [sym__heredoc_middle] = ACTIONS(1250),
    [sym__heredoc_end] = ACTIONS(2296),
    [anon_sym_DOLLAR] = ACTIONS(1254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1256),
    [sym_comment] = ACTIONS(52),
  },
  [868] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [aux_sym_command_repeat2] = STATE(590),
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(2298),
    [anon_sym_RPAREN] = ACTIONS(2300),
    [anon_sym_PIPE_AMP] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(520),
    [anon_sym_GT] = ACTIONS(520),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_AMP_GT] = ACTIONS(520),
    [anon_sym_AMP_GT_GT] = ACTIONS(522),
    [anon_sym_LT_AMP] = ACTIONS(522),
    [anon_sym_GT_AMP] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [sym_comment] = ACTIONS(52),
  },
  [869] = {
    [aux_sym_concatenation_repeat1] = STATE(1082),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(1625),
    [sym_variable_name] = ACTIONS(440),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_PIPE_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_PIPE_PIPE] = ACTIONS(844),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_AMP_GT] = ACTIONS(844),
    [anon_sym_AMP_GT_GT] = ACTIONS(440),
    [anon_sym_LT_AMP] = ACTIONS(440),
    [anon_sym_GT_AMP] = ACTIONS(440),
    [anon_sym_DQUOTE] = ACTIONS(440),
    [sym_raw_string] = ACTIONS(440),
    [anon_sym_DOLLAR] = ACTIONS(844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(440),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [anon_sym_LT_LPAREN] = ACTIONS(440),
    [anon_sym_GT_LPAREN] = ACTIONS(440),
    [sym_word] = ACTIONS(442),
    [sym_comment] = ACTIONS(52),
  },
  [870] = {
    [sym_compound_statement] = STATE(1083),
    [anon_sym_LBRACE] = ACTIONS(504),
    [sym_comment] = ACTIONS(52),
  },
  [871] = {
    [sym_file_redirect] = STATE(1049),
    [sym_file_descriptor] = ACTIONS(1178),
    [anon_sym_PIPE] = ACTIONS(2224),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
    [anon_sym_AMP_AMP] = ACTIONS(2226),
    [anon_sym_PIPE_PIPE] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(1180),
    [anon_sym_GT] = ACTIONS(1180),
    [anon_sym_GT_GT] = ACTIONS(1182),
    [anon_sym_AMP_GT] = ACTIONS(1180),
    [anon_sym_AMP_GT_GT] = ACTIONS(1182),
    [anon_sym_LT_AMP] = ACTIONS(1182),
    [anon_sym_GT_AMP] = ACTIONS(1182),
    [anon_sym_BQUOTE] = ACTIONS(2226),
    [sym_comment] = ACTIONS(52),
  },
  [872] = {
    [sym_concatenation] = STATE(1051),
    [sym_string] = STATE(1084),
    [sym_simple_expansion] = STATE(1084),
    [sym_expansion] = STATE(1084),
    [sym_command_substitution] = STATE(1084),
    [sym_process_substitution] = STATE(1084),
    [anon_sym_DQUOTE] = ACTIONS(1700),
    [sym_raw_string] = ACTIONS(2302),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1706),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [anon_sym_LT_LPAREN] = ACTIONS(1712),
    [anon_sym_GT_LPAREN] = ACTIONS(1712),
    [sym_word] = ACTIONS(2304),
    [sym_comment] = ACTIONS(52),
  },
  [873] = {
    [aux_sym_concatenation_repeat1] = STATE(1085),
    [sym__concat] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(404),
    [anon_sym_PIPE_AMP] = ACTIONS(400),
    [anon_sym_AMP_AMP] = ACTIONS(400),
    [anon_sym_PIPE_PIPE] = ACTIONS(400),
    [anon_sym_BQUOTE] = ACTIONS(400),
    [sym_comment] = ACTIONS(52),
  },
  [874] = {
    [aux_sym_concatenation_repeat1] = STATE(875),
    [sym_file_descriptor] = ACTIONS(690),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_AMP_GT] = ACTIONS(692),
    [anon_sym_AMP_GT_GT] = ACTIONS(690),
    [anon_sym_LT_AMP] = ACTIONS(690),
    [anon_sym_GT_AMP] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(692),
    [anon_sym_LT_LT_DASH] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_comment] = ACTIONS(52),
  },
  [875] = {
    [aux_sym_concatenation_repeat1] = STATE(1086),
    [sym_file_descriptor] = ACTIONS(440),
    [sym__concat] = ACTIONS(1730),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_PIPE_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_PIPE_PIPE] = ACTIONS(440),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(440),
    [anon_sym_AMP_GT] = ACTIONS(844),
    [anon_sym_AMP_GT_GT] = ACTIONS(440),
    [anon_sym_LT_AMP] = ACTIONS(440),
    [anon_sym_GT_AMP] = ACTIONS(440),
    [anon_sym_LT_LT] = ACTIONS(844),
    [anon_sym_LT_LT_DASH] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [sym_comment] = ACTIONS(52),
  },
  [876] = {
    [sym_file_redirect] = STATE(326),
    [sym_heredoc_redirect] = STATE(326),
    [aux_sym_command_repeat2] = STATE(606),
    [sym_file_descriptor] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(2298),
    [anon_sym_PIPE_AMP] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_PIPE_PIPE] = ACTIONS(2300),
    [anon_sym_LT] = ACTIONS(550),
    [anon_sym_GT] = ACTIONS(550),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_AMP_GT] = ACTIONS(550),
    [anon_sym_AMP_GT_GT] = ACTIONS(552),
    [anon_sym_LT_AMP] = ACTIONS(552),
    [anon_sym_GT_AMP] = ACTIONS(552),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT_LT_DASH] = ACTIONS(526),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [sym_comment] = ACTIONS(52),
  },
  [877] = {
    [anon_sym_PIPE] = ACTIONS(2096),
    [anon_sym_RPAREN] = ACTIONS(2096),
    [anon_sym_SEMI_SEMI] = ACTIONS(2096),
    [anon_sym_PIPE_AMP] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2096),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym_LF] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2096),
  },
  [878] = {
    [aux_sym_concatenation_repeat1] = STATE(883),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [879] = {
    [anon_sym_PIPE] = ACTIONS(1846),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [880] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(418),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_SEMI_SEMI] = ACTIONS(418),
    [anon_sym_PIPE_AMP] = ACTIONS(418),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(418),
    [anon_sym_LF] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(418),
  },
  [881] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [882] = {
    [sym_string] = STATE(1088),
    [sym_simple_expansion] = STATE(1088),
    [sym_expansion] = STATE(1088),
    [sym_command_substitution] = STATE(1088),
    [sym_process_substitution] = STATE(1088),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [sym_raw_string] = ACTIONS(2308),
    [anon_sym_DOLLAR] = ACTIONS(1210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1214),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [anon_sym_LT_LPAREN] = ACTIONS(1218),
    [anon_sym_GT_LPAREN] = ACTIONS(1218),
    [sym_word] = ACTIONS(2310),
    [sym_comment] = ACTIONS(52),
  },
  [883] = {
    [aux_sym_concatenation_repeat1] = STATE(1089),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_PIPE_AMP] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [884] = {
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(446),
    [anon_sym_RPAREN] = ACTIONS(446),
    [anon_sym_SEMI_SEMI] = ACTIONS(446),
    [anon_sym_PIPE_AMP] = ACTIONS(446),
    [anon_sym_AMP_AMP] = ACTIONS(446),
    [anon_sym_PIPE_PIPE] = ACTIONS(446),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym_LF] = ACTIONS(446),
    [anon_sym_AMP] = ACTIONS(446),
  },
  [885] = {
    [sym__concat] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(450),
    [anon_sym_RPAREN] = ACTIONS(450),
    [anon_sym_SEMI_SEMI] = ACTIONS(450),
    [anon_sym_PIPE_AMP] = ACTIONS(450),
    [anon_sym_AMP_AMP] = ACTIONS(450),
    [anon_sym_PIPE_PIPE] = ACTIONS(450),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(450),
    [anon_sym_LF] = ACTIONS(450),
    [anon_sym_AMP] = ACTIONS(450),
  },
  [886] = {
    [sym__concat] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(454),
    [anon_sym_RPAREN] = ACTIONS(454),
    [anon_sym_SEMI_SEMI] = ACTIONS(454),
    [anon_sym_PIPE_AMP] = ACTIONS(454),
    [anon_sym_AMP_AMP] = ACTIONS(454),
    [anon_sym_PIPE_PIPE] = ACTIONS(454),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_LF] = ACTIONS(454),
    [anon_sym_AMP] = ACTIONS(454),
  },
  [887] = {
    [sym_special_variable_name] = STATE(1091),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [888] = {
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2316),
    [anon_sym_EQ] = ACTIONS(2318),
    [anon_sym_COLON] = ACTIONS(2320),
    [anon_sym_COLON_QMARK] = ACTIONS(2318),
    [anon_sym_COLON_DASH] = ACTIONS(2318),
    [anon_sym_PERCENT] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2318),
    [sym_comment] = ACTIONS(52),
  },
  [889] = {
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2324),
    [anon_sym_EQ] = ACTIONS(2326),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_COLON_QMARK] = ACTIONS(2326),
    [anon_sym_COLON_DASH] = ACTIONS(2326),
    [anon_sym_PERCENT] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2326),
    [sym_comment] = ACTIONS(52),
  },
  [890] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2330),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [891] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2330),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [892] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(2330),
    [sym_comment] = ACTIONS(52),
  },
  [893] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(2330),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [894] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2332),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [895] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2332),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [896] = {
    [sym_file_descriptor] = ACTIONS(1000),
    [sym__concat] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1002),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [anon_sym_SEMI_SEMI] = ACTIONS(1002),
    [anon_sym_PIPE_AMP] = ACTIONS(1002),
    [anon_sym_AMP_AMP] = ACTIONS(1002),
    [anon_sym_PIPE_PIPE] = ACTIONS(1002),
    [anon_sym_LT] = ACTIONS(1002),
    [anon_sym_GT] = ACTIONS(1002),
    [anon_sym_GT_GT] = ACTIONS(1002),
    [anon_sym_AMP_GT] = ACTIONS(1002),
    [anon_sym_AMP_GT_GT] = ACTIONS(1002),
    [anon_sym_LT_AMP] = ACTIONS(1002),
    [anon_sym_GT_AMP] = ACTIONS(1002),
    [anon_sym_LT_LT] = ACTIONS(1002),
    [anon_sym_LT_LT_DASH] = ACTIONS(1002),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_LF] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
  },
  [897] = {
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_LT_LT_DASH] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [898] = {
    [aux_sym_concatenation_repeat1] = STATE(898),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(2334),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_LT_LT_DASH] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [899] = {
    [anon_sym_RBRACE] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2339),
    [sym_comment] = ACTIONS(52),
  },
  [900] = {
    [anon_sym_RBRACE] = ACTIONS(2341),
    [anon_sym_LBRACK] = ACTIONS(2343),
    [sym_comment] = ACTIONS(52),
  },
  [901] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT] = ACTIONS(1038),
    [anon_sym_AMP_GT_GT] = ACTIONS(1038),
    [anon_sym_LT_AMP] = ACTIONS(1038),
    [anon_sym_GT_AMP] = ACTIONS(1038),
    [anon_sym_LT_LT] = ACTIONS(1038),
    [anon_sym_LT_LT_DASH] = ACTIONS(1038),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
  },
  [902] = {
    [anon_sym_AT] = ACTIONS(2345),
    [sym_comment] = ACTIONS(52),
  },
  [903] = {
    [sym_concatenation] = STATE(1106),
    [sym_string] = STATE(1105),
    [sym_simple_expansion] = STATE(1105),
    [sym_expansion] = STATE(1105),
    [sym_command_substitution] = STATE(1105),
    [sym_process_substitution] = STATE(1105),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2349),
    [sym_comment] = ACTIONS(52),
  },
  [904] = {
    [sym_file_descriptor] = ACTIONS(1046),
    [sym__concat] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1048),
    [anon_sym_RPAREN] = ACTIONS(1048),
    [anon_sym_SEMI_SEMI] = ACTIONS(1048),
    [anon_sym_PIPE_AMP] = ACTIONS(1048),
    [anon_sym_AMP_AMP] = ACTIONS(1048),
    [anon_sym_PIPE_PIPE] = ACTIONS(1048),
    [anon_sym_LT] = ACTIONS(1048),
    [anon_sym_GT] = ACTIONS(1048),
    [anon_sym_GT_GT] = ACTIONS(1048),
    [anon_sym_AMP_GT] = ACTIONS(1048),
    [anon_sym_AMP_GT_GT] = ACTIONS(1048),
    [anon_sym_LT_AMP] = ACTIONS(1048),
    [anon_sym_GT_AMP] = ACTIONS(1048),
    [anon_sym_LT_LT] = ACTIONS(1048),
    [anon_sym_LT_LT_DASH] = ACTIONS(1048),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1048),
    [anon_sym_LF] = ACTIONS(1048),
    [anon_sym_AMP] = ACTIONS(1048),
  },
  [905] = {
    [anon_sym_AT] = ACTIONS(2351),
    [sym_comment] = ACTIONS(52),
  },
  [906] = {
    [sym_concatenation] = STATE(1109),
    [sym_string] = STATE(1108),
    [sym_simple_expansion] = STATE(1108),
    [sym_expansion] = STATE(1108),
    [sym_command_substitution] = STATE(1108),
    [sym_process_substitution] = STATE(1108),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2353),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2355),
    [sym_comment] = ACTIONS(52),
  },
  [907] = {
    [sym_file_descriptor] = ACTIONS(1136),
    [sym__concat] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1138),
    [anon_sym_RPAREN] = ACTIONS(1138),
    [anon_sym_SEMI_SEMI] = ACTIONS(1138),
    [anon_sym_PIPE_AMP] = ACTIONS(1138),
    [anon_sym_AMP_AMP] = ACTIONS(1138),
    [anon_sym_PIPE_PIPE] = ACTIONS(1138),
    [anon_sym_LT] = ACTIONS(1138),
    [anon_sym_GT] = ACTIONS(1138),
    [anon_sym_GT_GT] = ACTIONS(1138),
    [anon_sym_AMP_GT] = ACTIONS(1138),
    [anon_sym_AMP_GT_GT] = ACTIONS(1138),
    [anon_sym_LT_AMP] = ACTIONS(1138),
    [anon_sym_GT_AMP] = ACTIONS(1138),
    [anon_sym_LT_LT] = ACTIONS(1138),
    [anon_sym_LT_LT_DASH] = ACTIONS(1138),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_LF] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1138),
  },
  [908] = {
    [sym_file_descriptor] = ACTIONS(1192),
    [sym__concat] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_RPAREN] = ACTIONS(1194),
    [anon_sym_SEMI_SEMI] = ACTIONS(1194),
    [anon_sym_PIPE_AMP] = ACTIONS(1194),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [anon_sym_LT] = ACTIONS(1194),
    [anon_sym_GT] = ACTIONS(1194),
    [anon_sym_GT_GT] = ACTIONS(1194),
    [anon_sym_AMP_GT] = ACTIONS(1194),
    [anon_sym_AMP_GT_GT] = ACTIONS(1194),
    [anon_sym_LT_AMP] = ACTIONS(1194),
    [anon_sym_GT_AMP] = ACTIONS(1194),
    [anon_sym_LT_LT] = ACTIONS(1194),
    [anon_sym_LT_LT_DASH] = ACTIONS(1194),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_AMP] = ACTIONS(1194),
  },
  [909] = {
    [sym__heredoc_middle] = ACTIONS(444),
    [sym__heredoc_end] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(444),
    [sym_comment] = ACTIONS(52),
  },
  [910] = {
    [sym__heredoc_middle] = ACTIONS(448),
    [sym__heredoc_end] = ACTIONS(448),
    [anon_sym_DOLLAR] = ACTIONS(846),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(448),
    [sym_comment] = ACTIONS(52),
  },
  [911] = {
    [sym__heredoc_middle] = ACTIONS(452),
    [sym__heredoc_end] = ACTIONS(452),
    [anon_sym_DOLLAR] = ACTIONS(848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(452),
    [sym_comment] = ACTIONS(52),
  },
  [912] = {
    [sym_special_variable_name] = STATE(1111),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(2357),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [913] = {
    [anon_sym_RBRACE] = ACTIONS(2359),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_EQ] = ACTIONS(2363),
    [anon_sym_COLON] = ACTIONS(2365),
    [anon_sym_COLON_QMARK] = ACTIONS(2363),
    [anon_sym_COLON_DASH] = ACTIONS(2363),
    [anon_sym_PERCENT] = ACTIONS(2363),
    [anon_sym_SLASH] = ACTIONS(2363),
    [sym_comment] = ACTIONS(52),
  },
  [914] = {
    [anon_sym_RBRACE] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_COLON_QMARK] = ACTIONS(2371),
    [anon_sym_COLON_DASH] = ACTIONS(2371),
    [anon_sym_PERCENT] = ACTIONS(2371),
    [anon_sym_SLASH] = ACTIONS(2371),
    [sym_comment] = ACTIONS(52),
  },
  [915] = {
    [sym_file_descriptor] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(2377),
    [anon_sym_RPAREN] = ACTIONS(2377),
    [anon_sym_SEMI_SEMI] = ACTIONS(2377),
    [anon_sym_PIPE_AMP] = ACTIONS(2377),
    [anon_sym_AMP_AMP] = ACTIONS(2377),
    [anon_sym_PIPE_PIPE] = ACTIONS(2377),
    [anon_sym_LT] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2377),
    [anon_sym_GT_GT] = ACTIONS(2377),
    [anon_sym_AMP_GT] = ACTIONS(2377),
    [anon_sym_AMP_GT_GT] = ACTIONS(2377),
    [anon_sym_LT_AMP] = ACTIONS(2377),
    [anon_sym_GT_AMP] = ACTIONS(2377),
    [anon_sym_LT_LT] = ACTIONS(2377),
    [anon_sym_LT_LT_DASH] = ACTIONS(2377),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2377),
    [anon_sym_LF] = ACTIONS(2377),
    [anon_sym_AMP] = ACTIONS(2377),
  },
  [916] = {
    [sym_simple_expansion] = STATE(638),
    [sym_expansion] = STATE(638),
    [aux_sym_heredoc_repeat1] = STATE(916),
    [sym__heredoc_middle] = ACTIONS(2379),
    [sym__heredoc_end] = ACTIONS(2382),
    [anon_sym_DOLLAR] = ACTIONS(2384),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(52),
  },
  [917] = {
    [sym_file_descriptor] = ACTIONS(1338),
    [sym_variable_name] = ACTIONS(1338),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_GT_GT] = ACTIONS(1338),
    [anon_sym_AMP_GT] = ACTIONS(2172),
    [anon_sym_AMP_GT_GT] = ACTIONS(1338),
    [anon_sym_LT_AMP] = ACTIONS(1338),
    [anon_sym_GT_AMP] = ACTIONS(1338),
    [anon_sym_DQUOTE] = ACTIONS(1338),
    [sym_raw_string] = ACTIONS(1338),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1338),
    [anon_sym_BQUOTE] = ACTIONS(1338),
    [anon_sym_LT_LPAREN] = ACTIONS(1338),
    [anon_sym_GT_LPAREN] = ACTIONS(1338),
    [sym_word] = ACTIONS(2172),
    [sym_comment] = ACTIONS(52),
  },
  [918] = {
    [sym_concatenation] = STATE(397),
    [sym_string] = STATE(391),
    [sym_simple_expansion] = STATE(391),
    [sym_expansion] = STATE(391),
    [sym_command_substitution] = STATE(391),
    [sym_process_substitution] = STATE(391),
    [aux_sym_for_statement_repeat1] = STATE(677),
    [anon_sym_RPAREN] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(716),
    [sym_raw_string] = ACTIONS(718),
    [anon_sym_DOLLAR] = ACTIONS(720),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(722),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(724),
    [anon_sym_BQUOTE] = ACTIONS(726),
    [anon_sym_LT_LPAREN] = ACTIONS(728),
    [anon_sym_GT_LPAREN] = ACTIONS(728),
    [sym_word] = ACTIONS(730),
    [sym_comment] = ACTIONS(52),
  },
  [919] = {
    [sym__concat] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_RBRACK] = ACTIONS(1599),
    [sym_comment] = ACTIONS(52),
  },
  [920] = {
    [anon_sym_AT] = ACTIONS(2392),
    [sym_comment] = ACTIONS(52),
  },
  [921] = {
    [sym__concat] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1605),
    [anon_sym_RPAREN] = ACTIONS(1605),
    [anon_sym_RBRACK] = ACTIONS(1605),
    [sym_comment] = ACTIONS(52),
  },
  [922] = {
    [anon_sym_AT] = ACTIONS(2394),
    [sym_comment] = ACTIONS(52),
  },
  [923] = {
    [anon_sym_RBRACK] = ACTIONS(2396),
    [sym_comment] = ACTIONS(52),
  },
  [924] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(52),
  },
  [925] = {
    [anon_sym_RBRACE] = ACTIONS(2398),
    [sym_comment] = ACTIONS(52),
  },
  [926] = {
    [anon_sym_RBRACK] = ACTIONS(2400),
    [sym_comment] = ACTIONS(52),
  },
  [927] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(52),
  },
  [928] = {
    [anon_sym_RBRACE] = ACTIONS(2402),
    [sym_comment] = ACTIONS(52),
  },
  [929] = {
    [sym__concat] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [sym_raw_string] = ACTIONS(1000),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1000),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1000),
    [anon_sym_GT_LPAREN] = ACTIONS(1000),
    [sym_word] = ACTIONS(1498),
    [sym_comment] = ACTIONS(52),
  },
  [930] = {
    [sym__concat] = ACTIONS(1021),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1500),
    [sym_comment] = ACTIONS(52),
  },
  [931] = {
    [aux_sym_concatenation_repeat1] = STATE(931),
    [sym__concat] = ACTIONS(2404),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1500),
    [sym_comment] = ACTIONS(52),
  },
  [932] = {
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [sym_comment] = ACTIONS(52),
  },
  [933] = {
    [anon_sym_RBRACE] = ACTIONS(2411),
    [anon_sym_LBRACK] = ACTIONS(2413),
    [sym_comment] = ACTIONS(52),
  },
  [934] = {
    [sym__concat] = ACTIONS(1036),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LT_LPAREN] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1036),
    [sym_word] = ACTIONS(1513),
    [sym_comment] = ACTIONS(52),
  },
  [935] = {
    [anon_sym_AT] = ACTIONS(2415),
    [sym_comment] = ACTIONS(52),
  },
  [936] = {
    [sym_concatenation] = STATE(1131),
    [sym_string] = STATE(1130),
    [sym_simple_expansion] = STATE(1130),
    [sym_expansion] = STATE(1130),
    [sym_command_substitution] = STATE(1130),
    [sym_process_substitution] = STATE(1130),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2417),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2419),
    [sym_comment] = ACTIONS(52),
  },
  [937] = {
    [sym__concat] = ACTIONS(1046),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_raw_string] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_LT_LPAREN] = ACTIONS(1046),
    [anon_sym_GT_LPAREN] = ACTIONS(1046),
    [sym_word] = ACTIONS(1521),
    [sym_comment] = ACTIONS(52),
  },
  [938] = {
    [anon_sym_AT] = ACTIONS(2421),
    [sym_comment] = ACTIONS(52),
  },
  [939] = {
    [sym_concatenation] = STATE(1134),
    [sym_string] = STATE(1133),
    [sym_simple_expansion] = STATE(1133),
    [sym_expansion] = STATE(1133),
    [sym_command_substitution] = STATE(1133),
    [sym_process_substitution] = STATE(1133),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2423),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2425),
    [sym_comment] = ACTIONS(52),
  },
  [940] = {
    [sym__concat] = ACTIONS(1136),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [sym_raw_string] = ACTIONS(1136),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [anon_sym_LT_LPAREN] = ACTIONS(1136),
    [anon_sym_GT_LPAREN] = ACTIONS(1136),
    [sym_word] = ACTIONS(1529),
    [sym_comment] = ACTIONS(52),
  },
  [941] = {
    [sym__concat] = ACTIONS(1192),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [sym_word] = ACTIONS(1531),
    [sym_comment] = ACTIONS(52),
  },
  [942] = {
    [sym_file_descriptor] = ACTIONS(1599),
    [sym__concat] = ACTIONS(1599),
    [sym_variable_name] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1601),
    [anon_sym_SEMI_SEMI] = ACTIONS(1601),
    [anon_sym_PIPE_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_GT] = ACTIONS(1601),
    [anon_sym_AMP_GT_GT] = ACTIONS(1601),
    [anon_sym_LT_AMP] = ACTIONS(1601),
    [anon_sym_GT_AMP] = ACTIONS(1601),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [sym_raw_string] = ACTIONS(1601),
    [anon_sym_DOLLAR] = ACTIONS(1601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1601),
    [anon_sym_LT_LPAREN] = ACTIONS(1601),
    [anon_sym_GT_LPAREN] = ACTIONS(1601),
    [sym_word] = ACTIONS(1601),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_LF] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
  },
  [943] = {
    [anon_sym_AT] = ACTIONS(2427),
    [sym_comment] = ACTIONS(52),
  },
  [944] = {
    [sym_file_descriptor] = ACTIONS(1605),
    [sym__concat] = ACTIONS(1605),
    [sym_variable_name] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1607),
    [anon_sym_RPAREN] = ACTIONS(1607),
    [anon_sym_SEMI_SEMI] = ACTIONS(1607),
    [anon_sym_PIPE_AMP] = ACTIONS(1607),
    [anon_sym_AMP_AMP] = ACTIONS(1607),
    [anon_sym_PIPE_PIPE] = ACTIONS(1607),
    [anon_sym_LT] = ACTIONS(1607),
    [anon_sym_GT] = ACTIONS(1607),
    [anon_sym_GT_GT] = ACTIONS(1607),
    [anon_sym_AMP_GT] = ACTIONS(1607),
    [anon_sym_AMP_GT_GT] = ACTIONS(1607),
    [anon_sym_LT_AMP] = ACTIONS(1607),
    [anon_sym_GT_AMP] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_raw_string] = ACTIONS(1607),
    [anon_sym_DOLLAR] = ACTIONS(1607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1607),
    [anon_sym_BQUOTE] = ACTIONS(1607),
    [anon_sym_LT_LPAREN] = ACTIONS(1607),
    [anon_sym_GT_LPAREN] = ACTIONS(1607),
    [sym_word] = ACTIONS(1607),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_LF] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
  },
  [945] = {
    [anon_sym_AT] = ACTIONS(2429),
    [sym_comment] = ACTIONS(52),
  },
  [946] = {
    [anon_sym_RBRACK] = ACTIONS(2431),
    [sym_comment] = ACTIONS(52),
  },
  [947] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2433),
    [sym_comment] = ACTIONS(52),
  },
  [948] = {
    [anon_sym_RBRACE] = ACTIONS(2433),
    [sym_comment] = ACTIONS(52),
  },
  [949] = {
    [anon_sym_RBRACK] = ACTIONS(2435),
    [sym_comment] = ACTIONS(52),
  },
  [950] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [sym_comment] = ACTIONS(52),
  },
  [951] = {
    [anon_sym_RBRACE] = ACTIONS(2437),
    [sym_comment] = ACTIONS(52),
  },
  [952] = {
    [sym__concat] = ACTIONS(1000),
    [anon_sym_SEMI_SEMI] = ACTIONS(1002),
    [anon_sym_DQUOTE] = ACTIONS(1002),
    [sym_raw_string] = ACTIONS(1002),
    [anon_sym_DOLLAR] = ACTIONS(1002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1002),
    [anon_sym_BQUOTE] = ACTIONS(1002),
    [anon_sym_LT_LPAREN] = ACTIONS(1002),
    [anon_sym_GT_LPAREN] = ACTIONS(1002),
    [sym_word] = ACTIONS(1002),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_LF] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
  },
  [953] = {
    [sym__concat] = ACTIONS(1021),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [sym_raw_string] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LPAREN] = ACTIONS(1023),
    [anon_sym_GT_LPAREN] = ACTIONS(1023),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [954] = {
    [aux_sym_concatenation_repeat1] = STATE(954),
    [sym__concat] = ACTIONS(2439),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [sym_raw_string] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LPAREN] = ACTIONS(1023),
    [anon_sym_GT_LPAREN] = ACTIONS(1023),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [955] = {
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [sym_comment] = ACTIONS(52),
  },
  [956] = {
    [anon_sym_RBRACE] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [sym_comment] = ACTIONS(52),
  },
  [957] = {
    [sym__concat] = ACTIONS(1036),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [sym_raw_string] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [anon_sym_LT_LPAREN] = ACTIONS(1038),
    [anon_sym_GT_LPAREN] = ACTIONS(1038),
    [sym_word] = ACTIONS(1038),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
  },
  [958] = {
    [anon_sym_AT] = ACTIONS(2450),
    [sym_comment] = ACTIONS(52),
  },
  [959] = {
    [sym_concatenation] = STATE(1147),
    [sym_string] = STATE(1146),
    [sym_simple_expansion] = STATE(1146),
    [sym_expansion] = STATE(1146),
    [sym_command_substitution] = STATE(1146),
    [sym_process_substitution] = STATE(1146),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2452),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2454),
    [sym_comment] = ACTIONS(52),
  },
  [960] = {
    [sym__concat] = ACTIONS(1046),
    [anon_sym_SEMI_SEMI] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1048),
    [sym_raw_string] = ACTIONS(1048),
    [anon_sym_DOLLAR] = ACTIONS(1048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1048),
    [anon_sym_BQUOTE] = ACTIONS(1048),
    [anon_sym_LT_LPAREN] = ACTIONS(1048),
    [anon_sym_GT_LPAREN] = ACTIONS(1048),
    [sym_word] = ACTIONS(1048),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1048),
    [anon_sym_LF] = ACTIONS(1048),
    [anon_sym_AMP] = ACTIONS(1048),
  },
  [961] = {
    [anon_sym_AT] = ACTIONS(2456),
    [sym_comment] = ACTIONS(52),
  },
  [962] = {
    [sym_concatenation] = STATE(1150),
    [sym_string] = STATE(1149),
    [sym_simple_expansion] = STATE(1149),
    [sym_expansion] = STATE(1149),
    [sym_command_substitution] = STATE(1149),
    [sym_process_substitution] = STATE(1149),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2460),
    [sym_comment] = ACTIONS(52),
  },
  [963] = {
    [sym__concat] = ACTIONS(1136),
    [anon_sym_SEMI_SEMI] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1138),
    [sym_raw_string] = ACTIONS(1138),
    [anon_sym_DOLLAR] = ACTIONS(1138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1138),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1138),
    [anon_sym_BQUOTE] = ACTIONS(1138),
    [anon_sym_LT_LPAREN] = ACTIONS(1138),
    [anon_sym_GT_LPAREN] = ACTIONS(1138),
    [sym_word] = ACTIONS(1138),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_LF] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1138),
  },
  [964] = {
    [sym__concat] = ACTIONS(1192),
    [anon_sym_SEMI_SEMI] = ACTIONS(1194),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [sym_raw_string] = ACTIONS(1194),
    [anon_sym_DOLLAR] = ACTIONS(1194),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1194),
    [anon_sym_BQUOTE] = ACTIONS(1194),
    [anon_sym_LT_LPAREN] = ACTIONS(1194),
    [anon_sym_GT_LPAREN] = ACTIONS(1194),
    [sym_word] = ACTIONS(1194),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_AMP] = ACTIONS(1194),
  },
  [965] = {
    [anon_sym_PIPE] = ACTIONS(2462),
    [anon_sym_RPAREN] = ACTIONS(2462),
    [anon_sym_SEMI_SEMI] = ACTIONS(2462),
    [anon_sym_PIPE_AMP] = ACTIONS(2462),
    [anon_sym_AMP_AMP] = ACTIONS(2462),
    [anon_sym_PIPE_PIPE] = ACTIONS(2462),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2462),
    [anon_sym_LF] = ACTIONS(2462),
    [anon_sym_AMP] = ACTIONS(2462),
  },
  [966] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(433),
    [sym_while_statement] = STATE(433),
    [sym_if_statement] = STATE(433),
    [sym_case_statement] = STATE(433),
    [sym_function_definition] = STATE(433),
    [sym_subshell] = STATE(433),
    [sym_pipeline] = STATE(433),
    [sym_list] = STATE(433),
    [sym_bracket_command] = STATE(433),
    [sym_command] = STATE(433),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(436),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1151),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2464),
    [anon_sym_elif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [967] = {
    [sym_file_descriptor] = ACTIONS(574),
    [sym_variable_name] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(576),
    [anon_sym_while] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(576),
    [anon_sym_fi] = ACTIONS(576),
    [anon_sym_case] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(576),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(576),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_word] = ACTIONS(578),
    [sym_comment] = ACTIONS(52),
  },
  [968] = {
    [sym__terminated_statement] = STATE(713),
    [sym_for_statement] = STATE(714),
    [sym_while_statement] = STATE(714),
    [sym_if_statement] = STATE(714),
    [sym_case_statement] = STATE(714),
    [sym_function_definition] = STATE(714),
    [sym_subshell] = STATE(714),
    [sym_pipeline] = STATE(714),
    [sym_list] = STATE(714),
    [sym_bracket_command] = STATE(714),
    [sym_command] = STATE(714),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(715),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(968),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(610),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_fi] = ACTIONS(2053),
    [anon_sym_case] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(645),
    [anon_sym_LT_AMP] = ACTIONS(645),
    [anon_sym_GT_AMP] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(663),
    [anon_sym_LT_LPAREN] = ACTIONS(666),
    [anon_sym_GT_LPAREN] = ACTIONS(666),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(52),
  },
  [969] = {
    [anon_sym_PIPE] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_SEMI_SEMI] = ACTIONS(2466),
    [anon_sym_PIPE_AMP] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_LF] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2466),
  },
  [970] = {
    [anon_sym_fi] = ACTIONS(2468),
    [sym_comment] = ACTIONS(52),
  },
  [971] = {
    [sym_concatenation] = STATE(1154),
    [sym_string] = STATE(1153),
    [sym_simple_expansion] = STATE(1153),
    [sym_expansion] = STATE(1153),
    [sym_command_substitution] = STATE(1153),
    [sym_process_substitution] = STATE(1153),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(2470),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(2472),
    [sym_comment] = ACTIONS(52),
  },
  [972] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1156),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2474),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [973] = {
    [aux_sym_case_item_repeat1] = STATE(1158),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_RPAREN] = ACTIONS(2476),
    [sym_comment] = ACTIONS(52),
  },
  [974] = {
    [aux_sym_concatenation_repeat1] = STATE(1159),
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(440),
    [sym_comment] = ACTIONS(52),
  },
  [975] = {
    [anon_sym_PIPE] = ACTIONS(2478),
    [anon_sym_RPAREN] = ACTIONS(2478),
    [anon_sym_SEMI_SEMI] = ACTIONS(2478),
    [anon_sym_PIPE_AMP] = ACTIONS(2478),
    [anon_sym_AMP_AMP] = ACTIONS(2478),
    [anon_sym_PIPE_PIPE] = ACTIONS(2478),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2478),
    [anon_sym_LF] = ACTIONS(2478),
    [anon_sym_AMP] = ACTIONS(2478),
  },
  [976] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(976),
    [anon_sym_esac] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [sym_raw_string] = ACTIONS(2485),
    [anon_sym_DOLLAR] = ACTIONS(2488),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2491),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2494),
    [anon_sym_BQUOTE] = ACTIONS(2497),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_word] = ACTIONS(2503),
    [sym_comment] = ACTIONS(52),
  },
  [977] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(976),
    [anon_sym_esac] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1442),
    [sym_comment] = ACTIONS(52),
  },
  [978] = {
    [anon_sym_RBRACK] = ACTIONS(2508),
    [sym_comment] = ACTIONS(52),
  },
  [979] = {
    [anon_sym_RBRACK] = ACTIONS(2510),
    [sym_comment] = ACTIONS(52),
  },
  [980] = {
    [anon_sym_RBRACE] = ACTIONS(2512),
    [sym_comment] = ACTIONS(52),
  },
  [981] = {
    [sym__concat] = ACTIONS(2162),
    [anon_sym_in] = ACTIONS(2164),
    [anon_sym_SEMI_SEMI] = ACTIONS(2164),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym_LF] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2164),
  },
  [982] = {
    [anon_sym_RBRACE] = ACTIONS(2514),
    [sym_comment] = ACTIONS(52),
  },
  [983] = {
    [sym__concat] = ACTIONS(2168),
    [anon_sym_in] = ACTIONS(2170),
    [anon_sym_SEMI_SEMI] = ACTIONS(2170),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_LF] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
  },
  [984] = {
    [anon_sym_PIPE] = ACTIONS(2516),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_SEMI_SEMI] = ACTIONS(2516),
    [anon_sym_PIPE_AMP] = ACTIONS(2516),
    [anon_sym_AMP_AMP] = ACTIONS(2516),
    [anon_sym_PIPE_PIPE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_LF] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2516),
  },
  [985] = {
    [aux_sym_concatenation_repeat1] = STATE(985),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1979),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [sym_raw_string] = ACTIONS(1023),
    [anon_sym_DOLLAR] = ACTIONS(1023),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1023),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1023),
    [anon_sym_BQUOTE] = ACTIONS(1023),
    [anon_sym_LT_LPAREN] = ACTIONS(1023),
    [anon_sym_GT_LPAREN] = ACTIONS(1023),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [986] = {
    [sym_file_redirect] = STATE(984),
    [sym_file_descriptor] = ACTIONS(816),
    [anon_sym_PIPE] = ACTIONS(2096),
    [anon_sym_RPAREN] = ACTIONS(2096),
    [anon_sym_SEMI_SEMI] = ACTIONS(2096),
    [anon_sym_PIPE_AMP] = ACTIONS(2096),
    [anon_sym_AMP_AMP] = ACTIONS(2096),
    [anon_sym_PIPE_PIPE] = ACTIONS(2096),
    [anon_sym_LT] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(818),
    [anon_sym_GT_GT] = ACTIONS(818),
    [anon_sym_AMP_GT] = ACTIONS(818),
    [anon_sym_AMP_GT_GT] = ACTIONS(818),
    [anon_sym_LT_AMP] = ACTIONS(818),
    [anon_sym_GT_AMP] = ACTIONS(818),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym_LF] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2096),
  },
  [987] = {
    [aux_sym_concatenation_repeat1] = STATE(988),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(1846),
    [anon_sym_RPAREN] = ACTIONS(1846),
    [anon_sym_SEMI_SEMI] = ACTIONS(1846),
    [anon_sym_PIPE_AMP] = ACTIONS(1846),
    [anon_sym_AMP_AMP] = ACTIONS(1846),
    [anon_sym_PIPE_PIPE] = ACTIONS(1846),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_AMP] = ACTIONS(1846),
  },
  [988] = {
    [aux_sym_concatenation_repeat1] = STATE(1165),
    [sym__concat] = ACTIONS(1834),
    [anon_sym_PIPE] = ACTIONS(442),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_SEMI_SEMI] = ACTIONS(442),
    [anon_sym_PIPE_AMP] = ACTIONS(442),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_LF] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(442),
  },
  [989] = {
    [aux_sym_concatenation_repeat1] = STATE(989),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(2334),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [anon_sym_LT] = ACTIONS(1023),
    [anon_sym_GT] = ACTIONS(1023),
    [anon_sym_GT_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT] = ACTIONS(1023),
    [anon_sym_AMP_GT_GT] = ACTIONS(1023),
    [anon_sym_LT_AMP] = ACTIONS(1023),
    [anon_sym_GT_AMP] = ACTIONS(1023),
    [anon_sym_LT_LT] = ACTIONS(1023),
    [anon_sym_LT_LT_DASH] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [990] = {
    [anon_sym_RBRACK] = ACTIONS(2518),
    [sym_comment] = ACTIONS(52),
  },
  [991] = {
    [anon_sym_RBRACK] = ACTIONS(2520),
    [sym_comment] = ACTIONS(52),
  },
  [992] = {
    [anon_sym_RBRACE] = ACTIONS(2522),
    [sym_comment] = ACTIONS(52),
  },
  [993] = {
    [sym__concat] = ACTIONS(2162),
    [anon_sym_RBRACE] = ACTIONS(2162),
    [anon_sym_RBRACK] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_raw_string] = ACTIONS(2162),
    [anon_sym_DOLLAR] = ACTIONS(2524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2162),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_word] = ACTIONS(2164),
    [sym_comment] = ACTIONS(52),
  },
  [994] = {
    [anon_sym_RBRACE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(52),
  },
  [995] = {
    [sym__concat] = ACTIONS(2168),
    [anon_sym_RBRACE] = ACTIONS(2168),
    [anon_sym_RBRACK] = ACTIONS(2528),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [sym_raw_string] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [anon_sym_LT_LPAREN] = ACTIONS(2168),
    [anon_sym_GT_LPAREN] = ACTIONS(2168),
    [sym_word] = ACTIONS(2170),
    [sym_comment] = ACTIONS(52),
  },
  [996] = {
    [anon_sym_RBRACK] = ACTIONS(2530),
    [sym_comment] = ACTIONS(52),
  },
  [997] = {
    [anon_sym_RBRACK] = ACTIONS(2532),
    [sym_comment] = ACTIONS(52),
  },
  [998] = {
    [anon_sym_RBRACE] = ACTIONS(2534),
    [sym_comment] = ACTIONS(52),
  },
  [999] = {
    [sym__concat] = ACTIONS(2162),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_raw_string] = ACTIONS(2162),
    [anon_sym_DOLLAR] = ACTIONS(2524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2162),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_word] = ACTIONS(2164),
    [sym_comment] = ACTIONS(52),
  },
  [1000] = {
    [anon_sym_RBRACE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(52),
  },
  [1001] = {
    [sym__concat] = ACTIONS(2168),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2528),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [sym_raw_string] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [anon_sym_LT_LPAREN] = ACTIONS(2168),
    [anon_sym_GT_LPAREN] = ACTIONS(2168),
    [sym_word] = ACTIONS(2170),
    [sym_comment] = ACTIONS(52),
  },
  [1002] = {
    [anon_sym_RBRACK] = ACTIONS(2538),
    [sym_comment] = ACTIONS(52),
  },
  [1003] = {
    [anon_sym_RBRACK] = ACTIONS(2540),
    [sym_comment] = ACTIONS(52),
  },
  [1004] = {
    [anon_sym_RBRACE] = ACTIONS(2542),
    [sym_comment] = ACTIONS(52),
  },
  [1005] = {
    [sym_file_descriptor] = ACTIONS(2162),
    [sym__concat] = ACTIONS(2162),
    [sym_variable_name] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_GT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2162),
    [anon_sym_AMP_GT] = ACTIONS(2524),
    [anon_sym_AMP_GT_GT] = ACTIONS(2162),
    [anon_sym_LT_AMP] = ACTIONS(2162),
    [anon_sym_GT_AMP] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_raw_string] = ACTIONS(2162),
    [anon_sym_DOLLAR] = ACTIONS(2524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2162),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_word] = ACTIONS(2524),
    [sym_comment] = ACTIONS(52),
  },
  [1006] = {
    [anon_sym_RBRACE] = ACTIONS(2544),
    [sym_comment] = ACTIONS(52),
  },
  [1007] = {
    [sym_file_descriptor] = ACTIONS(2168),
    [sym__concat] = ACTIONS(2168),
    [sym_variable_name] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(2528),
    [anon_sym_GT] = ACTIONS(2528),
    [anon_sym_GT_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT] = ACTIONS(2528),
    [anon_sym_AMP_GT_GT] = ACTIONS(2168),
    [anon_sym_LT_AMP] = ACTIONS(2168),
    [anon_sym_GT_AMP] = ACTIONS(2168),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [sym_raw_string] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [anon_sym_LT_LPAREN] = ACTIONS(2168),
    [anon_sym_GT_LPAREN] = ACTIONS(2168),
    [sym_word] = ACTIONS(2528),
    [sym_comment] = ACTIONS(52),
  },
  [1008] = {
    [anon_sym_RBRACK] = ACTIONS(2546),
    [sym_comment] = ACTIONS(52),
  },
  [1009] = {
    [anon_sym_RBRACK] = ACTIONS(2548),
    [sym_comment] = ACTIONS(52),
  },
  [1010] = {
    [anon_sym_RBRACE] = ACTIONS(2550),
    [sym_comment] = ACTIONS(52),
  },
  [1011] = {
    [anon_sym_DQUOTE] = ACTIONS(2164),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2524),
    [anon_sym_DOLLAR] = ACTIONS(2164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2164),
    [anon_sym_BQUOTE] = ACTIONS(2164),
    [sym_comment] = ACTIONS(150),
  },
  [1012] = {
    [anon_sym_RBRACE] = ACTIONS(2552),
    [sym_comment] = ACTIONS(52),
  },
  [1013] = {
    [anon_sym_DQUOTE] = ACTIONS(2170),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2528),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2170),
    [anon_sym_BQUOTE] = ACTIONS(2170),
    [sym_comment] = ACTIONS(150),
  },
  [1014] = {
    [anon_sym_RBRACE] = ACTIONS(2554),
    [sym_comment] = ACTIONS(52),
  },
  [1015] = {
    [anon_sym_RBRACE] = ACTIONS(2556),
    [sym_comment] = ACTIONS(52),
  },
  [1016] = {
    [sym_file_descriptor] = ACTIONS(2558),
    [sym__concat] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(2560),
    [anon_sym_GT] = ACTIONS(2560),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [anon_sym_LT_LT] = ACTIONS(2560),
    [anon_sym_LT_LT_DASH] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_word] = ACTIONS(2560),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2560),
  },
  [1017] = {
    [aux_sym_concatenation_repeat1] = STATE(1017),
    [sym__concat] = ACTIONS(1502),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [1018] = {
    [sym_file_descriptor] = ACTIONS(2562),
    [sym__concat] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_GT] = ACTIONS(2564),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2564),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [sym_raw_string] = ACTIONS(2564),
    [anon_sym_DOLLAR] = ACTIONS(2564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2564),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [anon_sym_LT_LPAREN] = ACTIONS(2564),
    [anon_sym_GT_LPAREN] = ACTIONS(2564),
    [sym_word] = ACTIONS(2564),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2564),
  },
  [1019] = {
    [sym_file_descriptor] = ACTIONS(1951),
    [sym_variable_name] = ACTIONS(1951),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(1951),
    [anon_sym_PIPE_AMP] = ACTIONS(1951),
    [anon_sym_AMP_AMP] = ACTIONS(1951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(1951),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(1951),
    [anon_sym_LT_AMP] = ACTIONS(1951),
    [anon_sym_GT_AMP] = ACTIONS(1951),
    [anon_sym_DQUOTE] = ACTIONS(1951),
    [sym_raw_string] = ACTIONS(1951),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1951),
    [anon_sym_BQUOTE] = ACTIONS(1951),
    [anon_sym_LT_LPAREN] = ACTIONS(1951),
    [anon_sym_GT_LPAREN] = ACTIONS(1951),
    [sym_word] = ACTIONS(1953),
    [sym_comment] = ACTIONS(52),
  },
  [1020] = {
    [sym_file_descriptor] = ACTIONS(1000),
    [sym__concat] = ACTIONS(1000),
    [sym_variable_name] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_PIPE_AMP] = ACTIONS(1000),
    [anon_sym_AMP_AMP] = ACTIONS(1000),
    [anon_sym_PIPE_PIPE] = ACTIONS(1498),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1000),
    [anon_sym_AMP_GT] = ACTIONS(1498),
    [anon_sym_AMP_GT_GT] = ACTIONS(1000),
    [anon_sym_LT_AMP] = ACTIONS(1000),
    [anon_sym_GT_AMP] = ACTIONS(1000),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [sym_raw_string] = ACTIONS(1000),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1000),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1000),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [anon_sym_LT_LPAREN] = ACTIONS(1000),
    [anon_sym_GT_LPAREN] = ACTIONS(1000),
    [sym_word] = ACTIONS(1002),
    [sym_comment] = ACTIONS(52),
  },
  [1021] = {
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1021),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [1022] = {
    [aux_sym_concatenation_repeat1] = STATE(1022),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(2568),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [1023] = {
    [anon_sym_RBRACE] = ACTIONS(2571),
    [anon_sym_LBRACK] = ACTIONS(2573),
    [sym_comment] = ACTIONS(52),
  },
  [1024] = {
    [anon_sym_RBRACE] = ACTIONS(2575),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [sym_comment] = ACTIONS(52),
  },
  [1025] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1036),
    [sym_variable_name] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1513),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1513),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1036),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LT_LPAREN] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1036),
    [sym_word] = ACTIONS(1038),
    [sym_comment] = ACTIONS(52),
  },
  [1026] = {
    [anon_sym_AT] = ACTIONS(2579),
    [sym_comment] = ACTIONS(52),
  },
  [1027] = {
    [sym_concatenation] = STATE(1190),
    [sym_string] = STATE(1189),
    [sym_simple_expansion] = STATE(1189),
    [sym_expansion] = STATE(1189),
    [sym_command_substitution] = STATE(1189),
    [sym_process_substitution] = STATE(1189),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2581),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2583),
    [sym_comment] = ACTIONS(52),
  },
  [1028] = {
    [sym_file_descriptor] = ACTIONS(1046),
    [sym__concat] = ACTIONS(1046),
    [sym_variable_name] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [anon_sym_PIPE_AMP] = ACTIONS(1046),
    [anon_sym_AMP_AMP] = ACTIONS(1046),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_AMP_GT] = ACTIONS(1521),
    [anon_sym_AMP_GT_GT] = ACTIONS(1046),
    [anon_sym_LT_AMP] = ACTIONS(1046),
    [anon_sym_GT_AMP] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_raw_string] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_LT_LPAREN] = ACTIONS(1046),
    [anon_sym_GT_LPAREN] = ACTIONS(1046),
    [sym_word] = ACTIONS(1048),
    [sym_comment] = ACTIONS(52),
  },
  [1029] = {
    [anon_sym_AT] = ACTIONS(2585),
    [sym_comment] = ACTIONS(52),
  },
  [1030] = {
    [sym_concatenation] = STATE(1193),
    [sym_string] = STATE(1192),
    [sym_simple_expansion] = STATE(1192),
    [sym_expansion] = STATE(1192),
    [sym_command_substitution] = STATE(1192),
    [sym_process_substitution] = STATE(1192),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2587),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2589),
    [sym_comment] = ACTIONS(52),
  },
  [1031] = {
    [sym_file_descriptor] = ACTIONS(1136),
    [sym__concat] = ACTIONS(1136),
    [sym_variable_name] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT] = ACTIONS(1529),
    [anon_sym_AMP_GT_GT] = ACTIONS(1136),
    [anon_sym_LT_AMP] = ACTIONS(1136),
    [anon_sym_GT_AMP] = ACTIONS(1136),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [sym_raw_string] = ACTIONS(1136),
    [anon_sym_DOLLAR] = ACTIONS(1529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1136),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [anon_sym_LT_LPAREN] = ACTIONS(1136),
    [anon_sym_GT_LPAREN] = ACTIONS(1136),
    [sym_word] = ACTIONS(1138),
    [sym_comment] = ACTIONS(52),
  },
  [1032] = {
    [sym_file_descriptor] = ACTIONS(1192),
    [sym__concat] = ACTIONS(1192),
    [sym_variable_name] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_PIPE_AMP] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1192),
    [anon_sym_AMP_GT] = ACTIONS(1531),
    [anon_sym_AMP_GT_GT] = ACTIONS(1192),
    [anon_sym_LT_AMP] = ACTIONS(1192),
    [anon_sym_GT_AMP] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1192),
    [sym_raw_string] = ACTIONS(1192),
    [anon_sym_DOLLAR] = ACTIONS(1531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1192),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1192),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [anon_sym_LT_LPAREN] = ACTIONS(1192),
    [anon_sym_GT_LPAREN] = ACTIONS(1192),
    [sym_word] = ACTIONS(1194),
    [sym_comment] = ACTIONS(52),
  },
  [1033] = {
    [sym_do_group] = STATE(1194),
    [anon_sym_do] = ACTIONS(1078),
    [sym_comment] = ACTIONS(52),
  },
  [1034] = {
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_RPAREN] = ACTIONS(2593),
    [anon_sym_PIPE_AMP] = ACTIONS(2593),
    [anon_sym_AMP_AMP] = ACTIONS(2593),
    [anon_sym_PIPE_PIPE] = ACTIONS(2593),
    [anon_sym_BQUOTE] = ACTIONS(2593),
    [sym_comment] = ACTIONS(52),
  },
  [1035] = {
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_RPAREN] = ACTIONS(2597),
    [anon_sym_PIPE_AMP] = ACTIONS(2597),
    [anon_sym_AMP_AMP] = ACTIONS(2597),
    [anon_sym_PIPE_PIPE] = ACTIONS(2597),
    [anon_sym_BQUOTE] = ACTIONS(2597),
    [sym_comment] = ACTIONS(52),
  },
  [1036] = {
    [anon_sym_fi] = ACTIONS(2599),
    [sym_comment] = ACTIONS(52),
  },
  [1037] = {
    [sym_elif_clause] = STATE(434),
    [sym_else_clause] = STATE(1196),
    [aux_sym_if_statement_repeat1] = STATE(722),
    [anon_sym_fi] = ACTIONS(2599),
    [anon_sym_elif] = ACTIONS(1434),
    [anon_sym_else] = ACTIONS(1436),
    [sym_comment] = ACTIONS(52),
  },
  [1038] = {
    [anon_sym_PIPE] = ACTIONS(2601),
    [anon_sym_RPAREN] = ACTIONS(2603),
    [anon_sym_PIPE_AMP] = ACTIONS(2603),
    [anon_sym_AMP_AMP] = ACTIONS(2603),
    [anon_sym_PIPE_PIPE] = ACTIONS(2603),
    [anon_sym_BQUOTE] = ACTIONS(2603),
    [sym_comment] = ACTIONS(52),
  },
  [1039] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(976),
    [anon_sym_esac] = ACTIONS(2605),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1442),
    [sym_comment] = ACTIONS(52),
  },
  [1040] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(1198),
    [anon_sym_esac] = ACTIONS(2605),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1442),
    [sym_comment] = ACTIONS(52),
  },
  [1041] = {
    [sym_file_redirect] = STATE(1199),
    [sym_file_descriptor] = ACTIONS(1126),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_RPAREN] = ACTIONS(2609),
    [anon_sym_PIPE_AMP] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(1132),
    [anon_sym_GT] = ACTIONS(1132),
    [anon_sym_GT_GT] = ACTIONS(1134),
    [anon_sym_AMP_GT] = ACTIONS(1132),
    [anon_sym_AMP_GT_GT] = ACTIONS(1134),
    [anon_sym_LT_AMP] = ACTIONS(1134),
    [anon_sym_GT_AMP] = ACTIONS(1134),
    [sym_comment] = ACTIONS(52),
  },
  [1042] = {
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_RPAREN] = ACTIONS(2613),
    [anon_sym_PIPE_AMP] = ACTIONS(2613),
    [anon_sym_AMP_AMP] = ACTIONS(2613),
    [anon_sym_PIPE_PIPE] = ACTIONS(2613),
    [anon_sym_BQUOTE] = ACTIONS(2613),
    [sym_comment] = ACTIONS(52),
  },
  [1043] = {
    [anon_sym_RBRACK] = ACTIONS(2615),
    [sym_comment] = ACTIONS(52),
  },
  [1044] = {
    [anon_sym_RBRACK] = ACTIONS(2617),
    [sym_comment] = ACTIONS(52),
  },
  [1045] = {
    [anon_sym_RBRACE] = ACTIONS(2619),
    [sym_comment] = ACTIONS(52),
  },
  [1046] = {
    [sym_file_descriptor] = ACTIONS(2162),
    [sym__concat] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2524),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_PIPE_AMP] = ACTIONS(2162),
    [anon_sym_AMP_AMP] = ACTIONS(2162),
    [anon_sym_PIPE_PIPE] = ACTIONS(2524),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_GT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2162),
    [anon_sym_AMP_GT] = ACTIONS(2524),
    [anon_sym_AMP_GT_GT] = ACTIONS(2162),
    [anon_sym_LT_AMP] = ACTIONS(2162),
    [anon_sym_GT_AMP] = ACTIONS(2162),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_LT_LT_DASH] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_raw_string] = ACTIONS(2162),
    [anon_sym_DOLLAR] = ACTIONS(2524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2162),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_word] = ACTIONS(2164),
    [sym_comment] = ACTIONS(52),
  },
  [1047] = {
    [anon_sym_RBRACE] = ACTIONS(2621),
    [sym_comment] = ACTIONS(52),
  },
  [1048] = {
    [sym_file_descriptor] = ACTIONS(2168),
    [sym__concat] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2528),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_PIPE_AMP] = ACTIONS(2168),
    [anon_sym_AMP_AMP] = ACTIONS(2168),
    [anon_sym_PIPE_PIPE] = ACTIONS(2528),
    [anon_sym_LT] = ACTIONS(2528),
    [anon_sym_GT] = ACTIONS(2528),
    [anon_sym_GT_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT] = ACTIONS(2528),
    [anon_sym_AMP_GT_GT] = ACTIONS(2168),
    [anon_sym_LT_AMP] = ACTIONS(2168),
    [anon_sym_GT_AMP] = ACTIONS(2168),
    [anon_sym_LT_LT] = ACTIONS(2528),
    [anon_sym_LT_LT_DASH] = ACTIONS(2168),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [sym_raw_string] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [anon_sym_LT_LPAREN] = ACTIONS(2168),
    [anon_sym_GT_LPAREN] = ACTIONS(2168),
    [sym_word] = ACTIONS(2170),
    [sym_comment] = ACTIONS(52),
  },
  [1049] = {
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_RPAREN] = ACTIONS(2609),
    [anon_sym_PIPE_AMP] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(2609),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_comment] = ACTIONS(52),
  },
  [1050] = {
    [aux_sym_concatenation_repeat1] = STATE(1055),
    [sym__concat] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [sym_comment] = ACTIONS(52),
  },
  [1051] = {
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_comment] = ACTIONS(52),
  },
  [1052] = {
    [sym__concat] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(836),
    [anon_sym_RPAREN] = ACTIONS(416),
    [anon_sym_PIPE_AMP] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(416),
    [anon_sym_PIPE_PIPE] = ACTIONS(416),
    [anon_sym_BQUOTE] = ACTIONS(416),
    [sym_comment] = ACTIONS(52),
  },
  [1053] = {
    [sym_simple_expansion] = STATE(85),
    [sym_expansion] = STATE(85),
    [sym_command_substitution] = STATE(85),
    [aux_sym_string_repeat1] = STATE(277),
    [anon_sym_DQUOTE] = ACTIONS(2623),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(140),
    [anon_sym_DOLLAR] = ACTIONS(142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(146),
    [anon_sym_BQUOTE] = ACTIONS(148),
    [sym_comment] = ACTIONS(150),
  },
  [1054] = {
    [sym_string] = STATE(1205),
    [sym_simple_expansion] = STATE(1205),
    [sym_expansion] = STATE(1205),
    [sym_command_substitution] = STATE(1205),
    [sym_process_substitution] = STATE(1205),
    [anon_sym_DQUOTE] = ACTIONS(1700),
    [sym_raw_string] = ACTIONS(2625),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1706),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1710),
    [anon_sym_LT_LPAREN] = ACTIONS(1712),
    [anon_sym_GT_LPAREN] = ACTIONS(1712),
    [sym_word] = ACTIONS(2627),
    [sym_comment] = ACTIONS(52),
  },
  [1055] = {
    [aux_sym_concatenation_repeat1] = STATE(1206),
    [sym__concat] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_RPAREN] = ACTIONS(440),
    [anon_sym_PIPE_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_PIPE_PIPE] = ACTIONS(440),
    [sym_comment] = ACTIONS(52),
  },
  [1056] = {
    [sym__concat] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(456),
    [anon_sym_RPAREN] = ACTIONS(444),
    [anon_sym_PIPE_AMP] = ACTIONS(444),
    [anon_sym_AMP_AMP] = ACTIONS(444),
    [anon_sym_PIPE_PIPE] = ACTIONS(444),
    [anon_sym_BQUOTE] = ACTIONS(444),
    [sym_comment] = ACTIONS(52),
  },
  [1057] = {
    [sym__concat] = ACTIONS(448),
    [anon_sym_PIPE] = ACTIONS(846),
    [anon_sym_RPAREN] = ACTIONS(448),
    [anon_sym_PIPE_AMP] = ACTIONS(448),
    [anon_sym_AMP_AMP] = ACTIONS(448),
    [anon_sym_PIPE_PIPE] = ACTIONS(448),
    [anon_sym_BQUOTE] = ACTIONS(448),
    [sym_comment] = ACTIONS(52),
  },
  [1058] = {
    [sym__concat] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(848),
    [anon_sym_RPAREN] = ACTIONS(452),
    [anon_sym_PIPE_AMP] = ACTIONS(452),
    [anon_sym_AMP_AMP] = ACTIONS(452),
    [anon_sym_PIPE_PIPE] = ACTIONS(452),
    [anon_sym_BQUOTE] = ACTIONS(452),
    [sym_comment] = ACTIONS(52),
  },
  [1059] = {
    [sym_special_variable_name] = STATE(1208),
    [anon_sym_RBRACE] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(444),
    [anon_sym_EQ] = ACTIONS(444),
    [anon_sym_DOLLAR] = ACTIONS(164),
    [anon_sym_POUND] = ACTIONS(164),
    [anon_sym_AT] = ACTIONS(164),
    [anon_sym_COLON] = ACTIONS(456),
    [anon_sym_COLON_QMARK] = ACTIONS(444),
    [anon_sym_COLON_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [sym_comment] = ACTIONS(150),
    [sym_simple_variable_name] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_DASH] = ACTIONS(164),
    [anon_sym_BANG] = ACTIONS(164),
    [anon_sym_0] = ACTIONS(170),
    [anon_sym__] = ACTIONS(170),
  },
  [1060] = {
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_EQ] = ACTIONS(2635),
    [anon_sym_COLON] = ACTIONS(2637),
    [anon_sym_COLON_QMARK] = ACTIONS(2635),
    [anon_sym_COLON_DASH] = ACTIONS(2635),
    [anon_sym_PERCENT] = ACTIONS(2635),
    [anon_sym_SLASH] = ACTIONS(2635),
    [sym_comment] = ACTIONS(52),
  },
  [1061] = {
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_LBRACK] = ACTIONS(2641),
    [anon_sym_EQ] = ACTIONS(2643),
    [anon_sym_COLON] = ACTIONS(2645),
    [anon_sym_COLON_QMARK] = ACTIONS(2643),
    [anon_sym_COLON_DASH] = ACTIONS(2643),
    [anon_sym_PERCENT] = ACTIONS(2643),
    [anon_sym_SLASH] = ACTIONS(2643),
    [sym_comment] = ACTIONS(52),
  },
  [1062] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2647),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [1063] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2647),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [1064] = {
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_BQUOTE] = ACTIONS(2647),
    [sym_comment] = ACTIONS(52),
  },
  [1065] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(2647),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [1066] = {
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2649),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(512),
    [sym_comment] = ACTIONS(52),
  },
  [1067] = {
    [sym_file_descriptor] = ACTIONS(254),
    [sym_variable_name] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(2649),
    [anon_sym_PIPE_AMP] = ACTIONS(510),
    [anon_sym_AMP_AMP] = ACTIONS(512),
    [anon_sym_PIPE_PIPE] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_AMP_GT] = ACTIONS(258),
    [anon_sym_AMP_GT_GT] = ACTIONS(254),
    [anon_sym_LT_AMP] = ACTIONS(254),
    [anon_sym_GT_AMP] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_raw_string] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [anon_sym_LT_LPAREN] = ACTIONS(254),
    [anon_sym_GT_LPAREN] = ACTIONS(254),
    [sym_word] = ACTIONS(256),
    [sym_comment] = ACTIONS(52),
  },
  [1068] = {
    [sym_file_descriptor] = ACTIONS(1000),
    [sym__concat] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_PIPE_AMP] = ACTIONS(1000),
    [anon_sym_AMP_AMP] = ACTIONS(1000),
    [anon_sym_PIPE_PIPE] = ACTIONS(1000),
    [anon_sym_LT] = ACTIONS(1498),
    [anon_sym_GT] = ACTIONS(1498),
    [anon_sym_GT_GT] = ACTIONS(1000),
    [anon_sym_AMP_GT] = ACTIONS(1498),
    [anon_sym_AMP_GT_GT] = ACTIONS(1000),
    [anon_sym_LT_AMP] = ACTIONS(1000),
    [anon_sym_GT_AMP] = ACTIONS(1000),
    [anon_sym_LT_LT] = ACTIONS(1498),
    [anon_sym_LT_LT_DASH] = ACTIONS(1000),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [sym_comment] = ACTIONS(52),
  },
  [1069] = {
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_LT_LT] = ACTIONS(1500),
    [anon_sym_LT_LT_DASH] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [1070] = {
    [aux_sym_concatenation_repeat1] = STATE(1070),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_LT_LT] = ACTIONS(1500),
    [anon_sym_LT_LT_DASH] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [1071] = {
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [sym_comment] = ACTIONS(52),
  },
  [1072] = {
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [sym_comment] = ACTIONS(52),
  },
  [1073] = {
    [sym_file_descriptor] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_GT] = ACTIONS(1513),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1513),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1513),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [1074] = {
    [anon_sym_AT] = ACTIONS(2662),
    [sym_comment] = ACTIONS(52),
  },
  [1075] = {
    [sym_concatenation] = STATE(1223),
    [sym_string] = STATE(1222),
    [sym_simple_expansion] = STATE(1222),
    [sym_expansion] = STATE(1222),
    [sym_command_substitution] = STATE(1222),
    [sym_process_substitution] = STATE(1222),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2664),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2666),
    [sym_comment] = ACTIONS(52),
  },
  [1076] = {
    [sym_file_descriptor] = ACTIONS(1046),
    [sym__concat] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [anon_sym_PIPE_AMP] = ACTIONS(1046),
    [anon_sym_AMP_AMP] = ACTIONS(1046),
    [anon_sym_PIPE_PIPE] = ACTIONS(1046),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_GT] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1046),
    [anon_sym_AMP_GT] = ACTIONS(1521),
    [anon_sym_AMP_GT_GT] = ACTIONS(1046),
    [anon_sym_LT_AMP] = ACTIONS(1046),
    [anon_sym_GT_AMP] = ACTIONS(1046),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_LT_LT_DASH] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [sym_comment] = ACTIONS(52),
  },
  [1077] = {
    [anon_sym_AT] = ACTIONS(2668),
    [sym_comment] = ACTIONS(52),
  },
  [1078] = {
    [sym_concatenation] = STATE(1226),
    [sym_string] = STATE(1225),
    [sym_simple_expansion] = STATE(1225),
    [sym_expansion] = STATE(1225),
    [sym_command_substitution] = STATE(1225),
    [sym_process_substitution] = STATE(1225),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2672),
    [sym_comment] = ACTIONS(52),
  },
  [1079] = {
    [sym_file_descriptor] = ACTIONS(1136),
    [sym__concat] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [anon_sym_LT] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1136),
    [anon_sym_AMP_GT] = ACTIONS(1529),
    [anon_sym_AMP_GT_GT] = ACTIONS(1136),
    [anon_sym_LT_AMP] = ACTIONS(1136),
    [anon_sym_GT_AMP] = ACTIONS(1136),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_LT_LT_DASH] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [sym_comment] = ACTIONS(52),
  },
  [1080] = {
    [sym_file_descriptor] = ACTIONS(1192),
    [sym__concat] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_PIPE_AMP] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_LT] = ACTIONS(1531),
    [anon_sym_GT] = ACTIONS(1531),
    [anon_sym_GT_GT] = ACTIONS(1192),
    [anon_sym_AMP_GT] = ACTIONS(1531),
    [anon_sym_AMP_GT_GT] = ACTIONS(1192),
    [anon_sym_LT_AMP] = ACTIONS(1192),
    [anon_sym_GT_AMP] = ACTIONS(1192),
    [anon_sym_LT_LT] = ACTIONS(1531),
    [anon_sym_LT_LT_DASH] = ACTIONS(1192),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [sym_comment] = ACTIONS(52),
  },
  [1081] = {
    [sym_file_descriptor] = ACTIONS(2375),
    [anon_sym_PIPE] = ACTIONS(2674),
    [anon_sym_RPAREN] = ACTIONS(2375),
    [anon_sym_PIPE_AMP] = ACTIONS(2375),
    [anon_sym_AMP_AMP] = ACTIONS(2375),
    [anon_sym_PIPE_PIPE] = ACTIONS(2375),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_GT] = ACTIONS(2674),
    [anon_sym_GT_GT] = ACTIONS(2375),
    [anon_sym_AMP_GT] = ACTIONS(2674),
    [anon_sym_AMP_GT_GT] = ACTIONS(2375),
    [anon_sym_LT_AMP] = ACTIONS(2375),
    [anon_sym_GT_AMP] = ACTIONS(2375),
    [anon_sym_LT_LT] = ACTIONS(2674),
    [anon_sym_LT_LT_DASH] = ACTIONS(2375),
    [anon_sym_BQUOTE] = ACTIONS(2375),
    [sym_comment] = ACTIONS(52),
  },
  [1082] = {
    [aux_sym_concatenation_repeat1] = STATE(1082),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(2568),
    [sym_variable_name] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1500),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1021),
    [sym_raw_string] = ACTIONS(1021),
    [anon_sym_DOLLAR] = ACTIONS(1500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1021),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [anon_sym_LT_LPAREN] = ACTIONS(1021),
    [anon_sym_GT_LPAREN] = ACTIONS(1021),
    [sym_word] = ACTIONS(1023),
    [sym_comment] = ACTIONS(52),
  },
  [1083] = {
    [sym_file_redirect] = STATE(1199),
    [sym_file_descriptor] = ACTIONS(1178),
    [anon_sym_PIPE] = ACTIONS(2607),
    [anon_sym_PIPE_AMP] = ACTIONS(2609),
    [anon_sym_AMP_AMP] = ACTIONS(2609),
    [anon_sym_PIPE_PIPE] = ACTIONS(2609),
    [anon_sym_LT] = ACTIONS(1180),
    [anon_sym_GT] = ACTIONS(1180),
    [anon_sym_GT_GT] = ACTIONS(1182),
    [anon_sym_AMP_GT] = ACTIONS(1180),
    [anon_sym_AMP_GT_GT] = ACTIONS(1182),
    [anon_sym_LT_AMP] = ACTIONS(1182),
    [anon_sym_GT_AMP] = ACTIONS(1182),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_comment] = ACTIONS(52),
  },
  [1084] = {
    [aux_sym_concatenation_repeat1] = STATE(1085),
    [sym__concat] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_PIPE_AMP] = ACTIONS(690),
    [anon_sym_AMP_AMP] = ACTIONS(690),
    [anon_sym_PIPE_PIPE] = ACTIONS(690),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_comment] = ACTIONS(52),
  },
  [1085] = {
    [aux_sym_concatenation_repeat1] = STATE(1227),
    [sym__concat] = ACTIONS(2254),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_PIPE_AMP] = ACTIONS(440),
    [anon_sym_AMP_AMP] = ACTIONS(440),
    [anon_sym_PIPE_PIPE] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(440),
    [sym_comment] = ACTIONS(52),
  },
  [1086] = {
    [aux_sym_concatenation_repeat1] = STATE(1086),
    [sym_file_descriptor] = ACTIONS(1021),
    [sym__concat] = ACTIONS(2651),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [anon_sym_LT] = ACTIONS(1500),
    [anon_sym_GT] = ACTIONS(1500),
    [anon_sym_GT_GT] = ACTIONS(1021),
    [anon_sym_AMP_GT] = ACTIONS(1500),
    [anon_sym_AMP_GT_GT] = ACTIONS(1021),
    [anon_sym_LT_AMP] = ACTIONS(1021),
    [anon_sym_GT_AMP] = ACTIONS(1021),
    [anon_sym_LT_LT] = ACTIONS(1500),
    [anon_sym_LT_LT_DASH] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [1087] = {
    [sym__concat] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1002),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [anon_sym_SEMI_SEMI] = ACTIONS(1002),
    [anon_sym_PIPE_AMP] = ACTIONS(1002),
    [anon_sym_AMP_AMP] = ACTIONS(1002),
    [anon_sym_PIPE_PIPE] = ACTIONS(1002),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1002),
    [anon_sym_LF] = ACTIONS(1002),
    [anon_sym_AMP] = ACTIONS(1002),
  },
  [1088] = {
    [sym__concat] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [1089] = {
    [aux_sym_concatenation_repeat1] = STATE(1089),
    [sym__concat] = ACTIONS(2676),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [1090] = {
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [sym_comment] = ACTIONS(52),
  },
  [1091] = {
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [sym_comment] = ACTIONS(52),
  },
  [1092] = {
    [sym__concat] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [anon_sym_PIPE_AMP] = ACTIONS(1038),
    [anon_sym_AMP_AMP] = ACTIONS(1038),
    [anon_sym_PIPE_PIPE] = ACTIONS(1038),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
  },
  [1093] = {
    [anon_sym_AT] = ACTIONS(2687),
    [sym_comment] = ACTIONS(52),
  },
  [1094] = {
    [sym_concatenation] = STATE(1234),
    [sym_string] = STATE(1233),
    [sym_simple_expansion] = STATE(1233),
    [sym_expansion] = STATE(1233),
    [sym_command_substitution] = STATE(1233),
    [sym_process_substitution] = STATE(1233),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2689),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2691),
    [sym_comment] = ACTIONS(52),
  },
  [1095] = {
    [sym__concat] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1048),
    [anon_sym_RPAREN] = ACTIONS(1048),
    [anon_sym_SEMI_SEMI] = ACTIONS(1048),
    [anon_sym_PIPE_AMP] = ACTIONS(1048),
    [anon_sym_AMP_AMP] = ACTIONS(1048),
    [anon_sym_PIPE_PIPE] = ACTIONS(1048),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1048),
    [anon_sym_LF] = ACTIONS(1048),
    [anon_sym_AMP] = ACTIONS(1048),
  },
  [1096] = {
    [anon_sym_AT] = ACTIONS(2693),
    [sym_comment] = ACTIONS(52),
  },
  [1097] = {
    [sym_concatenation] = STATE(1237),
    [sym_string] = STATE(1236),
    [sym_simple_expansion] = STATE(1236),
    [sym_expansion] = STATE(1236),
    [sym_command_substitution] = STATE(1236),
    [sym_process_substitution] = STATE(1236),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2695),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2697),
    [sym_comment] = ACTIONS(52),
  },
  [1098] = {
    [sym__concat] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1138),
    [anon_sym_RPAREN] = ACTIONS(1138),
    [anon_sym_SEMI_SEMI] = ACTIONS(1138),
    [anon_sym_PIPE_AMP] = ACTIONS(1138),
    [anon_sym_AMP_AMP] = ACTIONS(1138),
    [anon_sym_PIPE_PIPE] = ACTIONS(1138),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_LF] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1138),
  },
  [1099] = {
    [sym__concat] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1194),
    [anon_sym_RPAREN] = ACTIONS(1194),
    [anon_sym_SEMI_SEMI] = ACTIONS(1194),
    [anon_sym_PIPE_AMP] = ACTIONS(1194),
    [anon_sym_AMP_AMP] = ACTIONS(1194),
    [anon_sym_PIPE_PIPE] = ACTIONS(1194),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1194),
    [anon_sym_LF] = ACTIONS(1194),
    [anon_sym_AMP] = ACTIONS(1194),
  },
  [1100] = {
    [sym_file_descriptor] = ACTIONS(1599),
    [sym__concat] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1601),
    [anon_sym_SEMI_SEMI] = ACTIONS(1601),
    [anon_sym_PIPE_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE] = ACTIONS(1601),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_AMP_GT] = ACTIONS(1601),
    [anon_sym_AMP_GT_GT] = ACTIONS(1601),
    [anon_sym_LT_AMP] = ACTIONS(1601),
    [anon_sym_GT_AMP] = ACTIONS(1601),
    [anon_sym_LT_LT] = ACTIONS(1601),
    [anon_sym_LT_LT_DASH] = ACTIONS(1601),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_LF] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
  },
  [1101] = {
    [anon_sym_AT] = ACTIONS(2699),
    [sym_comment] = ACTIONS(52),
  },
  [1102] = {
    [sym_file_descriptor] = ACTIONS(1605),
    [sym__concat] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1607),
    [anon_sym_RPAREN] = ACTIONS(1607),
    [anon_sym_SEMI_SEMI] = ACTIONS(1607),
    [anon_sym_PIPE_AMP] = ACTIONS(1607),
    [anon_sym_AMP_AMP] = ACTIONS(1607),
    [anon_sym_PIPE_PIPE] = ACTIONS(1607),
    [anon_sym_LT] = ACTIONS(1607),
    [anon_sym_GT] = ACTIONS(1607),
    [anon_sym_GT_GT] = ACTIONS(1607),
    [anon_sym_AMP_GT] = ACTIONS(1607),
    [anon_sym_AMP_GT_GT] = ACTIONS(1607),
    [anon_sym_LT_AMP] = ACTIONS(1607),
    [anon_sym_GT_AMP] = ACTIONS(1607),
    [anon_sym_LT_LT] = ACTIONS(1607),
    [anon_sym_LT_LT_DASH] = ACTIONS(1607),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_LF] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
  },
  [1103] = {
    [anon_sym_AT] = ACTIONS(2701),
    [sym_comment] = ACTIONS(52),
  },
  [1104] = {
    [anon_sym_RBRACK] = ACTIONS(2703),
    [sym_comment] = ACTIONS(52),
  },
  [1105] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2705),
    [sym_comment] = ACTIONS(52),
  },
  [1106] = {
    [anon_sym_RBRACE] = ACTIONS(2705),
    [sym_comment] = ACTIONS(52),
  },
  [1107] = {
    [anon_sym_RBRACK] = ACTIONS(2707),
    [sym_comment] = ACTIONS(52),
  },
  [1108] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2709),
    [sym_comment] = ACTIONS(52),
  },
  [1109] = {
    [anon_sym_RBRACE] = ACTIONS(2709),
    [sym_comment] = ACTIONS(52),
  },
  [1110] = {
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [sym_comment] = ACTIONS(52),
  },
  [1111] = {
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [sym_comment] = ACTIONS(52),
  },
  [1112] = {
    [sym__heredoc_middle] = ACTIONS(1036),
    [sym__heredoc_end] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(1513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [1113] = {
    [anon_sym_AT] = ACTIONS(2719),
    [sym_comment] = ACTIONS(52),
  },
  [1114] = {
    [sym_concatenation] = STATE(1250),
    [sym_string] = STATE(1249),
    [sym_simple_expansion] = STATE(1249),
    [sym_expansion] = STATE(1249),
    [sym_command_substitution] = STATE(1249),
    [sym_process_substitution] = STATE(1249),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2721),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2723),
    [sym_comment] = ACTIONS(52),
  },
  [1115] = {
    [sym__heredoc_middle] = ACTIONS(1046),
    [sym__heredoc_end] = ACTIONS(1046),
    [anon_sym_DOLLAR] = ACTIONS(1521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [sym_comment] = ACTIONS(52),
  },
  [1116] = {
    [anon_sym_AT] = ACTIONS(2725),
    [sym_comment] = ACTIONS(52),
  },
  [1117] = {
    [sym_concatenation] = STATE(1253),
    [sym_string] = STATE(1252),
    [sym_simple_expansion] = STATE(1252),
    [sym_expansion] = STATE(1252),
    [sym_command_substitution] = STATE(1252),
    [sym_process_substitution] = STATE(1252),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2727),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2729),
    [sym_comment] = ACTIONS(52),
  },
  [1118] = {
    [sym_file_descriptor] = ACTIONS(1951),
    [sym_variable_name] = ACTIONS(1951),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(1951),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(1951),
    [anon_sym_LT_AMP] = ACTIONS(1951),
    [anon_sym_GT_AMP] = ACTIONS(1951),
    [anon_sym_DQUOTE] = ACTIONS(1951),
    [sym_raw_string] = ACTIONS(1951),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1951),
    [anon_sym_BQUOTE] = ACTIONS(1951),
    [anon_sym_LT_LPAREN] = ACTIONS(1951),
    [anon_sym_GT_LPAREN] = ACTIONS(1951),
    [sym_word] = ACTIONS(2566),
    [sym_comment] = ACTIONS(52),
  },
  [1119] = {
    [anon_sym_RBRACK] = ACTIONS(2731),
    [sym_comment] = ACTIONS(52),
  },
  [1120] = {
    [anon_sym_RBRACK] = ACTIONS(2733),
    [sym_comment] = ACTIONS(52),
  },
  [1121] = {
    [anon_sym_RBRACE] = ACTIONS(2735),
    [sym_comment] = ACTIONS(52),
  },
  [1122] = {
    [sym__concat] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2162),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_RBRACK] = ACTIONS(2162),
    [sym_comment] = ACTIONS(52),
  },
  [1123] = {
    [anon_sym_RBRACE] = ACTIONS(2737),
    [sym_comment] = ACTIONS(52),
  },
  [1124] = {
    [sym__concat] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2168),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_RBRACK] = ACTIONS(2168),
    [sym_comment] = ACTIONS(52),
  },
  [1125] = {
    [sym__concat] = ACTIONS(1599),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_raw_string] = ACTIONS(1599),
    [anon_sym_DOLLAR] = ACTIONS(2104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1599),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_LT_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_LPAREN] = ACTIONS(1599),
    [sym_word] = ACTIONS(2104),
    [sym_comment] = ACTIONS(52),
  },
  [1126] = {
    [anon_sym_AT] = ACTIONS(2739),
    [sym_comment] = ACTIONS(52),
  },
  [1127] = {
    [sym__concat] = ACTIONS(1605),
    [anon_sym_RPAREN] = ACTIONS(1605),
    [anon_sym_DQUOTE] = ACTIONS(1605),
    [sym_raw_string] = ACTIONS(1605),
    [anon_sym_DOLLAR] = ACTIONS(2108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [anon_sym_LT_LPAREN] = ACTIONS(1605),
    [anon_sym_GT_LPAREN] = ACTIONS(1605),
    [sym_word] = ACTIONS(2108),
    [sym_comment] = ACTIONS(52),
  },
  [1128] = {
    [anon_sym_AT] = ACTIONS(2741),
    [sym_comment] = ACTIONS(52),
  },
  [1129] = {
    [anon_sym_RBRACK] = ACTIONS(2743),
    [sym_comment] = ACTIONS(52),
  },
  [1130] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [sym_comment] = ACTIONS(52),
  },
  [1131] = {
    [anon_sym_RBRACE] = ACTIONS(2745),
    [sym_comment] = ACTIONS(52),
  },
  [1132] = {
    [anon_sym_RBRACK] = ACTIONS(2747),
    [sym_comment] = ACTIONS(52),
  },
  [1133] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [sym_comment] = ACTIONS(52),
  },
  [1134] = {
    [anon_sym_RBRACE] = ACTIONS(2749),
    [sym_comment] = ACTIONS(52),
  },
  [1135] = {
    [anon_sym_RBRACK] = ACTIONS(2751),
    [sym_comment] = ACTIONS(52),
  },
  [1136] = {
    [anon_sym_RBRACK] = ACTIONS(2753),
    [sym_comment] = ACTIONS(52),
  },
  [1137] = {
    [anon_sym_RBRACE] = ACTIONS(2755),
    [sym_comment] = ACTIONS(52),
  },
  [1138] = {
    [sym_file_descriptor] = ACTIONS(2162),
    [sym__concat] = ACTIONS(2162),
    [sym_variable_name] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2164),
    [anon_sym_RPAREN] = ACTIONS(2164),
    [anon_sym_SEMI_SEMI] = ACTIONS(2164),
    [anon_sym_PIPE_AMP] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_PIPE_PIPE] = ACTIONS(2164),
    [anon_sym_LT] = ACTIONS(2164),
    [anon_sym_GT] = ACTIONS(2164),
    [anon_sym_GT_GT] = ACTIONS(2164),
    [anon_sym_AMP_GT] = ACTIONS(2164),
    [anon_sym_AMP_GT_GT] = ACTIONS(2164),
    [anon_sym_LT_AMP] = ACTIONS(2164),
    [anon_sym_GT_AMP] = ACTIONS(2164),
    [anon_sym_DQUOTE] = ACTIONS(2164),
    [sym_raw_string] = ACTIONS(2164),
    [anon_sym_DOLLAR] = ACTIONS(2164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2164),
    [anon_sym_BQUOTE] = ACTIONS(2164),
    [anon_sym_LT_LPAREN] = ACTIONS(2164),
    [anon_sym_GT_LPAREN] = ACTIONS(2164),
    [sym_word] = ACTIONS(2164),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym_LF] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2164),
  },
  [1139] = {
    [anon_sym_RBRACE] = ACTIONS(2757),
    [sym_comment] = ACTIONS(52),
  },
  [1140] = {
    [sym_file_descriptor] = ACTIONS(2168),
    [sym__concat] = ACTIONS(2168),
    [sym_variable_name] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_SEMI_SEMI] = ACTIONS(2170),
    [anon_sym_PIPE_AMP] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2170),
    [anon_sym_GT_GT] = ACTIONS(2170),
    [anon_sym_AMP_GT] = ACTIONS(2170),
    [anon_sym_AMP_GT_GT] = ACTIONS(2170),
    [anon_sym_LT_AMP] = ACTIONS(2170),
    [anon_sym_GT_AMP] = ACTIONS(2170),
    [anon_sym_DQUOTE] = ACTIONS(2170),
    [sym_raw_string] = ACTIONS(2170),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2170),
    [anon_sym_BQUOTE] = ACTIONS(2170),
    [anon_sym_LT_LPAREN] = ACTIONS(2170),
    [anon_sym_GT_LPAREN] = ACTIONS(2170),
    [sym_word] = ACTIONS(2170),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_LF] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
  },
  [1141] = {
    [sym__concat] = ACTIONS(1599),
    [anon_sym_SEMI_SEMI] = ACTIONS(1601),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [sym_raw_string] = ACTIONS(1601),
    [anon_sym_DOLLAR] = ACTIONS(1601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1601),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1601),
    [anon_sym_BQUOTE] = ACTIONS(1601),
    [anon_sym_LT_LPAREN] = ACTIONS(1601),
    [anon_sym_GT_LPAREN] = ACTIONS(1601),
    [sym_word] = ACTIONS(1601),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_LF] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
  },
  [1142] = {
    [anon_sym_AT] = ACTIONS(2759),
    [sym_comment] = ACTIONS(52),
  },
  [1143] = {
    [sym__concat] = ACTIONS(1605),
    [anon_sym_SEMI_SEMI] = ACTIONS(1607),
    [anon_sym_DQUOTE] = ACTIONS(1607),
    [sym_raw_string] = ACTIONS(1607),
    [anon_sym_DOLLAR] = ACTIONS(1607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1607),
    [anon_sym_BQUOTE] = ACTIONS(1607),
    [anon_sym_LT_LPAREN] = ACTIONS(1607),
    [anon_sym_GT_LPAREN] = ACTIONS(1607),
    [sym_word] = ACTIONS(1607),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_LF] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
  },
  [1144] = {
    [anon_sym_AT] = ACTIONS(2761),
    [sym_comment] = ACTIONS(52),
  },
  [1145] = {
    [anon_sym_RBRACK] = ACTIONS(2763),
    [sym_comment] = ACTIONS(52),
  },
  [1146] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [sym_comment] = ACTIONS(52),
  },
  [1147] = {
    [anon_sym_RBRACE] = ACTIONS(2765),
    [sym_comment] = ACTIONS(52),
  },
  [1148] = {
    [anon_sym_RBRACK] = ACTIONS(2767),
    [sym_comment] = ACTIONS(52),
  },
  [1149] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [sym_comment] = ACTIONS(52),
  },
  [1150] = {
    [anon_sym_RBRACE] = ACTIONS(2769),
    [sym_comment] = ACTIONS(52),
  },
  [1151] = {
    [sym__terminated_statement] = STATE(432),
    [sym_for_statement] = STATE(433),
    [sym_while_statement] = STATE(433),
    [sym_if_statement] = STATE(433),
    [sym_case_statement] = STATE(433),
    [sym_function_definition] = STATE(433),
    [sym_subshell] = STATE(433),
    [sym_pipeline] = STATE(433),
    [sym_list] = STATE(433),
    [sym_bracket_command] = STATE(433),
    [sym_command] = STATE(433),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(436),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(720),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_fi] = ACTIONS(2771),
    [anon_sym_elif] = ACTIONS(2771),
    [anon_sym_else] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [1152] = {
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_SEMI_SEMI] = ACTIONS(2773),
    [anon_sym_PIPE_AMP] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2773),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_LF] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2773),
  },
  [1153] = {
    [aux_sym_concatenation_repeat1] = STATE(974),
    [sym__concat] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(2775),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [sym_comment] = ACTIONS(52),
  },
  [1154] = {
    [anon_sym_PIPE] = ACTIONS(2775),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [sym_comment] = ACTIONS(52),
  },
  [1155] = {
    [anon_sym_esac] = ACTIONS(2777),
    [anon_sym_DQUOTE] = ACTIONS(2779),
    [sym_raw_string] = ACTIONS(2779),
    [anon_sym_DOLLAR] = ACTIONS(2777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2779),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2779),
    [anon_sym_BQUOTE] = ACTIONS(2779),
    [anon_sym_LT_LPAREN] = ACTIONS(2779),
    [anon_sym_GT_LPAREN] = ACTIONS(2779),
    [sym_word] = ACTIONS(2781),
    [sym_comment] = ACTIONS(52),
  },
  [1156] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1275),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [1157] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1276),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [1158] = {
    [aux_sym_case_item_repeat1] = STATE(1158),
    [anon_sym_PIPE] = ACTIONS(2785),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [sym_comment] = ACTIONS(52),
  },
  [1159] = {
    [aux_sym_concatenation_repeat1] = STATE(1159),
    [sym__concat] = ACTIONS(1900),
    [anon_sym_PIPE] = ACTIONS(1021),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [1160] = {
    [anon_sym_PIPE] = ACTIONS(2788),
    [anon_sym_RPAREN] = ACTIONS(2788),
    [anon_sym_SEMI_SEMI] = ACTIONS(2788),
    [anon_sym_PIPE_AMP] = ACTIONS(2788),
    [anon_sym_AMP_AMP] = ACTIONS(2788),
    [anon_sym_PIPE_PIPE] = ACTIONS(2788),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2788),
    [anon_sym_LF] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2788),
  },
  [1161] = {
    [anon_sym_RBRACE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(52),
  },
  [1162] = {
    [anon_sym_RBRACE] = ACTIONS(2792),
    [sym_comment] = ACTIONS(52),
  },
  [1163] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_in] = ACTIONS(2560),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2560),
  },
  [1164] = {
    [sym__concat] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2564),
  },
  [1165] = {
    [aux_sym_concatenation_repeat1] = STATE(1165),
    [sym__concat] = ACTIONS(2676),
    [anon_sym_PIPE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_SEMI_SEMI] = ACTIONS(1023),
    [anon_sym_PIPE_AMP] = ACTIONS(1023),
    [anon_sym_AMP_AMP] = ACTIONS(1023),
    [anon_sym_PIPE_PIPE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1023),
    [anon_sym_LF] = ACTIONS(1023),
    [anon_sym_AMP] = ACTIONS(1023),
  },
  [1166] = {
    [anon_sym_RBRACE] = ACTIONS(2794),
    [sym_comment] = ACTIONS(52),
  },
  [1167] = {
    [anon_sym_RBRACE] = ACTIONS(2796),
    [sym_comment] = ACTIONS(52),
  },
  [1168] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_RBRACK] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [anon_sym_LT_LPAREN] = ACTIONS(2558),
    [anon_sym_GT_LPAREN] = ACTIONS(2558),
    [sym_word] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [1169] = {
    [sym__concat] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_RBRACK] = ACTIONS(2800),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_word] = ACTIONS(2564),
    [sym_comment] = ACTIONS(52),
  },
  [1170] = {
    [anon_sym_RBRACE] = ACTIONS(2802),
    [sym_comment] = ACTIONS(52),
  },
  [1171] = {
    [anon_sym_RBRACE] = ACTIONS(2804),
    [sym_comment] = ACTIONS(52),
  },
  [1172] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2798),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [anon_sym_LT_LPAREN] = ACTIONS(2558),
    [anon_sym_GT_LPAREN] = ACTIONS(2558),
    [sym_word] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [1173] = {
    [sym__concat] = ACTIONS(2562),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2800),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_word] = ACTIONS(2564),
    [sym_comment] = ACTIONS(52),
  },
  [1174] = {
    [anon_sym_RBRACE] = ACTIONS(2806),
    [sym_comment] = ACTIONS(52),
  },
  [1175] = {
    [anon_sym_RBRACE] = ACTIONS(2808),
    [sym_comment] = ACTIONS(52),
  },
  [1176] = {
    [sym_file_descriptor] = ACTIONS(2558),
    [sym__concat] = ACTIONS(2558),
    [sym_variable_name] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_GT] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT] = ACTIONS(2798),
    [anon_sym_AMP_GT_GT] = ACTIONS(2558),
    [anon_sym_LT_AMP] = ACTIONS(2558),
    [anon_sym_GT_AMP] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [anon_sym_LT_LPAREN] = ACTIONS(2558),
    [anon_sym_GT_LPAREN] = ACTIONS(2558),
    [sym_word] = ACTIONS(2798),
    [sym_comment] = ACTIONS(52),
  },
  [1177] = {
    [sym_file_descriptor] = ACTIONS(2562),
    [sym__concat] = ACTIONS(2562),
    [sym_variable_name] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2800),
    [anon_sym_GT] = ACTIONS(2800),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2800),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_word] = ACTIONS(2800),
    [sym_comment] = ACTIONS(52),
  },
  [1178] = {
    [anon_sym_RBRACE] = ACTIONS(2810),
    [sym_comment] = ACTIONS(52),
  },
  [1179] = {
    [anon_sym_RBRACE] = ACTIONS(2812),
    [sym_comment] = ACTIONS(52),
  },
  [1180] = {
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2798),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(150),
  },
  [1181] = {
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2800),
    [anon_sym_DOLLAR] = ACTIONS(2564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2564),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(150),
  },
  [1182] = {
    [sym_file_descriptor] = ACTIONS(2814),
    [sym__concat] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2816),
    [anon_sym_RPAREN] = ACTIONS(2816),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [anon_sym_PIPE_AMP] = ACTIONS(2816),
    [anon_sym_AMP_AMP] = ACTIONS(2816),
    [anon_sym_PIPE_PIPE] = ACTIONS(2816),
    [anon_sym_LT] = ACTIONS(2816),
    [anon_sym_GT] = ACTIONS(2816),
    [anon_sym_GT_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT_GT] = ACTIONS(2816),
    [anon_sym_LT_AMP] = ACTIONS(2816),
    [anon_sym_GT_AMP] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2816),
    [anon_sym_LT_LT_DASH] = ACTIONS(2816),
    [anon_sym_DQUOTE] = ACTIONS(2816),
    [sym_raw_string] = ACTIONS(2816),
    [anon_sym_DOLLAR] = ACTIONS(2816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2816),
    [anon_sym_BQUOTE] = ACTIONS(2816),
    [anon_sym_LT_LPAREN] = ACTIONS(2816),
    [anon_sym_GT_LPAREN] = ACTIONS(2816),
    [sym_word] = ACTIONS(2816),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2816),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2816),
  },
  [1183] = {
    [sym_file_descriptor] = ACTIONS(2818),
    [sym__concat] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2820),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_SEMI_SEMI] = ACTIONS(2820),
    [anon_sym_PIPE_AMP] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_PIPE_PIPE] = ACTIONS(2820),
    [anon_sym_LT] = ACTIONS(2820),
    [anon_sym_GT] = ACTIONS(2820),
    [anon_sym_GT_GT] = ACTIONS(2820),
    [anon_sym_AMP_GT] = ACTIONS(2820),
    [anon_sym_AMP_GT_GT] = ACTIONS(2820),
    [anon_sym_LT_AMP] = ACTIONS(2820),
    [anon_sym_GT_AMP] = ACTIONS(2820),
    [anon_sym_LT_LT] = ACTIONS(2820),
    [anon_sym_LT_LT_DASH] = ACTIONS(2820),
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [sym_raw_string] = ACTIONS(2820),
    [anon_sym_DOLLAR] = ACTIONS(2820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2820),
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [anon_sym_LT_LPAREN] = ACTIONS(2820),
    [anon_sym_GT_LPAREN] = ACTIONS(2820),
    [sym_word] = ACTIONS(2820),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_LF] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2820),
  },
  [1184] = {
    [sym_file_descriptor] = ACTIONS(1599),
    [sym__concat] = ACTIONS(1599),
    [sym_variable_name] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(2104),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_PIPE_AMP] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(2104),
    [anon_sym_LT] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(2104),
    [anon_sym_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_GT] = ACTIONS(2104),
    [anon_sym_AMP_GT_GT] = ACTIONS(1599),
    [anon_sym_LT_AMP] = ACTIONS(1599),
    [anon_sym_GT_AMP] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1599),
    [sym_raw_string] = ACTIONS(1599),
    [anon_sym_DOLLAR] = ACTIONS(2104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1599),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1599),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [anon_sym_LT_LPAREN] = ACTIONS(1599),
    [anon_sym_GT_LPAREN] = ACTIONS(1599),
    [sym_word] = ACTIONS(1601),
    [sym_comment] = ACTIONS(52),
  },
  [1185] = {
    [anon_sym_AT] = ACTIONS(2822),
    [sym_comment] = ACTIONS(52),
  },
  [1186] = {
    [sym_file_descriptor] = ACTIONS(1605),
    [sym__concat] = ACTIONS(1605),
    [sym_variable_name] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(2108),
    [anon_sym_RPAREN] = ACTIONS(1605),
    [anon_sym_PIPE_AMP] = ACTIONS(1605),
    [anon_sym_AMP_AMP] = ACTIONS(1605),
    [anon_sym_PIPE_PIPE] = ACTIONS(2108),
    [anon_sym_LT] = ACTIONS(2108),
    [anon_sym_GT] = ACTIONS(2108),
    [anon_sym_GT_GT] = ACTIONS(1605),
    [anon_sym_AMP_GT] = ACTIONS(2108),
    [anon_sym_AMP_GT_GT] = ACTIONS(1605),
    [anon_sym_LT_AMP] = ACTIONS(1605),
    [anon_sym_GT_AMP] = ACTIONS(1605),
    [anon_sym_DQUOTE] = ACTIONS(1605),
    [sym_raw_string] = ACTIONS(1605),
    [anon_sym_DOLLAR] = ACTIONS(2108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1605),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [anon_sym_LT_LPAREN] = ACTIONS(1605),
    [anon_sym_GT_LPAREN] = ACTIONS(1605),
    [sym_word] = ACTIONS(1607),
    [sym_comment] = ACTIONS(52),
  },
  [1187] = {
    [anon_sym_AT] = ACTIONS(2824),
    [sym_comment] = ACTIONS(52),
  },
  [1188] = {
    [anon_sym_RBRACK] = ACTIONS(2826),
    [sym_comment] = ACTIONS(52),
  },
  [1189] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2828),
    [sym_comment] = ACTIONS(52),
  },
  [1190] = {
    [anon_sym_RBRACE] = ACTIONS(2828),
    [sym_comment] = ACTIONS(52),
  },
  [1191] = {
    [anon_sym_RBRACK] = ACTIONS(2830),
    [sym_comment] = ACTIONS(52),
  },
  [1192] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2832),
    [sym_comment] = ACTIONS(52),
  },
  [1193] = {
    [anon_sym_RBRACE] = ACTIONS(2832),
    [sym_comment] = ACTIONS(52),
  },
  [1194] = {
    [anon_sym_PIPE] = ACTIONS(2834),
    [anon_sym_RPAREN] = ACTIONS(2836),
    [anon_sym_PIPE_AMP] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_PIPE_PIPE] = ACTIONS(2836),
    [anon_sym_BQUOTE] = ACTIONS(2836),
    [sym_comment] = ACTIONS(52),
  },
  [1195] = {
    [anon_sym_PIPE] = ACTIONS(2838),
    [anon_sym_RPAREN] = ACTIONS(2840),
    [anon_sym_PIPE_AMP] = ACTIONS(2840),
    [anon_sym_AMP_AMP] = ACTIONS(2840),
    [anon_sym_PIPE_PIPE] = ACTIONS(2840),
    [anon_sym_BQUOTE] = ACTIONS(2840),
    [sym_comment] = ACTIONS(52),
  },
  [1196] = {
    [anon_sym_fi] = ACTIONS(2842),
    [sym_comment] = ACTIONS(52),
  },
  [1197] = {
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_RPAREN] = ACTIONS(2846),
    [anon_sym_PIPE_AMP] = ACTIONS(2846),
    [anon_sym_AMP_AMP] = ACTIONS(2846),
    [anon_sym_PIPE_PIPE] = ACTIONS(2846),
    [anon_sym_BQUOTE] = ACTIONS(2846),
    [sym_comment] = ACTIONS(52),
  },
  [1198] = {
    [sym_case_item] = STATE(725),
    [sym_concatenation] = STATE(726),
    [sym_string] = STATE(724),
    [sym_simple_expansion] = STATE(724),
    [sym_expansion] = STATE(724),
    [sym_command_substitution] = STATE(724),
    [sym_process_substitution] = STATE(724),
    [aux_sym_case_statement_repeat1] = STATE(976),
    [anon_sym_esac] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(270),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(278),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [anon_sym_LT_LPAREN] = ACTIONS(282),
    [anon_sym_GT_LPAREN] = ACTIONS(282),
    [sym_word] = ACTIONS(1442),
    [sym_comment] = ACTIONS(52),
  },
  [1199] = {
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_RPAREN] = ACTIONS(2852),
    [anon_sym_PIPE_AMP] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_BQUOTE] = ACTIONS(2852),
    [sym_comment] = ACTIONS(52),
  },
  [1200] = {
    [anon_sym_RBRACE] = ACTIONS(2854),
    [sym_comment] = ACTIONS(52),
  },
  [1201] = {
    [anon_sym_RBRACE] = ACTIONS(2856),
    [sym_comment] = ACTIONS(52),
  },
  [1202] = {
    [sym_file_descriptor] = ACTIONS(2558),
    [sym__concat] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2798),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_PIPE_AMP] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_GT] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT] = ACTIONS(2798),
    [anon_sym_AMP_GT_GT] = ACTIONS(2558),
    [anon_sym_LT_AMP] = ACTIONS(2558),
    [anon_sym_GT_AMP] = ACTIONS(2558),
    [anon_sym_LT_LT] = ACTIONS(2798),
    [anon_sym_LT_LT_DASH] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [anon_sym_LT_LPAREN] = ACTIONS(2558),
    [anon_sym_GT_LPAREN] = ACTIONS(2558),
    [sym_word] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [1203] = {
    [sym_file_descriptor] = ACTIONS(2562),
    [sym__concat] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2800),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2800),
    [anon_sym_GT] = ACTIONS(2800),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2800),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2800),
    [anon_sym_LT_LT_DASH] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_word] = ACTIONS(2564),
    [sym_comment] = ACTIONS(52),
  },
  [1204] = {
    [sym__concat] = ACTIONS(1000),
    [anon_sym_PIPE] = ACTIONS(1498),
    [anon_sym_RPAREN] = ACTIONS(1000),
    [anon_sym_PIPE_AMP] = ACTIONS(1000),
    [anon_sym_AMP_AMP] = ACTIONS(1000),
    [anon_sym_PIPE_PIPE] = ACTIONS(1000),
    [anon_sym_BQUOTE] = ACTIONS(1000),
    [sym_comment] = ACTIONS(52),
  },
  [1205] = {
    [sym__concat] = ACTIONS(1021),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [1206] = {
    [aux_sym_concatenation_repeat1] = STATE(1206),
    [sym__concat] = ACTIONS(2858),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [1207] = {
    [anon_sym_RBRACE] = ACTIONS(2861),
    [anon_sym_LBRACK] = ACTIONS(2863),
    [sym_comment] = ACTIONS(52),
  },
  [1208] = {
    [anon_sym_RBRACE] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(2867),
    [sym_comment] = ACTIONS(52),
  },
  [1209] = {
    [sym__concat] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [sym_comment] = ACTIONS(52),
  },
  [1210] = {
    [anon_sym_AT] = ACTIONS(2869),
    [sym_comment] = ACTIONS(52),
  },
  [1211] = {
    [sym_concatenation] = STATE(1303),
    [sym_string] = STATE(1302),
    [sym_simple_expansion] = STATE(1302),
    [sym_expansion] = STATE(1302),
    [sym_command_substitution] = STATE(1302),
    [sym_process_substitution] = STATE(1302),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2873),
    [sym_comment] = ACTIONS(52),
  },
  [1212] = {
    [sym__concat] = ACTIONS(1046),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [anon_sym_PIPE_AMP] = ACTIONS(1046),
    [anon_sym_AMP_AMP] = ACTIONS(1046),
    [anon_sym_PIPE_PIPE] = ACTIONS(1046),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [sym_comment] = ACTIONS(52),
  },
  [1213] = {
    [anon_sym_AT] = ACTIONS(2875),
    [sym_comment] = ACTIONS(52),
  },
  [1214] = {
    [sym_concatenation] = STATE(1306),
    [sym_string] = STATE(1305),
    [sym_simple_expansion] = STATE(1305),
    [sym_expansion] = STATE(1305),
    [sym_command_substitution] = STATE(1305),
    [sym_process_substitution] = STATE(1305),
    [anon_sym_DQUOTE] = ACTIONS(90),
    [sym_raw_string] = ACTIONS(2877),
    [anon_sym_DOLLAR] = ACTIONS(94),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(96),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(98),
    [anon_sym_BQUOTE] = ACTIONS(100),
    [anon_sym_LT_LPAREN] = ACTIONS(102),
    [anon_sym_GT_LPAREN] = ACTIONS(102),
    [sym_word] = ACTIONS(2879),
    [sym_comment] = ACTIONS(52),
  },
  [1215] = {
    [sym__concat] = ACTIONS(1136),
    [anon_sym_PIPE] = ACTIONS(1529),
    [anon_sym_RPAREN] = ACTIONS(1136),
    [anon_sym_PIPE_AMP] = ACTIONS(1136),
    [anon_sym_AMP_AMP] = ACTIONS(1136),
    [anon_sym_PIPE_PIPE] = ACTIONS(1136),
    [anon_sym_BQUOTE] = ACTIONS(1136),
    [sym_comment] = ACTIONS(52),
  },
  [1216] = {
    [sym__concat] = ACTIONS(1192),
    [anon_sym_PIPE] = ACTIONS(1531),
    [anon_sym_RPAREN] = ACTIONS(1192),
    [anon_sym_PIPE_AMP] = ACTIONS(1192),
    [anon_sym_AMP_AMP] = ACTIONS(1192),
    [anon_sym_PIPE_PIPE] = ACTIONS(1192),
    [anon_sym_BQUOTE] = ACTIONS(1192),
    [sym_comment] = ACTIONS(52),
  },
  [1217] = {
    [sym_file_descriptor] = ACTIONS(1599),
    [sym__concat] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(2104),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_PIPE_AMP] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(2104),
    [anon_sym_GT] = ACTIONS(2104),
    [anon_sym_GT_GT] = ACTIONS(1599),
    [anon_sym_AMP_GT] = ACTIONS(2104),
    [anon_sym_AMP_GT_GT] = ACTIONS(1599),
    [anon_sym_LT_AMP] = ACTIONS(1599),
    [anon_sym_GT_AMP] = ACTIONS(1599),
    [anon_sym_LT_LT] = ACTIONS(2104),
    [anon_sym_LT_LT_DASH] = ACTIONS(1599),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(52),
  },
  [1218] = {
    [anon_sym_AT] = ACTIONS(2881),
    [sym_comment] = ACTIONS(52),
  },
  [1219] = {
    [sym_file_descriptor] = ACTIONS(1605),
    [sym__concat] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(2108),
    [anon_sym_RPAREN] = ACTIONS(1605),
    [anon_sym_PIPE_AMP] = ACTIONS(1605),
    [anon_sym_AMP_AMP] = ACTIONS(1605),
    [anon_sym_PIPE_PIPE] = ACTIONS(1605),
    [anon_sym_LT] = ACTIONS(2108),
    [anon_sym_GT] = ACTIONS(2108),
    [anon_sym_GT_GT] = ACTIONS(1605),
    [anon_sym_AMP_GT] = ACTIONS(2108),
    [anon_sym_AMP_GT_GT] = ACTIONS(1605),
    [anon_sym_LT_AMP] = ACTIONS(1605),
    [anon_sym_GT_AMP] = ACTIONS(1605),
    [anon_sym_LT_LT] = ACTIONS(2108),
    [anon_sym_LT_LT_DASH] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [sym_comment] = ACTIONS(52),
  },
  [1220] = {
    [anon_sym_AT] = ACTIONS(2883),
    [sym_comment] = ACTIONS(52),
  },
  [1221] = {
    [anon_sym_RBRACK] = ACTIONS(2885),
    [sym_comment] = ACTIONS(52),
  },
  [1222] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [sym_comment] = ACTIONS(52),
  },
  [1223] = {
    [anon_sym_RBRACE] = ACTIONS(2887),
    [sym_comment] = ACTIONS(52),
  },
  [1224] = {
    [anon_sym_RBRACK] = ACTIONS(2889),
    [sym_comment] = ACTIONS(52),
  },
  [1225] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [sym_comment] = ACTIONS(52),
  },
  [1226] = {
    [anon_sym_RBRACE] = ACTIONS(2891),
    [sym_comment] = ACTIONS(52),
  },
  [1227] = {
    [aux_sym_concatenation_repeat1] = STATE(1227),
    [sym__concat] = ACTIONS(2858),
    [anon_sym_PIPE] = ACTIONS(1500),
    [anon_sym_PIPE_AMP] = ACTIONS(1021),
    [anon_sym_AMP_AMP] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(1021),
    [anon_sym_BQUOTE] = ACTIONS(1021),
    [sym_comment] = ACTIONS(52),
  },
  [1228] = {
    [sym__concat] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_RPAREN] = ACTIONS(1601),
    [anon_sym_SEMI_SEMI] = ACTIONS(1601),
    [anon_sym_PIPE_AMP] = ACTIONS(1601),
    [anon_sym_AMP_AMP] = ACTIONS(1601),
    [anon_sym_PIPE_PIPE] = ACTIONS(1601),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_LF] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
  },
  [1229] = {
    [anon_sym_AT] = ACTIONS(2893),
    [sym_comment] = ACTIONS(52),
  },
  [1230] = {
    [sym__concat] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1607),
    [anon_sym_RPAREN] = ACTIONS(1607),
    [anon_sym_SEMI_SEMI] = ACTIONS(1607),
    [anon_sym_PIPE_AMP] = ACTIONS(1607),
    [anon_sym_AMP_AMP] = ACTIONS(1607),
    [anon_sym_PIPE_PIPE] = ACTIONS(1607),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(1607),
    [anon_sym_LF] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
  },
  [1231] = {
    [anon_sym_AT] = ACTIONS(2895),
    [sym_comment] = ACTIONS(52),
  },
  [1232] = {
    [anon_sym_RBRACK] = ACTIONS(2897),
    [sym_comment] = ACTIONS(52),
  },
  [1233] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(52),
  },
  [1234] = {
    [anon_sym_RBRACE] = ACTIONS(2899),
    [sym_comment] = ACTIONS(52),
  },
  [1235] = {
    [anon_sym_RBRACK] = ACTIONS(2901),
    [sym_comment] = ACTIONS(52),
  },
  [1236] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2903),
    [sym_comment] = ACTIONS(52),
  },
  [1237] = {
    [anon_sym_RBRACE] = ACTIONS(2903),
    [sym_comment] = ACTIONS(52),
  },
  [1238] = {
    [anon_sym_RBRACK] = ACTIONS(2905),
    [sym_comment] = ACTIONS(52),
  },
  [1239] = {
    [anon_sym_RBRACK] = ACTIONS(2907),
    [sym_comment] = ACTIONS(52),
  },
  [1240] = {
    [anon_sym_RBRACE] = ACTIONS(2909),
    [sym_comment] = ACTIONS(52),
  },
  [1241] = {
    [sym_file_descriptor] = ACTIONS(2162),
    [sym__concat] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2164),
    [anon_sym_RPAREN] = ACTIONS(2164),
    [anon_sym_SEMI_SEMI] = ACTIONS(2164),
    [anon_sym_PIPE_AMP] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_PIPE_PIPE] = ACTIONS(2164),
    [anon_sym_LT] = ACTIONS(2164),
    [anon_sym_GT] = ACTIONS(2164),
    [anon_sym_GT_GT] = ACTIONS(2164),
    [anon_sym_AMP_GT] = ACTIONS(2164),
    [anon_sym_AMP_GT_GT] = ACTIONS(2164),
    [anon_sym_LT_AMP] = ACTIONS(2164),
    [anon_sym_GT_AMP] = ACTIONS(2164),
    [anon_sym_LT_LT] = ACTIONS(2164),
    [anon_sym_LT_LT_DASH] = ACTIONS(2164),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym_LF] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2164),
  },
  [1242] = {
    [anon_sym_RBRACE] = ACTIONS(2911),
    [sym_comment] = ACTIONS(52),
  },
  [1243] = {
    [sym_file_descriptor] = ACTIONS(2168),
    [sym__concat] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_SEMI_SEMI] = ACTIONS(2170),
    [anon_sym_PIPE_AMP] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [anon_sym_LT] = ACTIONS(2170),
    [anon_sym_GT] = ACTIONS(2170),
    [anon_sym_GT_GT] = ACTIONS(2170),
    [anon_sym_AMP_GT] = ACTIONS(2170),
    [anon_sym_AMP_GT_GT] = ACTIONS(2170),
    [anon_sym_LT_AMP] = ACTIONS(2170),
    [anon_sym_GT_AMP] = ACTIONS(2170),
    [anon_sym_LT_LT] = ACTIONS(2170),
    [anon_sym_LT_LT_DASH] = ACTIONS(2170),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_LF] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
  },
  [1244] = {
    [sym__heredoc_middle] = ACTIONS(1599),
    [sym__heredoc_end] = ACTIONS(1599),
    [anon_sym_DOLLAR] = ACTIONS(2104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(52),
  },
  [1245] = {
    [anon_sym_AT] = ACTIONS(2913),
    [sym_comment] = ACTIONS(52),
  },
  [1246] = {
    [sym__heredoc_middle] = ACTIONS(1605),
    [sym__heredoc_end] = ACTIONS(1605),
    [anon_sym_DOLLAR] = ACTIONS(2108),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1605),
    [sym_comment] = ACTIONS(52),
  },
  [1247] = {
    [anon_sym_AT] = ACTIONS(2915),
    [sym_comment] = ACTIONS(52),
  },
  [1248] = {
    [anon_sym_RBRACK] = ACTIONS(2917),
    [sym_comment] = ACTIONS(52),
  },
  [1249] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [sym_comment] = ACTIONS(52),
  },
  [1250] = {
    [anon_sym_RBRACE] = ACTIONS(2919),
    [sym_comment] = ACTIONS(52),
  },
  [1251] = {
    [anon_sym_RBRACK] = ACTIONS(2921),
    [sym_comment] = ACTIONS(52),
  },
  [1252] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2923),
    [sym_comment] = ACTIONS(52),
  },
  [1253] = {
    [anon_sym_RBRACE] = ACTIONS(2923),
    [sym_comment] = ACTIONS(52),
  },
  [1254] = {
    [anon_sym_RBRACE] = ACTIONS(2925),
    [sym_comment] = ACTIONS(52),
  },
  [1255] = {
    [anon_sym_RBRACE] = ACTIONS(2927),
    [sym_comment] = ACTIONS(52),
  },
  [1256] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2558),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_RBRACK] = ACTIONS(2558),
    [sym_comment] = ACTIONS(52),
  },
  [1257] = {
    [sym__concat] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_RBRACK] = ACTIONS(2562),
    [sym_comment] = ACTIONS(52),
  },
  [1258] = {
    [anon_sym_RBRACK] = ACTIONS(2929),
    [sym_comment] = ACTIONS(52),
  },
  [1259] = {
    [anon_sym_RBRACK] = ACTIONS(2931),
    [sym_comment] = ACTIONS(52),
  },
  [1260] = {
    [anon_sym_RBRACE] = ACTIONS(2933),
    [sym_comment] = ACTIONS(52),
  },
  [1261] = {
    [sym__concat] = ACTIONS(2162),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_raw_string] = ACTIONS(2162),
    [anon_sym_DOLLAR] = ACTIONS(2524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2162),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_word] = ACTIONS(2524),
    [sym_comment] = ACTIONS(52),
  },
  [1262] = {
    [anon_sym_RBRACE] = ACTIONS(2935),
    [sym_comment] = ACTIONS(52),
  },
  [1263] = {
    [sym__concat] = ACTIONS(2168),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [sym_raw_string] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [anon_sym_LT_LPAREN] = ACTIONS(2168),
    [anon_sym_GT_LPAREN] = ACTIONS(2168),
    [sym_word] = ACTIONS(2528),
    [sym_comment] = ACTIONS(52),
  },
  [1264] = {
    [anon_sym_RBRACE] = ACTIONS(2937),
    [sym_comment] = ACTIONS(52),
  },
  [1265] = {
    [anon_sym_RBRACE] = ACTIONS(2939),
    [sym_comment] = ACTIONS(52),
  },
  [1266] = {
    [sym_file_descriptor] = ACTIONS(2558),
    [sym__concat] = ACTIONS(2558),
    [sym_variable_name] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(2560),
    [anon_sym_GT] = ACTIONS(2560),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_word] = ACTIONS(2560),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2560),
  },
  [1267] = {
    [sym_file_descriptor] = ACTIONS(2562),
    [sym__concat] = ACTIONS(2562),
    [sym_variable_name] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_GT] = ACTIONS(2564),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [sym_raw_string] = ACTIONS(2564),
    [anon_sym_DOLLAR] = ACTIONS(2564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2564),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [anon_sym_LT_LPAREN] = ACTIONS(2564),
    [anon_sym_GT_LPAREN] = ACTIONS(2564),
    [sym_word] = ACTIONS(2564),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2564),
  },
  [1268] = {
    [anon_sym_RBRACK] = ACTIONS(2941),
    [sym_comment] = ACTIONS(52),
  },
  [1269] = {
    [anon_sym_RBRACK] = ACTIONS(2943),
    [sym_comment] = ACTIONS(52),
  },
  [1270] = {
    [anon_sym_RBRACE] = ACTIONS(2945),
    [sym_comment] = ACTIONS(52),
  },
  [1271] = {
    [sym__concat] = ACTIONS(2162),
    [anon_sym_SEMI_SEMI] = ACTIONS(2164),
    [anon_sym_DQUOTE] = ACTIONS(2164),
    [sym_raw_string] = ACTIONS(2164),
    [anon_sym_DOLLAR] = ACTIONS(2164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2164),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2164),
    [anon_sym_BQUOTE] = ACTIONS(2164),
    [anon_sym_LT_LPAREN] = ACTIONS(2164),
    [anon_sym_GT_LPAREN] = ACTIONS(2164),
    [sym_word] = ACTIONS(2164),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym_LF] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2164),
  },
  [1272] = {
    [anon_sym_RBRACE] = ACTIONS(2947),
    [sym_comment] = ACTIONS(52),
  },
  [1273] = {
    [sym__concat] = ACTIONS(2168),
    [anon_sym_SEMI_SEMI] = ACTIONS(2170),
    [anon_sym_DQUOTE] = ACTIONS(2170),
    [sym_raw_string] = ACTIONS(2170),
    [anon_sym_DOLLAR] = ACTIONS(2170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2170),
    [anon_sym_BQUOTE] = ACTIONS(2170),
    [anon_sym_LT_LPAREN] = ACTIONS(2170),
    [anon_sym_GT_LPAREN] = ACTIONS(2170),
    [sym_word] = ACTIONS(2170),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_LF] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
  },
  [1274] = {
    [anon_sym_esac] = ACTIONS(2949),
    [anon_sym_DQUOTE] = ACTIONS(2951),
    [sym_raw_string] = ACTIONS(2951),
    [anon_sym_DOLLAR] = ACTIONS(2949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2951),
    [anon_sym_BQUOTE] = ACTIONS(2951),
    [anon_sym_LT_LPAREN] = ACTIONS(2951),
    [anon_sym_GT_LPAREN] = ACTIONS(2951),
    [sym_word] = ACTIONS(2953),
    [sym_comment] = ACTIONS(52),
  },
  [1275] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1275),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(610),
    [sym_variable_name] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_while] = ACTIONS(621),
    [anon_sym_if] = ACTIONS(624),
    [anon_sym_case] = ACTIONS(627),
    [anon_sym_SEMI_SEMI] = ACTIONS(616),
    [anon_sym_function] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_LBRACK] = ACTIONS(636),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(639),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(645),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(645),
    [anon_sym_LT_AMP] = ACTIONS(645),
    [anon_sym_GT_AMP] = ACTIONS(645),
    [anon_sym_DQUOTE] = ACTIONS(648),
    [sym_raw_string] = ACTIONS(651),
    [anon_sym_DOLLAR] = ACTIONS(654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(657),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(660),
    [anon_sym_BQUOTE] = ACTIONS(663),
    [anon_sym_LT_LPAREN] = ACTIONS(666),
    [anon_sym_GT_LPAREN] = ACTIONS(666),
    [sym_word] = ACTIONS(669),
    [sym_comment] = ACTIONS(52),
  },
  [1276] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_bracket_command] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_environment_variable_assignment] = STATE(25),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1275),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(10),
    [sym_variable_name] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(16),
    [anon_sym_while] = ACTIONS(18),
    [anon_sym_if] = ACTIONS(20),
    [anon_sym_case] = ACTIONS(22),
    [anon_sym_SEMI_SEMI] = ACTIONS(2955),
    [anon_sym_function] = ACTIONS(24),
    [anon_sym_LPAREN] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(28),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(30),
    [anon_sym_LT] = ACTIONS(32),
    [anon_sym_GT] = ACTIONS(32),
    [anon_sym_GT_GT] = ACTIONS(34),
    [anon_sym_AMP_GT] = ACTIONS(32),
    [anon_sym_AMP_GT_GT] = ACTIONS(34),
    [anon_sym_LT_AMP] = ACTIONS(34),
    [anon_sym_GT_AMP] = ACTIONS(34),
    [anon_sym_DQUOTE] = ACTIONS(36),
    [sym_raw_string] = ACTIONS(38),
    [anon_sym_DOLLAR] = ACTIONS(40),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(42),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(44),
    [anon_sym_BQUOTE] = ACTIONS(46),
    [anon_sym_LT_LPAREN] = ACTIONS(48),
    [anon_sym_GT_LPAREN] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
    [sym_comment] = ACTIONS(52),
  },
  [1277] = {
    [sym__concat] = ACTIONS(2814),
    [anon_sym_in] = ACTIONS(2816),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2816),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2816),
  },
  [1278] = {
    [sym__concat] = ACTIONS(2818),
    [anon_sym_in] = ACTIONS(2820),
    [anon_sym_SEMI_SEMI] = ACTIONS(2820),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_LF] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2820),
  },
  [1279] = {
    [sym__concat] = ACTIONS(2814),
    [anon_sym_RBRACE] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym_raw_string] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_LT_LPAREN] = ACTIONS(2814),
    [anon_sym_GT_LPAREN] = ACTIONS(2814),
    [sym_word] = ACTIONS(2816),
    [sym_comment] = ACTIONS(52),
  },
  [1280] = {
    [sym__concat] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2818),
    [anon_sym_RBRACK] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [sym_raw_string] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2818),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(2818),
    [anon_sym_GT_LPAREN] = ACTIONS(2818),
    [sym_word] = ACTIONS(2820),
    [sym_comment] = ACTIONS(52),
  },
  [1281] = {
    [sym__concat] = ACTIONS(2814),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym_raw_string] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_LT_LPAREN] = ACTIONS(2814),
    [anon_sym_GT_LPAREN] = ACTIONS(2814),
    [sym_word] = ACTIONS(2816),
    [sym_comment] = ACTIONS(52),
  },
  [1282] = {
    [sym__concat] = ACTIONS(2818),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2959),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [sym_raw_string] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2818),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(2818),
    [anon_sym_GT_LPAREN] = ACTIONS(2818),
    [sym_word] = ACTIONS(2820),
    [sym_comment] = ACTIONS(52),
  },
  [1283] = {
    [sym_file_descriptor] = ACTIONS(2814),
    [sym__concat] = ACTIONS(2814),
    [sym_variable_name] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2814),
    [anon_sym_AMP_GT] = ACTIONS(2957),
    [anon_sym_AMP_GT_GT] = ACTIONS(2814),
    [anon_sym_LT_AMP] = ACTIONS(2814),
    [anon_sym_GT_AMP] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym_raw_string] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_LT_LPAREN] = ACTIONS(2814),
    [anon_sym_GT_LPAREN] = ACTIONS(2814),
    [sym_word] = ACTIONS(2957),
    [sym_comment] = ACTIONS(52),
  },
  [1284] = {
    [sym_file_descriptor] = ACTIONS(2818),
    [sym__concat] = ACTIONS(2818),
    [sym_variable_name] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2959),
    [anon_sym_GT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2818),
    [anon_sym_AMP_GT] = ACTIONS(2959),
    [anon_sym_AMP_GT_GT] = ACTIONS(2818),
    [anon_sym_LT_AMP] = ACTIONS(2818),
    [anon_sym_GT_AMP] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [sym_raw_string] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2818),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(2818),
    [anon_sym_GT_LPAREN] = ACTIONS(2818),
    [sym_word] = ACTIONS(2959),
    [sym_comment] = ACTIONS(52),
  },
  [1285] = {
    [anon_sym_DQUOTE] = ACTIONS(2816),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2957),
    [anon_sym_DOLLAR] = ACTIONS(2816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2816),
    [anon_sym_BQUOTE] = ACTIONS(2816),
    [sym_comment] = ACTIONS(150),
  },
  [1286] = {
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [aux_sym_SLASH_LBRACK_CARET_DQUOTE_BQUOTE_DOLLAR_RBRACK_PLUS_SLASH] = ACTIONS(2959),
    [anon_sym_DOLLAR] = ACTIONS(2820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2820),
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [sym_comment] = ACTIONS(150),
  },
  [1287] = {
    [anon_sym_RBRACK] = ACTIONS(2961),
    [sym_comment] = ACTIONS(52),
  },
  [1288] = {
    [anon_sym_RBRACK] = ACTIONS(2963),
    [sym_comment] = ACTIONS(52),
  },
  [1289] = {
    [anon_sym_RBRACE] = ACTIONS(2965),
    [sym_comment] = ACTIONS(52),
  },
  [1290] = {
    [sym_file_descriptor] = ACTIONS(2162),
    [sym__concat] = ACTIONS(2162),
    [sym_variable_name] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2524),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_PIPE_AMP] = ACTIONS(2162),
    [anon_sym_AMP_AMP] = ACTIONS(2162),
    [anon_sym_PIPE_PIPE] = ACTIONS(2524),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_GT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2162),
    [anon_sym_AMP_GT] = ACTIONS(2524),
    [anon_sym_AMP_GT_GT] = ACTIONS(2162),
    [anon_sym_LT_AMP] = ACTIONS(2162),
    [anon_sym_GT_AMP] = ACTIONS(2162),
    [anon_sym_DQUOTE] = ACTIONS(2162),
    [sym_raw_string] = ACTIONS(2162),
    [anon_sym_DOLLAR] = ACTIONS(2524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2162),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [anon_sym_LT_LPAREN] = ACTIONS(2162),
    [anon_sym_GT_LPAREN] = ACTIONS(2162),
    [sym_word] = ACTIONS(2164),
    [sym_comment] = ACTIONS(52),
  },
  [1291] = {
    [anon_sym_RBRACE] = ACTIONS(2967),
    [sym_comment] = ACTIONS(52),
  },
  [1292] = {
    [sym_file_descriptor] = ACTIONS(2168),
    [sym__concat] = ACTIONS(2168),
    [sym_variable_name] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2528),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_PIPE_AMP] = ACTIONS(2168),
    [anon_sym_AMP_AMP] = ACTIONS(2168),
    [anon_sym_PIPE_PIPE] = ACTIONS(2528),
    [anon_sym_LT] = ACTIONS(2528),
    [anon_sym_GT] = ACTIONS(2528),
    [anon_sym_GT_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT] = ACTIONS(2528),
    [anon_sym_AMP_GT_GT] = ACTIONS(2168),
    [anon_sym_LT_AMP] = ACTIONS(2168),
    [anon_sym_GT_AMP] = ACTIONS(2168),
    [anon_sym_DQUOTE] = ACTIONS(2168),
    [sym_raw_string] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [anon_sym_LT_LPAREN] = ACTIONS(2168),
    [anon_sym_GT_LPAREN] = ACTIONS(2168),
    [sym_word] = ACTIONS(2170),
    [sym_comment] = ACTIONS(52),
  },
  [1293] = {
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_RPAREN] = ACTIONS(2971),
    [anon_sym_PIPE_AMP] = ACTIONS(2971),
    [anon_sym_AMP_AMP] = ACTIONS(2971),
    [anon_sym_PIPE_PIPE] = ACTIONS(2971),
    [anon_sym_BQUOTE] = ACTIONS(2971),
    [sym_comment] = ACTIONS(52),
  },
  [1294] = {
    [anon_sym_PIPE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_PIPE_AMP] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_BQUOTE] = ACTIONS(2975),
    [sym_comment] = ACTIONS(52),
  },
  [1295] = {
    [sym_file_descriptor] = ACTIONS(2814),
    [sym__concat] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_PIPE_AMP] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2814),
    [anon_sym_AMP_GT] = ACTIONS(2957),
    [anon_sym_AMP_GT_GT] = ACTIONS(2814),
    [anon_sym_LT_AMP] = ACTIONS(2814),
    [anon_sym_GT_AMP] = ACTIONS(2814),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_LT_LT_DASH] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym_raw_string] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_LT_LPAREN] = ACTIONS(2814),
    [anon_sym_GT_LPAREN] = ACTIONS(2814),
    [sym_word] = ACTIONS(2816),
    [sym_comment] = ACTIONS(52),
  },
  [1296] = {
    [sym_file_descriptor] = ACTIONS(2818),
    [sym__concat] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_PIPE_AMP] = ACTIONS(2818),
    [anon_sym_AMP_AMP] = ACTIONS(2818),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_LT] = ACTIONS(2959),
    [anon_sym_GT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2818),
    [anon_sym_AMP_GT] = ACTIONS(2959),
    [anon_sym_AMP_GT_GT] = ACTIONS(2818),
    [anon_sym_LT_AMP] = ACTIONS(2818),
    [anon_sym_GT_AMP] = ACTIONS(2818),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_LT_LT_DASH] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [sym_raw_string] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2818),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(2818),
    [anon_sym_GT_LPAREN] = ACTIONS(2818),
    [sym_word] = ACTIONS(2820),
    [sym_comment] = ACTIONS(52),
  },
  [1297] = {
    [sym__concat] = ACTIONS(1599),
    [anon_sym_PIPE] = ACTIONS(2104),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_PIPE_AMP] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1599),
    [anon_sym_PIPE_PIPE] = ACTIONS(1599),
    [anon_sym_BQUOTE] = ACTIONS(1599),
    [sym_comment] = ACTIONS(52),
  },
  [1298] = {
    [anon_sym_AT] = ACTIONS(2977),
    [sym_comment] = ACTIONS(52),
  },
  [1299] = {
    [sym__concat] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(2108),
    [anon_sym_RPAREN] = ACTIONS(1605),
    [anon_sym_PIPE_AMP] = ACTIONS(1605),
    [anon_sym_AMP_AMP] = ACTIONS(1605),
    [anon_sym_PIPE_PIPE] = ACTIONS(1605),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [sym_comment] = ACTIONS(52),
  },
  [1300] = {
    [anon_sym_AT] = ACTIONS(2979),
    [sym_comment] = ACTIONS(52),
  },
  [1301] = {
    [anon_sym_RBRACK] = ACTIONS(2981),
    [sym_comment] = ACTIONS(52),
  },
  [1302] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [sym_comment] = ACTIONS(52),
  },
  [1303] = {
    [anon_sym_RBRACE] = ACTIONS(2983),
    [sym_comment] = ACTIONS(52),
  },
  [1304] = {
    [anon_sym_RBRACK] = ACTIONS(2985),
    [sym_comment] = ACTIONS(52),
  },
  [1305] = {
    [aux_sym_concatenation_repeat1] = STATE(793),
    [sym__concat] = ACTIONS(360),
    [anon_sym_RBRACE] = ACTIONS(2987),
    [sym_comment] = ACTIONS(52),
  },
  [1306] = {
    [anon_sym_RBRACE] = ACTIONS(2987),
    [sym_comment] = ACTIONS(52),
  },
  [1307] = {
    [anon_sym_RBRACK] = ACTIONS(2989),
    [sym_comment] = ACTIONS(52),
  },
  [1308] = {
    [anon_sym_RBRACK] = ACTIONS(2991),
    [sym_comment] = ACTIONS(52),
  },
  [1309] = {
    [anon_sym_RBRACE] = ACTIONS(2993),
    [sym_comment] = ACTIONS(52),
  },
  [1310] = {
    [sym_file_descriptor] = ACTIONS(2162),
    [sym__concat] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2524),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_PIPE_AMP] = ACTIONS(2162),
    [anon_sym_AMP_AMP] = ACTIONS(2162),
    [anon_sym_PIPE_PIPE] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(2524),
    [anon_sym_GT] = ACTIONS(2524),
    [anon_sym_GT_GT] = ACTIONS(2162),
    [anon_sym_AMP_GT] = ACTIONS(2524),
    [anon_sym_AMP_GT_GT] = ACTIONS(2162),
    [anon_sym_LT_AMP] = ACTIONS(2162),
    [anon_sym_GT_AMP] = ACTIONS(2162),
    [anon_sym_LT_LT] = ACTIONS(2524),
    [anon_sym_LT_LT_DASH] = ACTIONS(2162),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [sym_comment] = ACTIONS(52),
  },
  [1311] = {
    [anon_sym_RBRACE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(52),
  },
  [1312] = {
    [sym_file_descriptor] = ACTIONS(2168),
    [sym__concat] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2528),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_PIPE_AMP] = ACTIONS(2168),
    [anon_sym_AMP_AMP] = ACTIONS(2168),
    [anon_sym_PIPE_PIPE] = ACTIONS(2168),
    [anon_sym_LT] = ACTIONS(2528),
    [anon_sym_GT] = ACTIONS(2528),
    [anon_sym_GT_GT] = ACTIONS(2168),
    [anon_sym_AMP_GT] = ACTIONS(2528),
    [anon_sym_AMP_GT_GT] = ACTIONS(2168),
    [anon_sym_LT_AMP] = ACTIONS(2168),
    [anon_sym_GT_AMP] = ACTIONS(2168),
    [anon_sym_LT_LT] = ACTIONS(2528),
    [anon_sym_LT_LT_DASH] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [sym_comment] = ACTIONS(52),
  },
  [1313] = {
    [anon_sym_RBRACK] = ACTIONS(2997),
    [sym_comment] = ACTIONS(52),
  },
  [1314] = {
    [anon_sym_RBRACK] = ACTIONS(2999),
    [sym_comment] = ACTIONS(52),
  },
  [1315] = {
    [anon_sym_RBRACE] = ACTIONS(3001),
    [sym_comment] = ACTIONS(52),
  },
  [1316] = {
    [sym__concat] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2164),
    [anon_sym_RPAREN] = ACTIONS(2164),
    [anon_sym_SEMI_SEMI] = ACTIONS(2164),
    [anon_sym_PIPE_AMP] = ACTIONS(2164),
    [anon_sym_AMP_AMP] = ACTIONS(2164),
    [anon_sym_PIPE_PIPE] = ACTIONS(2164),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2164),
    [anon_sym_LF] = ACTIONS(2164),
    [anon_sym_AMP] = ACTIONS(2164),
  },
  [1317] = {
    [anon_sym_RBRACE] = ACTIONS(3003),
    [sym_comment] = ACTIONS(52),
  },
  [1318] = {
    [sym__concat] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_SEMI_SEMI] = ACTIONS(2170),
    [anon_sym_PIPE_AMP] = ACTIONS(2170),
    [anon_sym_AMP_AMP] = ACTIONS(2170),
    [anon_sym_PIPE_PIPE] = ACTIONS(2170),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2170),
    [anon_sym_LF] = ACTIONS(2170),
    [anon_sym_AMP] = ACTIONS(2170),
  },
  [1319] = {
    [anon_sym_RBRACE] = ACTIONS(3005),
    [sym_comment] = ACTIONS(52),
  },
  [1320] = {
    [anon_sym_RBRACE] = ACTIONS(3007),
    [sym_comment] = ACTIONS(52),
  },
  [1321] = {
    [sym_file_descriptor] = ACTIONS(2558),
    [sym__concat] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(2560),
    [anon_sym_GT] = ACTIONS(2560),
    [anon_sym_GT_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT] = ACTIONS(2560),
    [anon_sym_AMP_GT_GT] = ACTIONS(2560),
    [anon_sym_LT_AMP] = ACTIONS(2560),
    [anon_sym_GT_AMP] = ACTIONS(2560),
    [anon_sym_LT_LT] = ACTIONS(2560),
    [anon_sym_LT_LT_DASH] = ACTIONS(2560),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2560),
  },
  [1322] = {
    [sym_file_descriptor] = ACTIONS(2562),
    [sym__concat] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2564),
    [anon_sym_GT] = ACTIONS(2564),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2564),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2564),
  },
  [1323] = {
    [anon_sym_RBRACK] = ACTIONS(3009),
    [sym_comment] = ACTIONS(52),
  },
  [1324] = {
    [anon_sym_RBRACK] = ACTIONS(3011),
    [sym_comment] = ACTIONS(52),
  },
  [1325] = {
    [anon_sym_RBRACE] = ACTIONS(3013),
    [sym_comment] = ACTIONS(52),
  },
  [1326] = {
    [sym__heredoc_middle] = ACTIONS(2162),
    [sym__heredoc_end] = ACTIONS(2162),
    [anon_sym_DOLLAR] = ACTIONS(2524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2162),
    [sym_comment] = ACTIONS(52),
  },
  [1327] = {
    [anon_sym_RBRACE] = ACTIONS(3015),
    [sym_comment] = ACTIONS(52),
  },
  [1328] = {
    [sym__heredoc_middle] = ACTIONS(2168),
    [sym__heredoc_end] = ACTIONS(2168),
    [anon_sym_DOLLAR] = ACTIONS(2528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2168),
    [sym_comment] = ACTIONS(52),
  },
  [1329] = {
    [sym__concat] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2814),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_RBRACK] = ACTIONS(2814),
    [sym_comment] = ACTIONS(52),
  },
  [1330] = {
    [sym__concat] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2818),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_RBRACK] = ACTIONS(2818),
    [sym_comment] = ACTIONS(52),
  },
  [1331] = {
    [anon_sym_RBRACE] = ACTIONS(3017),
    [sym_comment] = ACTIONS(52),
  },
  [1332] = {
    [anon_sym_RBRACE] = ACTIONS(3019),
    [sym_comment] = ACTIONS(52),
  },
  [1333] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [anon_sym_LT_LPAREN] = ACTIONS(2558),
    [anon_sym_GT_LPAREN] = ACTIONS(2558),
    [sym_word] = ACTIONS(2798),
    [sym_comment] = ACTIONS(52),
  },
  [1334] = {
    [sym__concat] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_word] = ACTIONS(2800),
    [sym_comment] = ACTIONS(52),
  },
  [1335] = {
    [sym_file_descriptor] = ACTIONS(2814),
    [sym__concat] = ACTIONS(2814),
    [sym_variable_name] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2816),
    [anon_sym_RPAREN] = ACTIONS(2816),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [anon_sym_PIPE_AMP] = ACTIONS(2816),
    [anon_sym_AMP_AMP] = ACTIONS(2816),
    [anon_sym_PIPE_PIPE] = ACTIONS(2816),
    [anon_sym_LT] = ACTIONS(2816),
    [anon_sym_GT] = ACTIONS(2816),
    [anon_sym_GT_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT_GT] = ACTIONS(2816),
    [anon_sym_LT_AMP] = ACTIONS(2816),
    [anon_sym_GT_AMP] = ACTIONS(2816),
    [anon_sym_DQUOTE] = ACTIONS(2816),
    [sym_raw_string] = ACTIONS(2816),
    [anon_sym_DOLLAR] = ACTIONS(2816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2816),
    [anon_sym_BQUOTE] = ACTIONS(2816),
    [anon_sym_LT_LPAREN] = ACTIONS(2816),
    [anon_sym_GT_LPAREN] = ACTIONS(2816),
    [sym_word] = ACTIONS(2816),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2816),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2816),
  },
  [1336] = {
    [sym_file_descriptor] = ACTIONS(2818),
    [sym__concat] = ACTIONS(2818),
    [sym_variable_name] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2820),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_SEMI_SEMI] = ACTIONS(2820),
    [anon_sym_PIPE_AMP] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_PIPE_PIPE] = ACTIONS(2820),
    [anon_sym_LT] = ACTIONS(2820),
    [anon_sym_GT] = ACTIONS(2820),
    [anon_sym_GT_GT] = ACTIONS(2820),
    [anon_sym_AMP_GT] = ACTIONS(2820),
    [anon_sym_AMP_GT_GT] = ACTIONS(2820),
    [anon_sym_LT_AMP] = ACTIONS(2820),
    [anon_sym_GT_AMP] = ACTIONS(2820),
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [sym_raw_string] = ACTIONS(2820),
    [anon_sym_DOLLAR] = ACTIONS(2820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2820),
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [anon_sym_LT_LPAREN] = ACTIONS(2820),
    [anon_sym_GT_LPAREN] = ACTIONS(2820),
    [sym_word] = ACTIONS(2820),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_LF] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2820),
  },
  [1337] = {
    [anon_sym_RBRACE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(52),
  },
  [1338] = {
    [anon_sym_RBRACE] = ACTIONS(3023),
    [sym_comment] = ACTIONS(52),
  },
  [1339] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [sym_raw_string] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2560),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2560),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [anon_sym_LT_LPAREN] = ACTIONS(2560),
    [anon_sym_GT_LPAREN] = ACTIONS(2560),
    [sym_word] = ACTIONS(2560),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2560),
  },
  [1340] = {
    [sym__concat] = ACTIONS(2562),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [sym_raw_string] = ACTIONS(2564),
    [anon_sym_DOLLAR] = ACTIONS(2564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2564),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [anon_sym_LT_LPAREN] = ACTIONS(2564),
    [anon_sym_GT_LPAREN] = ACTIONS(2564),
    [sym_word] = ACTIONS(2564),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2564),
  },
  [1341] = {
    [anon_sym_esac] = ACTIONS(3025),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [sym_raw_string] = ACTIONS(3027),
    [anon_sym_DOLLAR] = ACTIONS(3025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3027),
    [anon_sym_BQUOTE] = ACTIONS(3027),
    [anon_sym_LT_LPAREN] = ACTIONS(3027),
    [anon_sym_GT_LPAREN] = ACTIONS(3027),
    [sym_word] = ACTIONS(3029),
    [sym_comment] = ACTIONS(52),
  },
  [1342] = {
    [anon_sym_RBRACE] = ACTIONS(3031),
    [sym_comment] = ACTIONS(52),
  },
  [1343] = {
    [anon_sym_RBRACE] = ACTIONS(3033),
    [sym_comment] = ACTIONS(52),
  },
  [1344] = {
    [sym_file_descriptor] = ACTIONS(2558),
    [sym__concat] = ACTIONS(2558),
    [sym_variable_name] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2798),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_PIPE_AMP] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2798),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_GT] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT] = ACTIONS(2798),
    [anon_sym_AMP_GT_GT] = ACTIONS(2558),
    [anon_sym_LT_AMP] = ACTIONS(2558),
    [anon_sym_GT_AMP] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_raw_string] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2558),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [anon_sym_LT_LPAREN] = ACTIONS(2558),
    [anon_sym_GT_LPAREN] = ACTIONS(2558),
    [sym_word] = ACTIONS(2560),
    [sym_comment] = ACTIONS(52),
  },
  [1345] = {
    [sym_file_descriptor] = ACTIONS(2562),
    [sym__concat] = ACTIONS(2562),
    [sym_variable_name] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2800),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2800),
    [anon_sym_GT] = ACTIONS(2800),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2800),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [anon_sym_LT_LPAREN] = ACTIONS(2562),
    [anon_sym_GT_LPAREN] = ACTIONS(2562),
    [sym_word] = ACTIONS(2564),
    [sym_comment] = ACTIONS(52),
  },
  [1346] = {
    [anon_sym_RBRACK] = ACTIONS(3035),
    [sym_comment] = ACTIONS(52),
  },
  [1347] = {
    [anon_sym_RBRACK] = ACTIONS(3037),
    [sym_comment] = ACTIONS(52),
  },
  [1348] = {
    [anon_sym_RBRACE] = ACTIONS(3039),
    [sym_comment] = ACTIONS(52),
  },
  [1349] = {
    [sym__concat] = ACTIONS(2162),
    [anon_sym_PIPE] = ACTIONS(2524),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_PIPE_AMP] = ACTIONS(2162),
    [anon_sym_AMP_AMP] = ACTIONS(2162),
    [anon_sym_PIPE_PIPE] = ACTIONS(2162),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [sym_comment] = ACTIONS(52),
  },
  [1350] = {
    [anon_sym_RBRACE] = ACTIONS(3041),
    [sym_comment] = ACTIONS(52),
  },
  [1351] = {
    [sym__concat] = ACTIONS(2168),
    [anon_sym_PIPE] = ACTIONS(2528),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_PIPE_AMP] = ACTIONS(2168),
    [anon_sym_AMP_AMP] = ACTIONS(2168),
    [anon_sym_PIPE_PIPE] = ACTIONS(2168),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [sym_comment] = ACTIONS(52),
  },
  [1352] = {
    [anon_sym_RBRACE] = ACTIONS(3043),
    [sym_comment] = ACTIONS(52),
  },
  [1353] = {
    [anon_sym_RBRACE] = ACTIONS(3045),
    [sym_comment] = ACTIONS(52),
  },
  [1354] = {
    [sym_file_descriptor] = ACTIONS(2558),
    [sym__concat] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2798),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_PIPE_AMP] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2558),
    [anon_sym_LT] = ACTIONS(2798),
    [anon_sym_GT] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2558),
    [anon_sym_AMP_GT] = ACTIONS(2798),
    [anon_sym_AMP_GT_GT] = ACTIONS(2558),
    [anon_sym_LT_AMP] = ACTIONS(2558),
    [anon_sym_GT_AMP] = ACTIONS(2558),
    [anon_sym_LT_LT] = ACTIONS(2798),
    [anon_sym_LT_LT_DASH] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [sym_comment] = ACTIONS(52),
  },
  [1355] = {
    [sym_file_descriptor] = ACTIONS(2562),
    [sym__concat] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2800),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2800),
    [anon_sym_GT] = ACTIONS(2800),
    [anon_sym_GT_GT] = ACTIONS(2562),
    [anon_sym_AMP_GT] = ACTIONS(2800),
    [anon_sym_AMP_GT_GT] = ACTIONS(2562),
    [anon_sym_LT_AMP] = ACTIONS(2562),
    [anon_sym_GT_AMP] = ACTIONS(2562),
    [anon_sym_LT_LT] = ACTIONS(2800),
    [anon_sym_LT_LT_DASH] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [sym_comment] = ACTIONS(52),
  },
  [1356] = {
    [anon_sym_RBRACE] = ACTIONS(3047),
    [sym_comment] = ACTIONS(52),
  },
  [1357] = {
    [anon_sym_RBRACE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(52),
  },
  [1358] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_SEMI_SEMI] = ACTIONS(2560),
    [anon_sym_PIPE_AMP] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_LF] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2560),
  },
  [1359] = {
    [sym__concat] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2564),
  },
  [1360] = {
    [sym_file_descriptor] = ACTIONS(2814),
    [sym__concat] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2816),
    [anon_sym_RPAREN] = ACTIONS(2816),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [anon_sym_PIPE_AMP] = ACTIONS(2816),
    [anon_sym_AMP_AMP] = ACTIONS(2816),
    [anon_sym_PIPE_PIPE] = ACTIONS(2816),
    [anon_sym_LT] = ACTIONS(2816),
    [anon_sym_GT] = ACTIONS(2816),
    [anon_sym_GT_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT] = ACTIONS(2816),
    [anon_sym_AMP_GT_GT] = ACTIONS(2816),
    [anon_sym_LT_AMP] = ACTIONS(2816),
    [anon_sym_GT_AMP] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2816),
    [anon_sym_LT_LT_DASH] = ACTIONS(2816),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2816),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2816),
  },
  [1361] = {
    [sym_file_descriptor] = ACTIONS(2818),
    [sym__concat] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2820),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_SEMI_SEMI] = ACTIONS(2820),
    [anon_sym_PIPE_AMP] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_PIPE_PIPE] = ACTIONS(2820),
    [anon_sym_LT] = ACTIONS(2820),
    [anon_sym_GT] = ACTIONS(2820),
    [anon_sym_GT_GT] = ACTIONS(2820),
    [anon_sym_AMP_GT] = ACTIONS(2820),
    [anon_sym_AMP_GT_GT] = ACTIONS(2820),
    [anon_sym_LT_AMP] = ACTIONS(2820),
    [anon_sym_GT_AMP] = ACTIONS(2820),
    [anon_sym_LT_LT] = ACTIONS(2820),
    [anon_sym_LT_LT_DASH] = ACTIONS(2820),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_LF] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2820),
  },
  [1362] = {
    [anon_sym_RBRACE] = ACTIONS(3051),
    [sym_comment] = ACTIONS(52),
  },
  [1363] = {
    [anon_sym_RBRACE] = ACTIONS(3053),
    [sym_comment] = ACTIONS(52),
  },
  [1364] = {
    [sym__heredoc_middle] = ACTIONS(2558),
    [sym__heredoc_end] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2558),
    [sym_comment] = ACTIONS(52),
  },
  [1365] = {
    [sym__heredoc_middle] = ACTIONS(2562),
    [sym__heredoc_end] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2562),
    [sym_comment] = ACTIONS(52),
  },
  [1366] = {
    [sym__concat] = ACTIONS(2814),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym_raw_string] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_LT_LPAREN] = ACTIONS(2814),
    [anon_sym_GT_LPAREN] = ACTIONS(2814),
    [sym_word] = ACTIONS(2957),
    [sym_comment] = ACTIONS(52),
  },
  [1367] = {
    [sym__concat] = ACTIONS(2818),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [sym_raw_string] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2818),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(2818),
    [anon_sym_GT_LPAREN] = ACTIONS(2818),
    [sym_word] = ACTIONS(2959),
    [sym_comment] = ACTIONS(52),
  },
  [1368] = {
    [sym__concat] = ACTIONS(2814),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [anon_sym_DQUOTE] = ACTIONS(2816),
    [sym_raw_string] = ACTIONS(2816),
    [anon_sym_DOLLAR] = ACTIONS(2816),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2816),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2816),
    [anon_sym_BQUOTE] = ACTIONS(2816),
    [anon_sym_LT_LPAREN] = ACTIONS(2816),
    [anon_sym_GT_LPAREN] = ACTIONS(2816),
    [sym_word] = ACTIONS(2816),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2816),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2816),
  },
  [1369] = {
    [sym__concat] = ACTIONS(2818),
    [anon_sym_SEMI_SEMI] = ACTIONS(2820),
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [sym_raw_string] = ACTIONS(2820),
    [anon_sym_DOLLAR] = ACTIONS(2820),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2820),
    [anon_sym_BQUOTE] = ACTIONS(2820),
    [anon_sym_LT_LPAREN] = ACTIONS(2820),
    [anon_sym_GT_LPAREN] = ACTIONS(2820),
    [sym_word] = ACTIONS(2820),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_LF] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2820),
  },
  [1370] = {
    [sym_file_descriptor] = ACTIONS(2814),
    [sym__concat] = ACTIONS(2814),
    [sym_variable_name] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_PIPE_AMP] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2814),
    [anon_sym_AMP_GT] = ACTIONS(2957),
    [anon_sym_AMP_GT_GT] = ACTIONS(2814),
    [anon_sym_LT_AMP] = ACTIONS(2814),
    [anon_sym_GT_AMP] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(2814),
    [sym_raw_string] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [anon_sym_LT_LPAREN] = ACTIONS(2814),
    [anon_sym_GT_LPAREN] = ACTIONS(2814),
    [sym_word] = ACTIONS(2816),
    [sym_comment] = ACTIONS(52),
  },
  [1371] = {
    [sym_file_descriptor] = ACTIONS(2818),
    [sym__concat] = ACTIONS(2818),
    [sym_variable_name] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_PIPE_AMP] = ACTIONS(2818),
    [anon_sym_AMP_AMP] = ACTIONS(2818),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_LT] = ACTIONS(2959),
    [anon_sym_GT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2818),
    [anon_sym_AMP_GT] = ACTIONS(2959),
    [anon_sym_AMP_GT_GT] = ACTIONS(2818),
    [anon_sym_LT_AMP] = ACTIONS(2818),
    [anon_sym_GT_AMP] = ACTIONS(2818),
    [anon_sym_DQUOTE] = ACTIONS(2818),
    [sym_raw_string] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2818),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2818),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [anon_sym_LT_LPAREN] = ACTIONS(2818),
    [anon_sym_GT_LPAREN] = ACTIONS(2818),
    [sym_word] = ACTIONS(2820),
    [sym_comment] = ACTIONS(52),
  },
  [1372] = {
    [anon_sym_RBRACE] = ACTIONS(3055),
    [sym_comment] = ACTIONS(52),
  },
  [1373] = {
    [anon_sym_RBRACE] = ACTIONS(3057),
    [sym_comment] = ACTIONS(52),
  },
  [1374] = {
    [sym__concat] = ACTIONS(2558),
    [anon_sym_PIPE] = ACTIONS(2798),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_PIPE_AMP] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2558),
    [anon_sym_BQUOTE] = ACTIONS(2558),
    [sym_comment] = ACTIONS(52),
  },
  [1375] = {
    [sym__concat] = ACTIONS(2562),
    [anon_sym_PIPE] = ACTIONS(2800),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_PIPE_AMP] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_BQUOTE] = ACTIONS(2562),
    [sym_comment] = ACTIONS(52),
  },
  [1376] = {
    [sym_file_descriptor] = ACTIONS(2814),
    [sym__concat] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_PIPE_AMP] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(2814),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2814),
    [anon_sym_AMP_GT] = ACTIONS(2957),
    [anon_sym_AMP_GT_GT] = ACTIONS(2814),
    [anon_sym_LT_AMP] = ACTIONS(2814),
    [anon_sym_GT_AMP] = ACTIONS(2814),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_LT_LT_DASH] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(52),
  },
  [1377] = {
    [sym_file_descriptor] = ACTIONS(2818),
    [sym__concat] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_PIPE_AMP] = ACTIONS(2818),
    [anon_sym_AMP_AMP] = ACTIONS(2818),
    [anon_sym_PIPE_PIPE] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(2959),
    [anon_sym_GT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2818),
    [anon_sym_AMP_GT] = ACTIONS(2959),
    [anon_sym_AMP_GT_GT] = ACTIONS(2818),
    [anon_sym_LT_AMP] = ACTIONS(2818),
    [anon_sym_GT_AMP] = ACTIONS(2818),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_LT_LT_DASH] = ACTIONS(2818),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(52),
  },
  [1378] = {
    [sym__concat] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2816),
    [anon_sym_RPAREN] = ACTIONS(2816),
    [anon_sym_SEMI_SEMI] = ACTIONS(2816),
    [anon_sym_PIPE_AMP] = ACTIONS(2816),
    [anon_sym_AMP_AMP] = ACTIONS(2816),
    [anon_sym_PIPE_PIPE] = ACTIONS(2816),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2816),
    [anon_sym_LF] = ACTIONS(2816),
    [anon_sym_AMP] = ACTIONS(2816),
  },
  [1379] = {
    [sym__concat] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2820),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [anon_sym_SEMI_SEMI] = ACTIONS(2820),
    [anon_sym_PIPE_AMP] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_PIPE_PIPE] = ACTIONS(2820),
    [sym_comment] = ACTIONS(150),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym_LF] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2820),
  },
  [1380] = {
    [sym__heredoc_middle] = ACTIONS(2814),
    [sym__heredoc_end] = ACTIONS(2814),
    [anon_sym_DOLLAR] = ACTIONS(2957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(52),
  },
  [1381] = {
    [sym__heredoc_middle] = ACTIONS(2818),
    [sym__heredoc_end] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(52),
  },
  [1382] = {
    [sym__concat] = ACTIONS(2814),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_RPAREN] = ACTIONS(2814),
    [anon_sym_PIPE_AMP] = ACTIONS(2814),
    [anon_sym_AMP_AMP] = ACTIONS(2814),
    [anon_sym_PIPE_PIPE] = ACTIONS(2814),
    [anon_sym_BQUOTE] = ACTIONS(2814),
    [sym_comment] = ACTIONS(52),
  },
  [1383] = {
    [sym__concat] = ACTIONS(2818),
    [anon_sym_PIPE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_PIPE_AMP] = ACTIONS(2818),
    [anon_sym_AMP_AMP] = ACTIONS(2818),
    [anon_sym_PIPE_PIPE] = ACTIONS(2818),
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(52),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false, .depends_on_lookahead = false},
  [1] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, RECOVER(),
  [5] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(), RECOVER(),
  [8] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, RECOVER(),
  [10] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2),
  [12] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(3),
  [14] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 0),
  [16] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(4),
  [18] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(5),
  [20] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(6),
  [22] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(7),
  [24] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(8),
  [26] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(9),
  [28] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(10),
  [30] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(11),
  [32] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(12),
  [34] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(12),
  [36] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(13),
  [38] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(14),
  [40] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(15),
  [42] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(16),
  [44] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(17),
  [46] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(18),
  [48] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(19),
  [50] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(20),
  [52] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT_EXTRA(),
  [54] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(31),
  [56] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(31),
  [58] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(32),
  [60] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(33),
  [62] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(34),
  [64] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(39),
  [66] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(40),
  [68] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(41),
  [70] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(42),
  [72] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(43),
  [74] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(44),
  [76] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(45),
  [78] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(40),
  [80] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(47),
  [82] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(48),
  [84] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(49),
  [86] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(50),
  [88] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(51),
  [90] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(58),
  [92] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(59),
  [94] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(60),
  [96] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(61),
  [98] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(62),
  [100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(63),
  [102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(64),
  [104] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(59),
  [106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(67),
  [108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(68),
  [110] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(69),
  [112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(70),
  [114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(71),
  [116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(72),
  [118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(73),
  [120] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(68),
  [122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(76),
  [124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(77),
  [126] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(78),
  [128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(79),
  [130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(80),
  [132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(81),
  [134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(82),
  [136] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(77),
  [138] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(84),
  [140] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(85),
  [142] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(86),
  [144] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(87),
  [146] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(88),
  [148] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(89),
  [150] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(),
  [152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [154] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(91),
  [156] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(93),
  [160] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(94),
  [162] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(93),
  [164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(96),
  [166] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(97),
  [168] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(98),
  [170] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(96),
  [172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(100),
  [174] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(101),
  [176] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(102),
  [178] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(103),
  [180] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(104),
  [182] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(105),
  [184] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(106),
  [186] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(107),
  [188] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(108),
  [190] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(109),
  [192] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(110),
  [194] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(111),
  [196] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(112),
  [198] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(113),
  [200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(114),
  [202] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(115),
  [204] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(116),
  [206] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(123),
  [208] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(124),
  [210] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(125),
  [212] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(126),
  [214] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(134),
  [216] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(135),
  [218] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, ACCEPT_INPUT(),
  [220] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [222] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1),
  [224] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [226] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(137),
  [228] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(138),
  [230] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(139),
  [232] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(140),
  [234] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [236] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(141),
  [238] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(142),
  [240] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(13),
  [242] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(143),
  [244] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(15),
  [246] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(16),
  [248] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(17),
  [250] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(18),
  [252] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(19),
  [254] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [256] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [258] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 1),
  [262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(149),
  [264] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(14),
  [266] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(153),
  [268] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(153),
  [270] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(155),
  [272] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(156),
  [274] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(157),
  [276] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(158),
  [278] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(159),
  [280] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(160),
  [282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(161),
  [284] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(156),
  [286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(163),
  [288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(164),
  [290] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(165),
  [292] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(166),
  [294] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(167),
  [296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(168),
  [298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(169),
  [300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(170),
  [302] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(171),
  [304] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(166),
  [306] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(172),
  [308] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(173),
  [310] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(175),
  [312] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(176),
  [314] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(177),
  [316] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(179),
  [318] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(180),
  [320] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(181),
  [322] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(183),
  [324] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(184),
  [326] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(183),
  [328] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(186),
  [330] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(187),
  [332] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(195),
  [334] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(135),
  [336] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(197),
  [338] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(198),
  [340] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(200),
  [342] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(202),
  [344] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(203),
  [346] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(204),
  [348] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(205),
  [350] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(206),
  [352] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(207),
  [354] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(208),
  [356] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(50),
  [358] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(215),
  [360] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(217),
  [362] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [364] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [366] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [368] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(219),
  [370] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(220),
  [372] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(219),
  [374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(222),
  [376] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(223),
  [378] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(231),
  [380] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(59),
  [382] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(233),
  [384] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(235),
  [386] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(237),
  [388] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(238),
  [390] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(237),
  [392] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(240),
  [394] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(241),
  [396] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(68),
  [398] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(250),
  [400] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [402] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(252),
  [404] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2),
  [406] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(254),
  [408] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(255),
  [410] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(254),
  [412] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(257),
  [414] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(258),
  [416] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [418] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [420] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1),
  [422] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 1),
  [424] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(266),
  [426] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(267),
  [428] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(266),
  [430] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(269),
  [432] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(270),
  [434] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(276),
  [436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(278),
  [438] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(278),
  [440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [442] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [446] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_special_variable_name, 1),
  [448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 1),
  [450] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 1),
  [452] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [454] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [456] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_special_variable_name, 1),
  [458] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(280),
  [460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(282),
  [462] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(283),
  [464] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(284),
  [466] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(284),
  [468] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(285),
  [470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(286),
  [472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(287),
  [474] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(287),
  [476] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(288),
  [478] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(289),
  [480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(292),
  [482] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(292),
  [484] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(294),
  [486] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(300),
  [488] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(302),
  [490] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1),
  [492] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(304),
  [494] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(305),
  [496] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(304),
  [498] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(307),
  [500] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(308),
  [502] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(316),
  [504] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(317),
  [506] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(319),
  [508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(320),
  [510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(319),
  [512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(321),
  [514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(322),
  [516] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 1),
  [518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [520] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(323),
  [522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(323),
  [524] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(324),
  [526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(324),
  [528] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(325),
  [530] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(325),
  [532] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(321),
  [534] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(110),
  [536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(331),
  [538] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(332),
  [540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(334),
  [542] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(336),
  [544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(336),
  [546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(337),
  [548] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(338),
  [550] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(339),
  [552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(339),
  [554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(340),
  [556] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(340),
  [558] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(337),
  [560] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(125),
  [562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(344),
  [564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(345),
  [566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(346),
  [568] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(348),
  [570] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 2),
  [572] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(349),
  [574] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [576] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2),
  [578] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [580] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(355),
  [582] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(355),
  [584] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(356),
  [586] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(357),
  [588] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(358),
  [590] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(359),
  [592] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(360),
  [594] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(361),
  [596] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(362),
  [598] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(357),
  [600] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(364),
  [602] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(365),
  [604] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [606] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 1),
  [608] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [610] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [613] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [616] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [618] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [621] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [624] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [627] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [630] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [633] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [636] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [639] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [642] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [645] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [648] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [651] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [654] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [657] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [660] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [663] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [666] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [669] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(370),
  [674] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [677] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(149),
  [680] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(12),
  [683] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(12),
  [686] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2),
  [688] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2),
  [690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [692] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3),
  [694] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(372),
  [696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(374),
  [698] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(375),
  [700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(377),
  [702] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(378),
  [704] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(377),
  [706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(380),
  [708] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(381),
  [710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_environment_variable_assignment, 3),
  [712] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_environment_variable_assignment, 3),
  [714] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(389),
  [716] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(390),
  [718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(391),
  [720] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(392),
  [722] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(393),
  [724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(394),
  [726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(395),
  [728] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(396),
  [730] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(391),
  [732] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(399),
  [734] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(401),
  [736] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(403),
  [738] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(404),
  [740] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(403),
  [742] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(406),
  [744] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(407),
  [746] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(415),
  [748] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(416),
  [750] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(417),
  [752] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(418),
  [754] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(419),
  [756] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(420),
  [758] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(421),
  [760] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(416),
  [762] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(424),
  [764] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [766] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(429),
  [768] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(430),
  [770] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(431),
  [772] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(439),
  [774] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(440),
  [776] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(440),
  [778] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(441),
  [780] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(442),
  [782] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(444),
  [784] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(446),
  [786] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(447),
  [788] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(448),
  [790] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(448),
  [792] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(449),
  [794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(450),
  [796] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(451),
  [798] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(451),
  [800] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(452),
  [802] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(453),
  [804] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(454),
  [806] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3),
  [808] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(456),
  [810] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(456),
  [812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(457),
  [814] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(460),
  [816] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(461),
  [818] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(462),
  [820] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [822] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(463),
  [824] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(466),
  [826] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(466),
  [828] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(467),
  [830] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(467),
  [832] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(463),
  [834] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(471),
  [836] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 2),
  [838] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(473),
  [840] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(474),
  [842] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(474),
  [844] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_concatenation, 2),
  [846] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 1),
  [848] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2),
  [850] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(476),
  [852] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(478),
  [854] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(479),
  [856] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(480),
  [858] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(480),
  [860] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(481),
  [862] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(482),
  [864] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(483),
  [866] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(483),
  [868] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(484),
  [870] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(485),
  [872] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [874] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [876] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(58),
  [879] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(59),
  [882] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(60),
  [885] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(61),
  [888] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(62),
  [891] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(63),
  [894] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(64),
  [897] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(59),
  [900] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(486),
  [902] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(487),
  [904] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(487),
  [906] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(489),
  [908] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(491),
  [910] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(492),
  [912] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(493),
  [914] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(493),
  [916] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(494),
  [918] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(495),
  [920] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(496),
  [922] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(496),
  [924] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(497),
  [926] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(498),
  [928] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(67),
  [931] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(68),
  [934] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(69),
  [937] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(70),
  [940] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(71),
  [943] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(72),
  [946] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(73),
  [949] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(68),
  [952] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(499),
  [954] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(500),
  [956] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(500),
  [958] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(502),
  [960] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(504),
  [962] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(505),
  [964] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(506),
  [966] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(506),
  [968] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(507),
  [970] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(508),
  [972] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(509),
  [974] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(509),
  [976] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(510),
  [978] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(511),
  [980] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(512),
  [982] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(514),
  [984] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(515),
  [986] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(516),
  [988] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(516),
  [990] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(517),
  [992] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(518),
  [994] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(519),
  [996] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(519),
  [998] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(520),
  [1000] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [1002] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [1004] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1006] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(85),
  [1009] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(86),
  [1012] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(87),
  [1015] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(88),
  [1018] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(89),
  [1021] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1023] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1025] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(91),
  [1028] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(521),
  [1030] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(522),
  [1032] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(523),
  [1034] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(524),
  [1036] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 1),
  [1038] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 1),
  [1040] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(525),
  [1042] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(526),
  [1044] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(526),
  [1046] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [1048] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [1050] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(528),
  [1052] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(529),
  [1054] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(529),
  [1056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(531),
  [1058] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(532),
  [1060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(533),
  [1062] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(534),
  [1064] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(535),
  [1066] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(536),
  [1068] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(537),
  [1070] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(538),
  [1072] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(539),
  [1074] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(534),
  [1076] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(540),
  [1078] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(541),
  [1080] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(543),
  [1082] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(544),
  [1084] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(545),
  [1086] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(546),
  [1088] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(548),
  [1090] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(549),
  [1092] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(552),
  [1094] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(553),
  [1096] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(554),
  [1098] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(554),
  [1100] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(556),
  [1102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(558),
  [1104] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(559),
  [1106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(560),
  [1108] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(560),
  [1110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(561),
  [1112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(562),
  [1114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(563),
  [1116] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(563),
  [1118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(564),
  [1120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(565),
  [1122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(566),
  [1124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(567),
  [1126] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(569),
  [1128] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 2),
  [1130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 2),
  [1132] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(570),
  [1134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(570),
  [1136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1138] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1140] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(576),
  [1142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(576),
  [1144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(577),
  [1146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(578),
  [1148] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(579),
  [1150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(580),
  [1152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(581),
  [1154] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(582),
  [1156] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(583),
  [1158] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(578),
  [1160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(585),
  [1162] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(586),
  [1164] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 1),
  [1166] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2),
  [1168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [1170] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(592),
  [1172] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(592),
  [1174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(593),
  [1176] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(596),
  [1178] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(597),
  [1180] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(598),
  [1182] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(598),
  [1184] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(602),
  [1186] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(602),
  [1188] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(603),
  [1190] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(603),
  [1192] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1194] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1196] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1198] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [1200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(609),
  [1202] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(611),
  [1204] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(611),
  [1206] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(612),
  [1208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(613),
  [1210] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(614),
  [1212] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(615),
  [1214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(616),
  [1216] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(617),
  [1218] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(618),
  [1220] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(613),
  [1222] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [1224] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1226] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(620),
  [1228] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(620),
  [1230] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(622),
  [1232] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(624),
  [1234] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [1236] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(626),
  [1238] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(627),
  [1240] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(626),
  [1242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(629),
  [1244] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(630),
  [1246] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1248] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(638),
  [1252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(639),
  [1254] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(640),
  [1256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(641),
  [1258] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1260] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1264] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1266] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(13),
  [1269] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(143),
  [1272] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(15),
  [1275] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(16),
  [1278] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(17),
  [1281] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(18),
  [1284] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(19),
  [1287] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1289] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(140),
  [1292] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1294] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(141),
  [1297] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(142),
  [1300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(643),
  [1302] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(644),
  [1304] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(645),
  [1306] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(645),
  [1308] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(647),
  [1310] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(648),
  [1312] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(648),
  [1314] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [1316] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(650),
  [1318] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(652),
  [1320] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(653),
  [1322] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(654),
  [1324] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(654),
  [1326] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(655),
  [1328] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(656),
  [1330] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(657),
  [1332] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(657),
  [1334] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(658),
  [1336] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(659),
  [1338] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1340] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1342] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(660),
  [1344] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(662),
  [1346] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(664),
  [1348] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(665),
  [1350] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(664),
  [1352] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(667),
  [1354] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(668),
  [1356] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(676),
  [1358] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(678),
  [1360] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(679),
  [1362] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(679),
  [1364] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(681),
  [1366] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(683),
  [1368] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(684),
  [1370] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(685),
  [1372] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(685),
  [1374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(686),
  [1376] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(687),
  [1378] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(688),
  [1380] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(688),
  [1382] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(689),
  [1384] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(690),
  [1386] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(691),
  [1388] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(693),
  [1390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(695),
  [1392] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(696),
  [1394] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(695),
  [1396] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(698),
  [1398] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(699),
  [1400] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(707),
  [1402] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(415),
  [1404] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(416),
  [1406] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(417),
  [1408] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(418),
  [1410] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(419),
  [1412] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(420),
  [1414] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(421),
  [1416] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [1418] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(709),
  [1420] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(710),
  [1422] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [1424] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 1),
  [1426] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(717),
  [1428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [1430] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(718),
  [1432] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(718),
  [1434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(430),
  [1436] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(431),
  [1438] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(723),
  [1440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(724),
  [1442] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(724),
  [1444] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(728),
  [1446] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(179),
  [1449] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(729),
  [1451] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(730),
  [1453] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(731),
  [1455] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(732),
  [1457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(733),
  [1459] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(734),
  [1461] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(734),
  [1463] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(736),
  [1465] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(737),
  [1467] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(737),
  [1469] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [1471] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(741),
  [1473] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(743),
  [1475] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(743),
  [1477] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(744),
  [1479] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(744),
  [1481] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [1483] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(745),
  [1485] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(745),
  [1487] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(208),
  [1490] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(206),
  [1493] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(207),
  [1496] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(747),
  [1498] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 3),
  [1500] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1502] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(217),
  [1505] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(749),
  [1507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(750),
  [1509] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(751),
  [1511] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(752),
  [1513] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 1),
  [1515] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(753),
  [1517] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(754),
  [1519] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(754),
  [1521] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3),
  [1523] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(756),
  [1525] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(757),
  [1527] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(757),
  [1529] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_substitution, 3),
  [1531] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_process_substitution, 3),
  [1533] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(235),
  [1536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(759),
  [1538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(760),
  [1540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(761),
  [1542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(762),
  [1544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(763),
  [1546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(764),
  [1548] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(764),
  [1550] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(766),
  [1552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(767),
  [1554] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(767),
  [1556] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(252),
  [1559] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(769),
  [1561] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(770),
  [1563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(771),
  [1565] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(772),
  [1567] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(773),
  [1569] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(774),
  [1571] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(774),
  [1573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(776),
  [1575] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(777),
  [1577] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(777),
  [1579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(779),
  [1581] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(780),
  [1583] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(781),
  [1585] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(782),
  [1587] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(783),
  [1589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(784),
  [1591] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(784),
  [1593] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(786),
  [1595] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(787),
  [1597] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(787),
  [1599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 2),
  [1601] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 2),
  [1603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(789),
  [1605] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [1607] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [1609] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(790),
  [1611] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(791),
  [1613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(792),
  [1615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(794),
  [1617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(795),
  [1619] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_environment_variable_assignment, 3),
  [1621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(796),
  [1623] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(798),
  [1625] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(800),
  [1627] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(802),
  [1629] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(803),
  [1631] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(802),
  [1633] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(805),
  [1635] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(806),
  [1637] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(815),
  [1639] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 3),
  [1641] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [1643] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(817),
  [1645] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(821),
  [1647] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(822),
  [1649] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(823),
  [1651] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 3),
  [1653] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3),
  [1655] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 3),
  [1657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [1659] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(825),
  [1661] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(825),
  [1663] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(826),
  [1665] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_bracket_command, 3),
  [1667] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_bracket_command, 3),
  [1669] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(302),
  [1672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(827),
  [1674] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(828),
  [1676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(829),
  [1678] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(830),
  [1680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(831),
  [1682] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(832),
  [1684] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(832),
  [1686] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(834),
  [1688] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(835),
  [1690] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(835),
  [1692] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 2),
  [1694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(838),
  [1696] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(839),
  [1698] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(839),
  [1700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(840),
  [1702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(841),
  [1704] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(842),
  [1706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(843),
  [1708] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(844),
  [1710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(845),
  [1712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(846),
  [1714] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(841),
  [1716] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_pipeline, 3),
  [1718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [1720] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1722] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_list, 3, .fragile = true),
  [1724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(848),
  [1726] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(848),
  [1728] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(850),
  [1730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(852),
  [1732] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(854),
  [1734] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(855),
  [1736] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(854),
  [1738] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(857),
  [1740] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(858),
  [1742] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 1),
  [1744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(866),
  [1746] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc_redirect, 2),
  [1748] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(109),
  [1751] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(325),
  [1754] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(111),
  [1757] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(112),
  [1760] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(113),
  [1763] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(114),
  [1766] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(115),
  [1769] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(325),
  [1772] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3),
  [1774] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1776] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(322),
  [1779] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1783] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(323),
  [1786] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(323),
  [1789] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(324),
  [1792] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(324),
  [1795] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(870),
  [1797] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(872),
  [1799] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(872),
  [1801] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(873),
  [1803] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(873),
  [1805] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(874),
  [1807] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(874),
  [1809] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(340),
  [1812] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(340),
  [1815] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(338),
  [1818] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(339),
  [1821] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(339),
  [1824] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [1826] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [1828] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(878),
  [1830] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(878),
  [1832] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(880),
  [1834] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(882),
  [1836] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(884),
  [1838] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(885),
  [1840] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(884),
  [1842] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(887),
  [1844] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(888),
  [1846] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [1848] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(896),
  [1850] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(897),
  [1852] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(897),
  [1854] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(899),
  [1856] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(901),
  [1858] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(902),
  [1860] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(903),
  [1862] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(903),
  [1864] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(904),
  [1866] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(905),
  [1868] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(906),
  [1870] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(906),
  [1872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(907),
  [1874] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(908),
  [1876] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [1878] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [1880] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [1882] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [1884] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(909),
  [1886] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(910),
  [1888] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(909),
  [1890] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(912),
  [1892] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(913),
  [1894] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(915),
  [1896] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(917),
  [1898] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [1900] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(374),
  [1903] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(919),
  [1905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(920),
  [1907] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(921),
  [1909] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(922),
  [1911] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(923),
  [1913] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(924),
  [1915] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(924),
  [1917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(926),
  [1919] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(927),
  [1921] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(927),
  [1923] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(929),
  [1925] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(930),
  [1927] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(930),
  [1929] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(932),
  [1931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(934),
  [1933] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(935),
  [1935] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(936),
  [1937] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(936),
  [1939] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(937),
  [1941] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(938),
  [1943] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(939),
  [1945] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(939),
  [1947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(940),
  [1949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(941),
  [1951] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [1953] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [1955] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(390),
  [1958] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(391),
  [1961] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(392),
  [1964] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(393),
  [1967] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(394),
  [1970] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(395),
  [1973] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(396),
  [1976] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(391),
  [1979] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(401),
  [1982] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(942),
  [1984] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(943),
  [1986] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(944),
  [1988] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(945),
  [1990] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(946),
  [1992] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(947),
  [1994] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(947),
  [1996] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(949),
  [1998] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(950),
  [2000] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(950),
  [2002] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(952),
  [2004] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(953),
  [2006] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(953),
  [2008] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(955),
  [2010] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(957),
  [2012] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(958),
  [2014] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(959),
  [2016] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(959),
  [2018] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(960),
  [2020] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(961),
  [2022] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(962),
  [2024] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(962),
  [2026] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(963),
  [2028] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(964),
  [2030] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(415),
  [2033] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(416),
  [2036] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(417),
  [2039] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(418),
  [2042] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(419),
  [2045] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(420),
  [2048] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(421),
  [2051] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [2053] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2),
  [2055] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(966),
  [2057] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(967),
  [2059] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2),
  [2061] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [2063] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(969),
  [2065] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [2067] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(430),
  [2070] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [2072] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(971),
  [2074] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(972),
  [2076] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2078] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2080] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [2082] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(975),
  [2084] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(978),
  [2086] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(979),
  [2088] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(980),
  [2090] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(981),
  [2092] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(982),
  [2094] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(983),
  [2096] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [2098] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(987),
  [2100] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(987),
  [2102] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [2104] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 2),
  [2106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(990),
  [2108] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4),
  [2110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(991),
  [2112] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(992),
  [2114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(993),
  [2116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(994),
  [2118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(995),
  [2120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(996),
  [2122] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(997),
  [2124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(998),
  [2126] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(999),
  [2128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1000),
  [2130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1001),
  [2132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1002),
  [2134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1003),
  [2136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1004),
  [2138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1005),
  [2140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1006),
  [2142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1007),
  [2144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1008),
  [2146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1009),
  [2148] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1010),
  [2150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1011),
  [2152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1012),
  [2154] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1013),
  [2156] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1014),
  [2158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1015),
  [2160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1016),
  [2162] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 1),
  [2164] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 1),
  [2166] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1018),
  [2168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [2170] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [2172] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 2),
  [2174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1019),
  [2176] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1020),
  [2178] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1021),
  [2180] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1021),
  [2182] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1023),
  [2184] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1025),
  [2186] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1026),
  [2188] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1027),
  [2190] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1027),
  [2192] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1028),
  [2194] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1029),
  [2196] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1030),
  [2198] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1030),
  [2200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1031),
  [2202] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1032),
  [2204] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1033),
  [2206] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 2),
  [2208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [2210] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1034),
  [2212] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 4),
  [2214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [2216] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1035),
  [2218] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1035),
  [2220] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1038),
  [2222] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1040),
  [2224] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 4),
  [2226] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [2228] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 4),
  [2230] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [2232] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1042),
  [2234] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1043),
  [2236] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1044),
  [2238] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1045),
  [2240] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1046),
  [2242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1047),
  [2244] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1048),
  [2246] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 3),
  [2248] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1050),
  [2250] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1050),
  [2252] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1052),
  [2254] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1054),
  [2256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1056),
  [2258] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1057),
  [2260] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1056),
  [2262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1059),
  [2264] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1060),
  [2266] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1068),
  [2268] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1069),
  [2270] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1069),
  [2272] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1071),
  [2274] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1073),
  [2276] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1074),
  [2278] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1075),
  [2280] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1075),
  [2282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1076),
  [2284] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1077),
  [2286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1078),
  [2288] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1078),
  [2290] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1079),
  [2292] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1080),
  [2294] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 2),
  [2296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1081),
  [2298] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4),
  [2300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [2302] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1084),
  [2304] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1084),
  [2306] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1087),
  [2308] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1088),
  [2310] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1088),
  [2312] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1090),
  [2314] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1092),
  [2316] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1093),
  [2318] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1094),
  [2320] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1094),
  [2322] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1095),
  [2324] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1096),
  [2326] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1097),
  [2328] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1097),
  [2330] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1098),
  [2332] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1099),
  [2334] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(624),
  [2337] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1100),
  [2339] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1101),
  [2341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1102),
  [2343] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1103),
  [2345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1104),
  [2347] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1105),
  [2349] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1105),
  [2351] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1107),
  [2353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1108),
  [2355] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1108),
  [2357] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1110),
  [2359] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1112),
  [2361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1113),
  [2363] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1114),
  [2365] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1114),
  [2367] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1115),
  [2369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1116),
  [2371] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1117),
  [2373] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1117),
  [2375] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [2377] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [2379] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(638),
  [2382] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [2384] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(640),
  [2387] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(641),
  [2390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1118),
  [2392] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1119),
  [2394] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1120),
  [2396] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1121),
  [2398] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1122),
  [2400] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1123),
  [2402] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1124),
  [2404] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(662),
  [2407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1125),
  [2409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1126),
  [2411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1127),
  [2413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1128),
  [2415] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1129),
  [2417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1130),
  [2419] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1130),
  [2421] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1132),
  [2423] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1133),
  [2425] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1133),
  [2427] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1135),
  [2429] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1136),
  [2431] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1137),
  [2433] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1138),
  [2435] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1139),
  [2437] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1140),
  [2439] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(693),
  [2442] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1141),
  [2444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1142),
  [2446] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1143),
  [2448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1144),
  [2450] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1145),
  [2452] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1146),
  [2454] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1146),
  [2456] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1148),
  [2458] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1149),
  [2460] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1149),
  [2462] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6),
  [2464] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3),
  [2466] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [2468] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1152),
  [2470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1153),
  [2472] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1153),
  [2474] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1155),
  [2476] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1157),
  [2478] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [2480] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [2482] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(155),
  [2485] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(724),
  [2488] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(157),
  [2491] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(158),
  [2494] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(159),
  [2497] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(160),
  [2500] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(161),
  [2503] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(724),
  [2506] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1160),
  [2508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1161),
  [2510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1162),
  [2512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1163),
  [2514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1164),
  [2516] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6),
  [2518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1166),
  [2520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1167),
  [2522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1168),
  [2524] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 1),
  [2526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1169),
  [2528] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5),
  [2530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1170),
  [2532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1171),
  [2534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1172),
  [2536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1173),
  [2538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1174),
  [2540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1175),
  [2542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1176),
  [2544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1177),
  [2546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1178),
  [2548] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1179),
  [2550] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1180),
  [2552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1181),
  [2554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1182),
  [2556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1183),
  [2558] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 1),
  [2560] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 1),
  [2562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [2564] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [2566] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 3),
  [2568] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(800),
  [2571] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1184),
  [2573] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1185),
  [2575] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1186),
  [2577] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1187),
  [2579] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1188),
  [2581] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1189),
  [2583] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1189),
  [2585] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1191),
  [2587] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1192),
  [2589] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1192),
  [2591] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 3),
  [2593] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [2595] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 5),
  [2597] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [2599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1195),
  [2601] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5),
  [2603] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [2605] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1197),
  [2607] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 5),
  [2609] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [2611] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 5),
  [2613] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [2615] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1200),
  [2617] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1201),
  [2619] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1202),
  [2621] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1203),
  [2623] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1204),
  [2625] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1205),
  [2627] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1205),
  [2629] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1207),
  [2631] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1209),
  [2633] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1210),
  [2635] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1211),
  [2637] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1211),
  [2639] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1212),
  [2641] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1213),
  [2643] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1214),
  [2645] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1214),
  [2647] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1215),
  [2649] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1216),
  [2651] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(852),
  [2654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1217),
  [2656] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1218),
  [2658] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1219),
  [2660] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1220),
  [2662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1221),
  [2664] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1222),
  [2666] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1222),
  [2668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1224),
  [2670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1225),
  [2672] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1225),
  [2674] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 3),
  [2676] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(882),
  [2679] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1228),
  [2681] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1229),
  [2683] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1230),
  [2685] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1231),
  [2687] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1232),
  [2689] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1233),
  [2691] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1233),
  [2693] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1235),
  [2695] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1236),
  [2697] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1236),
  [2699] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1238),
  [2701] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1239),
  [2703] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1240),
  [2705] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1241),
  [2707] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1242),
  [2709] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1243),
  [2711] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1244),
  [2713] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1245),
  [2715] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1246),
  [2717] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1247),
  [2719] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1248),
  [2721] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1249),
  [2723] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1249),
  [2725] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1251),
  [2727] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1252),
  [2729] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1252),
  [2731] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1254),
  [2733] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1255),
  [2735] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1256),
  [2737] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1257),
  [2739] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1258),
  [2741] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1259),
  [2743] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1260),
  [2745] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1261),
  [2747] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1262),
  [2749] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1263),
  [2751] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1264),
  [2753] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1265),
  [2755] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1266),
  [2757] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1267),
  [2759] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1268),
  [2761] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1269),
  [2763] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1270),
  [2765] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1271),
  [2767] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1272),
  [2769] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1273),
  [2771] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4),
  [2773] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [2775] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2),
  [2777] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3),
  [2779] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [2781] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [2783] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1274),
  [2785] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(971),
  [2788] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [2790] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1277),
  [2792] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1278),
  [2794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1279),
  [2796] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1280),
  [2798] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 1),
  [2800] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6),
  [2802] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1281),
  [2804] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1282),
  [2806] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1283),
  [2808] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1284),
  [2810] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1285),
  [2812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1286),
  [2814] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 2),
  [2816] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 2),
  [2818] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7),
  [2820] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 7),
  [2822] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1287),
  [2824] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1288),
  [2826] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1289),
  [2828] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1290),
  [2830] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1291),
  [2832] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1292),
  [2834] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_for_statement, 6),
  [2836] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6),
  [2838] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 6),
  [2840] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [2842] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1293),
  [2844] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6),
  [2846] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [2848] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1294),
  [2850] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 6),
  [2852] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6),
  [2854] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1295),
  [2856] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1296),
  [2858] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1054),
  [2861] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1297),
  [2863] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1298),
  [2865] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1299),
  [2867] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1300),
  [2869] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1301),
  [2871] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1302),
  [2873] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1302),
  [2875] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1304),
  [2877] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1305),
  [2879] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1305),
  [2881] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1307),
  [2883] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1308),
  [2885] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1309),
  [2887] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1310),
  [2889] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1311),
  [2891] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1312),
  [2893] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1313),
  [2895] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1314),
  [2897] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1315),
  [2899] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1316),
  [2901] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1317),
  [2903] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1318),
  [2905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1319),
  [2907] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1320),
  [2909] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1321),
  [2911] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1322),
  [2913] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1323),
  [2915] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1324),
  [2917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1325),
  [2919] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1326),
  [2921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1327),
  [2923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1328),
  [2925] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1329),
  [2927] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1330),
  [2929] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1331),
  [2931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1332),
  [2933] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1333),
  [2935] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1334),
  [2937] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1335),
  [2939] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1336),
  [2941] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1337),
  [2943] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1338),
  [2945] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1339),
  [2947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1340),
  [2949] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4),
  [2951] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [2953] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [2955] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1341),
  [2957] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 2),
  [2959] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 7),
  [2961] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1342),
  [2963] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1343),
  [2965] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1344),
  [2967] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1345),
  [2969] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 7),
  [2971] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [2973] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7),
  [2975] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7),
  [2977] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1346),
  [2979] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1347),
  [2981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1348),
  [2983] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1349),
  [2985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1350),
  [2987] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1351),
  [2989] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1352),
  [2991] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1353),
  [2993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1354),
  [2995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1355),
  [2997] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1356),
  [2999] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1357),
  [3001] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1358),
  [3003] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1359),
  [3005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1360),
  [3007] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1361),
  [3009] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1362),
  [3011] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1363),
  [3013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1364),
  [3015] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1365),
  [3017] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1366),
  [3019] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1367),
  [3021] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1368),
  [3023] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1369),
  [3025] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5),
  [3027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [3029] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [3031] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1370),
  [3033] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1371),
  [3035] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1372),
  [3037] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1373),
  [3039] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1374),
  [3041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1375),
  [3043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1376),
  [3045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1377),
  [3047] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1378),
  [3049] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1379),
  [3051] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1380),
  [3053] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1381),
  [3055] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1382),
  [3057] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1383),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
